/* Application.c generated by valac 0.56.17, the Vala compiler
 * generated from Application.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file Application.vala
 *
 * @brief Main application class and namespace assets for the Tuner radio application
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <gdk/gdk.h>
#include <locale.h>
#include <glib/gi18n-lib.h>

#define VERSION "2.0.0"
#define TUNER_APPLICATION_APP_VERSION VERSION
#define TUNER_APPLICATION_APP_ID "com.github.louis77.tuner"
#define TUNER_APPLICATION_STAR_CHAR "★ "
#define TUNER_APPLICATION_UNSTAR_CHAR "☆ "
#define TUNER_APPLICATION_EXCLAIM_CHAR "⚠ "
#define TUNER_APPLICATION_STARRED "starred.json"
#define GETTEXT_PACKAGE "com.github.louis77.tuner"
#define LOCALEDIR "/usr/share/locale"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
typedef enum  {
	TUNER_THEME_SYSTEM,
	TUNER_THEME_LIGHT,
	TUNER_THEME_DARK
} TunerTHEME;

#define TUNER_TYPE_THEME (tuner_theme_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block21Data Block21Data;
typedef struct _TunerNapData TunerNapData;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TunerFadeData TunerFadeData;
typedef struct _TunerApplicationPrivate TunerApplicationPrivate;

#define TUNER_TYPE_SETTINGS (tuner_settings_get_type ())
#define TUNER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_SETTINGS, TunerSettings))
#define TUNER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_SETTINGS, TunerSettingsClass))
#define TUNER_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_SETTINGS))
#define TUNER_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_SETTINGS))
#define TUNER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_SETTINGS, TunerSettingsClass))

typedef struct _TunerSettings TunerSettings;
typedef struct _TunerSettingsClass TunerSettingsClass;

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;

#define TUNER_TYPE_DIRECTORY_CONTROLLER (tuner_directory_controller_get_type ())
#define TUNER_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryController))
#define TUNER_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))
#define TUNER_IS_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_IS_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_DIRECTORY_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))

typedef struct _TunerDirectoryController TunerDirectoryController;
typedef struct _TunerDirectoryControllerClass TunerDirectoryControllerClass;

#define TUNER_TYPE_STAR_STORE (tuner_star_store_get_type ())
#define TUNER_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STAR_STORE, TunerStarStore))
#define TUNER_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))
#define TUNER_IS_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STAR_STORE))
#define TUNER_IS_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STAR_STORE))
#define TUNER_STAR_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))

typedef struct _TunerStarStore TunerStarStore;
typedef struct _TunerStarStoreClass TunerStarStoreClass;

#define TUNER_DATA_PROVIDER_TYPE_API (tuner_data_provider_api_get_type ())
#define TUNER_DATA_PROVIDER_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPI))
#define TUNER_DATA_PROVIDER_IS_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_API))
#define TUNER_DATA_PROVIDER_API_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPIIface))

typedef struct _TunerDataProviderAPI TunerDataProviderAPI;
typedef struct _TunerDataProviderAPIIface TunerDataProviderAPIIface;

#define TUNER_DATA_PROVIDER_TYPE_TAG (tuner_data_provider_tag_get_type ())
#define TUNER_DATA_PROVIDER_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTag))
#define TUNER_DATA_PROVIDER_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))
#define TUNER_DATA_PROVIDER_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))

typedef struct _TunerDataProviderTag TunerDataProviderTag;
typedef struct _TunerDataProviderTagClass TunerDataProviderTagClass;

#define TUNER_DATA_PROVIDER_TYPE_DATA_ERROR (tuner_data_provider_data_error_get_type ())

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;

#define TUNER_DATA_PROVIDER_TYPE_SEARCH_PARAMS (tuner_data_provider_search_params_get_type ())
typedef struct _TunerDataProviderSearchParams TunerDataProviderSearchParams;
typedef enum  {
	TUNER_DATA_PROVIDER_SORT_ORDER_NAME,
	TUNER_DATA_PROVIDER_SORT_ORDER_URL,
	TUNER_DATA_PROVIDER_SORT_ORDER_HOMEPAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_FAVICON,
	TUNER_DATA_PROVIDER_SORT_ORDER_TAGS,
	TUNER_DATA_PROVIDER_SORT_ORDER_COUNTRY,
	TUNER_DATA_PROVIDER_SORT_ORDER_STATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LANGUAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_VOTES,
	TUNER_DATA_PROVIDER_SORT_ORDER_CODEC,
	TUNER_DATA_PROVIDER_SORT_ORDER_BITRATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKOK,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKTIME,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTIMESTAMP,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND,
	TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM
} TunerDataProviderSortOrder;

#define TUNER_DATA_PROVIDER_TYPE_SORT_ORDER (tuner_data_provider_sort_order_get_type ())
typedef enum  {
	TUNER_DATA_PROVIDER_API_STATUS_OK,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED,
	TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE,
	TUNER_DATA_PROVIDER_API_STATUS_UNKNOW_ERROR
} TunerDataProviderAPIStatus;

#define TUNER_DATA_PROVIDER_API_TYPE_STATUS (tuner_data_provider_api_status_get_type ())

#define TUNER_TYPE_WINDOW (tuner_window_get_type ())
#define TUNER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_WINDOW, TunerWindow))
#define TUNER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_WINDOW, TunerWindowClass))
#define TUNER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_WINDOW))
#define TUNER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_WINDOW))
#define TUNER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_WINDOW, TunerWindowClass))

typedef struct _TunerWindow TunerWindow;
typedef struct _TunerWindowClass TunerWindowClass;
enum  {
	TUNER_APPLICATION_0_PROPERTY,
	TUNER_APPLICATION_LANGUAGE_PROPERTY,
	TUNER_APPLICATION_SETTINGS_PROPERTY,
	TUNER_APPLICATION_PLAYER_PROPERTY,
	TUNER_APPLICATION_DIRECTORY_PROPERTY,
	TUNER_APPLICATION_STARS_PROPERTY,
	TUNER_APPLICATION_PROVIDER_PROPERTY,
	TUNER_APPLICATION_CACHE_DIR_PROPERTY,
	TUNER_APPLICATION_DATA_DIR_PROPERTY,
	TUNER_APPLICATION_OFFLINE_CANCEL_PROPERTY,
	TUNER_APPLICATION_IS_OFFLINE_PROPERTY,
	TUNER_APPLICATION_IS_ONLINE_PROPERTY,
	TUNER_APPLICATION_WINDOW_PROPERTY,
	TUNER_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* tuner_application_properties[TUNER_APPLICATION_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER (tuner_data_provider_radio_browser_get_type ())
#define TUNER_DATA_PROVIDER_RADIO_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser))
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowserClass))
#define TUNER_DATA_PROVIDER_IS_RADIO_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER))
#define TUNER_DATA_PROVIDER_IS_RADIO_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER))
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowserClass))

typedef struct _TunerDataProviderRadioBrowser TunerDataProviderRadioBrowser;
typedef struct _TunerDataProviderRadioBrowserClass TunerDataProviderRadioBrowserClass;
typedef enum  {
	TUNER_PLAYER_CONTROLLER_IS_BUFFERING,
	TUNER_PLAYER_CONTROLLER_IS_PAUSED,
	TUNER_PLAYER_CONTROLLER_IS_PLAYING,
	TUNER_PLAYER_CONTROLLER_IS_STOPPED,
	TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR
} TunerPlayerControllerIs;

#define TUNER_PLAYER_CONTROLLER_TYPE_IS (tuner_player_controller_is_get_type ())
typedef struct _TunerModelFaviconPrivate TunerModelFaviconPrivate;
typedef struct _TunerModelStationPrivate TunerModelStationPrivate;
enum  {
	TUNER_APPLICATION_SHUFFLE_MODE_SIG_SIGNAL,
	TUNER_APPLICATION_NUM_SIGNALS
};
static guint tuner_application_signals[TUNER_APPLICATION_NUM_SIGNALS] = {0};

struct _Block21Data {
	int _ref_count_;
	gpointer _async_data_;
};

struct _TunerNapData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	guint interval;
	Block21Data* _data21_;
};

struct _TunerFadeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GtkImage* image;
	guint duration_ms;
	gboolean fading_in;
	gdouble step;
	guint interval;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gboolean _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble op;
	gdouble _tmp8_;
	gdouble _tmp9_;
};

struct _TunerApplication {
	GtkApplication parent_instance;
	TunerApplicationPrivate * priv;
};

struct _TunerApplicationClass {
	GtkApplicationClass parent_class;
};

typedef enum  {
	TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA,
	TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION
} TunerDataProviderDataError;
#define TUNER_DATA_PROVIDER_DATA_ERROR tuner_data_provider_data_error_quark ()

struct _TunerDataProviderSearchParams {
	gchar* text;
	GeeSet* tags;
	GeeSet* uuids;
	gchar* countrycode;
	TunerDataProviderSortOrder order;
	gboolean reverse;
};

struct _TunerDataProviderAPIIface {
	GTypeInterface parent_iface;
	void (*clear_last_error) (TunerDataProviderAPI* self);
	gchar* (*name) (TunerDataProviderAPI* self);
	gint (*available_stations) (TunerDataProviderAPI* self);
	gint (*available_tags) (TunerDataProviderAPI* self);
	gboolean (*initialize) (TunerDataProviderAPI* self);
	void (*click) (TunerDataProviderAPI* self, const gchar* stationuuid);
	void (*vote) (TunerDataProviderAPI* self, const gchar* stationuuid);
	GeeSet* (*get_tags) (TunerDataProviderAPI* self, gint offset, gint limit, GError** error);
	GeeSet* (*by_uuid) (TunerDataProviderAPI* self, const gchar* uuids, GError** error);
	GeeSet* (*by_uuids) (TunerDataProviderAPI* self, GeeCollection* uuids, GError** error);
	GeeSet* (*search) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GError** error);
	void (*search_async) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeSet* (*search_finish) (TunerDataProviderAPI* self, GAsyncResult* _res_, GError** error);
	GError* (*get_last_data_error) (TunerDataProviderAPI* self);
	void (*set_last_data_error) (TunerDataProviderAPI* self, GError* value);
	TunerDataProviderAPIStatus (*get_status) (TunerDataProviderAPI* self);
	void (*set_status) (TunerDataProviderAPI* self, TunerDataProviderAPIStatus value);
};

struct _TunerApplicationPrivate {
	TunerSettings* _settings;
	TunerPlayerController* _player;
	TunerDirectoryController* _directory;
	TunerStarStore* _stars;
	TunerDataProviderAPI* _provider;
	gchar* _cache_dir;
	gchar* _data_dir;
	GCancellable* _offline_cancel;
	gboolean _is_offline;
	gboolean _is_online;
	TunerWindow* _window;
	guint _monitor_changed_id;
	gboolean _has_started;
};

struct _TunerModelFavicon {
	GObject parent_instance;
	TunerModelFaviconPrivate * priv;
};

struct _TunerModelFaviconClass {
	GObjectClass parent_class;
	gchar* (*favicon_cache_file) (TunerModelFavicon* self);
};

struct _TunerModelStation {
	TunerModelFavicon parent_instance;
	TunerModelStationPrivate * priv;
	gint votes;
	gchar* lastchangetime;
	gchar* lastchangetime_iso8601;
	gint lastcheckok;
	gchar* lastchecktime;
	gchar* lastchecktime_iso8601;
	gchar* lastcheckoktime;
	gchar* lastcheckoktime_iso8601;
	gchar* lastlocalchecktime;
	gchar* lastlocalchecktime_iso8601;
	gchar* clicktimestamp;
	gchar* clicktimestamp_iso8601;
	gint clickcount;
	gint clicktrend;
	gint ssl_error;
	gchar* geo_lat;
	gchar* geo_long;
	gboolean has_extended_info;
	gboolean is_in_index;
	gboolean is_up_to_date;
	gchar* up_to_date_difference;
};

struct _TunerModelStationClass {
	TunerModelFaviconClass parent_class;
};

VALA_EXTERN TunerApplication* tuner__instance;
TunerApplication* tuner__instance = NULL;
static gint TunerApplication_private_offset;
static gpointer tuner_application_parent_class = NULL;
static GtkSettings* tuner_application_GTK_SETTINGS;
static GtkSettings* tuner_application_GTK_SETTINGS = NULL;
static gchar* tuner_application_GTK_SYSTEM_THEME;
static gchar* tuner_application_GTK_SYSTEM_THEME = NULL;
static gchar* tuner_application_ENV_LANG;
static gchar* tuner_application_ENV_LANG = NULL;
VALA_EXTERN GeeCollection* tuner_application_LANGUAGES;
GeeCollection* tuner_application_LANGUAGES = NULL;
static GNetworkMonitor* tuner_application_NETMON;
static GNetworkMonitor* tuner_application_NETMON = NULL;
static GtkCssProvider* tuner_application_CSSPROVIDER;
static GtkCssProvider* tuner_application_CSSPROVIDER = NULL;

VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN GType tuner_theme_get_type (void) G_GNUC_CONST ;
VALA_EXTERN const gchar* tuner_theme_get_name (TunerTHEME self);
VALA_EXTERN void tuner_apply_theme (TunerTHEME requested_theme);
VALA_EXTERN void tuner_apply_theme_name (const gchar* requested_theme);
VALA_EXTERN gchar* tuner_application_SYSTEM_THEME (void);
VALA_EXTERN TunerApplication* tuner_app (void);
static void tuner_nap_data_free (gpointer _data);
VALA_EXTERN void tuner_nap (guint interval,
                GAsyncReadyCallback _callback_,
                gpointer _user_data_);
VALA_EXTERN void tuner_nap_finish (GAsyncResult* _res_);
static gboolean tuner_nap_co (TunerNapData* _data_);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block21Data* _data21_);
static gboolean ___lambda4__gsource_func (gpointer self);
static void tuner_fade_data_free (gpointer _data);
VALA_EXTERN void tuner_fade (GtkImage* image,
                 guint duration_ms,
                 gboolean fading_in,
                 GAsyncReadyCallback _callback_,
                 gpointer _user_data_);
VALA_EXTERN void tuner_fade_finish (GAsyncResult* _res_);
static gboolean tuner_fade_co (TunerFadeData* _data_);
static void tuner_fade_ready (GObject* source_object,
                       GAsyncResult* _res_,
                       gpointer _user_data_);
VALA_EXTERN const gchar* tuner_safestrip (const gchar* text);
VALA_EXTERN GType tuner_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerSettings, g_object_unref)
VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
VALA_EXTERN GType tuner_directory_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDirectoryController, g_object_unref)
VALA_EXTERN GType tuner_star_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStarStore, g_object_unref)
VALA_EXTERN GType tuner_data_provider_tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderTag, g_object_unref)
VALA_EXTERN GQuark tuner_data_provider_data_error_quark (void);
VALA_EXTERN GType tuner_data_provider_data_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN GType tuner_data_provider_search_params_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_sort_order_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TunerDataProviderSearchParams* tuner_data_provider_search_params_dup (const TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_free (TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_copy (const TunerDataProviderSearchParams* self,
                                             TunerDataProviderSearchParams* dest);
VALA_EXTERN void tuner_data_provider_search_params_destroy (TunerDataProviderSearchParams* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TunerDataProviderSearchParams, tuner_data_provider_search_params_destroy)
VALA_EXTERN GType tuner_data_provider_api_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_api_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderAPI, g_object_unref)
VALA_EXTERN GType tuner_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerWindow, g_object_unref)
static void tuner_application_on_resume_window (TunerApplication* self);
static void _tuner_application_on_resume_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static TunerApplication* tuner_application_new (void);
static TunerApplication* tuner_application_construct (GType object_type);
static void tuner_application_real_activate (GApplication* base);
VALA_EXTERN TunerWindow* tuner_application_get_window (TunerApplication* self);
VALA_EXTERN void tuner_dbus_initialize (void);
VALA_EXTERN TunerSettings* tuner_application_get_settings (TunerApplication* self);
VALA_EXTERN const gchar* tuner_settings_get_theme_mode (TunerSettings* self);
VALA_EXTERN const gchar* tuner_settings_get_language (TunerSettings* self);
VALA_EXTERN void tuner_application_set_language (TunerApplication* self,
                                     const gchar* value);
VALA_EXTERN TunerPlayerController* tuner_application_get_player (TunerApplication* self);
VALA_EXTERN TunerDirectoryController* tuner_application_get_directory (TunerApplication* self);
VALA_EXTERN TunerWindow* tuner_window_new (TunerApplication* app,
                               TunerPlayerController* player,
                               TunerSettings* settings,
                               TunerDirectoryController* directory);
VALA_EXTERN TunerWindow* tuner_window_construct (GType object_type,
                                     TunerApplication* app,
                                     TunerPlayerController* player,
                                     TunerSettings* settings,
                                     TunerDirectoryController* directory);
static void tuner_application_set_window (TunerApplication* self,
                                   TunerWindow* value);
VALA_EXTERN void tuner_settings_configure (TunerSettings* self);
static gchar* tuner_application_stat_dir (TunerApplication* self,
                                   const gchar* dir);
static void tuner_application_check_online_status (TunerApplication* self);
VALA_EXTERN gboolean tuner_application_get_is_offline (TunerApplication* self);
static gboolean ___lambda96_ (TunerApplication* self);
static void tuner_application_set_is_online (TunerApplication* self,
                                      gboolean value);
static gboolean ____lambda96__gsource_func (gpointer self);
VALA_EXTERN const gchar* tuner_application_get_language (TunerApplication* self);
VALA_EXTERN void tuner_settings_set_language (TunerSettings* self,
                                  const gchar* value);
static void tuner_application_set_settings (TunerApplication* self,
                                     TunerSettings* value);
static void tuner_application_set_player (TunerApplication* self,
                                   TunerPlayerController* value);
static void tuner_application_set_directory (TunerApplication* self,
                                      TunerDirectoryController* value);
VALA_EXTERN TunerStarStore* tuner_application_get_stars (TunerApplication* self);
static void tuner_application_set_stars (TunerApplication* self,
                                  TunerStarStore* value);
VALA_EXTERN TunerDataProviderAPI* tuner_application_get_provider (TunerApplication* self);
static void tuner_application_set_provider (TunerApplication* self,
                                     TunerDataProviderAPI* value);
VALA_EXTERN const gchar* tuner_application_get_cache_dir (TunerApplication* self);
static void tuner_application_set_cache_dir (TunerApplication* self,
                                      const gchar* value);
VALA_EXTERN const gchar* tuner_application_get_data_dir (TunerApplication* self);
static void tuner_application_set_data_dir (TunerApplication* self,
                                     const gchar* value);
VALA_EXTERN GCancellable* tuner_application_get_offline_cancel (TunerApplication* self);
static void tuner_application_set_offline_cancel (TunerApplication* self,
                                           GCancellable* value);
static void tuner_application_set_is_offline (TunerApplication* self,
                                       gboolean value);
VALA_EXTERN gboolean tuner_application_get_is_online (TunerApplication* self);
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
static GObject * tuner_application_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _tuner_application___lambda97_ (TunerApplication* self,
                                     gboolean monitor);
static void __tuner_application___lambda97__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                                        gboolean network_available,
                                                                        gpointer self);
VALA_EXTERN TunerSettings* tuner_settings_new (void);
VALA_EXTERN TunerSettings* tuner_settings_construct (GType object_type);
VALA_EXTERN TunerDataProviderRadioBrowser* tuner_data_provider_radio_browser_new (const gchar* optionalservers);
VALA_EXTERN TunerDataProviderRadioBrowser* tuner_data_provider_radio_browser_construct (GType object_type,
                                                                            const gchar* optionalservers);
VALA_EXTERN GType tuner_data_provider_radio_browser_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderRadioBrowser, g_object_unref)
VALA_EXTERN TunerPlayerController* tuner_player_controller_new (void);
VALA_EXTERN TunerPlayerController* tuner_player_controller_construct (GType object_type);
VALA_EXTERN TunerStarStore* tuner_star_store_new (GFile* starred_file);
VALA_EXTERN TunerStarStore* tuner_star_store_construct (GType object_type,
                                            GFile* starred_file);
VALA_EXTERN TunerDirectoryController* tuner_directory_controller_new (TunerDataProviderAPI* provider,
                                                          TunerStarStore* star_store);
VALA_EXTERN TunerDirectoryController* tuner_directory_controller_construct (GType object_type,
                                                                TunerDataProviderAPI* provider,
                                                                TunerStarStore* star_store);
VALA_EXTERN GType tuner_player_controller_is_get_type (void) G_GNUC_CONST ;
static void _tuner_application___lambda103_ (TunerApplication* self,
                                      TunerModelStation* station,
                                      TunerPlayerControllerIs state);
VALA_EXTERN gboolean tuner_settings_get_do_not_vote (TunerSettings* self);
VALA_EXTERN void tuner_data_provider_api_click (TunerDataProviderAPI* self,
                                    const gchar* stationuuid);
VALA_EXTERN const gchar* tuner_model_station_get_stationuuid (TunerModelStation* self);
static void __tuner_application___lambda103__tuner_player_controller_state_changed_sig (TunerPlayerController* _sender,
                                                                                 TunerModelStation* station,
                                                                                 TunerPlayerControllerIs state,
                                                                                 gpointer self);
static void _tuner_application___lambda104_ (TunerApplication* self,
                                      TunerModelStation* station);
VALA_EXTERN gboolean tuner_model_station_get_starred (TunerModelStation* self);
VALA_EXTERN void tuner_data_provider_api_vote (TunerDataProviderAPI* self,
                                   const gchar* stationuuid);
static void __tuner_application___lambda104__tuner_player_controller_tape_counter_sig (TunerPlayerController* _sender,
                                                                                TunerModelStation* station,
                                                                                gpointer self);
static void tuner_application_finalize (GObject * obj);
static GType tuner_application_get_type_once (void);
static void _vala_tuner_application_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_tuner_application_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry TUNER_APPLICATION_ACTION_ENTRIES[1] = {{"resume-window", _tuner_application_on_resume_window_gsimple_action_activate_callback}};

/**
    * @brief Available themes
    *
    */
const gchar*
tuner_theme_get_name (TunerTHEME self)
{
	const gchar* result;
#line 39 "../src/Application.vala"
	switch (self) {
#line 39 "../src/Application.vala"
		case TUNER_THEME_SYSTEM:
#line 597 "Application.c"
		{
#line 41 "../src/Application.vala"
			result = "system";
#line 41 "../src/Application.vala"
			return result;
#line 603 "Application.c"
		}
#line 39 "../src/Application.vala"
		case TUNER_THEME_LIGHT:
#line 607 "Application.c"
		{
#line 44 "../src/Application.vala"
			result = "light";
#line 44 "../src/Application.vala"
			return result;
#line 613 "Application.c"
		}
#line 39 "../src/Application.vala"
		case TUNER_THEME_DARK:
#line 617 "Application.c"
		{
#line 47 "../src/Application.vala"
			result = "dark";
#line 47 "../src/Application.vala"
			return result;
#line 623 "Application.c"
		}
		default:
		{
#line 50 "../src/Application.vala"
			g_assert_not_reached ();
#line 629 "Application.c"
		}
	}
}

static GType
tuner_theme_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_THEME_SYSTEM, "TUNER_THEME_SYSTEM", "system"}, {TUNER_THEME_LIGHT, "TUNER_THEME_LIGHT", "light"}, {TUNER_THEME_DARK, "TUNER_THEME_DARK", "dark"}, {0, NULL, NULL}};
	GType tuner_theme_type_id;
	tuner_theme_type_id = g_enum_register_static ("TunerTHEME", values);
	return tuner_theme_type_id;
}

GType
tuner_theme_get_type (void)
{
	static volatile gsize tuner_theme_type_id__once = 0;
	if (g_once_init_enter (&tuner_theme_type_id__once)) {
		GType tuner_theme_type_id;
		tuner_theme_type_id = tuner_theme_get_type_once ();
		g_once_init_leave (&tuner_theme_type_id__once, tuner_theme_type_id);
	}
	return tuner_theme_type_id__once;
}

/**
    * @brief Applys the given theme to the app
    *
    * @return The Application instance
    */
void
tuner_apply_theme (TunerTHEME requested_theme)
{
	const gchar* _tmp0_;
#line 63 "../src/Application.vala"
	_tmp0_ = tuner_theme_get_name (requested_theme);
#line 63 "../src/Application.vala"
	tuner_apply_theme_name (_tmp0_);
#line 668 "Application.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 681 "Application.c"
}

void
tuner_apply_theme_name (const gchar* requested_theme)
{
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	const gchar* _tmp6_;
#line 67 "../src/Application.vala"
	g_return_if_fail (requested_theme != NULL);
#line 69 "../src/Application.vala"
	_tmp0_ = tuner_theme_get_name (TUNER_THEME_LIGHT);
#line 69 "../src/Application.vala"
	if (g_strcmp0 (requested_theme, _tmp0_) == 0) {
#line 696 "Application.c"
		GtkSettings* _tmp1_;
		GValue _tmp2_ = {0};
#line 71 "../src/Application.vala"
		g_debug ("Application.vala:71: %s", "Applying theme: light");
#line 72 "../src/Application.vala"
		_tmp1_ = gtk_settings_get_default ();
#line 72 "../src/Application.vala"
		g_value_init (&_tmp2_, G_TYPE_STRING);
#line 72 "../src/Application.vala"
		g_value_set_string (&_tmp2_, "Adwaita");
#line 72 "../src/Application.vala"
		g_object_set_property ((GObject*) _tmp1_, "gtk-theme-name", &_tmp2_);
#line 72 "../src/Application.vala"
		G_IS_VALUE (&_tmp2_) ? (g_value_unset (&_tmp2_), NULL) : NULL;
#line 73 "../src/Application.vala"
		return;
#line 713 "Application.c"
	}
#line 76 "../src/Application.vala"
	_tmp3_ = tuner_theme_get_name (TUNER_THEME_DARK);
#line 76 "../src/Application.vala"
	if (g_strcmp0 (requested_theme, _tmp3_) == 0) {
#line 719 "Application.c"
		GtkSettings* _tmp4_;
		GValue _tmp5_ = {0};
#line 78 "../src/Application.vala"
		g_debug ("Application.vala:78: %s", "Applying theme: dark");
#line 79 "../src/Application.vala"
		_tmp4_ = gtk_settings_get_default ();
#line 79 "../src/Application.vala"
		g_value_init (&_tmp5_, G_TYPE_STRING);
#line 79 "../src/Application.vala"
		g_value_set_string (&_tmp5_, "Adwaita-dark");
#line 79 "../src/Application.vala"
		g_object_set_property ((GObject*) _tmp4_, "gtk-theme-name", &_tmp5_);
#line 79 "../src/Application.vala"
		G_IS_VALUE (&_tmp5_) ? (g_value_unset (&_tmp5_), NULL) : NULL;
#line 80 "../src/Application.vala"
		return;
#line 736 "Application.c"
	}
#line 83 "../src/Application.vala"
	_tmp6_ = tuner_theme_get_name (TUNER_THEME_SYSTEM);
#line 83 "../src/Application.vala"
	if (g_strcmp0 (requested_theme, _tmp6_) == 0) {
#line 742 "Application.c"
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GtkSettings* _tmp12_;
		gchar* _tmp13_;
		GValue _tmp14_ = {0};
#line 85 "../src/Application.vala"
		_tmp7_ = tuner_application_SYSTEM_THEME ();
#line 85 "../src/Application.vala"
		_tmp8_ = _tmp7_;
#line 85 "../src/Application.vala"
		_tmp9_ = string_to_string (_tmp8_);
#line 85 "../src/Application.vala"
		_tmp10_ = g_strconcat ("System theme X: ", _tmp9_, NULL);
#line 85 "../src/Application.vala"
		_tmp11_ = _tmp10_;
#line 85 "../src/Application.vala"
		g_debug ("Application.vala:85: %s", _tmp11_);
#line 85 "../src/Application.vala"
		_g_free0 (_tmp11_);
#line 85 "../src/Application.vala"
		_g_free0 (_tmp8_);
#line 86 "../src/Application.vala"
		_tmp12_ = gtk_settings_get_default ();
#line 86 "../src/Application.vala"
		_tmp13_ = tuner_application_SYSTEM_THEME ();
#line 86 "../src/Application.vala"
		g_value_init (&_tmp14_, G_TYPE_STRING);
#line 86 "../src/Application.vala"
		g_value_take_string (&_tmp14_, _tmp13_);
#line 86 "../src/Application.vala"
		g_object_set_property ((GObject*) _tmp12_, "gtk-theme-name", &_tmp14_);
#line 86 "../src/Application.vala"
		G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
#line 87 "../src/Application.vala"
		return;
#line 781 "Application.c"
	}
#line 89 "../src/Application.vala"
	g_assert_not_reached ();
#line 785 "Application.c"
}

/**
    * @brief Getter for the singleton instance
    *
    * @return The Application instance
    */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 99 "../src/Application.vala"
	return self ? g_object_ref (self) : NULL;
#line 798 "Application.c"
}

TunerApplication*
tuner_app (void)
{
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	TunerApplication* result;
#line 99 "../src/Application.vala"
	_tmp0_ = tuner__instance;
#line 99 "../src/Application.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 99 "../src/Application.vala"
	result = _tmp1_;
#line 99 "../src/Application.vala"
	return result;
#line 815 "Application.c"
}

static void
tuner_nap_data_free (gpointer _data)
{
	TunerNapData* _data_;
	_data_ = _data;
	g_slice_free (TunerNapData, _data_);
}

void
tuner_nap (guint interval,
           GAsyncReadyCallback _callback_,
           gpointer _user_data_)
{
	TunerNapData* _data_;
	_data_ = g_slice_new0 (TunerNapData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_nap_data_free);
	_data_->interval = interval;
	tuner_nap_co (_data_);
}

void
tuner_nap_finish (GAsyncResult* _res_)
{
	TunerNapData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

/**
    * @brief Send the calling method for a nap
    *
    * @param interval the time to nap
    * @param priority priority of chacking nap is over
    */
static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 109 "../src/Application.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 109 "../src/Application.vala"
	return _data21_;
#line 859 "Application.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 109 "../src/Application.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 109 "../src/Application.vala"
		g_slice_free (Block21Data, _data21_);
#line 871 "Application.c"
	}
}

static gboolean
__lambda4_ (Block21Data* _data21_)
{
	gboolean result;
#line 111 "../src/Application.vala"
	tuner_nap_co (_data21_->_async_data_);
#line 112 "../src/Application.vala"
	result = G_SOURCE_REMOVE;
#line 112 "../src/Application.vala"
	return result;
#line 885 "Application.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
#line 110 "../src/Application.vala"
	return result;
#line 895 "Application.c"
}

static gboolean
tuner_nap_co (TunerNapData* _data_)
{
#line 109 "../src/Application.vala"
	switch (_data_->_state_) {
#line 109 "../src/Application.vala"
		case 0:
#line 905 "Application.c"
		goto _state_0;
#line 109 "../src/Application.vala"
		case 1:
#line 909 "Application.c"
		goto _state_1;
		default:
#line 109 "../src/Application.vala"
		g_assert_not_reached ();
#line 914 "Application.c"
	}
	_state_0:
#line 109 "../src/Application.vala"
	_data_->_data21_ = g_slice_new0 (Block21Data);
#line 109 "../src/Application.vala"
	_data_->_data21_->_ref_count_ = 1;
#line 109 "../src/Application.vala"
	_data_->_data21_->_async_data_ = _data_;
#line 110 "../src/Application.vala"
	g_timeout_add_full (G_PRIORITY_LOW, _data_->interval, ___lambda4__gsource_func, block21_data_ref (_data_->_data21_), block21_data_unref);
#line 114 "../src/Application.vala"
	_data_->_state_ = 1;
#line 114 "../src/Application.vala"
	return FALSE;
#line 929 "Application.c"
	_state_1:
	;
#line 109 "../src/Application.vala"
	block21_data_unref (_data_->_data21_);
#line 109 "../src/Application.vala"
	_data_->_data21_ = NULL;
#line 109 "../src/Application.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 109 "../src/Application.vala"
	if (_data_->_state_ != 0) {
#line 109 "../src/Application.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 109 "../src/Application.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 944 "Application.c"
		}
	}
#line 109 "../src/Application.vala"
	g_object_unref (_data_->_async_result);
#line 109 "../src/Application.vala"
	return FALSE;
#line 951 "Application.c"
}

static void
tuner_fade_data_free (gpointer _data)
{
	TunerFadeData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->image);
	g_slice_free (TunerFadeData, _data_);
}

void
tuner_fade (GtkImage* image,
            guint duration_ms,
            gboolean fading_in,
            GAsyncReadyCallback _callback_,
            gpointer _user_data_)
{
	TunerFadeData* _data_;
	GtkImage* _tmp0_;
	g_return_if_fail (image != NULL);
	_data_ = g_slice_new0 (TunerFadeData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, tuner_fade_data_free);
	_tmp0_ = _g_object_ref0 (image);
	_g_object_unref0 (_data_->image);
	_data_->image = _tmp0_;
	_data_->duration_ms = duration_ms;
	_data_->fading_in = fading_in;
	tuner_fade_co (_data_);
}

void
tuner_fade_finish (GAsyncResult* _res_)
{
	TunerFadeData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

/**
    * @brief Asynchronously transitions the image with a fade effect.
    * 
    * @param {Gtk.Image} image - The image to transition.
    * @param {uint} duration_ms - Duration of the fade effect in milliseconds.
    * @param {Closure} callback - Optional callback function to execute after fading.
    */
static void
tuner_fade_ready (GObject* source_object,
                  GAsyncResult* _res_,
                  gpointer _user_data_)
{
	TunerFadeData* _data_;
#line 134 "../src/Application.vala"
	_data_ = _user_data_;
#line 134 "../src/Application.vala"
	_data_->_source_object_ = source_object;
#line 134 "../src/Application.vala"
	_data_->_res_ = _res_;
#line 134 "../src/Application.vala"
	tuner_fade_co (_data_);
#line 1012 "Application.c"
}

static gboolean
tuner_fade_co (TunerFadeData* _data_)
{
#line 125 "../src/Application.vala"
	switch (_data_->_state_) {
#line 125 "../src/Application.vala"
		case 0:
#line 1022 "Application.c"
		goto _state_0;
#line 125 "../src/Application.vala"
		case 1:
#line 1026 "Application.c"
		goto _state_1;
		default:
#line 125 "../src/Application.vala"
		g_assert_not_reached ();
#line 1031 "Application.c"
	}
	_state_0:
#line 127 "../src/Application.vala"
	_data_->step = 0.05;
#line 128 "../src/Application.vala"
	_data_->interval = (guint) (_data_->duration_ms / (1.0 / _data_->step));
#line 130 "../src/Application.vala"
	while (TRUE) {
#line 130 "../src/Application.vala"
		if (!_data_->fading_in) {
#line 130 "../src/Application.vala"
			_data_->_tmp2_ = gtk_widget_get_opacity ((GtkWidget*) _data_->image);
#line 130 "../src/Application.vala"
			_data_->_tmp3_ = _data_->_tmp2_;
#line 130 "../src/Application.vala"
			_data_->_tmp1_ = _data_->_tmp3_ != ((gdouble) 0);
#line 1048 "Application.c"
		} else {
#line 130 "../src/Application.vala"
			_data_->_tmp1_ = FALSE;
#line 1052 "Application.c"
		}
#line 130 "../src/Application.vala"
		if (_data_->_tmp1_) {
#line 130 "../src/Application.vala"
			_data_->_tmp0_ = TRUE;
#line 1058 "Application.c"
		} else {
#line 130 "../src/Application.vala"
			if (_data_->fading_in) {
#line 130 "../src/Application.vala"
				_data_->_tmp5_ = gtk_widget_get_opacity ((GtkWidget*) _data_->image);
#line 130 "../src/Application.vala"
				_data_->_tmp6_ = _data_->_tmp5_;
#line 130 "../src/Application.vala"
				_data_->_tmp4_ = _data_->_tmp6_ != ((gdouble) 1);
#line 1068 "Application.c"
			} else {
#line 130 "../src/Application.vala"
				_data_->_tmp4_ = FALSE;
#line 1072 "Application.c"
			}
#line 130 "../src/Application.vala"
			_data_->_tmp0_ = _data_->_tmp4_;
#line 1076 "Application.c"
		}
#line 130 "../src/Application.vala"
		if (!_data_->_tmp0_) {
#line 130 "../src/Application.vala"
			break;
#line 1082 "Application.c"
		}
#line 132 "../src/Application.vala"
		if (_data_->fading_in) {
#line 132 "../src/Application.vala"
			_data_->_tmp7_ = _data_->step;
#line 1088 "Application.c"
		} else {
#line 132 "../src/Application.vala"
			_data_->_tmp7_ = -_data_->step;
#line 1092 "Application.c"
		}
#line 132 "../src/Application.vala"
		_data_->_tmp8_ = gtk_widget_get_opacity ((GtkWidget*) _data_->image);
#line 132 "../src/Application.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 132 "../src/Application.vala"
		_data_->op = _data_->_tmp9_ + _data_->_tmp7_;
#line 133 "../src/Application.vala"
		gtk_widget_set_opacity ((GtkWidget*) _data_->image, CLAMP (_data_->op, (gdouble) 0, (gdouble) 1));
#line 134 "../src/Application.vala"
		_data_->_state_ = 1;
#line 134 "../src/Application.vala"
		tuner_nap (_data_->interval, tuner_fade_ready, _data_);
#line 134 "../src/Application.vala"
		return FALSE;
#line 1108 "Application.c"
		_state_1:
#line 134 "../src/Application.vala"
		tuner_nap_finish (_data_->_res_);
#line 1112 "Application.c"
	}
#line 125 "../src/Application.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 125 "../src/Application.vala"
	if (_data_->_state_ != 0) {
#line 125 "../src/Application.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 125 "../src/Application.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1122 "Application.c"
		}
	}
#line 125 "../src/Application.vala"
	g_object_unref (_data_->_async_result);
#line 125 "../src/Application.vala"
	return FALSE;
#line 1129 "Application.c"
}

const gchar*
tuner_safestrip (const gchar* text)
{
	gint _tmp0_;
	gint _tmp1_;
	const gchar* _tmp2_;
	const gchar* result;
#line 141 "../src/Application.vala"
	if (text == NULL) {
#line 141 "../src/Application.vala"
		result = "";
#line 141 "../src/Application.vala"
		return result;
#line 1145 "Application.c"
	}
#line 142 "../src/Application.vala"
	_tmp0_ = strlen (text);
#line 142 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/Application.vala"
	if (_tmp1_ == 0) {
#line 142 "../src/Application.vala"
		result = "";
#line 142 "../src/Application.vala"
		return result;
#line 1157 "Application.c"
	}
#line 143 "../src/Application.vala"
	_tmp2_ = g_strstrip (text);
#line 143 "../src/Application.vala"
	result = _tmp2_;
#line 143 "../src/Application.vala"
	return result;
#line 1165 "Application.c"
}

static inline gpointer
tuner_application_get_instance_private (TunerApplication* self)
{
	return G_STRUCT_MEMBER_P (self, TunerApplication_private_offset);
}

static void
_tuner_application_on_resume_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 294 "../src/Application.vala"
	tuner_application_on_resume_window ((TunerApplication*) self);
#line 1181 "Application.c"
}

gchar*
tuner_application_SYSTEM_THEME (void)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 203 "../src/Application.vala"
	_tmp0_ = tuner_application_GTK_SYSTEM_THEME;
#line 203 "../src/Application.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 203 "../src/Application.vala"
	result = _tmp1_;
#line 203 "../src/Application.vala"
	return result;
#line 1198 "Application.c"
}

/**
        * @brief Constructor for the Application
        */
static TunerApplication*
tuner_application_construct (GType object_type)
{
	TunerApplication * self = NULL;
#line 306 "../src/Application.vala"
	self = (TunerApplication*) g_object_new (object_type, "application-id", TUNER_APPLICATION_APP_ID, "flags", G_APPLICATION_FLAGS_NONE, NULL);
#line 305 "../src/Application.vala"
	return self;
#line 1212 "Application.c"
}

static TunerApplication*
tuner_application_new (void)
{
#line 305 "../src/Application.vala"
	return tuner_application_construct (TUNER_TYPE_APPLICATION);
#line 1220 "Application.c"
}

/**
        * @brief Activates the application
        *
        * This method is called when the application is activated. It creates
        * or presents the main window and initializes the DBus connection.
        */
static void
tuner_application_real_activate (GApplication* base)
{
	TunerApplication * self;
	TunerWindow* _tmp0_;
#line 417 "../src/Application.vala"
	self = (TunerApplication*) base;
#line 419 "../src/Application.vala"
	_tmp0_ = self->priv->_window;
#line 419 "../src/Application.vala"
	if (_tmp0_ == NULL) {
#line 1240 "Application.c"
		GtkSettings* _tmp1_;
		GtkSettings* _tmp2_;
		GtkSettings* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GtkCssProvider* _tmp6_;
		GdkScreen* _tmp7_;
		GtkCssProvider* _tmp8_;
		TunerSettings* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		TunerSettings* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		TunerPlayerController* _tmp15_;
		TunerSettings* _tmp16_;
		TunerDirectoryController* _tmp17_;
		TunerWindow* _tmp18_;
		TunerWindow* _tmp19_;
		TunerSettings* _tmp20_;
		TunerWindow* _tmp21_;
#line 420 "../src/Application.vala"
		tuner_dbus_initialize ();
#line 422 "../src/Application.vala"
		_tmp1_ = gtk_settings_get_default ();
#line 422 "../src/Application.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 422 "../src/Application.vala"
		_g_object_unref0 (tuner_application_GTK_SETTINGS);
#line 422 "../src/Application.vala"
		tuner_application_GTK_SETTINGS = _tmp2_;
#line 423 "../src/Application.vala"
		_tmp3_ = tuner_application_GTK_SETTINGS;
#line 423 "../src/Application.vala"
		g_object_get (_tmp3_, "gtk-theme-name", &_tmp4_, NULL);
#line 423 "../src/Application.vala"
		_tmp5_ = _tmp4_;
#line 423 "../src/Application.vala"
		_g_free0 (tuner_application_GTK_SYSTEM_THEME);
#line 423 "../src/Application.vala"
		tuner_application_GTK_SYSTEM_THEME = _tmp5_;
#line 424 "../src/Application.vala"
		_tmp6_ = tuner_application_CSSPROVIDER;
#line 424 "../src/Application.vala"
		gtk_css_provider_load_from_resource (_tmp6_, "/com/github/louis77/tuner/css/Tuner-system.css");
#line 425 "../src/Application.vala"
		_tmp7_ = gdk_screen_get_default ();
#line 425 "../src/Application.vala"
		_tmp8_ = tuner_application_CSSPROVIDER;
#line 425 "../src/Application.vala"
		gtk_style_context_add_provider_for_screen (_tmp7_, (GtkStyleProvider*) _tmp8_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 431 "../src/Application.vala"
		_tmp9_ = self->priv->_settings;
#line 431 "../src/Application.vala"
		_tmp10_ = tuner_settings_get_theme_mode (_tmp9_);
#line 431 "../src/Application.vala"
		_tmp11_ = _tmp10_;
#line 431 "../src/Application.vala"
		tuner_apply_theme_name (_tmp11_);
#line 432 "../src/Application.vala"
		_tmp12_ = self->priv->_settings;
#line 432 "../src/Application.vala"
		_tmp13_ = tuner_settings_get_language (_tmp12_);
#line 432 "../src/Application.vala"
		_tmp14_ = _tmp13_;
#line 432 "../src/Application.vala"
		tuner_application_set_language (self, _tmp14_);
#line 434 "../src/Application.vala"
		_tmp15_ = self->priv->_player;
#line 434 "../src/Application.vala"
		_tmp16_ = self->priv->_settings;
#line 434 "../src/Application.vala"
		_tmp17_ = self->priv->_directory;
#line 434 "../src/Application.vala"
		_tmp18_ = tuner_window_new (self, _tmp15_, _tmp16_, _tmp17_);
#line 434 "../src/Application.vala"
		g_object_ref_sink (_tmp18_);
#line 434 "../src/Application.vala"
		_tmp19_ = _tmp18_;
#line 434 "../src/Application.vala"
		tuner_application_set_window (self, _tmp19_);
#line 434 "../src/Application.vala"
		_g_object_unref0 (_tmp19_);
#line 435 "../src/Application.vala"
		_tmp20_ = self->priv->_settings;
#line 435 "../src/Application.vala"
		tuner_settings_configure (_tmp20_);
#line 438 "../src/Application.vala"
		_tmp21_ = self->priv->_window;
#line 438 "../src/Application.vala"
		gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp21_);
#line 1332 "Application.c"
	} else {
		TunerWindow* _tmp22_;
#line 440 "../src/Application.vala"
		_tmp22_ = self->priv->_window;
#line 440 "../src/Application.vala"
		gtk_window_present ((GtkWindow*) _tmp22_);
#line 1339 "Application.c"
	}
}

/**
        * @brief Resumes the window
        *
        * This method is called to bring the main window to the foreground.
        */
static void
tuner_application_on_resume_window (TunerApplication* self)
{
	TunerWindow* _tmp0_;
#line 450 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 451 "../src/Application.vala"
	_tmp0_ = self->priv->_window;
#line 451 "../src/Application.vala"
	gtk_window_present ((GtkWindow*) _tmp0_);
#line 1358 "Application.c"
}

/**
        * @brief Create directory structure quietly
        *
        */
static gchar*
tuner_application_stat_dir (TunerApplication* self,
                            const gchar* dir)
{
	GFile* _dir = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 458 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 458 "../src/Application.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 460 "../src/Application.vala"
	_tmp0_ = g_application_get_application_id ((GApplication*) self);
#line 460 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 460 "../src/Application.vala"
	_tmp2_ = g_file_new_build_filename (dir, _tmp1_, NULL);
#line 460 "../src/Application.vala"
	_dir = _tmp2_;
#line 1388 "Application.c"
	{
#line 462 "../src/Application.vala"
		g_file_make_directory_with_parents (_dir, NULL, &_inner_error0_);
#line 462 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 462 "../src/Application.vala"
			if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 1396 "Application.c"
				goto __catch0_g_io_error_exists;
			}
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_io_error_exists:
	{
#line 461 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 1407 "Application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 461 "../src/Application.vala"
		e = _inner_error0_;
#line 461 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 465 "../src/Application.vala"
		_tmp3_ = e;
#line 465 "../src/Application.vala"
		_tmp4_ = _tmp3_->message;
#line 465 "../src/Application.vala"
		_tmp5_ = string_to_string (_tmp4_);
#line 465 "../src/Application.vala"
		_tmp6_ = g_strconcat ("Stat Directory failed ", _tmp5_, NULL);
#line 465 "../src/Application.vala"
		_tmp7_ = _tmp6_;
#line 465 "../src/Application.vala"
		g_warning ("Application.vala:465: %s", _tmp7_);
#line 465 "../src/Application.vala"
		_g_free0 (_tmp7_);
#line 466 "../src/Application.vala"
		result = NULL;
#line 466 "../src/Application.vala"
		_g_error_free0 (e);
#line 466 "../src/Application.vala"
		_g_object_unref0 (_dir);
#line 466 "../src/Application.vala"
		return result;
#line 1444 "Application.c"
	}
	__finally0:
#line 461 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 461 "../src/Application.vala"
		_g_object_unref0 (_dir);
#line 461 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 461 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 461 "../src/Application.vala"
		return NULL;
#line 1457 "Application.c"
	}
#line 468 "../src/Application.vala"
	_tmp8_ = g_file_get_path (_dir);
#line 468 "../src/Application.vala"
	result = _tmp8_;
#line 468 "../src/Application.vala"
	_g_object_unref0 (_dir);
#line 468 "../src/Application.vala"
	return result;
#line 1467 "Application.c"
}

/**
        * @brief Set the network availability
        *
        * If going offline, set immediately.
        * Going online - wait a second to allow network to stabilize
        * This method removes any existing timeout and sets a new one 
        * reduces network state bouncyness
        */
static gboolean
___lambda96_ (TunerApplication* self)
{
	GNetworkMonitor* _tmp0_;
	gboolean result;
#line 497 "../src/Application.vala"
	self->priv->_monitor_changed_id = (guint) 0;
#line 498 "../src/Application.vala"
	_tmp0_ = tuner_application_NETMON;
#line 498 "../src/Application.vala"
	tuner_application_set_is_online (self, g_network_monitor_get_network_available (_tmp0_));
#line 499 "../src/Application.vala"
	self->priv->_has_started = TRUE;
#line 500 "../src/Application.vala"
	result = G_SOURCE_REMOVE;
#line 500 "../src/Application.vala"
	return result;
#line 1495 "Application.c"
}

static gboolean
____lambda96__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda96_ ((TunerApplication*) self);
#line 495 "../src/Application.vala"
	return result;
#line 1505 "Application.c"
}

static void
tuner_application_check_online_status (TunerApplication* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 480 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/Application.vala"
	if (self->priv->_monitor_changed_id > ((guint) 0)) {
#line 484 "../src/Application.vala"
		g_source_remove (self->priv->_monitor_changed_id);
#line 485 "../src/Application.vala"
		self->priv->_monitor_changed_id = (guint) 0;
#line 1521 "Application.c"
	}
#line 493 "../src/Application.vala"
	_tmp1_ = self->priv->_is_offline;
#line 493 "../src/Application.vala"
	if (_tmp1_) {
#line 1527 "Application.c"
		GNetworkMonitor* _tmp2_;
#line 493 "../src/Application.vala"
		_tmp2_ = tuner_application_NETMON;
#line 493 "../src/Application.vala"
		_tmp0_ = g_network_monitor_get_network_available (_tmp2_);
#line 1533 "Application.c"
	} else {
#line 493 "../src/Application.vala"
		_tmp0_ = FALSE;
#line 1537 "Application.c"
	}
#line 493 "../src/Application.vala"
	if (_tmp0_) {
#line 495 "../src/Application.vala"
		self->priv->_monitor_changed_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) self->priv->_has_started, ____lambda96__gsource_func, g_object_ref (self), g_object_unref);
#line 503 "../src/Application.vala"
		return;
#line 1545 "Application.c"
	}
#line 506 "../src/Application.vala"
	tuner_application_set_is_online (self, FALSE);
#line 1549 "Application.c"
}

const gchar*
tuner_application_get_language (TunerApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 235 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 235 "../src/Application.vala"
	_tmp0_ = tuner_application_ENV_LANG;
#line 235 "../src/Application.vala"
	_tmp1_ = g_getenv (_tmp0_);
#line 235 "../src/Application.vala"
	result = _tmp1_;
#line 235 "../src/Application.vala"
	return result;
#line 1568 "Application.c"
}

void
tuner_application_set_language (TunerApplication* self,
                                const gchar* value)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp5_;
	TunerSettings* _tmp6_;
#line 236 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/Application.vala"
	_tmp1_ = tuner_application_ENV_LANG;
#line 237 "../src/Application.vala"
	_tmp2_ = g_getenv (_tmp1_);
#line 237 "../src/Application.vala"
	if (g_strcmp0 (_tmp2_, value) == 0) {
#line 237 "../src/Application.vala"
		_tmp0_ = TRUE;
#line 1590 "Application.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 238 "../src/Application.vala"
		if (g_strcmp0 (value, "") != 0) {
#line 1595 "Application.c"
			GeeCollection* _tmp4_;
#line 238 "../src/Application.vala"
			_tmp4_ = tuner_application_LANGUAGES;
#line 238 "../src/Application.vala"
			_tmp3_ = !gee_collection_contains (_tmp4_, value);
#line 1601 "Application.c"
		} else {
#line 238 "../src/Application.vala"
			_tmp3_ = FALSE;
#line 1605 "Application.c"
		}
#line 238 "../src/Application.vala"
		_tmp0_ = _tmp3_;
#line 1609 "Application.c"
	}
#line 237 "../src/Application.vala"
	if (_tmp0_) {
#line 238 "../src/Application.vala"
		return;
#line 1615 "Application.c"
	}
#line 239 "../src/Application.vala"
	_tmp5_ = tuner_application_ENV_LANG;
#line 239 "../src/Application.vala"
	g_setenv (_tmp5_, value, TRUE);
#line 240 "../src/Application.vala"
	_tmp6_ = self->priv->_settings;
#line 240 "../src/Application.vala"
	tuner_settings_set_language (_tmp6_, value);
#line 236 "../src/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_LANGUAGE_PROPERTY]);
#line 1627 "Application.c"
}

TunerSettings*
tuner_application_get_settings (TunerApplication* self)
{
	TunerSettings* result;
	TunerSettings* _tmp0_;
#line 245 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 245 "../src/Application.vala"
	_tmp0_ = self->priv->_settings;
#line 245 "../src/Application.vala"
	result = _tmp0_;
#line 245 "../src/Application.vala"
	return result;
#line 1643 "Application.c"
}

static void
tuner_application_set_settings (TunerApplication* self,
                                TunerSettings* value)
{
	TunerSettings* old_value;
#line 245 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/Application.vala"
	old_value = tuner_application_get_settings (self);
#line 245 "../src/Application.vala"
	if (old_value != value) {
#line 1657 "Application.c"
		TunerSettings* _tmp0_;
#line 245 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 245 "../src/Application.vala"
		_g_object_unref0 (self->priv->_settings);
#line 245 "../src/Application.vala"
		self->priv->_settings = _tmp0_;
#line 245 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_SETTINGS_PROPERTY]);
#line 1667 "Application.c"
	}
}

TunerPlayerController*
tuner_application_get_player (TunerApplication* self)
{
	TunerPlayerController* result;
	TunerPlayerController* _tmp0_;
#line 248 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 248 "../src/Application.vala"
	_tmp0_ = self->priv->_player;
#line 248 "../src/Application.vala"
	result = _tmp0_;
#line 248 "../src/Application.vala"
	return result;
#line 1684 "Application.c"
}

static void
tuner_application_set_player (TunerApplication* self,
                              TunerPlayerController* value)
{
	TunerPlayerController* old_value;
#line 248 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/Application.vala"
	old_value = tuner_application_get_player (self);
#line 248 "../src/Application.vala"
	if (old_value != value) {
#line 1698 "Application.c"
		TunerPlayerController* _tmp0_;
#line 248 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 248 "../src/Application.vala"
		_g_object_unref0 (self->priv->_player);
#line 248 "../src/Application.vala"
		self->priv->_player = _tmp0_;
#line 248 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_PLAYER_PROPERTY]);
#line 1708 "Application.c"
	}
}

TunerDirectoryController*
tuner_application_get_directory (TunerApplication* self)
{
	TunerDirectoryController* result;
	TunerDirectoryController* _tmp0_;
#line 251 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 251 "../src/Application.vala"
	_tmp0_ = self->priv->_directory;
#line 251 "../src/Application.vala"
	result = _tmp0_;
#line 251 "../src/Application.vala"
	return result;
#line 1725 "Application.c"
}

static void
tuner_application_set_directory (TunerApplication* self,
                                 TunerDirectoryController* value)
{
	TunerDirectoryController* old_value;
#line 251 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/Application.vala"
	old_value = tuner_application_get_directory (self);
#line 251 "../src/Application.vala"
	if (old_value != value) {
#line 1739 "Application.c"
		TunerDirectoryController* _tmp0_;
#line 251 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 251 "../src/Application.vala"
		_g_object_unref0 (self->priv->_directory);
#line 251 "../src/Application.vala"
		self->priv->_directory = _tmp0_;
#line 251 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_DIRECTORY_PROPERTY]);
#line 1749 "Application.c"
	}
}

TunerStarStore*
tuner_application_get_stars (TunerApplication* self)
{
	TunerStarStore* result;
	TunerStarStore* _tmp0_;
#line 254 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 254 "../src/Application.vala"
	_tmp0_ = self->priv->_stars;
#line 254 "../src/Application.vala"
	result = _tmp0_;
#line 254 "../src/Application.vala"
	return result;
#line 1766 "Application.c"
}

static void
tuner_application_set_stars (TunerApplication* self,
                             TunerStarStore* value)
{
	TunerStarStore* old_value;
#line 254 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/Application.vala"
	old_value = tuner_application_get_stars (self);
#line 254 "../src/Application.vala"
	if (old_value != value) {
#line 1780 "Application.c"
		TunerStarStore* _tmp0_;
#line 254 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 254 "../src/Application.vala"
		_g_object_unref0 (self->priv->_stars);
#line 254 "../src/Application.vala"
		self->priv->_stars = _tmp0_;
#line 254 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_STARS_PROPERTY]);
#line 1790 "Application.c"
	}
}

TunerDataProviderAPI*
tuner_application_get_provider (TunerApplication* self)
{
	TunerDataProviderAPI* result;
	TunerDataProviderAPI* _tmp0_;
#line 257 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 257 "../src/Application.vala"
	_tmp0_ = self->priv->_provider;
#line 257 "../src/Application.vala"
	result = _tmp0_;
#line 257 "../src/Application.vala"
	return result;
#line 1807 "Application.c"
}

static void
tuner_application_set_provider (TunerApplication* self,
                                TunerDataProviderAPI* value)
{
	TunerDataProviderAPI* old_value;
#line 257 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/Application.vala"
	old_value = tuner_application_get_provider (self);
#line 257 "../src/Application.vala"
	if (old_value != value) {
#line 1821 "Application.c"
		TunerDataProviderAPI* _tmp0_;
#line 257 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 257 "../src/Application.vala"
		_g_object_unref0 (self->priv->_provider);
#line 257 "../src/Application.vala"
		self->priv->_provider = _tmp0_;
#line 257 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_PROVIDER_PROPERTY]);
#line 1831 "Application.c"
	}
}

const gchar*
tuner_application_get_cache_dir (TunerApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 260 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 260 "../src/Application.vala"
	_tmp0_ = self->priv->_cache_dir;
#line 260 "../src/Application.vala"
	result = _tmp0_;
#line 260 "../src/Application.vala"
	return result;
#line 1848 "Application.c"
}

static void
tuner_application_set_cache_dir (TunerApplication* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 260 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/Application.vala"
	old_value = tuner_application_get_cache_dir (self);
#line 260 "../src/Application.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1862 "Application.c"
		gchar* _tmp0_;
#line 260 "../src/Application.vala"
		_tmp0_ = g_strdup (value);
#line 260 "../src/Application.vala"
		_g_free0 (self->priv->_cache_dir);
#line 260 "../src/Application.vala"
		self->priv->_cache_dir = _tmp0_;
#line 260 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_CACHE_DIR_PROPERTY]);
#line 1872 "Application.c"
	}
}

const gchar*
tuner_application_get_data_dir (TunerApplication* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 263 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 263 "../src/Application.vala"
	_tmp0_ = self->priv->_data_dir;
#line 263 "../src/Application.vala"
	result = _tmp0_;
#line 263 "../src/Application.vala"
	return result;
#line 1889 "Application.c"
}

static void
tuner_application_set_data_dir (TunerApplication* self,
                                const gchar* value)
{
	gchar* old_value;
#line 263 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/Application.vala"
	old_value = tuner_application_get_data_dir (self);
#line 263 "../src/Application.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1903 "Application.c"
		gchar* _tmp0_;
#line 263 "../src/Application.vala"
		_tmp0_ = g_strdup (value);
#line 263 "../src/Application.vala"
		_g_free0 (self->priv->_data_dir);
#line 263 "../src/Application.vala"
		self->priv->_data_dir = _tmp0_;
#line 263 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_DATA_DIR_PROPERTY]);
#line 1913 "Application.c"
	}
}

GCancellable*
tuner_application_get_offline_cancel (TunerApplication* self)
{
	GCancellable* result;
	GCancellable* _tmp0_;
#line 265 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 265 "../src/Application.vala"
	_tmp0_ = self->priv->_offline_cancel;
#line 265 "../src/Application.vala"
	result = _tmp0_;
#line 265 "../src/Application.vala"
	return result;
#line 1930 "Application.c"
}

static void
tuner_application_set_offline_cancel (TunerApplication* self,
                                      GCancellable* value)
{
	GCancellable* old_value;
#line 265 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/Application.vala"
	old_value = tuner_application_get_offline_cancel (self);
#line 265 "../src/Application.vala"
	if (old_value != value) {
#line 1944 "Application.c"
		GCancellable* _tmp0_;
#line 265 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 265 "../src/Application.vala"
		_g_object_unref0 (self->priv->_offline_cancel);
#line 265 "../src/Application.vala"
		self->priv->_offline_cancel = _tmp0_;
#line 265 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_OFFLINE_CANCEL_PROPERTY]);
#line 1954 "Application.c"
	}
}

gboolean
tuner_application_get_is_offline (TunerApplication* self)
{
	gboolean result;
#line 270 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 270 "../src/Application.vala"
	result = self->priv->_is_offline;
#line 270 "../src/Application.vala"
	return result;
#line 1968 "Application.c"
}

static void
tuner_application_set_is_offline (TunerApplication* self,
                                  gboolean value)
{
	gboolean old_value;
#line 270 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 270 "../src/Application.vala"
	old_value = tuner_application_get_is_offline (self);
#line 270 "../src/Application.vala"
	if (old_value != value) {
#line 270 "../src/Application.vala"
		self->priv->_is_offline = value;
#line 270 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_IS_OFFLINE_PROPERTY]);
#line 1986 "Application.c"
	}
}

gboolean
tuner_application_get_is_online (TunerApplication* self)
{
	gboolean result;
#line 273 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 273 "../src/Application.vala"
	result = self->priv->_is_online;
#line 273 "../src/Application.vala"
	return result;
#line 2000 "Application.c"
}

static void
tuner_application_set_is_online (TunerApplication* self,
                                 gboolean value)
{
#line 274 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/Application.vala"
	if (value) {
#line 2011 "Application.c"
		GCancellable* _tmp0_;
#line 277 "../src/Application.vala"
		_tmp0_ = self->priv->_offline_cancel;
#line 277 "../src/Application.vala"
		g_cancellable_reset (_tmp0_);
#line 2017 "Application.c"
	} else {
		GCancellable* _tmp1_;
#line 281 "../src/Application.vala"
		_tmp1_ = self->priv->_offline_cancel;
#line 281 "../src/Application.vala"
		g_cancellable_cancel (_tmp1_);
#line 2024 "Application.c"
	}
#line 283 "../src/Application.vala"
	self->priv->_is_online = value;
#line 284 "../src/Application.vala"
	tuner_application_set_is_offline (self, !value);
#line 274 "../src/Application.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_IS_ONLINE_PROPERTY]);
#line 2032 "Application.c"
}

TunerWindow*
tuner_application_get_window (TunerApplication* self)
{
	TunerWindow* result;
	TunerWindow* _tmp0_;
#line 290 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 290 "../src/Application.vala"
	_tmp0_ = self->priv->_window;
#line 290 "../src/Application.vala"
	result = _tmp0_;
#line 290 "../src/Application.vala"
	return result;
#line 2048 "Application.c"
}

static void
tuner_application_set_window (TunerApplication* self,
                              TunerWindow* value)
{
	TunerWindow* old_value;
#line 290 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 290 "../src/Application.vala"
	old_value = tuner_application_get_window (self);
#line 290 "../src/Application.vala"
	if (old_value != value) {
#line 2062 "Application.c"
		TunerWindow* _tmp0_;
#line 290 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 290 "../src/Application.vala"
		_g_object_unref0 (self->priv->_window);
#line 290 "../src/Application.vala"
		self->priv->_window = _tmp0_;
#line 290 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_application_properties[TUNER_APPLICATION_WINDOW_PROPERTY]);
#line 2072 "Application.c"
	}
}

TunerApplication*
tuner_application_get_instance (void)
{
	TunerApplication* result;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp2_;
#line 403 "../src/Application.vala"
	_tmp0_ = tuner__instance;
#line 403 "../src/Application.vala"
	if (_tmp0_ == NULL) {
#line 2086 "Application.c"
		TunerApplication* _tmp1_;
#line 404 "../src/Application.vala"
		_tmp1_ = tuner_application_new ();
#line 404 "../src/Application.vala"
		_g_object_unref0 (tuner__instance);
#line 404 "../src/Application.vala"
		tuner__instance = _tmp1_;
#line 2094 "Application.c"
	}
#line 406 "../src/Application.vala"
	_tmp2_ = tuner__instance;
#line 406 "../src/Application.vala"
	result = _tmp2_;
#line 406 "../src/Application.vala"
	return result;
#line 2102 "Application.c"
}

static void
_tuner_application___lambda97_ (TunerApplication* self,
                                gboolean monitor)
{
#line 347 "../src/Application.vala"
	tuner_application_check_online_status (self);
#line 2111 "Application.c"
}

static void
__tuner_application___lambda97__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                                   gboolean network_available,
                                                                   gpointer self)
{
#line 346 "../src/Application.vala"
	_tuner_application___lambda97_ ((TunerApplication*) self, network_available);
#line 2121 "Application.c"
}

static void
_tuner_application___lambda103_ (TunerApplication* self,
                                 TunerModelStation* station,
                                 TunerPlayerControllerIs state)
{
	gboolean _tmp0_ = FALSE;
	TunerSettings* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 367 "../src/Application.vala"
	g_return_if_fail (station != NULL);
#line 370 "../src/Application.vala"
	_tmp1_ = self->priv->_settings;
#line 370 "../src/Application.vala"
	_tmp2_ = tuner_settings_get_do_not_vote (_tmp1_);
#line 370 "../src/Application.vala"
	_tmp3_ = _tmp2_;
#line 370 "../src/Application.vala"
	if (!_tmp3_) {
#line 370 "../src/Application.vala"
		_tmp0_ = state == TUNER_PLAYER_CONTROLLER_IS_PLAYING;
#line 2145 "Application.c"
	} else {
#line 370 "../src/Application.vala"
		_tmp0_ = FALSE;
#line 2149 "Application.c"
	}
#line 370 "../src/Application.vala"
	if (_tmp0_) {
#line 2153 "Application.c"
		TunerDataProviderAPI* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 372 "../src/Application.vala"
		_tmp4_ = self->priv->_provider;
#line 372 "../src/Application.vala"
		_tmp5_ = tuner_model_station_get_stationuuid (station);
#line 372 "../src/Application.vala"
		_tmp6_ = _tmp5_;
#line 372 "../src/Application.vala"
		tuner_data_provider_api_click (_tmp4_, _tmp6_);
#line 373 "../src/Application.vala"
		_tmp7_ = station->clickcount;
#line 373 "../src/Application.vala"
		station->clickcount = _tmp7_ + 1;
#line 374 "../src/Application.vala"
		_tmp8_ = station->clicktrend;
#line 374 "../src/Application.vala"
		station->clicktrend = _tmp8_ + 1;
#line 2175 "Application.c"
	}
}

static void
__tuner_application___lambda103__tuner_player_controller_state_changed_sig (TunerPlayerController* _sender,
                                                                            TunerModelStation* station,
                                                                            TunerPlayerControllerIs state,
                                                                            gpointer self)
{
#line 367 "../src/Application.vala"
	_tuner_application___lambda103_ ((TunerApplication*) self, station, state);
#line 2187 "Application.c"
}

static void
_tuner_application___lambda104_ (TunerApplication* self,
                                 TunerModelStation* station)
{
	TunerSettings* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	TunerDataProviderAPI* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
#line 378 "../src/Application.vala"
	g_return_if_fail (station != NULL);
#line 382 "../src/Application.vala"
	_tmp0_ = self->priv->_settings;
#line 382 "../src/Application.vala"
	_tmp1_ = tuner_settings_get_do_not_vote (_tmp0_);
#line 382 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 382 "../src/Application.vala"
	if (_tmp2_) {
#line 382 "../src/Application.vala"
		return;
#line 2216 "Application.c"
	}
#line 383 "../src/Application.vala"
	_tmp3_ = tuner_model_station_get_starred (station);
#line 383 "../src/Application.vala"
	_tmp4_ = _tmp3_;
#line 383 "../src/Application.vala"
	if (_tmp4_) {
#line 2224 "Application.c"
		TunerDataProviderAPI* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gint _tmp8_;
#line 385 "../src/Application.vala"
		_tmp5_ = self->priv->_provider;
#line 385 "../src/Application.vala"
		_tmp6_ = tuner_model_station_get_stationuuid (station);
#line 385 "../src/Application.vala"
		_tmp7_ = _tmp6_;
#line 385 "../src/Application.vala"
		tuner_data_provider_api_vote (_tmp5_, _tmp7_);
#line 386 "../src/Application.vala"
		_tmp8_ = station->votes;
#line 386 "../src/Application.vala"
		station->votes = _tmp8_ + 1;
#line 2241 "Application.c"
	}
#line 388 "../src/Application.vala"
	_tmp9_ = self->priv->_provider;
#line 388 "../src/Application.vala"
	_tmp10_ = tuner_model_station_get_stationuuid (station);
#line 388 "../src/Application.vala"
	_tmp11_ = _tmp10_;
#line 388 "../src/Application.vala"
	tuner_data_provider_api_click (_tmp9_, _tmp11_);
#line 389 "../src/Application.vala"
	_tmp12_ = station->clickcount;
#line 389 "../src/Application.vala"
	station->clickcount = _tmp12_ + 1;
#line 390 "../src/Application.vala"
	_tmp13_ = station->clicktrend;
#line 390 "../src/Application.vala"
	station->clicktrend = _tmp13_ + 1;
#line 2259 "Application.c"
}

static void
__tuner_application___lambda104__tuner_player_controller_tape_counter_sig (TunerPlayerController* _sender,
                                                                           TunerModelStation* station,
                                                                           gpointer self)
{
#line 378 "../src/Application.vala"
	_tuner_application___lambda104_ ((TunerApplication*) self, station);
#line 2269 "Application.c"
}

static GObject *
tuner_application_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerApplication * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _favorites_file = NULL;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _starred_file = NULL;
	const gchar* _tmp8_;
	GFile* _tmp9_;
	GCancellable* _tmp18_;
	GCancellable* _tmp19_;
	GNetworkMonitor* _tmp20_;
	GNetworkMonitor* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	TunerSettings* _tmp24_;
	TunerSettings* _tmp25_;
	TunerDataProviderRadioBrowser* _tmp26_;
	TunerDataProviderRadioBrowser* _tmp27_;
	TunerPlayerController* _tmp28_;
	TunerPlayerController* _tmp29_;
	GFile* _tmp30_;
	TunerStarStore* _tmp31_;
	TunerStarStore* _tmp32_;
	TunerDataProviderAPI* _tmp33_;
	TunerStarStore* _tmp34_;
	TunerDirectoryController* _tmp35_;
	TunerDirectoryController* _tmp36_;
	TunerPlayerController* _tmp37_;
	TunerPlayerController* _tmp38_;
	GError* _inner_error0_ = NULL;
#line 316 "../src/Application.vala"
	parent_class = G_OBJECT_CLASS (tuner_application_parent_class);
#line 316 "../src/Application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 316 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_APPLICATION, TunerApplication);
#line 320 "../src/Application.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 320 "../src/Application.vala"
	_tmp1_ = tuner_application_stat_dir (self, _tmp0_);
#line 320 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 320 "../src/Application.vala"
	tuner_application_set_cache_dir (self, _tmp2_);
#line 320 "../src/Application.vala"
	_g_free0 (_tmp2_);
#line 321 "../src/Application.vala"
	_tmp3_ = g_get_user_data_dir ();
#line 321 "../src/Application.vala"
	_tmp4_ = tuner_application_stat_dir (self, _tmp3_);
#line 321 "../src/Application.vala"
	_tmp5_ = _tmp4_;
#line 321 "../src/Application.vala"
	tuner_application_set_data_dir (self, _tmp5_);
#line 321 "../src/Application.vala"
	_g_free0 (_tmp5_);
#line 327 "../src/Application.vala"
	_tmp6_ = self->priv->_data_dir;
#line 327 "../src/Application.vala"
	_tmp7_ = g_file_new_build_filename (_tmp6_, "favorites.json", NULL);
#line 327 "../src/Application.vala"
	_favorites_file = _tmp7_;
#line 328 "../src/Application.vala"
	_tmp8_ = self->priv->_data_dir;
#line 328 "../src/Application.vala"
	_tmp9_ = g_file_new_build_filename (_tmp8_, TUNER_APPLICATION_STARRED, NULL);
#line 328 "../src/Application.vala"
	_starred_file = _tmp9_;
#line 2352 "Application.c"
	{
		GFileIOStream* _tmp10_ = NULL;
		GFile* _tmp11_;
		GFileIOStream* _tmp12_;
		GFile* _tmp13_;
		GFileOutputStream* _tmp14_;
		GFileOutputStream* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 332 "../src/Application.vala"
		_tmp11_ = _favorites_file;
#line 332 "../src/Application.vala"
		_tmp12_ = g_file_open_readwrite (_tmp11_, NULL, &_inner_error0_);
#line 332 "../src/Application.vala"
		_tmp10_ = _tmp12_;
#line 332 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2370 "Application.c"
			goto __catch0_g_error;
		}
#line 332 "../src/Application.vala"
		g_io_stream_close ((GIOStream*) _tmp10_, NULL, &_inner_error0_);
#line 332 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "../src/Application.vala"
			_g_object_unref0 (_tmp10_);
#line 2379 "Application.c"
			goto __catch0_g_error;
		}
#line 333 "../src/Application.vala"
		_tmp13_ = _starred_file;
#line 333 "../src/Application.vala"
		_tmp14_ = g_file_create (_tmp13_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 333 "../src/Application.vala"
		_tmp15_ = _tmp14_;
#line 333 "../src/Application.vala"
		_g_object_unref0 (_tmp15_);
#line 333 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 333 "../src/Application.vala"
			_g_object_unref0 (_tmp10_);
#line 2394 "Application.c"
			goto __catch0_g_error;
		}
#line 334 "../src/Application.vala"
		_tmp16_ = _favorites_file;
#line 334 "../src/Application.vala"
		_tmp17_ = _starred_file;
#line 334 "../src/Application.vala"
		g_file_copy (_tmp16_, _tmp17_, G_FILE_COPY_NONE, NULL, NULL, NULL, &_inner_error0_);
#line 334 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 334 "../src/Application.vala"
			_g_object_unref0 (_tmp10_);
#line 2407 "Application.c"
			goto __catch0_g_error;
		}
#line 335 "../src/Application.vala"
		g_warning ("Application.vala:335: %s", "Migrated v1 Favorites to v2 Starred");
#line 331 "../src/Application.vala"
		_g_object_unref0 (_tmp10_);
#line 2414 "Application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 331 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 2421 "Application.c"
	}
	__finally0:
#line 331 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 331 "../src/Application.vala"
		_g_object_unref0 (_starred_file);
#line 331 "../src/Application.vala"
		_g_object_unref0 (_favorites_file);
#line 331 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 331 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 2434 "Application.c"
	}
#line 345 "../src/Application.vala"
	_tmp18_ = g_cancellable_new ();
#line 345 "../src/Application.vala"
	_tmp19_ = _tmp18_;
#line 345 "../src/Application.vala"
	tuner_application_set_offline_cancel (self, _tmp19_);
#line 345 "../src/Application.vala"
	_g_object_unref0 (_tmp19_);
#line 346 "../src/Application.vala"
	_tmp20_ = tuner_application_NETMON;
#line 346 "../src/Application.vala"
	g_signal_connect_object (_tmp20_, "network-changed", (GCallback) __tuner_application___lambda97__g_network_monitor_network_changed, self, 0);
#line 349 "../src/Application.vala"
	_tmp21_ = tuner_application_NETMON;
#line 349 "../src/Application.vala"
	tuner_application_set_is_online (self, g_network_monitor_get_network_available (_tmp21_));
#line 350 "../src/Application.vala"
	_tmp22_ = tuner_application_get_is_online (self);
#line 350 "../src/Application.vala"
	_tmp23_ = _tmp22_;
#line 350 "../src/Application.vala"
	tuner_application_set_is_offline (self, !_tmp23_);
#line 356 "../src/Application.vala"
	_tmp24_ = tuner_settings_new ();
#line 356 "../src/Application.vala"
	_tmp25_ = _tmp24_;
#line 356 "../src/Application.vala"
	tuner_application_set_settings (self, _tmp25_);
#line 356 "../src/Application.vala"
	_g_object_unref0 (_tmp25_);
#line 357 "../src/Application.vala"
	_tmp26_ = tuner_data_provider_radio_browser_new (NULL);
#line 357 "../src/Application.vala"
	_tmp27_ = _tmp26_;
#line 357 "../src/Application.vala"
	tuner_application_set_provider (self, (TunerDataProviderAPI*) _tmp27_);
#line 357 "../src/Application.vala"
	_g_object_unref0 (_tmp27_);
#line 358 "../src/Application.vala"
	_tmp28_ = tuner_player_controller_new ();
#line 358 "../src/Application.vala"
	_tmp29_ = _tmp28_;
#line 358 "../src/Application.vala"
	tuner_application_set_player (self, _tmp29_);
#line 358 "../src/Application.vala"
	_g_object_unref0 (_tmp29_);
#line 359 "../src/Application.vala"
	_tmp30_ = _starred_file;
#line 359 "../src/Application.vala"
	_tmp31_ = tuner_star_store_new (_tmp30_);
#line 359 "../src/Application.vala"
	_tmp32_ = _tmp31_;
#line 359 "../src/Application.vala"
	tuner_application_set_stars (self, _tmp32_);
#line 359 "../src/Application.vala"
	_g_object_unref0 (_tmp32_);
#line 360 "../src/Application.vala"
	_tmp33_ = self->priv->_provider;
#line 360 "../src/Application.vala"
	_tmp34_ = self->priv->_stars;
#line 360 "../src/Application.vala"
	_tmp35_ = tuner_directory_controller_new (_tmp33_, _tmp34_);
#line 360 "../src/Application.vala"
	_tmp36_ = _tmp35_;
#line 360 "../src/Application.vala"
	tuner_application_set_directory (self, _tmp36_);
#line 360 "../src/Application.vala"
	_g_object_unref0 (_tmp36_);
#line 362 "../src/Application.vala"
	g_action_map_add_action_entries ((GActionMap*) self, TUNER_APPLICATION_ACTION_ENTRIES, (gint) G_N_ELEMENTS (TUNER_APPLICATION_ACTION_ENTRIES), self);
#line 367 "../src/Application.vala"
	_tmp37_ = self->priv->_player;
#line 367 "../src/Application.vala"
	g_signal_connect_object (_tmp37_, "state-changed-sig", (GCallback) __tuner_application___lambda103__tuner_player_controller_state_changed_sig, self, 0);
#line 378 "../src/Application.vala"
	_tmp38_ = self->priv->_player;
#line 378 "../src/Application.vala"
	g_signal_connect_object (_tmp38_, "tape-counter-sig", (GCallback) __tuner_application___lambda104__tuner_player_controller_tape_counter_sig, self, 0);
#line 316 "../src/Application.vala"
	_g_object_unref0 (_starred_file);
#line 316 "../src/Application.vala"
	_g_object_unref0 (_favorites_file);
#line 316 "../src/Application.vala"
	return obj;
#line 2520 "Application.c"
}

static void
tuner_application_class_init (TunerApplicationClass * klass,
                              gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeTreeSet* _tmp2_;
	GNetworkMonitor* _tmp3_;
	GNetworkMonitor* _tmp4_;
	GtkCssProvider* _tmp5_;
	GeeCollection* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 168 "../src/Application.vala"
	tuner_application_parent_class = g_type_class_peek_parent (klass);
#line 168 "../src/Application.vala"
	g_type_class_adjust_private_offset (klass, &TunerApplication_private_offset);
#line 168 "../src/Application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) tuner_application_real_activate;
#line 168 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_application_get_property;
#line 168 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_application_set_property;
#line 168 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->constructor = tuner_application_constructor;
#line 168 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_application_finalize;
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_LANGUAGE_PROPERTY, tuner_application_properties[TUNER_APPLICATION_LANGUAGE_PROPERTY] = g_param_spec_string ("language", "language", "language", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2551 "Application.c"
	/** @brief Application settings */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_SETTINGS_PROPERTY, tuner_application_properties[TUNER_APPLICATION_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", TUNER_TYPE_SETTINGS, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2555 "Application.c"
	/** @brief Player controller */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_PLAYER_PROPERTY, tuner_application_properties[TUNER_APPLICATION_PLAYER_PROPERTY] = g_param_spec_object ("player", "player", "player", TUNER_TYPE_PLAYER_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2559 "Application.c"
	/** @brief Player controller */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_DIRECTORY_PROPERTY, tuner_application_properties[TUNER_APPLICATION_DIRECTORY_PROPERTY] = g_param_spec_object ("directory", "directory", "directory", TUNER_TYPE_DIRECTORY_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2563 "Application.c"
	/** @brief Player controller */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_STARS_PROPERTY, tuner_application_properties[TUNER_APPLICATION_STARS_PROPERTY] = g_param_spec_object ("stars", "stars", "stars", TUNER_TYPE_STAR_STORE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2567 "Application.c"
	/** @brief API DataProvider */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_PROVIDER_PROPERTY, tuner_application_properties[TUNER_APPLICATION_PROVIDER_PROPERTY] = g_param_spec_object ("provider", "provider", "provider", TUNER_DATA_PROVIDER_TYPE_API, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2571 "Application.c"
	/** @brief Cache directory path */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_CACHE_DIR_PROPERTY, tuner_application_properties[TUNER_APPLICATION_CACHE_DIR_PROPERTY] = g_param_spec_string ("cache-dir", "cache-dir", "cache-dir", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2575 "Application.c"
	/** @brief Data directory path */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_DATA_DIR_PROPERTY, tuner_application_properties[TUNER_APPLICATION_DATA_DIR_PROPERTY] = g_param_spec_string ("data-dir", "data-dir", "data-dir", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_OFFLINE_CANCEL_PROPERTY, tuner_application_properties[TUNER_APPLICATION_OFFLINE_CANCEL_PROPERTY] = g_param_spec_object ("offline-cancel", "offline-cancel", "offline-cancel", g_cancellable_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2581 "Application.c"
	/** @brief Are we online */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_IS_OFFLINE_PROPERTY, tuner_application_properties[TUNER_APPLICATION_IS_OFFLINE_PROPERTY] = g_param_spec_boolean ("is-offline", "is-offline", "is-offline", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_IS_ONLINE_PROPERTY, tuner_application_properties[TUNER_APPLICATION_IS_ONLINE_PROPERTY] = g_param_spec_boolean ("is-online", "is-online", "is-online", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2587 "Application.c"
	/** @brief Main application window */
#line 168 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_APPLICATION_WINDOW_PROPERTY, tuner_application_properties[TUNER_APPLICATION_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", TUNER_TYPE_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2591 "Application.c"
	/** @brief Signal emitted when the shuffle mode changes   */
#line 168 "../src/Application.vala"
	tuner_application_signals[TUNER_APPLICATION_SHUFFLE_MODE_SIG_SIGNAL] = g_signal_new ("shuffle-mode-sig", TUNER_TYPE_APPLICATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 175 "../src/Application.vala"
	_tmp0_ = g_strdup ("unset");
#line 175 "../src/Application.vala"
	tuner_application_GTK_SYSTEM_THEME = _tmp0_;
#line 176 "../src/Application.vala"
	_tmp1_ = g_strdup ("LANGUAGE");
#line 176 "../src/Application.vala"
	tuner_application_ENV_LANG = _tmp1_;
#line 196 "../src/Application.vala"
	_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 196 "../src/Application.vala"
	tuner_application_LANGUAGES = (GeeCollection*) _tmp2_;
#line 199 "../src/Application.vala"
	_tmp3_ = g_network_monitor_get_default ();
#line 199 "../src/Application.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 199 "../src/Application.vala"
	tuner_application_NETMON = _tmp4_;
#line 201 "../src/Application.vala"
	_tmp5_ = gtk_css_provider_new ();
#line 201 "../src/Application.vala"
	tuner_application_CSSPROVIDER = _tmp5_;
#line 208 "../src/Application.vala"
	setlocale (LC_ALL, "");
#line 209 "../src/Application.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 210 "../src/Application.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 211 "../src/Application.vala"
	textdomain (GETTEXT_PACKAGE);
#line 212 "../src/Application.vala"
	_tmp6_ = tuner_application_LANGUAGES;
#line 212 "../src/Application.vala"
	gee_collection_add (_tmp6_, "en");
#line 2629 "Application.c"
	{
		GFile* dir = NULL;
		GFile* _tmp7_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp8_;
		GFileEnumerator* _tmp9_;
		GFileInfo* info = NULL;
#line 215 "../src/Application.vala"
		_tmp7_ = g_file_new_for_path (LOCALEDIR);
#line 215 "../src/Application.vala"
		dir = _tmp7_;
#line 216 "../src/Application.vala"
		_tmp8_ = dir;
#line 216 "../src/Application.vala"
		_tmp9_ = g_file_enumerate_children (_tmp8_, "standard::*", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 216 "../src/Application.vala"
		enumerator = _tmp9_;
#line 216 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../src/Application.vala"
			_g_object_unref0 (dir);
#line 2651 "Application.c"
			goto __catch0_g_error;
		}
#line 218 "../src/Application.vala"
		while (TRUE) {
#line 2656 "Application.c"
			GFileInfo* _tmp10_ = NULL;
			GFileEnumerator* _tmp11_;
			GFileInfo* _tmp12_;
			GFileInfo* _tmp13_;
			GFileInfo* _tmp14_;
			gboolean _tmp15_ = FALSE;
			GFileInfo* _tmp16_;
#line 218 "../src/Application.vala"
			_tmp11_ = enumerator;
#line 218 "../src/Application.vala"
			_tmp12_ = g_file_enumerator_next_file (_tmp11_, NULL, &_inner_error0_);
#line 218 "../src/Application.vala"
			_tmp10_ = _tmp12_;
#line 218 "../src/Application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "../src/Application.vala"
				_g_object_unref0 (info);
#line 218 "../src/Application.vala"
				_g_object_unref0 (enumerator);
#line 218 "../src/Application.vala"
				_g_object_unref0 (dir);
#line 2678 "Application.c"
				goto __catch0_g_error;
			}
#line 218 "../src/Application.vala"
			_tmp13_ = _tmp10_;
#line 218 "../src/Application.vala"
			_tmp10_ = NULL;
#line 218 "../src/Application.vala"
			_g_object_unref0 (info);
#line 218 "../src/Application.vala"
			info = _tmp13_;
#line 218 "../src/Application.vala"
			_tmp14_ = info;
#line 218 "../src/Application.vala"
			if (!(_tmp14_ != NULL)) {
#line 218 "../src/Application.vala"
				_g_object_unref0 (_tmp10_);
#line 218 "../src/Application.vala"
				break;
#line 2697 "Application.c"
			}
#line 220 "../src/Application.vala"
			_tmp16_ = info;
#line 220 "../src/Application.vala"
			if (g_file_info_get_file_type (_tmp16_) == G_FILE_TYPE_DIRECTORY) {
#line 2703 "Application.c"
				GFileInfo* _tmp17_;
				const gchar* _tmp18_;
#line 220 "../src/Application.vala"
				_tmp17_ = info;
#line 220 "../src/Application.vala"
				_tmp18_ = g_file_info_get_name (_tmp17_);
#line 220 "../src/Application.vala"
				_tmp15_ = g_strcmp0 (_tmp18_, "C") != 0;
#line 2712 "Application.c"
			} else {
#line 220 "../src/Application.vala"
				_tmp15_ = FALSE;
#line 2716 "Application.c"
			}
#line 220 "../src/Application.vala"
			if (_tmp15_) {
#line 2720 "Application.c"
				GFile* lang_dir = NULL;
				GFile* _tmp19_;
				GFileInfo* _tmp20_;
				const gchar* _tmp21_;
				GFile* _tmp22_;
				GFile* mo_file = NULL;
				GFile* _tmp23_;
				GFile* _tmp24_;
				GFile* _tmp25_;
				GFile* _tmp26_;
				GFile* _tmp27_;
				GFile* _tmp28_;
#line 222 "../src/Application.vala"
				_tmp19_ = dir;
#line 222 "../src/Application.vala"
				_tmp20_ = info;
#line 222 "../src/Application.vala"
				_tmp21_ = g_file_info_get_name (_tmp20_);
#line 222 "../src/Application.vala"
				_tmp22_ = g_file_get_child (_tmp19_, _tmp21_);
#line 222 "../src/Application.vala"
				lang_dir = _tmp22_;
#line 223 "../src/Application.vala"
				_tmp23_ = lang_dir;
#line 223 "../src/Application.vala"
				_tmp24_ = g_file_get_child (_tmp23_, "LC_MESSAGES");
#line 223 "../src/Application.vala"
				_tmp25_ = _tmp24_;
#line 223 "../src/Application.vala"
				_tmp26_ = g_file_get_child (_tmp25_, GETTEXT_PACKAGE ".mo");
#line 223 "../src/Application.vala"
				_tmp27_ = _tmp26_;
#line 223 "../src/Application.vala"
				_g_object_unref0 (_tmp25_);
#line 223 "../src/Application.vala"
				mo_file = _tmp27_;
#line 224 "../src/Application.vala"
				_tmp28_ = mo_file;
#line 224 "../src/Application.vala"
				if (g_file_query_exists (_tmp28_, NULL)) {
#line 2761 "Application.c"
					GeeCollection* _tmp29_;
					GFileInfo* _tmp30_;
					const gchar* _tmp31_;
#line 224 "../src/Application.vala"
					_tmp29_ = tuner_application_LANGUAGES;
#line 224 "../src/Application.vala"
					_tmp30_ = info;
#line 224 "../src/Application.vala"
					_tmp31_ = g_file_info_get_name (_tmp30_);
#line 224 "../src/Application.vala"
					gee_collection_add (_tmp29_, _tmp31_);
#line 2773 "Application.c"
				}
#line 220 "../src/Application.vala"
				_g_object_unref0 (mo_file);
#line 220 "../src/Application.vala"
				_g_object_unref0 (lang_dir);
#line 2779 "Application.c"
			}
#line 218 "../src/Application.vala"
			_g_object_unref0 (_tmp10_);
#line 2783 "Application.c"
		}
#line 213 "../src/Application.vala"
		_g_object_unref0 (info);
#line 213 "../src/Application.vala"
		_g_object_unref0 (enumerator);
#line 213 "../src/Application.vala"
		_g_object_unref0 (dir);
#line 2791 "Application.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
#line 213 "../src/Application.vala"
		e = _inner_error0_;
#line 213 "../src/Application.vala"
		_inner_error0_ = NULL;
#line 228 "../src/Application.vala"
		_tmp32_ = e;
#line 228 "../src/Application.vala"
		_tmp33_ = _tmp32_->message;
#line 228 "../src/Application.vala"
		_tmp34_ = string_to_string (_tmp33_);
#line 228 "../src/Application.vala"
		_tmp35_ = g_strconcat ("Error reading locale path: ", _tmp34_, NULL);
#line 228 "../src/Application.vala"
		_tmp36_ = _tmp35_;
#line 228 "../src/Application.vala"
		g_warning ("Application.vala:228: %s", _tmp36_);
#line 228 "../src/Application.vala"
		_g_free0 (_tmp36_);
#line 213 "../src/Application.vala"
		_g_error_free0 (e);
#line 2822 "Application.c"
	}
	__finally0:
#line 213 "../src/Application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 213 "../src/Application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 213 "../src/Application.vala"
		g_clear_error (&_inner_error0_);
#line 2831 "Application.c"
	}
}

static void
tuner_application_instance_init (TunerApplication * self,
                                 gpointer klass)
{
#line 168 "../src/Application.vala"
	self->priv = tuner_application_get_instance_private (self);
#line 271 "../src/Application.vala"
	self->priv->_is_online = FALSE;
#line 298 "../src/Application.vala"
	self->priv->_monitor_changed_id = (guint) 0;
#line 299 "../src/Application.vala"
	self->priv->_has_started = FALSE;
#line 2847 "Application.c"
}

static void
tuner_application_finalize (GObject * obj)
{
	TunerApplication * self;
#line 168 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_APPLICATION, TunerApplication);
#line 245 "../src/Application.vala"
	_g_object_unref0 (self->priv->_settings);
#line 248 "../src/Application.vala"
	_g_object_unref0 (self->priv->_player);
#line 251 "../src/Application.vala"
	_g_object_unref0 (self->priv->_directory);
#line 254 "../src/Application.vala"
	_g_object_unref0 (self->priv->_stars);
#line 257 "../src/Application.vala"
	_g_object_unref0 (self->priv->_provider);
#line 260 "../src/Application.vala"
	_g_free0 (self->priv->_cache_dir);
#line 263 "../src/Application.vala"
	_g_free0 (self->priv->_data_dir);
#line 265 "../src/Application.vala"
	_g_object_unref0 (self->priv->_offline_cancel);
#line 290 "../src/Application.vala"
	_g_object_unref0 (self->priv->_window);
#line 168 "../src/Application.vala"
	G_OBJECT_CLASS (tuner_application_parent_class)->finalize (obj);
#line 2876 "Application.c"
}

/**
    * @class Application
    * @brief Main application class implementing core functionality
    * @ingroup Tuner
    * 
    * The Application class serves as the primary entry point and controller for the Tuner
    * application. It manages:
    * - Window creation and presentation
    * - Settings management
    * - Player control
    * - Directory structure
    * - DBus initialization
    * 
    * @note This class follows the singleton pattern, accessible via Application.instance
    */
static GType
tuner_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerApplication), 0, (GInstanceInitFunc) tuner_application_instance_init, NULL };
	GType tuner_application_type_id;
	tuner_application_type_id = g_type_register_static (gtk_application_get_type (), "TunerApplication", &g_define_type_info, 0);
	TunerApplication_private_offset = g_type_add_instance_private (tuner_application_type_id, sizeof (TunerApplicationPrivate));
	return tuner_application_type_id;
}

GType
tuner_application_get_type (void)
{
	static volatile gsize tuner_application_type_id__once = 0;
	if (g_once_init_enter (&tuner_application_type_id__once)) {
		GType tuner_application_type_id;
		tuner_application_type_id = tuner_application_get_type_once ();
		g_once_init_leave (&tuner_application_type_id__once, tuner_application_type_id);
	}
	return tuner_application_type_id__once;
}

static void
_vala_tuner_application_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	TunerApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_APPLICATION, TunerApplication);
#line 168 "../src/Application.vala"
	switch (property_id) {
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_LANGUAGE_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_string (value, tuner_application_get_language (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_SETTINGS_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_settings (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_PLAYER_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_player (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_DIRECTORY_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_directory (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_STARS_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_stars (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_PROVIDER_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_provider (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_CACHE_DIR_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_string (value, tuner_application_get_cache_dir (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_DATA_DIR_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_string (value, tuner_application_get_data_dir (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_OFFLINE_CANCEL_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_offline_cancel (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_IS_OFFLINE_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_boolean (value, tuner_application_get_is_offline (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_IS_ONLINE_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_boolean (value, tuner_application_get_is_online (self));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_WINDOW_PROPERTY:
#line 168 "../src/Application.vala"
		g_value_set_object (value, tuner_application_get_window (self));
#line 168 "../src/Application.vala"
		break;
#line 2998 "Application.c"
		default:
#line 168 "../src/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 168 "../src/Application.vala"
		break;
#line 3004 "Application.c"
	}
}

static void
_vala_tuner_application_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	TunerApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_APPLICATION, TunerApplication);
#line 168 "../src/Application.vala"
	switch (property_id) {
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_LANGUAGE_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_language (self, g_value_get_string (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_SETTINGS_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_settings (self, g_value_get_object (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_PLAYER_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_player (self, g_value_get_object (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_DIRECTORY_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_directory (self, g_value_get_object (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_STARS_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_stars (self, g_value_get_object (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_PROVIDER_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_provider (self, g_value_get_object (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_CACHE_DIR_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_cache_dir (self, g_value_get_string (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_DATA_DIR_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_data_dir (self, g_value_get_string (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_OFFLINE_CANCEL_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_offline_cancel (self, g_value_get_object (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_IS_OFFLINE_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_is_offline (self, g_value_get_boolean (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_IS_ONLINE_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_is_online (self, g_value_get_boolean (value));
#line 168 "../src/Application.vala"
		break;
#line 168 "../src/Application.vala"
		case TUNER_APPLICATION_WINDOW_PROPERTY:
#line 168 "../src/Application.vala"
		tuner_application_set_window (self, g_value_get_object (value));
#line 168 "../src/Application.vala"
		break;
#line 3090 "Application.c"
		default:
#line 168 "../src/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 168 "../src/Application.vala"
		break;
#line 3096 "Application.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

