/* DirectoryController.c generated by valac 0.56.17, the Vala compiler
 * generated from DirectoryController.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file DirectoryController.vala
 *
 * @brief Station Directories and their population
 *
 */
/**
     * @brief Get a collection of Station station by its stream URL. // TODO Not working at Provider
     *
     * @param uuid The URL of the station to load.
     * @return A StationSet object for the requested station.
     * @todo radio-browser should handle URL querys, but is broken
     */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gio/gio.h>
#include <gtk/gtk.h>

#define TUNER_DIRECTORY_CONTROLLER_DIRECTORY_LIMIT ((guint) 41)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SOURCE_ERROR (source_error_get_type ())

#define TUNER_TYPE_DIRECTORY_CONTROLLER (tuner_directory_controller_get_type ())
#define TUNER_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryController))
#define TUNER_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))
#define TUNER_IS_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_IS_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_DIRECTORY_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))

typedef struct _TunerDirectoryController TunerDirectoryController;
typedef struct _TunerDirectoryControllerClass TunerDirectoryControllerClass;
typedef struct _TunerDirectoryControllerPrivate TunerDirectoryControllerPrivate;

#define TUNER_DATA_PROVIDER_TYPE_API (tuner_data_provider_api_get_type ())
#define TUNER_DATA_PROVIDER_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPI))
#define TUNER_DATA_PROVIDER_IS_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_API))
#define TUNER_DATA_PROVIDER_API_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPIIface))

typedef struct _TunerDataProviderAPI TunerDataProviderAPI;
typedef struct _TunerDataProviderAPIIface TunerDataProviderAPIIface;

#define TUNER_DATA_PROVIDER_TYPE_TAG (tuner_data_provider_tag_get_type ())
#define TUNER_DATA_PROVIDER_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTag))
#define TUNER_DATA_PROVIDER_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))
#define TUNER_DATA_PROVIDER_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))

typedef struct _TunerDataProviderTag TunerDataProviderTag;
typedef struct _TunerDataProviderTagClass TunerDataProviderTagClass;

#define TUNER_DATA_PROVIDER_TYPE_DATA_ERROR (tuner_data_provider_data_error_get_type ())

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;

#define TUNER_DATA_PROVIDER_TYPE_SEARCH_PARAMS (tuner_data_provider_search_params_get_type ())
typedef struct _TunerDataProviderSearchParams TunerDataProviderSearchParams;
typedef enum  {
	TUNER_DATA_PROVIDER_SORT_ORDER_NAME,
	TUNER_DATA_PROVIDER_SORT_ORDER_URL,
	TUNER_DATA_PROVIDER_SORT_ORDER_HOMEPAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_FAVICON,
	TUNER_DATA_PROVIDER_SORT_ORDER_TAGS,
	TUNER_DATA_PROVIDER_SORT_ORDER_COUNTRY,
	TUNER_DATA_PROVIDER_SORT_ORDER_STATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LANGUAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_VOTES,
	TUNER_DATA_PROVIDER_SORT_ORDER_CODEC,
	TUNER_DATA_PROVIDER_SORT_ORDER_BITRATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKOK,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKTIME,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTIMESTAMP,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND,
	TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM
} TunerDataProviderSortOrder;

#define TUNER_DATA_PROVIDER_TYPE_SORT_ORDER (tuner_data_provider_sort_order_get_type ())
typedef enum  {
	TUNER_DATA_PROVIDER_API_STATUS_OK,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED,
	TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE,
	TUNER_DATA_PROVIDER_API_STATUS_UNKNOW_ERROR
} TunerDataProviderAPIStatus;

#define TUNER_DATA_PROVIDER_API_TYPE_STATUS (tuner_data_provider_api_status_get_type ())

#define TUNER_TYPE_STAR_STORE (tuner_star_store_get_type ())
#define TUNER_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STAR_STORE, TunerStarStore))
#define TUNER_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))
#define TUNER_IS_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STAR_STORE))
#define TUNER_IS_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STAR_STORE))
#define TUNER_STAR_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))

typedef struct _TunerStarStore TunerStarStore;
typedef struct _TunerStarStoreClass TunerStarStoreClass;
enum  {
	TUNER_DIRECTORY_CONTROLLER_0_PROPERTY,
	TUNER_DIRECTORY_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* tuner_directory_controller_properties[TUNER_DIRECTORY_CONTROLLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_STATION_SET (tuner_station_set_get_type ())
#define TUNER_STATION_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_SET, TunerStationSet))
#define TUNER_STATION_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_SET, TunerStationSetClass))
#define TUNER_IS_STATION_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_SET))
#define TUNER_IS_STATION_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_SET))
#define TUNER_STATION_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_SET, TunerStationSetClass))

typedef struct _TunerStationSet TunerStationSet;
typedef struct _TunerStationSetClass TunerStationSetClass;

#define TUNER_TYPE_SETTINGS (tuner_settings_get_type ())
#define TUNER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_SETTINGS, TunerSettings))
#define TUNER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_SETTINGS, TunerSettingsClass))
#define TUNER_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_SETTINGS))
#define TUNER_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_SETTINGS))
#define TUNER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_SETTINGS, TunerSettingsClass))

typedef struct _TunerSettings TunerSettings;
typedef struct _TunerSettingsClass TunerSettingsClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	TUNER_DIRECTORY_CONTROLLER_TAGS_UPDATED_SIGNAL,
	TUNER_DIRECTORY_CONTROLLER_NUM_SIGNALS
};
static guint tuner_directory_controller_signals[TUNER_DIRECTORY_CONTROLLER_NUM_SIGNALS] = {0};
typedef struct _TunerStationSetPrivate TunerStationSetPrivate;
enum  {
	TUNER_STATION_SET_0_PROPERTY,
	TUNER_STATION_SET_NUM_PROPERTIES
};
static GParamSpec* tuner_station_set_properties[TUNER_STATION_SET_NUM_PROPERTIES];
typedef struct _TunerStationSetNextPageAsyncData TunerStationSetNextPageAsyncData;
typedef struct _Block1Data Block1Data;

/**
 * @brief Error domain for source-related errors.
 */
typedef enum  {
	SOURCE_ERROR_UNAVAILABLE
} SourceError;
#define SOURCE_ERROR source_error_quark ()

struct _TunerDirectoryController {
	GObject parent_instance;
	TunerDirectoryControllerPrivate * priv;
};

struct _TunerDirectoryControllerClass {
	GObjectClass parent_class;
};

typedef enum  {
	TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA,
	TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION
} TunerDataProviderDataError;
#define TUNER_DATA_PROVIDER_DATA_ERROR tuner_data_provider_data_error_quark ()

struct _TunerDataProviderSearchParams {
	gchar* text;
	GeeSet* tags;
	GeeSet* uuids;
	gchar* countrycode;
	TunerDataProviderSortOrder order;
	gboolean reverse;
};

struct _TunerDataProviderAPIIface {
	GTypeInterface parent_iface;
	void (*clear_last_error) (TunerDataProviderAPI* self);
	gchar* (*name) (TunerDataProviderAPI* self);
	gint (*available_stations) (TunerDataProviderAPI* self);
	gint (*available_tags) (TunerDataProviderAPI* self);
	gboolean (*initialize) (TunerDataProviderAPI* self);
	void (*click) (TunerDataProviderAPI* self, const gchar* stationuuid);
	void (*vote) (TunerDataProviderAPI* self, const gchar* stationuuid);
	GeeSet* (*get_tags) (TunerDataProviderAPI* self, gint offset, gint limit, GError** error);
	GeeSet* (*by_uuid) (TunerDataProviderAPI* self, const gchar* uuids, GError** error);
	GeeSet* (*by_uuids) (TunerDataProviderAPI* self, GeeCollection* uuids, GError** error);
	GeeSet* (*search) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GError** error);
	void (*search_async) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeSet* (*search_finish) (TunerDataProviderAPI* self, GAsyncResult* _res_, GError** error);
	GError* (*get_last_data_error) (TunerDataProviderAPI* self);
	void (*set_last_data_error) (TunerDataProviderAPI* self, GError* value);
	TunerDataProviderAPIStatus (*get_status) (TunerDataProviderAPI* self);
	void (*set_status) (TunerDataProviderAPI* self, TunerDataProviderAPIStatus value);
};

struct _TunerDirectoryControllerPrivate {
	TunerDataProviderAPI* _provider;
	TunerStarStore* _star_store;
	gboolean _loaded;
};

struct _TunerStationSet {
	GObject parent_instance;
	TunerStationSetPrivate * priv;
};

struct _TunerStationSetClass {
	GObjectClass parent_class;
};

struct _TunerStationSetPrivate {
	guint _offset;
	guint _page_size;
	gboolean _more;
	TunerDataProviderSearchParams _params;
	TunerDataProviderAPI* _provider;
	TunerStarStore* _star_store;
};

struct _TunerStationSetNextPageAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerStationSet* self;
	GeeSet* result;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeSet* raw_stations;
	TunerDataProviderAPI* _tmp5_;
	TunerDataProviderSearchParams _tmp6_;
	GeeSet* _tmp7_;
	GeeIterator* filtered_stations;
	GeeSet* _tmp8_;
	GeeIterator* _tmp9_;
	GeeSet* stations;
	GeeIterator* _tmp10_;
	GeeSet* _tmp11_;
	GeeSet* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GeeSet* _tmp15_;
	GeeSet* _tmp16_;
	gint _tmp17_;
	gpointer* _tmp18_;
	TunerModelStation** _tmp19_;
	gint _tmp19__length1;
	TunerModelStation* _tmp20_;
	GError* _tmp21_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	TunerStationSet* self;
	TunerModelStation* station;
};

static gint TunerDirectoryController_private_offset;
static gpointer tuner_directory_controller_parent_class = NULL;
static gint TunerStationSet_private_offset;
static gpointer tuner_station_set_parent_class = NULL;

VALA_EXTERN GQuark source_error_quark (void);
VALA_EXTERN GType source_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_directory_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDirectoryController, g_object_unref)
VALA_EXTERN GType tuner_data_provider_tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderTag, g_object_unref)
VALA_EXTERN GQuark tuner_data_provider_data_error_quark (void);
VALA_EXTERN GType tuner_data_provider_data_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN GType tuner_data_provider_search_params_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_sort_order_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TunerDataProviderSearchParams* tuner_data_provider_search_params_dup (const TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_free (TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_copy (const TunerDataProviderSearchParams* self,
                                             TunerDataProviderSearchParams* dest);
VALA_EXTERN void tuner_data_provider_search_params_destroy (TunerDataProviderSearchParams* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TunerDataProviderSearchParams, tuner_data_provider_search_params_destroy)
VALA_EXTERN GType tuner_data_provider_api_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_api_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderAPI, g_object_unref)
VALA_EXTERN GType tuner_star_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStarStore, g_object_unref)
VALA_EXTERN gchar* tuner_directory_controller_provider_name (TunerDirectoryController* self);
VALA_EXTERN gchar* tuner_data_provider_api_name (TunerDataProviderAPI* self);
VALA_EXTERN TunerDirectoryController* tuner_directory_controller_new (TunerDataProviderAPI* provider,
                                                          TunerStarStore* star_store);
VALA_EXTERN TunerDirectoryController* tuner_directory_controller_construct (GType object_type,
                                                                TunerDataProviderAPI* provider,
                                                                TunerStarStore* star_store);
VALA_EXTERN gchar* tuner_directory_controller_provider (TunerDirectoryController* self);
VALA_EXTERN void tuner_directory_controller_load (TunerDirectoryController* self);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN gboolean tuner_application_get_is_offline (TunerApplication* self);
VALA_EXTERN gboolean tuner_data_provider_api_initialize (TunerDataProviderAPI* self);
VALA_EXTERN void tuner_star_store_load (TunerStarStore* self,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_);
VALA_EXTERN void tuner_star_store_load_finish (TunerStarStore* self,
                                   GAsyncResult* _res_);
VALA_EXTERN GeeSet* tuner_directory_controller_get_stations_by_uuid (TunerDirectoryController* self,
                                                         GeeCollection* uuids);
VALA_EXTERN GeeSet* tuner_data_provider_api_by_uuids (TunerDataProviderAPI* self,
                                          GeeCollection* uuids,
                                          GError** error);
VALA_EXTERN GType tuner_station_set_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationSet, g_object_unref)
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_station_uuid (TunerDirectoryController* self,
                                                               const gchar* uuid);
VALA_EXTERN TunerStationSet* tuner_station_set_new (guint limit,
                                        TunerDataProviderSearchParams* params,
                                        TunerDataProviderAPI* client,
                                        TunerStarStore* star_store);
VALA_EXTERN TunerStationSet* tuner_station_set_construct (GType object_type,
                                              guint limit,
                                              TunerDataProviderSearchParams* params,
                                              TunerDataProviderAPI* client,
                                              TunerStarStore* star_store);
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_random_stations (TunerDirectoryController* self,
                                                                  guint limit);
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_trending_stations (TunerDirectoryController* self,
                                                                    guint limit);
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_popular_stations (TunerDirectoryController* self,
                                                                   guint limit);
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_by_country (TunerDirectoryController* self,
                                                             guint limit,
                                                             const gchar* countrycode);
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_search_stations (TunerDirectoryController* self,
                                                                  const gchar* utext,
                                                                  guint limit);
VALA_EXTERN GeeCollection* tuner_directory_controller_get_starred (TunerDirectoryController* self);
VALA_EXTERN GeeCollection* tuner_star_store_get_all_stations (TunerStarStore* self);
VALA_EXTERN TunerStationSet* tuner_directory_controller_add_saved_search (TunerDirectoryController* self,
                                                              const gchar* search_term);
VALA_EXTERN void tuner_star_store_add_saved_search (TunerStarStore* self,
                                        const gchar* search_text);
VALA_EXTERN void tuner_directory_controller_remove_saved_search (TunerDirectoryController* self,
                                                     const gchar* search_text);
VALA_EXTERN void tuner_star_store_remove_saved_search (TunerStarStore* self,
                                           const gchar* search_text);
VALA_EXTERN GeeMap* tuner_directory_controller_load_saved_searches (TunerDirectoryController* self);
VALA_EXTERN GeeSet* tuner_star_store_get_all_searches (TunerStarStore* self);
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_by_tag (TunerDirectoryController* self,
                                                         const gchar* utag);
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_by_tag_set (TunerDirectoryController* self,
                                                             GeeSet* utags);
VALA_EXTERN void tuner_directory_controller_count_station_click (TunerDirectoryController* self,
                                                     TunerModelStation* station);
VALA_EXTERN GType tuner_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerSettings, g_object_unref)
VALA_EXTERN TunerSettings* tuner_application_get_settings (TunerApplication* self);
VALA_EXTERN gboolean tuner_settings_get_do_not_vote (TunerSettings* self);
VALA_EXTERN const gchar* tuner_model_station_get_stationuuid (TunerModelStation* self);
VALA_EXTERN void tuner_data_provider_api_click (TunerDataProviderAPI* self,
                                    const gchar* stationuuid);
VALA_EXTERN void tuner_directory_controller_load_tags (TunerDirectoryController* self);
VALA_EXTERN GeeSet* tuner_data_provider_api_get_tags (TunerDataProviderAPI* self,
                                          gint offset,
                                          gint limit,
                                          GError** error);
VALA_EXTERN GeeSet* tuner_directory_controller_load_random_genres (TunerDirectoryController* self,
                                                       gint genres);
VALA_EXTERN gboolean tuner_application_get_is_online (TunerApplication* self);
VALA_EXTERN gint tuner_data_provider_api_available_tags (TunerDataProviderAPI* self);
static void tuner_directory_controller_finalize (GObject * obj);
static GType tuner_directory_controller_get_type_once (void);
VALA_EXTERN GeeSet* tuner_station_set_next_page (TunerStationSet* self,
                                     GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_search (TunerDataProviderAPI* self,
                                        TunerDataProviderSearchParams* params,
                                        guint rowcount,
                                        guint offset,
                                        GError** error);
static GeeSet* tuner_station_set_convert_stations (TunerStationSet* self,
                                            GeeIterator* raw_stations);
static void tuner_station_set_next_page_async_data_free (gpointer _data);
VALA_EXTERN void tuner_station_set_next_page_async (TunerStationSet* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN GeeSet* tuner_station_set_next_page_finish (TunerStationSet* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static gboolean tuner_station_set_next_page_async_co (TunerStationSetNextPageAsyncData* _data_);
VALA_EXTERN void tuner_data_provider_api_search_async (TunerDataProviderAPI* self,
                                           TunerDataProviderSearchParams* params,
                                           guint rowcount,
                                           guint offset,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN GeeSet* tuner_data_provider_api_search_finish (TunerDataProviderAPI* self,
                                               GAsyncResult* _res_,
                                               GError** error);
static void tuner_station_set_next_page_async_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
VALA_EXTERN gboolean tuner_station_set_has_more (TunerStationSet* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void ___lambda65_ (Block1Data* _data1_);
VALA_EXTERN void tuner_star_store_update_from_station (TunerStarStore* self,
                                           TunerModelStation* station);
static void ____lambda65__tuner_model_station_station_star_changed_sig (TunerModelStation* _sender,
                                                                 gboolean starred,
                                                                 gpointer self);
static void tuner_station_set_finalize (GObject * obj);
static GType tuner_station_set_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

GQuark
source_error_quark (void)
{
	return g_quark_from_static_string ("source-error-quark");
}

static GType
source_error_get_type_once (void)
{
	static const GEnumValue values[] = {{SOURCE_ERROR_UNAVAILABLE, "SOURCE_ERROR_UNAVAILABLE", "unavailable"}, {0, NULL, NULL}};
	GType source_error_type_id;
	source_error_type_id = g_enum_register_static ("SourceError", values);
	return source_error_type_id;
}

GType
source_error_get_type (void)
{
	static volatile gsize source_error_type_id__once = 0;
	if (g_once_init_enter (&source_error_type_id__once)) {
		GType source_error_type_id;
		source_error_type_id = source_error_get_type_once ();
		g_once_init_leave (&source_error_type_id__once, source_error_type_id);
	}
	return source_error_type_id__once;
}

static inline gpointer
tuner_directory_controller_get_instance_private (TunerDirectoryController* self)
{
	return G_STRUCT_MEMBER_P (self, TunerDirectoryController_private_offset);
}

gchar*
tuner_directory_controller_provider_name (TunerDirectoryController* self)
{
	TunerDataProviderAPI* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 42 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = self->priv->_provider;
#line 44 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = tuner_data_provider_api_name (_tmp0_);
#line 44 "../src/Controllers/DirectoryController.vala"
	result = _tmp1_;
#line 44 "../src/Controllers/DirectoryController.vala"
	return result;
#line 528 "DirectoryController.c"
}

/**
     * @brief Constructor for DirectoryController.
     *
     * @param store The StationStore to use for managing stations.
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 54 "../src/Controllers/DirectoryController.vala"
	return self ? g_object_ref (self) : NULL;
#line 541 "DirectoryController.c"
}

TunerDirectoryController*
tuner_directory_controller_construct (GType object_type,
                                      TunerDataProviderAPI* provider,
                                      TunerStarStore* star_store)
{
	TunerDirectoryController * self = NULL;
	TunerDataProviderAPI* _tmp0_;
	TunerStarStore* _tmp1_;
#line 52 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (provider != NULL, NULL);
#line 52 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (star_store != NULL, NULL);
#line 53 "../src/Controllers/DirectoryController.vala"
	self = (TunerDirectoryController*) g_object_new (object_type, NULL);
#line 54 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = _g_object_ref0 (provider);
#line 54 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (self->priv->_provider);
#line 54 "../src/Controllers/DirectoryController.vala"
	self->priv->_provider = _tmp0_;
#line 55 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = _g_object_ref0 (star_store);
#line 55 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (self->priv->_star_store);
#line 55 "../src/Controllers/DirectoryController.vala"
	self->priv->_star_store = _tmp1_;
#line 52 "../src/Controllers/DirectoryController.vala"
	return self;
#line 572 "DirectoryController.c"
}

TunerDirectoryController*
tuner_directory_controller_new (TunerDataProviderAPI* provider,
                                TunerStarStore* star_store)
{
#line 52 "../src/Controllers/DirectoryController.vala"
	return tuner_directory_controller_construct (TUNER_TYPE_DIRECTORY_CONTROLLER, provider, star_store);
#line 581 "DirectoryController.c"
}

gchar*
tuner_directory_controller_provider (TunerDirectoryController* self)
{
	TunerDataProviderAPI* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 59 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = self->priv->_provider;
#line 61 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = tuner_data_provider_api_name (_tmp0_);
#line 61 "../src/Controllers/DirectoryController.vala"
	result = _tmp1_;
#line 61 "../src/Controllers/DirectoryController.vala"
	return result;
#line 600 "DirectoryController.c"
}

/**
* @brief Initializes the provider and starts the load of Saved Stations
*
*/
void
tuner_directory_controller_load (TunerDirectoryController* self)
{
	gboolean _tmp0_ = FALSE;
	TunerDataProviderAPI* _tmp5_;
	TunerStarStore* _tmp6_;
#line 68 "../src/Controllers/DirectoryController.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/Controllers/DirectoryController.vala"
	if (self->priv->_loaded) {
#line 70 "../src/Controllers/DirectoryController.vala"
		_tmp0_ = TRUE;
#line 619 "DirectoryController.c"
	} else {
		TunerApplication* _tmp1_;
		TunerApplication* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 70 "../src/Controllers/DirectoryController.vala"
		_tmp1_ = tuner_app ();
#line 70 "../src/Controllers/DirectoryController.vala"
		_tmp2_ = _tmp1_;
#line 70 "../src/Controllers/DirectoryController.vala"
		_tmp3_ = tuner_application_get_is_offline (_tmp2_);
#line 70 "../src/Controllers/DirectoryController.vala"
		_tmp4_ = _tmp3_;
#line 70 "../src/Controllers/DirectoryController.vala"
		_tmp0_ = _tmp4_;
#line 70 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (_tmp2_);
#line 637 "DirectoryController.c"
	}
#line 70 "../src/Controllers/DirectoryController.vala"
	if (_tmp0_) {
#line 71 "../src/Controllers/DirectoryController.vala"
		return;
#line 643 "DirectoryController.c"
	}
#line 73 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = self->priv->_provider;
#line 73 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_api_initialize (_tmp5_);
#line 74 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = self->priv->_star_store;
#line 74 "../src/Controllers/DirectoryController.vala"
	tuner_star_store_load (_tmp6_, NULL, NULL);
#line 75 "../src/Controllers/DirectoryController.vala"
	self->priv->_loaded = TRUE;
#line 655 "DirectoryController.c"
}

/**
* @brief Get a collection of Station station by its UUID.
*
* @param uuid The UUID of the station to load.
* @return A StationSet object for the requested station.
* @todo radio-browser should handle multiple UUID on a query, but is broken
*/
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 675 "DirectoryController.c"
}

GeeSet*
tuner_directory_controller_get_stations_by_uuid (TunerDirectoryController* self,
                                                 GeeCollection* uuids)
{
	GeeHashSet* _tmp10_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 86 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (uuids != NULL, NULL);
#line 689 "DirectoryController.c"
	{
		GeeSet* _tmp0_ = NULL;
		TunerDataProviderAPI* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
#line 90 "../src/Controllers/DirectoryController.vala"
		_tmp1_ = self->priv->_provider;
#line 90 "../src/Controllers/DirectoryController.vala"
		_tmp2_ = tuner_data_provider_api_by_uuids (_tmp1_, uuids, &_inner_error0_);
#line 90 "../src/Controllers/DirectoryController.vala"
		_tmp0_ = _tmp2_;
#line 90 "../src/Controllers/DirectoryController.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../src/Controllers/DirectoryController.vala"
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 705 "DirectoryController.c"
				goto __catch0_tuner_data_provider_data_error;
			}
#line 90 "../src/Controllers/DirectoryController.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../src/Controllers/DirectoryController.vala"
			g_clear_error (&_inner_error0_);
#line 90 "../src/Controllers/DirectoryController.vala"
			return NULL;
#line 714 "DirectoryController.c"
		}
#line 90 "../src/Controllers/DirectoryController.vala"
		_tmp3_ = _tmp0_;
#line 90 "../src/Controllers/DirectoryController.vala"
		_tmp0_ = NULL;
#line 90 "../src/Controllers/DirectoryController.vala"
		result = _tmp3_;
#line 90 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (_tmp0_);
#line 90 "../src/Controllers/DirectoryController.vala"
		return result;
#line 726 "DirectoryController.c"
	}
	goto __finally0;
	__catch0_tuner_data_provider_data_error:
	{
		TunerDataProviderAPI* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 88 "../src/Controllers/DirectoryController.vala"
		g_clear_error (&_inner_error0_);
#line 93 "../src/Controllers/DirectoryController.vala"
		_tmp4_ = self->priv->_provider;
#line 93 "../src/Controllers/DirectoryController.vala"
		_tmp5_ = tuner_data_provider_api_name (_tmp4_);
#line 93 "../src/Controllers/DirectoryController.vala"
		_tmp6_ = _tmp5_;
#line 93 "../src/Controllers/DirectoryController.vala"
		_tmp7_ = string_to_string (_tmp6_);
#line 93 "../src/Controllers/DirectoryController.vala"
		_tmp8_ = g_strconcat (_tmp7_, " unavailable", NULL);
#line 93 "../src/Controllers/DirectoryController.vala"
		_tmp9_ = _tmp8_;
#line 93 "../src/Controllers/DirectoryController.vala"
		g_critical ("DirectoryController.vala:93: %s", _tmp9_);
#line 93 "../src/Controllers/DirectoryController.vala"
		_g_free0 (_tmp9_);
#line 93 "../src/Controllers/DirectoryController.vala"
		_g_free0 (_tmp6_);
#line 757 "DirectoryController.c"
	}
	__finally0:
#line 88 "../src/Controllers/DirectoryController.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 88 "../src/Controllers/DirectoryController.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 88 "../src/Controllers/DirectoryController.vala"
		g_clear_error (&_inner_error0_);
#line 88 "../src/Controllers/DirectoryController.vala"
		return NULL;
#line 768 "DirectoryController.c"
	}
#line 95 "../src/Controllers/DirectoryController.vala"
	_tmp10_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 95 "../src/Controllers/DirectoryController.vala"
	result = (GeeSet*) _tmp10_;
#line 95 "../src/Controllers/DirectoryController.vala"
	return result;
#line 776 "DirectoryController.c"
}

/**
* @brief Load a station by its UUID.
*
* @param uuid The UUID of the station to load.
* @return A StationSet object for the requested station.
*/
TunerStationSet*
tuner_directory_controller_load_station_uuid (TunerDirectoryController* self,
                                              const gchar* uuid)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	TunerDataProviderSearchParams params = {0};
	GeeHashSet* _tmp3_;
	TunerDataProviderSearchParams _tmp4_ = {0};
	TunerDataProviderSearchParams _tmp5_;
	GeeSet* _tmp6_;
	TunerStationSet* source = NULL;
	TunerDataProviderSearchParams _tmp7_;
	TunerDataProviderAPI* _tmp8_;
	TunerStarStore* _tmp9_;
	TunerStationSet* _tmp10_;
	TunerStationSet* result;
#line 122 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 124 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = string_to_string (uuid);
#line 124 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = g_strconcat ("LBU UUID: ", _tmp0_, " ", NULL);
#line 124 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = _tmp1_;
#line 124 "../src/Controllers/DirectoryController.vala"
	g_debug ("DirectoryController.vala:124: %s", _tmp2_);
#line 124 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp2_);
#line 125 "../src/Controllers/DirectoryController.vala"
	_tmp3_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 125 "../src/Controllers/DirectoryController.vala"
	memset (&_tmp4_, 0, sizeof (TunerDataProviderSearchParams));
#line 125 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp4_.uuids);
#line 125 "../src/Controllers/DirectoryController.vala"
	_tmp4_.uuids = (GeeSet*) _tmp3_;
#line 125 "../src/Controllers/DirectoryController.vala"
	params = _tmp4_;
#line 129 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = params;
#line 129 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = _tmp5_.uuids;
#line 129 "../src/Controllers/DirectoryController.vala"
	gee_collection_add ((GeeCollection*) _tmp6_, uuid);
#line 130 "../src/Controllers/DirectoryController.vala"
	_tmp7_ = params;
#line 130 "../src/Controllers/DirectoryController.vala"
	_tmp8_ = self->priv->_provider;
#line 130 "../src/Controllers/DirectoryController.vala"
	_tmp9_ = self->priv->_star_store;
#line 130 "../src/Controllers/DirectoryController.vala"
	_tmp10_ = tuner_station_set_new ((guint) 1, &_tmp7_, _tmp8_, _tmp9_);
#line 130 "../src/Controllers/DirectoryController.vala"
	source = _tmp10_;
#line 131 "../src/Controllers/DirectoryController.vala"
	result = source;
#line 131 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&params);
#line 131 "../src/Controllers/DirectoryController.vala"
	return result;
#line 849 "DirectoryController.c"
}

/**
* @brief Load a set of random stations.
*
* @param limit The maximum number of stations to load.
* @return A StationSet object with random stations.
*/
TunerStationSet*
tuner_directory_controller_load_random_stations (TunerDirectoryController* self,
                                                 guint limit)
{
	TunerDataProviderSearchParams params = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeHashSet* _tmp2_;
	TunerDataProviderSearchParams _tmp3_ = {0};
	TunerStationSet* source = NULL;
	TunerDataProviderSearchParams _tmp4_;
	TunerDataProviderAPI* _tmp5_;
	TunerStarStore* _tmp6_;
	TunerStationSet* _tmp7_;
	TunerStationSet* result;
#line 141 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 143 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = g_strdup ("");
#line 143 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = g_strdup ("");
#line 143 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 143 "../src/Controllers/DirectoryController.vala"
	memset (&_tmp3_, 0, sizeof (TunerDataProviderSearchParams));
#line 143 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.text);
#line 143 "../src/Controllers/DirectoryController.vala"
	_tmp3_.text = _tmp0_;
#line 143 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.countrycode);
#line 143 "../src/Controllers/DirectoryController.vala"
	_tmp3_.countrycode = _tmp1_;
#line 143 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp3_.tags);
#line 143 "../src/Controllers/DirectoryController.vala"
	_tmp3_.tags = (GeeSet*) _tmp2_;
#line 143 "../src/Controllers/DirectoryController.vala"
	_tmp3_.order = TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM;
#line 143 "../src/Controllers/DirectoryController.vala"
	params = _tmp3_;
#line 149 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = params;
#line 149 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = self->priv->_provider;
#line 149 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = self->priv->_star_store;
#line 149 "../src/Controllers/DirectoryController.vala"
	_tmp7_ = tuner_station_set_new (limit, &_tmp4_, _tmp5_, _tmp6_);
#line 149 "../src/Controllers/DirectoryController.vala"
	source = _tmp7_;
#line 150 "../src/Controllers/DirectoryController.vala"
	result = source;
#line 150 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&params);
#line 150 "../src/Controllers/DirectoryController.vala"
	return result;
#line 915 "DirectoryController.c"
}

/**
* @brief Load trending stations.
*
* @param limit The maximum number of stations to load.
* @return A StationSet object with trending stations.
*/
TunerStationSet*
tuner_directory_controller_load_trending_stations (TunerDirectoryController* self,
                                                   guint limit)
{
	TunerDataProviderSearchParams params = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeHashSet* _tmp2_;
	TunerDataProviderSearchParams _tmp3_ = {0};
	TunerStationSet* source = NULL;
	TunerDataProviderSearchParams _tmp4_;
	TunerDataProviderAPI* _tmp5_;
	TunerStarStore* _tmp6_;
	TunerStationSet* _tmp7_;
	TunerStationSet* result;
#line 160 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 162 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = g_strdup ("");
#line 162 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = g_strdup ("");
#line 162 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 162 "../src/Controllers/DirectoryController.vala"
	memset (&_tmp3_, 0, sizeof (TunerDataProviderSearchParams));
#line 162 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.text);
#line 162 "../src/Controllers/DirectoryController.vala"
	_tmp3_.text = _tmp0_;
#line 162 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.countrycode);
#line 162 "../src/Controllers/DirectoryController.vala"
	_tmp3_.countrycode = _tmp1_;
#line 162 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp3_.tags);
#line 162 "../src/Controllers/DirectoryController.vala"
	_tmp3_.tags = (GeeSet*) _tmp2_;
#line 162 "../src/Controllers/DirectoryController.vala"
	_tmp3_.order = TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND;
#line 162 "../src/Controllers/DirectoryController.vala"
	_tmp3_.reverse = TRUE;
#line 162 "../src/Controllers/DirectoryController.vala"
	params = _tmp3_;
#line 169 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = params;
#line 169 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = self->priv->_provider;
#line 169 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = self->priv->_star_store;
#line 169 "../src/Controllers/DirectoryController.vala"
	_tmp7_ = tuner_station_set_new (limit, &_tmp4_, _tmp5_, _tmp6_);
#line 169 "../src/Controllers/DirectoryController.vala"
	source = _tmp7_;
#line 170 "../src/Controllers/DirectoryController.vala"
	result = source;
#line 170 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&params);
#line 170 "../src/Controllers/DirectoryController.vala"
	return result;
#line 983 "DirectoryController.c"
}

/**
* @brief Load popular stations.
*
* @param limit The maximum number of stations to load.
* @return A StationSet object with popular stations.
*/
TunerStationSet*
tuner_directory_controller_load_popular_stations (TunerDirectoryController* self,
                                                  guint limit)
{
	TunerDataProviderSearchParams params = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeHashSet* _tmp2_;
	TunerDataProviderSearchParams _tmp3_ = {0};
	TunerStationSet* source = NULL;
	TunerDataProviderSearchParams _tmp4_;
	TunerDataProviderAPI* _tmp5_;
	TunerStarStore* _tmp6_;
	TunerStationSet* _tmp7_;
	TunerStationSet* result;
#line 180 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 182 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = g_strdup ("");
#line 182 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = g_strdup ("");
#line 182 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 182 "../src/Controllers/DirectoryController.vala"
	memset (&_tmp3_, 0, sizeof (TunerDataProviderSearchParams));
#line 182 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.text);
#line 182 "../src/Controllers/DirectoryController.vala"
	_tmp3_.text = _tmp0_;
#line 182 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.countrycode);
#line 182 "../src/Controllers/DirectoryController.vala"
	_tmp3_.countrycode = _tmp1_;
#line 182 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp3_.tags);
#line 182 "../src/Controllers/DirectoryController.vala"
	_tmp3_.tags = (GeeSet*) _tmp2_;
#line 182 "../src/Controllers/DirectoryController.vala"
	_tmp3_.order = TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT;
#line 182 "../src/Controllers/DirectoryController.vala"
	_tmp3_.reverse = TRUE;
#line 182 "../src/Controllers/DirectoryController.vala"
	params = _tmp3_;
#line 189 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = params;
#line 189 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = self->priv->_provider;
#line 189 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = self->priv->_star_store;
#line 189 "../src/Controllers/DirectoryController.vala"
	_tmp7_ = tuner_station_set_new (limit, &_tmp4_, _tmp5_, _tmp6_);
#line 189 "../src/Controllers/DirectoryController.vala"
	source = _tmp7_;
#line 190 "../src/Controllers/DirectoryController.vala"
	result = source;
#line 190 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&params);
#line 190 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1051 "DirectoryController.c"
}

/**
* @brief Load stations by country code.
*
* @param limit The maximum number of stations to load.
* @param countrycode The country code to filter stations.
* @return A StationSet object with stations from the specified country.
*/
TunerStationSet*
tuner_directory_controller_load_by_country (TunerDirectoryController* self,
                                            guint limit,
                                            const gchar* countrycode)
{
	TunerDataProviderSearchParams params = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeHashSet* _tmp2_;
	TunerDataProviderSearchParams _tmp3_ = {0};
	TunerStationSet* source = NULL;
	TunerDataProviderSearchParams _tmp4_;
	TunerDataProviderAPI* _tmp5_;
	TunerStarStore* _tmp6_;
	TunerStationSet* _tmp7_;
	TunerStationSet* result;
#line 201 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (countrycode != NULL, NULL);
#line 203 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = g_strdup ("");
#line 203 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = g_strdup (countrycode);
#line 203 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 203 "../src/Controllers/DirectoryController.vala"
	memset (&_tmp3_, 0, sizeof (TunerDataProviderSearchParams));
#line 203 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.text);
#line 203 "../src/Controllers/DirectoryController.vala"
	_tmp3_.text = _tmp0_;
#line 203 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.countrycode);
#line 203 "../src/Controllers/DirectoryController.vala"
	_tmp3_.countrycode = _tmp1_;
#line 203 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp3_.tags);
#line 203 "../src/Controllers/DirectoryController.vala"
	_tmp3_.tags = (GeeSet*) _tmp2_;
#line 203 "../src/Controllers/DirectoryController.vala"
	_tmp3_.order = TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT;
#line 203 "../src/Controllers/DirectoryController.vala"
	_tmp3_.reverse = TRUE;
#line 203 "../src/Controllers/DirectoryController.vala"
	params = _tmp3_;
#line 210 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = params;
#line 210 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = self->priv->_provider;
#line 210 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = self->priv->_star_store;
#line 210 "../src/Controllers/DirectoryController.vala"
	_tmp7_ = tuner_station_set_new (limit, &_tmp4_, _tmp5_, _tmp6_);
#line 210 "../src/Controllers/DirectoryController.vala"
	source = _tmp7_;
#line 211 "../src/Controllers/DirectoryController.vala"
	result = source;
#line 211 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&params);
#line 211 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1123 "DirectoryController.c"
}

/**
* @brief Load stations based on search text.
*
* @param utext The search text to filter stations.
* @param limit The maximum number of stations to load.
* @return A StationSet object with stations matching the search text.
*/
TunerStationSet*
tuner_directory_controller_load_search_stations (TunerDirectoryController* self,
                                                 const gchar* utext,
                                                 guint limit)
{
	TunerDataProviderSearchParams params = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeHashSet* _tmp2_;
	TunerDataProviderSearchParams _tmp3_ = {0};
	TunerStationSet* source = NULL;
	TunerDataProviderSearchParams _tmp4_;
	TunerDataProviderAPI* _tmp5_;
	TunerStarStore* _tmp6_;
	TunerStationSet* _tmp7_;
	TunerStationSet* result;
#line 222 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 222 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (utext != NULL, NULL);
#line 224 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = g_strdup (utext);
#line 224 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = g_strdup ("");
#line 224 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 224 "../src/Controllers/DirectoryController.vala"
	memset (&_tmp3_, 0, sizeof (TunerDataProviderSearchParams));
#line 224 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.text);
#line 224 "../src/Controllers/DirectoryController.vala"
	_tmp3_.text = _tmp0_;
#line 224 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.countrycode);
#line 224 "../src/Controllers/DirectoryController.vala"
	_tmp3_.countrycode = _tmp1_;
#line 224 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp3_.tags);
#line 224 "../src/Controllers/DirectoryController.vala"
	_tmp3_.tags = (GeeSet*) _tmp2_;
#line 224 "../src/Controllers/DirectoryController.vala"
	_tmp3_.order = TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT;
#line 224 "../src/Controllers/DirectoryController.vala"
	_tmp3_.reverse = TRUE;
#line 224 "../src/Controllers/DirectoryController.vala"
	params = _tmp3_;
#line 231 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = params;
#line 231 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = self->priv->_provider;
#line 231 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = self->priv->_star_store;
#line 231 "../src/Controllers/DirectoryController.vala"
	_tmp7_ = tuner_station_set_new (limit, &_tmp4_, _tmp5_, _tmp6_);
#line 231 "../src/Controllers/DirectoryController.vala"
	source = _tmp7_;
#line 232 "../src/Controllers/DirectoryController.vala"
	result = source;
#line 232 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&params);
#line 232 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1195 "DirectoryController.c"
}

/**
     * @brief Get all starred stations.
     *
     * @return An Collection of starred Model.Station objects.
     */
GeeCollection*
tuner_directory_controller_get_starred (TunerDirectoryController* self)
{
	TunerStarStore* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* result;
#line 241 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 242 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = self->priv->_star_store;
#line 242 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = tuner_star_store_get_all_stations (_tmp0_);
#line 242 "../src/Controllers/DirectoryController.vala"
	result = _tmp1_;
#line 242 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1219 "DirectoryController.c"
}

/**
     * @brief Adds a saved search term and returns the StatioSet to retrieve the stations found
     *
     * @return A StationSet object with stations 
     */
TunerStationSet*
tuner_directory_controller_add_saved_search (TunerDirectoryController* self,
                                             const gchar* search_term)
{
	TunerStarStore* _tmp0_;
	TunerStationSet* _tmp1_;
	TunerStationSet* result;
#line 253 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (search_term != NULL, NULL);
#line 255 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = self->priv->_star_store;
#line 255 "../src/Controllers/DirectoryController.vala"
	tuner_star_store_add_saved_search (_tmp0_, search_term);
#line 256 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = tuner_directory_controller_load_search_stations (self, search_term, TUNER_DIRECTORY_CONTROLLER_DIRECTORY_LIMIT);
#line 256 "../src/Controllers/DirectoryController.vala"
	result = _tmp1_;
#line 256 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1248 "DirectoryController.c"
}

/**
     * @brief Removed the given saved search term
     *
     */
void
tuner_directory_controller_remove_saved_search (TunerDirectoryController* self,
                                                const gchar* search_text)
{
	TunerStarStore* _tmp0_;
#line 264 "../src/Controllers/DirectoryController.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/Controllers/DirectoryController.vala"
	g_return_if_fail (search_text != NULL);
#line 266 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = self->priv->_star_store;
#line 266 "../src/Controllers/DirectoryController.vala"
	tuner_star_store_remove_saved_search (_tmp0_, search_text);
#line 1268 "DirectoryController.c"
}

/**
     * @brief Loads stations found from each saved search term
     *
     * @return A map of search terms and related StationSet object with stations 
     */
GeeMap*
tuner_directory_controller_load_saved_searches (TunerDirectoryController* self)
{
	GeeMap* searches = NULL;
	GeeHashMap* _tmp0_;
	GeeMap* result;
#line 275 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 277 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TUNER_TYPE_STATION_SET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 277 "../src/Controllers/DirectoryController.vala"
	searches = (GeeMap*) _tmp0_;
#line 1288 "DirectoryController.c"
	{
		GeeIterator* _search_it = NULL;
		TunerStarStore* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 278 "../src/Controllers/DirectoryController.vala"
		_tmp1_ = self->priv->_star_store;
#line 278 "../src/Controllers/DirectoryController.vala"
		_tmp2_ = tuner_star_store_get_all_searches (_tmp1_);
#line 278 "../src/Controllers/DirectoryController.vala"
		_tmp3_ = _tmp2_;
#line 278 "../src/Controllers/DirectoryController.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 278 "../src/Controllers/DirectoryController.vala"
		_tmp5_ = _tmp4_;
#line 278 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (_tmp3_);
#line 278 "../src/Controllers/DirectoryController.vala"
		_search_it = _tmp5_;
#line 278 "../src/Controllers/DirectoryController.vala"
		while (TRUE) {
#line 1312 "DirectoryController.c"
			GeeIterator* _tmp6_;
			gchar* search = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMap* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			TunerStationSet* _tmp12_;
			TunerStationSet* _tmp13_;
#line 278 "../src/Controllers/DirectoryController.vala"
			_tmp6_ = _search_it;
#line 278 "../src/Controllers/DirectoryController.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 278 "../src/Controllers/DirectoryController.vala"
				break;
#line 1328 "DirectoryController.c"
			}
#line 278 "../src/Controllers/DirectoryController.vala"
			_tmp7_ = _search_it;
#line 278 "../src/Controllers/DirectoryController.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 278 "../src/Controllers/DirectoryController.vala"
			search = (gchar*) _tmp8_;
#line 280 "../src/Controllers/DirectoryController.vala"
			_tmp9_ = searches;
#line 280 "../src/Controllers/DirectoryController.vala"
			_tmp10_ = search;
#line 280 "../src/Controllers/DirectoryController.vala"
			_tmp11_ = search;
#line 280 "../src/Controllers/DirectoryController.vala"
			_tmp12_ = tuner_directory_controller_load_search_stations (self, _tmp11_, TUNER_DIRECTORY_CONTROLLER_DIRECTORY_LIMIT);
#line 280 "../src/Controllers/DirectoryController.vala"
			_tmp13_ = _tmp12_;
#line 280 "../src/Controllers/DirectoryController.vala"
			gee_map_set (_tmp9_, _tmp10_, _tmp13_);
#line 280 "../src/Controllers/DirectoryController.vala"
			_g_object_unref0 (_tmp13_);
#line 278 "../src/Controllers/DirectoryController.vala"
			_g_free0 (search);
#line 1352 "DirectoryController.c"
		}
#line 278 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (_search_it);
#line 1356 "DirectoryController.c"
	}
#line 282 "../src/Controllers/DirectoryController.vala"
	result = searches;
#line 282 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1362 "DirectoryController.c"
}

/**
* @brief Load stations by tags.
*
* @param utags An ArrayList of tags to filter stations.
* @return A StationSet object with stations matching the given tags.
*/
TunerStationSet*
tuner_directory_controller_load_by_tag (TunerDirectoryController* self,
                                        const gchar* utag)
{
	GeeHashSet* t = NULL;
	GeeHashSet* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	TunerDataProviderSearchParams params = {0};
	gchar* _tmp3_;
	gchar* _tmp4_;
	GeeSet* _tmp5_;
	TunerDataProviderSearchParams _tmp6_ = {0};
	TunerStationSet* source = NULL;
	TunerDataProviderSearchParams _tmp7_;
	TunerDataProviderAPI* _tmp8_;
	TunerStarStore* _tmp9_;
	TunerStationSet* _tmp10_;
	TunerStationSet* result;
#line 294 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 294 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (utag != NULL, NULL);
#line 296 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 296 "../src/Controllers/DirectoryController.vala"
	t = _tmp0_;
#line 297 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = g_utf8_strdown (utag, (gssize) -1);
#line 297 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = _tmp1_;
#line 297 "../src/Controllers/DirectoryController.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) t, _tmp2_);
#line 297 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp2_);
#line 298 "../src/Controllers/DirectoryController.vala"
	_tmp3_ = g_strdup ("");
#line 298 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = g_strdup ("");
#line 298 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = _g_object_ref0 ((GeeSet*) t);
#line 298 "../src/Controllers/DirectoryController.vala"
	memset (&_tmp6_, 0, sizeof (TunerDataProviderSearchParams));
#line 298 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp6_.text);
#line 298 "../src/Controllers/DirectoryController.vala"
	_tmp6_.text = _tmp3_;
#line 298 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp6_.countrycode);
#line 298 "../src/Controllers/DirectoryController.vala"
	_tmp6_.countrycode = _tmp4_;
#line 298 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp6_.tags);
#line 298 "../src/Controllers/DirectoryController.vala"
	_tmp6_.tags = _tmp5_;
#line 298 "../src/Controllers/DirectoryController.vala"
	_tmp6_.order = TUNER_DATA_PROVIDER_SORT_ORDER_VOTES;
#line 298 "../src/Controllers/DirectoryController.vala"
	_tmp6_.reverse = TRUE;
#line 298 "../src/Controllers/DirectoryController.vala"
	params = _tmp6_;
#line 305 "../src/Controllers/DirectoryController.vala"
	_tmp7_ = params;
#line 305 "../src/Controllers/DirectoryController.vala"
	_tmp8_ = self->priv->_provider;
#line 305 "../src/Controllers/DirectoryController.vala"
	_tmp9_ = self->priv->_star_store;
#line 305 "../src/Controllers/DirectoryController.vala"
	_tmp10_ = tuner_station_set_new ((guint) 40, &_tmp7_, _tmp8_, _tmp9_);
#line 305 "../src/Controllers/DirectoryController.vala"
	source = _tmp10_;
#line 306 "../src/Controllers/DirectoryController.vala"
	result = source;
#line 306 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&params);
#line 306 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (t);
#line 306 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1450 "DirectoryController.c"
}

/**
* @brief Count a click for a station.
*
* @param station The station that was clicked.
*/
TunerStationSet*
tuner_directory_controller_load_by_tag_set (TunerDirectoryController* self,
                                            GeeSet* utags)
{
	TunerDataProviderSearchParams params = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	GeeSet* _tmp2_;
	TunerDataProviderSearchParams _tmp3_ = {0};
	TunerStationSet* source = NULL;
	TunerDataProviderSearchParams _tmp4_;
	TunerDataProviderAPI* _tmp5_;
	TunerStarStore* _tmp6_;
	TunerStationSet* _tmp7_;
	TunerStationSet* result;
#line 315 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 315 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (utags != NULL, NULL);
#line 317 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = g_strdup ("");
#line 317 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = g_strdup ("");
#line 317 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = _g_object_ref0 (utags);
#line 317 "../src/Controllers/DirectoryController.vala"
	memset (&_tmp3_, 0, sizeof (TunerDataProviderSearchParams));
#line 317 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.text);
#line 317 "../src/Controllers/DirectoryController.vala"
	_tmp3_.text = _tmp0_;
#line 317 "../src/Controllers/DirectoryController.vala"
	_g_free0 (_tmp3_.countrycode);
#line 317 "../src/Controllers/DirectoryController.vala"
	_tmp3_.countrycode = _tmp1_;
#line 317 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp3_.tags);
#line 317 "../src/Controllers/DirectoryController.vala"
	_tmp3_.tags = _tmp2_;
#line 317 "../src/Controllers/DirectoryController.vala"
	_tmp3_.order = TUNER_DATA_PROVIDER_SORT_ORDER_VOTES;
#line 317 "../src/Controllers/DirectoryController.vala"
	_tmp3_.reverse = TRUE;
#line 317 "../src/Controllers/DirectoryController.vala"
	params = _tmp3_;
#line 324 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = params;
#line 324 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = self->priv->_provider;
#line 324 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = self->priv->_star_store;
#line 324 "../src/Controllers/DirectoryController.vala"
	_tmp7_ = tuner_station_set_new ((guint) 40, &_tmp4_, _tmp5_, _tmp6_);
#line 324 "../src/Controllers/DirectoryController.vala"
	source = _tmp7_;
#line 325 "../src/Controllers/DirectoryController.vala"
	result = source;
#line 325 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&params);
#line 325 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1519 "DirectoryController.c"
}

/**
* @brief Count a click for a station.
*
* @param station The station that was clicked.
*/
void
tuner_directory_controller_count_station_click (TunerDirectoryController* self,
                                                TunerModelStation* station)
{
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	TunerSettings* _tmp2_;
	TunerSettings* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 334 "../src/Controllers/DirectoryController.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/Controllers/DirectoryController.vala"
	g_return_if_fail (station != NULL);
#line 336 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = tuner_app ();
#line 336 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = _tmp0_;
#line 336 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = tuner_application_get_settings (_tmp1_);
#line 336 "../src/Controllers/DirectoryController.vala"
	_tmp3_ = _tmp2_;
#line 336 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = tuner_settings_get_do_not_vote (_tmp3_);
#line 336 "../src/Controllers/DirectoryController.vala"
	_tmp5_ = _tmp4_;
#line 336 "../src/Controllers/DirectoryController.vala"
	_tmp6_ = !_tmp5_;
#line 336 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp1_);
#line 336 "../src/Controllers/DirectoryController.vala"
	if (_tmp6_) {
#line 1560 "DirectoryController.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		TunerDataProviderAPI* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 338 "../src/Controllers/DirectoryController.vala"
		_tmp7_ = tuner_model_station_get_stationuuid (station);
#line 338 "../src/Controllers/DirectoryController.vala"
		_tmp8_ = _tmp7_;
#line 338 "../src/Controllers/DirectoryController.vala"
		_tmp9_ = string_to_string (_tmp8_);
#line 338 "../src/Controllers/DirectoryController.vala"
		_tmp10_ = g_strconcat ("Send listening event for station ", _tmp9_, NULL);
#line 338 "../src/Controllers/DirectoryController.vala"
		_tmp11_ = _tmp10_;
#line 338 "../src/Controllers/DirectoryController.vala"
		g_debug ("DirectoryController.vala:338: %s", _tmp11_);
#line 338 "../src/Controllers/DirectoryController.vala"
		_g_free0 (_tmp11_);
#line 339 "../src/Controllers/DirectoryController.vala"
		_tmp12_ = self->priv->_provider;
#line 339 "../src/Controllers/DirectoryController.vala"
		_tmp13_ = tuner_model_station_get_stationuuid (station);
#line 339 "../src/Controllers/DirectoryController.vala"
		_tmp14_ = _tmp13_;
#line 339 "../src/Controllers/DirectoryController.vala"
		tuner_data_provider_api_click (_tmp12_, _tmp14_);
#line 1591 "DirectoryController.c"
	} else {
#line 343 "../src/Controllers/DirectoryController.vala"
		g_debug ("DirectoryController.vala:343: do-not-vote enabled, will not send liste" \
"ning event");
#line 1595 "DirectoryController.c"
	}
}

/**
 * @brief Load tags from the _provider.
 */
void
tuner_directory_controller_load_tags (TunerDirectoryController* self)
{
	GError* _inner_error0_ = NULL;
#line 351 "../src/Controllers/DirectoryController.vala"
	g_return_if_fail (self != NULL);
#line 1608 "DirectoryController.c"
	{
		GeeSet* tags = NULL;
		TunerDataProviderAPI* _tmp0_;
		GeeSet* _tmp1_;
#line 355 "../src/Controllers/DirectoryController.vala"
		_tmp0_ = self->priv->_provider;
#line 355 "../src/Controllers/DirectoryController.vala"
		_tmp1_ = tuner_data_provider_api_get_tags (_tmp0_, 0, 0, &_inner_error0_);
#line 355 "../src/Controllers/DirectoryController.vala"
		tags = _tmp1_;
#line 355 "../src/Controllers/DirectoryController.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "../src/Controllers/DirectoryController.vala"
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 1623 "DirectoryController.c"
				goto __catch0_tuner_data_provider_data_error;
			}
#line 355 "../src/Controllers/DirectoryController.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 355 "../src/Controllers/DirectoryController.vala"
			g_clear_error (&_inner_error0_);
#line 355 "../src/Controllers/DirectoryController.vala"
			return;
#line 1632 "DirectoryController.c"
		}
#line 356 "../src/Controllers/DirectoryController.vala"
		g_signal_emit (self, tuner_directory_controller_signals[TUNER_DIRECTORY_CONTROLLER_TAGS_UPDATED_SIGNAL], 0, tags);
#line 353 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (tags);
#line 1638 "DirectoryController.c"
	}
	goto __finally0;
	__catch0_tuner_data_provider_data_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 353 "../src/Controllers/DirectoryController.vala"
		e = _inner_error0_;
#line 353 "../src/Controllers/DirectoryController.vala"
		_inner_error0_ = NULL;
#line 359 "../src/Controllers/DirectoryController.vala"
		_tmp2_ = e;
#line 359 "../src/Controllers/DirectoryController.vala"
		_tmp3_ = _tmp2_->message;
#line 359 "../src/Controllers/DirectoryController.vala"
		_tmp4_ = string_to_string (_tmp3_);
#line 359 "../src/Controllers/DirectoryController.vala"
		_tmp5_ = g_strconcat ("Load tags failed with error: ", _tmp4_, NULL);
#line 359 "../src/Controllers/DirectoryController.vala"
		_tmp6_ = _tmp5_;
#line 359 "../src/Controllers/DirectoryController.vala"
		g_warning ("DirectoryController.vala:359: %s", _tmp6_);
#line 359 "../src/Controllers/DirectoryController.vala"
		_g_free0 (_tmp6_);
#line 353 "../src/Controllers/DirectoryController.vala"
		_g_error_free0 (e);
#line 1669 "DirectoryController.c"
	}
	__finally0:
#line 353 "../src/Controllers/DirectoryController.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 353 "../src/Controllers/DirectoryController.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 353 "../src/Controllers/DirectoryController.vala"
		g_clear_error (&_inner_error0_);
#line 353 "../src/Controllers/DirectoryController.vala"
		return;
#line 1680 "DirectoryController.c"
	}
}

GeeSet*
tuner_directory_controller_load_random_genres (TunerDirectoryController* self,
                                               gint genres)
{
	GeeSet* _result_ = NULL;
	GeeHashSet* _tmp0_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 364 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 366 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = gee_hash_set_new (TUNER_DATA_PROVIDER_TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 366 "../src/Controllers/DirectoryController.vala"
	_result_ = (GeeSet*) _tmp0_;
#line 368 "../src/Controllers/DirectoryController.vala"
	while (TRUE) {
#line 1700 "DirectoryController.c"
		gboolean _tmp1_ = FALSE;
		TunerApplication* _tmp2_;
		TunerApplication* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 368 "../src/Controllers/DirectoryController.vala"
		_tmp2_ = tuner_app ();
#line 368 "../src/Controllers/DirectoryController.vala"
		_tmp3_ = _tmp2_;
#line 368 "../src/Controllers/DirectoryController.vala"
		_tmp4_ = tuner_application_get_is_online (_tmp3_);
#line 368 "../src/Controllers/DirectoryController.vala"
		_tmp5_ = _tmp4_;
#line 368 "../src/Controllers/DirectoryController.vala"
		_tmp6_ = _tmp5_;
#line 368 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (_tmp3_);
#line 368 "../src/Controllers/DirectoryController.vala"
		if (_tmp6_) {
#line 1721 "DirectoryController.c"
			GeeSet* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 368 "../src/Controllers/DirectoryController.vala"
			_tmp7_ = _result_;
#line 368 "../src/Controllers/DirectoryController.vala"
			_tmp8_ = gee_collection_get_size ((GeeCollection*) _tmp7_);
#line 368 "../src/Controllers/DirectoryController.vala"
			_tmp9_ = _tmp8_;
#line 368 "../src/Controllers/DirectoryController.vala"
			_tmp1_ = _tmp9_ < genres;
#line 1733 "DirectoryController.c"
		} else {
#line 368 "../src/Controllers/DirectoryController.vala"
			_tmp1_ = FALSE;
#line 1737 "DirectoryController.c"
		}
#line 368 "../src/Controllers/DirectoryController.vala"
		if (!_tmp1_) {
#line 368 "../src/Controllers/DirectoryController.vala"
			break;
#line 1743 "DirectoryController.c"
		}
		{
			gint32 offset = 0;
			TunerDataProviderAPI* _tmp10_;
			GeeSet* tag = NULL;
			TunerDataProviderAPI* _tmp11_;
			GeeSet* _tmp12_;
			GeeSet* _tmp13_;
			GeeSet* _tmp14_;
#line 372 "../src/Controllers/DirectoryController.vala"
			_tmp10_ = self->priv->_provider;
#line 372 "../src/Controllers/DirectoryController.vala"
			offset = g_random_int_range ((gint32) 0, (gint32) tuner_data_provider_api_available_tags (_tmp10_));
#line 373 "../src/Controllers/DirectoryController.vala"
			_tmp11_ = self->priv->_provider;
#line 373 "../src/Controllers/DirectoryController.vala"
			_tmp12_ = tuner_data_provider_api_get_tags (_tmp11_, (gint) offset, 1, &_inner_error0_);
#line 373 "../src/Controllers/DirectoryController.vala"
			tag = _tmp12_;
#line 373 "../src/Controllers/DirectoryController.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1765 "DirectoryController.c"
				goto __catch0_g_error;
			}
#line 374 "../src/Controllers/DirectoryController.vala"
			_tmp13_ = _result_;
#line 374 "../src/Controllers/DirectoryController.vala"
			_tmp14_ = tag;
#line 374 "../src/Controllers/DirectoryController.vala"
			gee_collection_add_all ((GeeCollection*) _tmp13_, (GeeCollection*) _tmp14_);
#line 370 "../src/Controllers/DirectoryController.vala"
			_g_object_unref0 (tag);
#line 1776 "DirectoryController.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 370 "../src/Controllers/DirectoryController.vala"
			g_clear_error (&_inner_error0_);
#line 1783 "DirectoryController.c"
		}
		__finally0:
#line 370 "../src/Controllers/DirectoryController.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 370 "../src/Controllers/DirectoryController.vala"
			_g_object_unref0 (_result_);
#line 370 "../src/Controllers/DirectoryController.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 370 "../src/Controllers/DirectoryController.vala"
			g_clear_error (&_inner_error0_);
#line 370 "../src/Controllers/DirectoryController.vala"
			return NULL;
#line 1796 "DirectoryController.c"
		}
	}
#line 379 "../src/Controllers/DirectoryController.vala"
	result = _result_;
#line 379 "../src/Controllers/DirectoryController.vala"
	return result;
#line 1803 "DirectoryController.c"
}

static void
tuner_directory_controller_class_init (TunerDirectoryControllerClass * klass,
                                       gpointer klass_data)
{
#line 31 "../src/Controllers/DirectoryController.vala"
	tuner_directory_controller_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/Controllers/DirectoryController.vala"
	g_type_class_adjust_private_offset (klass, &TunerDirectoryController_private_offset);
#line 31 "../src/Controllers/DirectoryController.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_directory_controller_finalize;
#line 31 "../src/Controllers/DirectoryController.vala"
	tuner_directory_controller_signals[TUNER_DIRECTORY_CONTROLLER_TAGS_UPDATED_SIGNAL] = g_signal_new ("tags-updated", TUNER_TYPE_DIRECTORY_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_SET);
#line 1818 "DirectoryController.c"
}

static void
tuner_directory_controller_instance_init (TunerDirectoryController * self,
                                          gpointer klass)
{
#line 31 "../src/Controllers/DirectoryController.vala"
	self->priv = tuner_directory_controller_get_instance_private (self);
#line 38 "../src/Controllers/DirectoryController.vala"
	self->priv->_loaded = FALSE;
#line 1829 "DirectoryController.c"
}

static void
tuner_directory_controller_finalize (GObject * obj)
{
	TunerDirectoryController * self;
#line 31 "../src/Controllers/DirectoryController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryController);
#line 36 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (self->priv->_provider);
#line 37 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (self->priv->_star_store);
#line 31 "../src/Controllers/DirectoryController.vala"
	G_OBJECT_CLASS (tuner_directory_controller_parent_class)->finalize (obj);
#line 1844 "DirectoryController.c"
}

/**
 * Controller class responsible for managing directory-related operations in the Tuner application.
 *
 * This class handles various directory management tasks,
 * such as file system operations, directory navigation, and file monitoring within the
 * context of the Tuner namespace.
 */
static GType
tuner_directory_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerDirectoryControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_directory_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerDirectoryController), 0, (GInstanceInitFunc) tuner_directory_controller_instance_init, NULL };
	GType tuner_directory_controller_type_id;
	tuner_directory_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerDirectoryController", &g_define_type_info, 0);
	TunerDirectoryController_private_offset = g_type_add_instance_private (tuner_directory_controller_type_id, sizeof (TunerDirectoryControllerPrivate));
	return tuner_directory_controller_type_id;
}

GType
tuner_directory_controller_get_type (void)
{
	static volatile gsize tuner_directory_controller_type_id__once = 0;
	if (g_once_init_enter (&tuner_directory_controller_type_id__once)) {
		GType tuner_directory_controller_type_id;
		tuner_directory_controller_type_id = tuner_directory_controller_get_type_once ();
		g_once_init_leave (&tuner_directory_controller_type_id__once, tuner_directory_controller_type_id);
	}
	return tuner_directory_controller_type_id__once;
}

static inline gpointer
tuner_station_set_get_instance_private (TunerStationSet* self)
{
	return G_STRUCT_MEMBER_P (self, TunerStationSet_private_offset);
}

/**
     * @brief Constructor for StationSet.
     *
     * @param limit The maximum number of stations to fetch.
     * @param params The search parameters for fetching stations.
     * @param client The RadioBrowser client to use for fetching stations.
     * @param star_store The StationStore to use for managing stations.
     */
TunerStationSet*
tuner_station_set_construct (GType object_type,
                             guint limit,
                             TunerDataProviderSearchParams* params,
                             TunerDataProviderAPI* client,
                             TunerStarStore* star_store)
{
	TunerStationSet * self = NULL;
	TunerDataProviderSearchParams _tmp0_;
	TunerDataProviderSearchParams _tmp1_;
	TunerDataProviderSearchParams _tmp2_ = {0};
	TunerDataProviderAPI* _tmp3_;
	TunerStarStore* _tmp4_;
#line 404 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 404 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (client != NULL, NULL);
#line 404 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (star_store != NULL, NULL);
#line 408 "../src/Controllers/DirectoryController.vala"
	self = (TunerStationSet*) g_object_new (object_type, NULL);
#line 410 "../src/Controllers/DirectoryController.vala"
	self->priv->_page_size = limit;
#line 411 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = *params;
#line 411 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = _tmp0_;
#line 411 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_copy (&_tmp1_, &_tmp2_);
#line 411 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&self->priv->_params);
#line 411 "../src/Controllers/DirectoryController.vala"
	self->priv->_params = _tmp2_;
#line 412 "../src/Controllers/DirectoryController.vala"
	_tmp3_ = _g_object_ref0 (client);
#line 412 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (self->priv->_provider);
#line 412 "../src/Controllers/DirectoryController.vala"
	self->priv->_provider = _tmp3_;
#line 413 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = _g_object_ref0 (star_store);
#line 413 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (self->priv->_star_store);
#line 413 "../src/Controllers/DirectoryController.vala"
	self->priv->_star_store = _tmp4_;
#line 404 "../src/Controllers/DirectoryController.vala"
	return self;
#line 1937 "DirectoryController.c"
}

TunerStationSet*
tuner_station_set_new (guint limit,
                       TunerDataProviderSearchParams* params,
                       TunerDataProviderAPI* client,
                       TunerStarStore* star_store)
{
#line 404 "../src/Controllers/DirectoryController.vala"
	return tuner_station_set_construct (TUNER_TYPE_STATION_SET, limit, params, client, star_store);
#line 1948 "DirectoryController.c"
}

/**
* @brief Fetch the next set of stations.
*
* @return An ArrayList of Model.Station objects.
* @throws SourceError If the source is unavailable.
*/
GeeSet*
tuner_station_set_next_page (TunerStationSet* self,
                             GError** error)
{
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 423 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 426 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = tuner_app ();
#line 426 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = _tmp0_;
#line 426 "../src/Controllers/DirectoryController.vala"
	_tmp2_ = tuner_application_get_is_offline (_tmp1_);
#line 426 "../src/Controllers/DirectoryController.vala"
	_tmp3_ = _tmp2_;
#line 426 "../src/Controllers/DirectoryController.vala"
	_tmp4_ = _tmp3_;
#line 426 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_tmp1_);
#line 426 "../src/Controllers/DirectoryController.vala"
	if (_tmp4_) {
#line 427 "../src/Controllers/DirectoryController.vala"
		result = NULL;
#line 427 "../src/Controllers/DirectoryController.vala"
		return result;
#line 1988 "DirectoryController.c"
	}
	{
		GeeSet* raw_stations = NULL;
		TunerDataProviderAPI* _tmp5_;
		TunerDataProviderSearchParams _tmp6_;
		GeeSet* _tmp7_;
		GeeIterator* filtered_stations = NULL;
		GeeSet* _tmp8_;
		GeeIterator* _tmp9_;
		GeeSet* stations = NULL;
		GeeIterator* _tmp10_;
		GeeSet* _tmp11_;
		GeeSet* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 432 "../src/Controllers/DirectoryController.vala"
		_tmp5_ = self->priv->_provider;
#line 432 "../src/Controllers/DirectoryController.vala"
		_tmp6_ = self->priv->_params;
#line 432 "../src/Controllers/DirectoryController.vala"
		_tmp7_ = tuner_data_provider_api_search (_tmp5_, &_tmp6_, self->priv->_page_size + 1, self->priv->_offset, &_inner_error0_);
#line 432 "../src/Controllers/DirectoryController.vala"
		raw_stations = _tmp7_;
#line 432 "../src/Controllers/DirectoryController.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 432 "../src/Controllers/DirectoryController.vala"
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 2016 "DirectoryController.c"
				goto __catch0_tuner_data_provider_data_error;
			}
#line 432 "../src/Controllers/DirectoryController.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 432 "../src/Controllers/DirectoryController.vala"
			g_clear_error (&_inner_error0_);
#line 432 "../src/Controllers/DirectoryController.vala"
			return NULL;
#line 2025 "DirectoryController.c"
		}
#line 435 "../src/Controllers/DirectoryController.vala"
		_tmp8_ = raw_stations;
#line 435 "../src/Controllers/DirectoryController.vala"
		_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 435 "../src/Controllers/DirectoryController.vala"
		filtered_stations = _tmp9_;
#line 437 "../src/Controllers/DirectoryController.vala"
		_tmp10_ = filtered_stations;
#line 437 "../src/Controllers/DirectoryController.vala"
		_tmp11_ = tuner_station_set_convert_stations (self, _tmp10_);
#line 437 "../src/Controllers/DirectoryController.vala"
		stations = _tmp11_;
#line 438 "../src/Controllers/DirectoryController.vala"
		self->priv->_offset = self->priv->_offset + self->priv->_page_size;
#line 439 "../src/Controllers/DirectoryController.vala"
		_tmp12_ = stations;
#line 439 "../src/Controllers/DirectoryController.vala"
		_tmp13_ = gee_collection_get_size ((GeeCollection*) _tmp12_);
#line 439 "../src/Controllers/DirectoryController.vala"
		_tmp14_ = _tmp13_;
#line 439 "../src/Controllers/DirectoryController.vala"
		self->priv->_more = ((guint) _tmp14_) > self->priv->_page_size;
#line 440 "../src/Controllers/DirectoryController.vala"
		if (self->priv->_more) {
#line 2051 "DirectoryController.c"
			GeeSet* _tmp15_;
			GeeSet* _tmp16_;
			gint _tmp17_ = 0;
			gpointer* _tmp18_;
			TunerModelStation** _tmp19_;
			gint _tmp19__length1;
			TunerModelStation* _tmp20_;
#line 441 "../src/Controllers/DirectoryController.vala"
			_tmp15_ = stations;
#line 441 "../src/Controllers/DirectoryController.vala"
			_tmp16_ = stations;
#line 441 "../src/Controllers/DirectoryController.vala"
			_tmp18_ = gee_collection_to_array ((GeeCollection*) _tmp16_, &_tmp17_);
#line 441 "../src/Controllers/DirectoryController.vala"
			_tmp19_ = _tmp18_;
#line 441 "../src/Controllers/DirectoryController.vala"
			_tmp19__length1 = _tmp17_;
#line 441 "../src/Controllers/DirectoryController.vala"
			_tmp20_ = _tmp19_[(gint) self->priv->_page_size];
#line 441 "../src/Controllers/DirectoryController.vala"
			gee_collection_remove ((GeeCollection*) _tmp15_, _tmp20_);
#line 441 "../src/Controllers/DirectoryController.vala"
			_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_object_unref), NULL);
#line 2075 "DirectoryController.c"
		}
#line 442 "../src/Controllers/DirectoryController.vala"
		result = stations;
#line 442 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (filtered_stations);
#line 442 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (raw_stations);
#line 442 "../src/Controllers/DirectoryController.vala"
		return result;
#line 2085 "DirectoryController.c"
	}
	goto __finally0;
	__catch0_tuner_data_provider_data_error:
	{
		GError* _tmp21_;
#line 430 "../src/Controllers/DirectoryController.vala"
		g_clear_error (&_inner_error0_);
#line 445 "../src/Controllers/DirectoryController.vala"
		_tmp21_ = g_error_new_literal (SOURCE_ERROR, SOURCE_ERROR_UNAVAILABLE, "Directory Error");
#line 445 "../src/Controllers/DirectoryController.vala"
		_inner_error0_ = _tmp21_;
#line 2097 "DirectoryController.c"
		goto __finally0;
	}
	__finally0:
#line 430 "../src/Controllers/DirectoryController.vala"
	if (_inner_error0_->domain == SOURCE_ERROR) {
#line 430 "../src/Controllers/DirectoryController.vala"
		g_propagate_error (error, _inner_error0_);
#line 430 "../src/Controllers/DirectoryController.vala"
		return NULL;
#line 2107 "DirectoryController.c"
	} else {
#line 430 "../src/Controllers/DirectoryController.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 430 "../src/Controllers/DirectoryController.vala"
		g_clear_error (&_inner_error0_);
#line 430 "../src/Controllers/DirectoryController.vala"
		return NULL;
#line 2115 "DirectoryController.c"
	}
}

static void
tuner_station_set_next_page_async_data_free (gpointer _data)
{
	TunerStationSetNextPageAsyncData* _data_;
	_data_ = _data;
#line 387 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_data_->result);
#line 387 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_data_->self);
#line 387 "../src/Controllers/DirectoryController.vala"
	g_slice_free (TunerStationSetNextPageAsyncData, _data_);
#line 2130 "DirectoryController.c"
}

void
tuner_station_set_next_page_async (TunerStationSet* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	TunerStationSetNextPageAsyncData* _data_;
	TunerStationSet* _tmp0_;
#line 387 "../src/Controllers/DirectoryController.vala"
	g_return_if_fail (self != NULL);
#line 387 "../src/Controllers/DirectoryController.vala"
	_data_ = g_slice_new0 (TunerStationSetNextPageAsyncData);
#line 387 "../src/Controllers/DirectoryController.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 387 "../src/Controllers/DirectoryController.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tuner_station_set_next_page_async_data_free);
#line 387 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 387 "../src/Controllers/DirectoryController.vala"
	_data_->self = _tmp0_;
#line 387 "../src/Controllers/DirectoryController.vala"
	tuner_station_set_next_page_async_co (_data_);
#line 2154 "DirectoryController.c"
}

GeeSet*
tuner_station_set_next_page_finish (TunerStationSet* self,
                                    GAsyncResult* _res_,
                                    GError** error)
{
	GeeSet* result;
	TunerStationSetNextPageAsyncData* _data_;
#line 387 "../src/Controllers/DirectoryController.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 387 "../src/Controllers/DirectoryController.vala"
	if (NULL == _data_) {
#line 387 "../src/Controllers/DirectoryController.vala"
		return NULL;
#line 2170 "DirectoryController.c"
	}
#line 387 "../src/Controllers/DirectoryController.vala"
	result = _data_->result;
#line 387 "../src/Controllers/DirectoryController.vala"
	_data_->result = NULL;
#line 387 "../src/Controllers/DirectoryController.vala"
	return result;
#line 2178 "DirectoryController.c"
}

/**
* @brief Fetch the next set of stations.
*
* @return An ArrayList of Model.Station objects.
* @throws SourceError If the source is unavailable.
*/
static void
tuner_station_set_next_page_async_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	TunerStationSetNextPageAsyncData* _data_;
#line 464 "../src/Controllers/DirectoryController.vala"
	_data_ = _user_data_;
#line 464 "../src/Controllers/DirectoryController.vala"
	_data_->_source_object_ = source_object;
#line 464 "../src/Controllers/DirectoryController.vala"
	_data_->_res_ = _res_;
#line 464 "../src/Controllers/DirectoryController.vala"
	tuner_station_set_next_page_async_co (_data_);
#line 2201 "DirectoryController.c"
}

static gboolean
tuner_station_set_next_page_async_co (TunerStationSetNextPageAsyncData* _data_)
{
#line 455 "../src/Controllers/DirectoryController.vala"
	switch (_data_->_state_) {
#line 455 "../src/Controllers/DirectoryController.vala"
		case 0:
#line 2211 "DirectoryController.c"
		goto _state_0;
#line 455 "../src/Controllers/DirectoryController.vala"
		case 1:
#line 2215 "DirectoryController.c"
		goto _state_1;
		default:
#line 455 "../src/Controllers/DirectoryController.vala"
		g_assert_not_reached ();
#line 2220 "DirectoryController.c"
	}
	_state_0:
#line 458 "../src/Controllers/DirectoryController.vala"
	_data_->_tmp0_ = tuner_app ();
#line 458 "../src/Controllers/DirectoryController.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 458 "../src/Controllers/DirectoryController.vala"
	_data_->_tmp2_ = tuner_application_get_is_offline (_data_->_tmp1_);
#line 458 "../src/Controllers/DirectoryController.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 458 "../src/Controllers/DirectoryController.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 458 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 458 "../src/Controllers/DirectoryController.vala"
	if (_data_->_tmp4_) {
#line 459 "../src/Controllers/DirectoryController.vala"
		_data_->result = NULL;
#line 459 "../src/Controllers/DirectoryController.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 459 "../src/Controllers/DirectoryController.vala"
		if (_data_->_state_ != 0) {
#line 459 "../src/Controllers/DirectoryController.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 459 "../src/Controllers/DirectoryController.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2247 "DirectoryController.c"
			}
		}
#line 459 "../src/Controllers/DirectoryController.vala"
		g_object_unref (_data_->_async_result);
#line 459 "../src/Controllers/DirectoryController.vala"
		return FALSE;
#line 2254 "DirectoryController.c"
	}
	{
#line 464 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp5_ = _data_->self->priv->_provider;
#line 464 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp6_ = _data_->self->priv->_params;
#line 464 "../src/Controllers/DirectoryController.vala"
		_data_->_state_ = 1;
#line 464 "../src/Controllers/DirectoryController.vala"
		tuner_data_provider_api_search_async (_data_->_tmp5_, &_data_->_tmp6_, _data_->self->priv->_page_size + 1, _data_->self->priv->_offset, tuner_station_set_next_page_async_ready, _data_);
#line 464 "../src/Controllers/DirectoryController.vala"
		return FALSE;
#line 2267 "DirectoryController.c"
		_state_1:
#line 464 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp7_ = tuner_data_provider_api_search_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
#line 464 "../src/Controllers/DirectoryController.vala"
		_data_->raw_stations = _data_->_tmp7_;
#line 464 "../src/Controllers/DirectoryController.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 464 "../src/Controllers/DirectoryController.vala"
			if (_data_->_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 2277 "DirectoryController.c"
				goto __catch0_tuner_data_provider_data_error;
			}
#line 464 "../src/Controllers/DirectoryController.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 464 "../src/Controllers/DirectoryController.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 464 "../src/Controllers/DirectoryController.vala"
			g_object_unref (_data_->_async_result);
#line 464 "../src/Controllers/DirectoryController.vala"
			return FALSE;
#line 2288 "DirectoryController.c"
		}
#line 467 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp8_ = _data_->raw_stations;
#line 467 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp9_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp8_);
#line 467 "../src/Controllers/DirectoryController.vala"
		_data_->filtered_stations = _data_->_tmp9_;
#line 469 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp10_ = _data_->filtered_stations;
#line 469 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp11_ = tuner_station_set_convert_stations (_data_->self, _data_->_tmp10_);
#line 469 "../src/Controllers/DirectoryController.vala"
		_data_->stations = _data_->_tmp11_;
#line 470 "../src/Controllers/DirectoryController.vala"
		_data_->self->priv->_offset = _data_->self->priv->_offset + _data_->self->priv->_page_size;
#line 471 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp12_ = _data_->stations;
#line 471 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp13_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp12_);
#line 471 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 471 "../src/Controllers/DirectoryController.vala"
		_data_->self->priv->_more = ((guint) _data_->_tmp14_) > _data_->self->priv->_page_size;
#line 472 "../src/Controllers/DirectoryController.vala"
		if (_data_->self->priv->_more) {
#line 473 "../src/Controllers/DirectoryController.vala"
			_data_->_tmp15_ = _data_->stations;
#line 473 "../src/Controllers/DirectoryController.vala"
			_data_->_tmp16_ = _data_->stations;
#line 473 "../src/Controllers/DirectoryController.vala"
			_data_->_tmp17_ = 0;
#line 473 "../src/Controllers/DirectoryController.vala"
			_data_->_tmp18_ = gee_collection_to_array ((GeeCollection*) _data_->_tmp16_, &_data_->_tmp17_);
#line 473 "../src/Controllers/DirectoryController.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 473 "../src/Controllers/DirectoryController.vala"
			_data_->_tmp19__length1 = _data_->_tmp17_;
#line 473 "../src/Controllers/DirectoryController.vala"
			_data_->_tmp20_ = _data_->_tmp19_[(gint) _data_->self->priv->_page_size];
#line 473 "../src/Controllers/DirectoryController.vala"
			gee_collection_remove ((GeeCollection*) _data_->_tmp15_, _data_->_tmp20_);
#line 473 "../src/Controllers/DirectoryController.vala"
			_data_->_tmp19_ = (_vala_array_free (_data_->_tmp19_, _data_->_tmp19__length1, (GDestroyNotify) g_object_unref), NULL);
#line 2332 "DirectoryController.c"
		}
#line 474 "../src/Controllers/DirectoryController.vala"
		_data_->result = _data_->stations;
#line 474 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (_data_->filtered_stations);
#line 474 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (_data_->raw_stations);
#line 474 "../src/Controllers/DirectoryController.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 474 "../src/Controllers/DirectoryController.vala"
		if (_data_->_state_ != 0) {
#line 474 "../src/Controllers/DirectoryController.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 474 "../src/Controllers/DirectoryController.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2348 "DirectoryController.c"
			}
		}
#line 474 "../src/Controllers/DirectoryController.vala"
		g_object_unref (_data_->_async_result);
#line 474 "../src/Controllers/DirectoryController.vala"
		return FALSE;
#line 2355 "DirectoryController.c"
	}
	goto __finally0;
	__catch0_tuner_data_provider_data_error:
	{
#line 462 "../src/Controllers/DirectoryController.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 477 "../src/Controllers/DirectoryController.vala"
		_data_->_tmp21_ = g_error_new_literal (SOURCE_ERROR, SOURCE_ERROR_UNAVAILABLE, "Directory Error");
#line 477 "../src/Controllers/DirectoryController.vala"
		_data_->_inner_error0_ = _data_->_tmp21_;
#line 2366 "DirectoryController.c"
		goto __finally0;
	}
	__finally0:
#line 462 "../src/Controllers/DirectoryController.vala"
	if (_data_->_inner_error0_->domain == SOURCE_ERROR) {
#line 462 "../src/Controllers/DirectoryController.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 462 "../src/Controllers/DirectoryController.vala"
		g_object_unref (_data_->_async_result);
#line 462 "../src/Controllers/DirectoryController.vala"
		return FALSE;
#line 2378 "DirectoryController.c"
	} else {
#line 462 "../src/Controllers/DirectoryController.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 462 "../src/Controllers/DirectoryController.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 462 "../src/Controllers/DirectoryController.vala"
		g_object_unref (_data_->_async_result);
#line 462 "../src/Controllers/DirectoryController.vala"
		return FALSE;
#line 2388 "DirectoryController.c"
	}
}

/**
* @brief Check if there are more stations to fetch.
*
* @return true if there are more stations, false otherwise.
*/
gboolean
tuner_station_set_has_more (TunerStationSet* self)
{
	gboolean result;
#line 487 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 489 "../src/Controllers/DirectoryController.vala"
	result = self->priv->_more;
#line 489 "../src/Controllers/DirectoryController.vala"
	return result;
#line 2407 "DirectoryController.c"
}

/**
* @brief Convert RadioBrowser.Station objects to Model.Station objects.
*
* @param raw_stations An iterator of RadioBrowser.Station objects.
* @return An ArrayList of converted Model.Station objects.
*/
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 503 "../src/Controllers/DirectoryController.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 503 "../src/Controllers/DirectoryController.vala"
	return _data1_;
#line 2423 "DirectoryController.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 503 "../src/Controllers/DirectoryController.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 2433 "DirectoryController.c"
		TunerStationSet* self;
#line 503 "../src/Controllers/DirectoryController.vala"
		self = _data1_->self;
#line 503 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (_data1_->station);
#line 503 "../src/Controllers/DirectoryController.vala"
		_g_object_unref0 (self);
#line 503 "../src/Controllers/DirectoryController.vala"
		g_slice_free (Block1Data, _data1_);
#line 2443 "DirectoryController.c"
	}
}

static void
___lambda65_ (Block1Data* _data1_)
{
	TunerStationSet* self;
	TunerStarStore* _tmp0_;
	TunerModelStation* _tmp1_;
#line 506 "../src/Controllers/DirectoryController.vala"
	self = _data1_->self;
#line 508 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = self->priv->_star_store;
#line 508 "../src/Controllers/DirectoryController.vala"
	_tmp1_ = _data1_->station;
#line 508 "../src/Controllers/DirectoryController.vala"
	tuner_star_store_update_from_station (_tmp0_, _tmp1_);
#line 2461 "DirectoryController.c"
}

static void
____lambda65__tuner_model_station_station_star_changed_sig (TunerModelStation* _sender,
                                                            gboolean starred,
                                                            gpointer self)
{
#line 506 "../src/Controllers/DirectoryController.vala"
	___lambda65_ (self);
#line 2471 "DirectoryController.c"
}

static GeeSet*
tuner_station_set_convert_stations (TunerStationSet* self,
                                    GeeIterator* raw_stations)
{
	GeeHashSet* stations = NULL;
	GeeHashSet* _tmp0_;
	GeeSet* result;
#line 499 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 499 "../src/Controllers/DirectoryController.vala"
	g_return_val_if_fail (raw_stations != NULL, NULL);
#line 501 "../src/Controllers/DirectoryController.vala"
	_tmp0_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 501 "../src/Controllers/DirectoryController.vala"
	stations = _tmp0_;
#line 503 "../src/Controllers/DirectoryController.vala"
	while (TRUE) {
#line 2491 "DirectoryController.c"
		Block1Data* _data1_;
		gpointer _tmp1_;
		TunerModelStation* _tmp2_;
		GeeHashSet* _tmp3_;
		TunerModelStation* _tmp4_;
#line 503 "../src/Controllers/DirectoryController.vala"
		_data1_ = g_slice_new0 (Block1Data);
#line 503 "../src/Controllers/DirectoryController.vala"
		_data1_->_ref_count_ = 1;
#line 503 "../src/Controllers/DirectoryController.vala"
		_data1_->self = g_object_ref (self);
#line 503 "../src/Controllers/DirectoryController.vala"
		if (!gee_iterator_next (raw_stations)) {
#line 503 "../src/Controllers/DirectoryController.vala"
			block1_data_unref (_data1_);
#line 503 "../src/Controllers/DirectoryController.vala"
			_data1_ = NULL;
#line 503 "../src/Controllers/DirectoryController.vala"
			break;
#line 2511 "DirectoryController.c"
		}
#line 505 "../src/Controllers/DirectoryController.vala"
		_tmp1_ = gee_iterator_get (raw_stations);
#line 505 "../src/Controllers/DirectoryController.vala"
		_data1_->station = (TunerModelStation*) _tmp1_;
#line 506 "../src/Controllers/DirectoryController.vala"
		_tmp2_ = _data1_->station;
#line 506 "../src/Controllers/DirectoryController.vala"
		g_signal_connect_data (_tmp2_, "station-star-changed-sig", (GCallback) ____lambda65__tuner_model_station_station_star_changed_sig, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 510 "../src/Controllers/DirectoryController.vala"
		_tmp3_ = stations;
#line 510 "../src/Controllers/DirectoryController.vala"
		_tmp4_ = _data1_->station;
#line 510 "../src/Controllers/DirectoryController.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, _tmp4_);
#line 503 "../src/Controllers/DirectoryController.vala"
		block1_data_unref (_data1_);
#line 503 "../src/Controllers/DirectoryController.vala"
		_data1_ = NULL;
#line 2531 "DirectoryController.c"
	}
#line 512 "../src/Controllers/DirectoryController.vala"
	result = (GeeSet*) stations;
#line 512 "../src/Controllers/DirectoryController.vala"
	return result;
#line 2537 "DirectoryController.c"
}

static void
tuner_station_set_class_init (TunerStationSetClass * klass,
                              gpointer klass_data)
{
#line 387 "../src/Controllers/DirectoryController.vala"
	tuner_station_set_parent_class = g_type_class_peek_parent (klass);
#line 387 "../src/Controllers/DirectoryController.vala"
	g_type_class_adjust_private_offset (klass, &TunerStationSet_private_offset);
#line 387 "../src/Controllers/DirectoryController.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_station_set_finalize;
#line 2550 "DirectoryController.c"
}

static void
tuner_station_set_instance_init (TunerStationSet * self,
                                 gpointer klass)
{
#line 387 "../src/Controllers/DirectoryController.vala"
	self->priv = tuner_station_set_get_instance_private (self);
#line 389 "../src/Controllers/DirectoryController.vala"
	self->priv->_offset = (guint) 0;
#line 390 "../src/Controllers/DirectoryController.vala"
	self->priv->_page_size = (guint) 20;
#line 391 "../src/Controllers/DirectoryController.vala"
	self->priv->_more = TRUE;
#line 2565 "DirectoryController.c"
}

static void
tuner_station_set_finalize (GObject * obj)
{
	TunerStationSet * self;
#line 387 "../src/Controllers/DirectoryController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_STATION_SET, TunerStationSet);
#line 392 "../src/Controllers/DirectoryController.vala"
	tuner_data_provider_search_params_destroy (&self->priv->_params);
#line 393 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (self->priv->_provider);
#line 394 "../src/Controllers/DirectoryController.vala"
	_g_object_unref0 (self->priv->_star_store);
#line 387 "../src/Controllers/DirectoryController.vala"
	G_OBJECT_CLASS (tuner_station_set_parent_class)->finalize (obj);
#line 2582 "DirectoryController.c"
}

/**
 * @brief A pagable set of Stations
 */
static GType
tuner_station_set_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerStationSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_station_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerStationSet), 0, (GInstanceInitFunc) tuner_station_set_instance_init, NULL };
	GType tuner_station_set_type_id;
	tuner_station_set_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerStationSet", &g_define_type_info, 0);
	TunerStationSet_private_offset = g_type_add_instance_private (tuner_station_set_type_id, sizeof (TunerStationSetPrivate));
	return tuner_station_set_type_id;
}

GType
tuner_station_set_get_type (void)
{
	static volatile gsize tuner_station_set_type_id__once = 0;
	if (g_once_init_enter (&tuner_station_set_type_id__once)) {
		GType tuner_station_set_type_id;
		tuner_station_set_type_id = tuner_station_set_get_type_once ();
		g_once_init_leave (&tuner_station_set_type_id__once, tuner_station_set_type_id);
	}
	return tuner_station_set_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

