/* PlayerController.c generated by valac 0.56.17, the Vala compiler
 * generated from PlayerController.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file PlayerController.vala
 */

#include <glib-object.h>
#include <glib.h>
#include <gst/player/player.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#define TUNER_PLAYER_CONTROLLER_TEN_MINUTES_IN_SECONDS ((guint) 606)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_PLAYER_CONTROLLER (tuner_player_controller_get_type ())
#define TUNER_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController))
#define TUNER_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))
#define TUNER_IS_PLAYER_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_IS_PLAYER_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PLAYER_CONTROLLER))
#define TUNER_PLAYER_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerControllerClass))

typedef struct _TunerPlayerController TunerPlayerController;
typedef struct _TunerPlayerControllerClass TunerPlayerControllerClass;
typedef struct _TunerPlayerControllerPrivate TunerPlayerControllerPrivate;

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;

#define TUNER_MODEL_TYPE_METADATA (tuner_model_metadata_get_type ())
#define TUNER_MODEL_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_METADATA, TunerModelMetadata))
#define TUNER_MODEL_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_METADATA, TunerModelMetadataClass))
#define TUNER_MODEL_IS_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_METADATA))
#define TUNER_MODEL_IS_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_METADATA))
#define TUNER_MODEL_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_METADATA, TunerModelMetadataClass))

typedef struct _TunerModelMetadata TunerModelMetadata;
typedef struct _TunerModelMetadataClass TunerModelMetadataClass;
typedef enum  {
	TUNER_PLAYER_CONTROLLER_IS_BUFFERING,
	TUNER_PLAYER_CONTROLLER_IS_PAUSED,
	TUNER_PLAYER_CONTROLLER_IS_PLAYING,
	TUNER_PLAYER_CONTROLLER_IS_STOPPED,
	TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR
} TunerPlayerControllerIs;

#define TUNER_PLAYER_CONTROLLER_TYPE_IS (tuner_player_controller_is_get_type ())
enum  {
	TUNER_PLAYER_CONTROLLER_0_PROPERTY,
	TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY,
	TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY,
	TUNER_PLAYER_CONTROLLER_STATION_PROPERTY,
	TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY,
	TUNER_PLAYER_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;

#define TUNER_TYPE_SETTINGS (tuner_settings_get_type ())
#define TUNER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_SETTINGS, TunerSettings))
#define TUNER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_SETTINGS, TunerSettingsClass))
#define TUNER_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_SETTINGS))
#define TUNER_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_SETTINGS))
#define TUNER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_SETTINGS, TunerSettingsClass))

typedef struct _TunerSettings TunerSettings;
typedef struct _TunerSettingsClass TunerSettingsClass;
enum  {
	TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_METADATA_CHANGED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_TAPE_COUNTER_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_SHUFFLE_REQUESTED_SIG_SIGNAL,
	TUNER_PLAYER_CONTROLLER_NUM_SIGNALS
};
static guint tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_NUM_SIGNALS] = {0};

struct _TunerPlayerController {
	GObject parent_instance;
	TunerPlayerControllerPrivate * priv;
};

struct _TunerPlayerControllerClass {
	GObjectClass parent_class;
};

struct _TunerPlayerControllerPrivate {
	gboolean _play_error;
	GstPlayer* _player;
	TunerModelStation* _station;
	TunerModelMetadata* _metadata;
	TunerPlayerControllerIs _player_state;
	gchar* _player_state_name;
	guint _tape_counter_id;
};

static gint TunerPlayerController_private_offset;
static gpointer tuner_player_controller_parent_class = NULL;

VALA_EXTERN GType tuner_player_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPlayerController, g_object_unref)
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN GType tuner_model_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelMetadata, g_object_unref)
VALA_EXTERN GType tuner_player_controller_is_get_type (void) G_GNUC_CONST ;
static void tuner_player_controller_set_play_state (TunerPlayerController* self,
                                             const gchar* state);
static gboolean ___lambda6_ (TunerPlayerController* self);
static void tuner_player_controller_set_player_state (TunerPlayerController* self,
                                               TunerPlayerControllerIs value);
static gboolean ____lambda6__gsource_func (gpointer self);
static gboolean ___lambda8_ (TunerPlayerController* self);
static gboolean ____lambda8__gsource_func (gpointer self);
VALA_EXTERN gboolean tuner_player_controller_get_play_error (TunerPlayerController* self);
static gboolean ____lambda9_ (TunerPlayerController* self);
static gboolean _____lambda9__gsource_func (gpointer self);
static gboolean ____lambda10_ (TunerPlayerController* self);
static gboolean _____lambda10__gsource_func (gpointer self);
VALA_EXTERN void tuner_player_controller_play_station (TunerPlayerController* self,
                                           TunerModelStation* station);
VALA_EXTERN const gchar* tuner_model_station_get_urlResolved (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_url (TunerModelStation* self);
static void tuner_player_controller_set_play_error (TunerPlayerController* self,
                                             gboolean value);
static gboolean __lambda11_ (TunerPlayerController* self);
static gboolean ___lambda11__gsource_func (gpointer self);
VALA_EXTERN gboolean tuner_player_controller_can_play (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_play_pause (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_stop (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_shuffle (TunerPlayerController* self);
VALA_EXTERN TunerPlayerController* tuner_player_controller_new (void);
VALA_EXTERN TunerPlayerController* tuner_player_controller_construct (GType object_type);
VALA_EXTERN TunerPlayerControllerIs tuner_player_controller_get_player_state (TunerPlayerController* self);
static gboolean _tuner_player_controller_player_state_____lambda7_ (TunerPlayerController* self);
static gboolean __tuner_player_controller_player_state_____lambda7__gsource_func (gpointer self);
VALA_EXTERN TunerModelStation* tuner_player_controller_get_station (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_station (TunerPlayerController* self,
                                          TunerModelStation* value);
VALA_EXTERN TunerModelMetadata* tuner_model_metadata_new (void);
VALA_EXTERN TunerModelMetadata* tuner_model_metadata_construct (GType object_type);
VALA_EXTERN gdouble tuner_player_controller_get_volume (TunerPlayerController* self);
VALA_EXTERN void tuner_player_controller_set_volume (TunerPlayerController* self,
                                         gdouble value);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * tuner_player_controller_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _tuner_player_controller___lambda12_ (TunerPlayerController* self,
                                           GError* _error_);
static void __tuner_player_controller___lambda12__gst_player_error (GstPlayer* _sender,
                                                             GError* object,
                                                             gpointer self);
static void _tuner_player_controller___lambda13_ (TunerPlayerController* self,
                                           GstPlayerMediaInfo* obj);
VALA_EXTERN gboolean tuner_model_metadata_process_media_info_update (TunerModelMetadata* self,
                                                         GstPlayerMediaInfo* media_info);
static void __tuner_player_controller___lambda13__gst_player_media_info_updated (GstPlayer* _sender,
                                                                          GstPlayerMediaInfo* object,
                                                                          gpointer self);
static void _tuner_player_controller___lambda14_ (TunerPlayerController* self,
                                           GstPlayer* obj);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN GType tuner_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerSettings, g_object_unref)
VALA_EXTERN TunerSettings* tuner_application_get_settings (TunerApplication* self);
VALA_EXTERN void tuner_settings_set_volume (TunerSettings* self,
                                gdouble value);
static void __tuner_player_controller___lambda14__gst_player_volume_changed (GstPlayer* _sender,
                                                                      gpointer self);
static void _tuner_player_controller___lambda15_ (TunerPlayerController* self,
                                           GstPlayerState state);
static void __tuner_player_controller___lambda15__gst_player_state_changed (GstPlayer* _sender,
                                                                     GstPlayerState object,
                                                                     gpointer self);
static void tuner_player_controller_finalize (GObject * obj);
static GType tuner_player_controller_get_type_once (void);
static void _vala_tuner_player_controller_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_tuner_player_controller_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
tuner_player_controller_get_instance_private (TunerPlayerController* self)
{
	return G_STRUCT_MEMBER_P (self, TunerPlayerController_private_offset);
}

/**
     * @brief the Tuner play state
     *
     * Using our own play state keeps gstreamer deps out of the rest of the code
     */
static GType
tuner_player_controller_is_get_type_once (void)
{
	static const GEnumValue values[] = {{TUNER_PLAYER_CONTROLLER_IS_BUFFERING, "TUNER_PLAYER_CONTROLLER_IS_BUFFERING", "buffering"}, {TUNER_PLAYER_CONTROLLER_IS_PAUSED, "TUNER_PLAYER_CONTROLLER_IS_PAUSED", "paused"}, {TUNER_PLAYER_CONTROLLER_IS_PLAYING, "TUNER_PLAYER_CONTROLLER_IS_PLAYING", "playing"}, {TUNER_PLAYER_CONTROLLER_IS_STOPPED, "TUNER_PLAYER_CONTROLLER_IS_STOPPED", "stopped"}, {TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR, "TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR", "stopped-error"}, {0, NULL, NULL}};
	GType tuner_player_controller_is_type_id;
	tuner_player_controller_is_type_id = g_enum_register_static ("TunerPlayerControllerIs", values);
	return tuner_player_controller_is_type_id;
}

GType
tuner_player_controller_is_get_type (void)
{
	static volatile gsize tuner_player_controller_is_type_id__once = 0;
	if (g_once_init_enter (&tuner_player_controller_is_type_id__once)) {
		GType tuner_player_controller_is_type_id;
		tuner_player_controller_is_type_id = tuner_player_controller_is_get_type_once ();
		g_once_init_leave (&tuner_player_controller_is_type_id__once, tuner_player_controller_is_type_id);
	}
	return tuner_player_controller_is_type_id__once;
}

/** 
     * @brief Process the Player play state changes emited from gstreamer.
     * 
     * Actions are set in a seperate thread as attempting UI interaction 
     * on the gstreamer signal results in a seg fault
     */
static gboolean
___lambda6_ (TunerPlayerController* self)
{
	gboolean result;
#line 117 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_set_player_state (self, TUNER_PLAYER_CONTROLLER_IS_PLAYING);
#line 118 "../src/Controllers/PlayerController.vala"
	result = FALSE;
#line 118 "../src/Controllers/PlayerController.vala"
	return result;
#line 307 "PlayerController.c"
}

static gboolean
____lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda6_ ((TunerPlayerController*) self);
#line 116 "../src/Controllers/PlayerController.vala"
	return result;
#line 317 "PlayerController.c"
}

static gboolean
___lambda8_ (TunerPlayerController* self)
{
	gboolean result;
#line 124 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_set_player_state (self, TUNER_PLAYER_CONTROLLER_IS_BUFFERING);
#line 125 "../src/Controllers/PlayerController.vala"
	result = FALSE;
#line 125 "../src/Controllers/PlayerController.vala"
	return result;
#line 330 "PlayerController.c"
}

static gboolean
____lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda8_ ((TunerPlayerController*) self);
#line 123 "../src/Controllers/PlayerController.vala"
	return result;
#line 340 "PlayerController.c"
}

static gboolean
____lambda9_ (TunerPlayerController* self)
{
	gboolean result;
#line 133 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_set_player_state (self, TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR);
#line 134 "../src/Controllers/PlayerController.vala"
	result = FALSE;
#line 134 "../src/Controllers/PlayerController.vala"
	return result;
#line 353 "PlayerController.c"
}

static gboolean
_____lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda9_ ((TunerPlayerController*) self);
#line 132 "../src/Controllers/PlayerController.vala"
	return result;
#line 363 "PlayerController.c"
}

static gboolean
____lambda10_ (TunerPlayerController* self)
{
	gboolean result;
#line 140 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_set_player_state (self, TUNER_PLAYER_CONTROLLER_IS_STOPPED);
#line 141 "../src/Controllers/PlayerController.vala"
	result = FALSE;
#line 141 "../src/Controllers/PlayerController.vala"
	return result;
#line 376 "PlayerController.c"
}

static gboolean
_____lambda10__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda10_ ((TunerPlayerController*) self);
#line 139 "../src/Controllers/PlayerController.vala"
	return result;
#line 386 "PlayerController.c"
}

static void
tuner_player_controller_set_play_state (TunerPlayerController* self,
                                        const gchar* state)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 114 "../src/Controllers/PlayerController.vala"
	static GQuark _tmp1_label0 = 0;
#line 114 "../src/Controllers/PlayerController.vala"
	static GQuark _tmp1_label1 = 0;
#line 112 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (state != NULL);
#line 114 "../src/Controllers/PlayerController.vala"
	_tmp0_ = state;
#line 114 "../src/Controllers/PlayerController.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 114 "../src/Controllers/PlayerController.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("playing")))) {
#line 114 "../src/Controllers/PlayerController.vala"
		switch (0) {
#line 411 "PlayerController.c"
			default:
			{
#line 116 "../src/Controllers/PlayerController.vala"
				gdk_threads_add_idle (____lambda6__gsource_func, self);
#line 120 "../src/Controllers/PlayerController.vala"
				break;
#line 418 "PlayerController.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("buffering")))) {
#line 114 "../src/Controllers/PlayerController.vala"
		switch (0) {
#line 424 "PlayerController.c"
			default:
			{
#line 123 "../src/Controllers/PlayerController.vala"
				gdk_threads_add_idle (____lambda8__gsource_func, self);
#line 127 "../src/Controllers/PlayerController.vala"
				break;
#line 431 "PlayerController.c"
			}
		}
	} else {
#line 114 "../src/Controllers/PlayerController.vala"
		switch (0) {
#line 437 "PlayerController.c"
			default:
			{
				gboolean _tmp3_;
#line 130 "../src/Controllers/PlayerController.vala"
				_tmp3_ = self->priv->_play_error;
#line 130 "../src/Controllers/PlayerController.vala"
				if (_tmp3_) {
#line 132 "../src/Controllers/PlayerController.vala"
					gdk_threads_add_idle (_____lambda9__gsource_func, self);
#line 447 "PlayerController.c"
				} else {
#line 139 "../src/Controllers/PlayerController.vala"
					gdk_threads_add_idle (_____lambda10__gsource_func, self);
#line 451 "PlayerController.c"
				}
#line 144 "../src/Controllers/PlayerController.vala"
				break;
#line 455 "PlayerController.c"
			}
		}
	}
}

/**
    * @brief Plays the specified station.
    *
    * @param station The station to play.
    */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 220 "../src/Controllers/PlayerController.vala"
	return self ? g_object_ref (self) : NULL;
#line 471 "PlayerController.c"
}

static gboolean
__lambda11_ (TunerPlayerController* self)
{
	GstPlayer* _tmp0_;
	gboolean result;
#line 227 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_player;
#line 227 "../src/Controllers/PlayerController.vala"
	gst_player_play (_tmp0_);
#line 228 "../src/Controllers/PlayerController.vala"
	result = G_SOURCE_REMOVE;
#line 228 "../src/Controllers/PlayerController.vala"
	return result;
#line 487 "PlayerController.c"
}

static gboolean
___lambda11__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda11_ ((TunerPlayerController*) self);
#line 224 "../src/Controllers/PlayerController.vala"
	return result;
#line 497 "PlayerController.c"
}

void
tuner_player_controller_play_station (TunerPlayerController* self,
                                      TunerModelStation* station)
{
	GstPlayer* _tmp0_;
	TunerModelStation* _tmp1_;
	TunerModelStation* _tmp2_;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	TunerModelStation* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GstPlayer* _tmp17_;
#line 217 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (station != NULL);
#line 219 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_player;
#line 219 "../src/Controllers/PlayerController.vala"
	gst_player_stop (_tmp0_);
#line 220 "../src/Controllers/PlayerController.vala"
	_tmp1_ = _g_object_ref0 (station);
#line 220 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->priv->_station);
#line 220 "../src/Controllers/PlayerController.vala"
	self->priv->_station = _tmp1_;
#line 221 "../src/Controllers/PlayerController.vala"
	_tmp2_ = self->priv->_station;
#line 221 "../src/Controllers/PlayerController.vala"
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIG_SIGNAL], 0, _tmp2_);
#line 222 "../src/Controllers/PlayerController.vala"
	_tmp5_ = self->priv->_station;
#line 222 "../src/Controllers/PlayerController.vala"
	_tmp6_ = tuner_model_station_get_urlResolved (_tmp5_);
#line 222 "../src/Controllers/PlayerController.vala"
	_tmp7_ = _tmp6_;
#line 222 "../src/Controllers/PlayerController.vala"
	if (_tmp7_ != NULL) {
#line 539 "PlayerController.c"
		TunerModelStation* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp8_ = self->priv->_station;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp9_ = tuner_model_station_get_urlResolved (_tmp8_);
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp10_ = _tmp9_;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp4_ = g_strcmp0 (_tmp10_, "") != 0;
#line 551 "PlayerController.c"
	} else {
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp4_ = FALSE;
#line 555 "PlayerController.c"
	}
#line 222 "../src/Controllers/PlayerController.vala"
	if (_tmp4_) {
#line 559 "PlayerController.c"
		TunerModelStation* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp11_ = self->priv->_station;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp12_ = tuner_model_station_get_urlResolved (_tmp11_);
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp13_ = _tmp12_;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp3_ = _tmp13_;
#line 571 "PlayerController.c"
	} else {
		TunerModelStation* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp14_ = self->priv->_station;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp15_ = tuner_model_station_get_url (_tmp14_);
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp16_ = _tmp15_;
#line 222 "../src/Controllers/PlayerController.vala"
		_tmp3_ = _tmp16_;
#line 584 "PlayerController.c"
	}
#line 222 "../src/Controllers/PlayerController.vala"
	_tmp17_ = self->priv->_player;
#line 222 "../src/Controllers/PlayerController.vala"
	gst_player_set_uri (_tmp17_, _tmp3_);
#line 223 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_set_play_error (self, FALSE);
#line 224 "../src/Controllers/PlayerController.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda11__gsource_func, g_object_ref (self), g_object_unref);
#line 594 "PlayerController.c"
}

/**
     * @brief Checks if the player has a station to play.
     *
     * @return True if a station is ready to be played
     */
gboolean
tuner_player_controller_can_play (TunerPlayerController* self)
{
	TunerModelStation* _tmp0_;
	gboolean result;
#line 238 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 239 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_station;
#line 239 "../src/Controllers/PlayerController.vala"
	result = _tmp0_ != NULL;
#line 239 "../src/Controllers/PlayerController.vala"
	return result;
#line 615 "PlayerController.c"
}

/**
     * @brief Toggles play/pause state of the player.
     */
void
tuner_player_controller_play_pause (TunerPlayerController* self)
{
#line 246 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/Controllers/PlayerController.vala"
	switch (self->priv->_player_state) {
#line 247 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_IS_PLAYING:
#line 247 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_IS_BUFFERING:
#line 632 "PlayerController.c"
		{
			GstPlayer* _tmp0_;
#line 250 "../src/Controllers/PlayerController.vala"
			_tmp0_ = self->priv->_player;
#line 250 "../src/Controllers/PlayerController.vala"
			gst_player_stop (_tmp0_);
#line 251 "../src/Controllers/PlayerController.vala"
			break;
#line 641 "PlayerController.c"
		}
		default:
		{
			GstPlayer* _tmp1_;
#line 253 "../src/Controllers/PlayerController.vala"
			_tmp1_ = self->priv->_player;
#line 253 "../src/Controllers/PlayerController.vala"
			gst_player_play (_tmp1_);
#line 254 "../src/Controllers/PlayerController.vala"
			break;
#line 652 "PlayerController.c"
		}
	}
}

/**
     * @brief Stops the player
     *
     */
void
tuner_player_controller_stop (TunerPlayerController* self)
{
	GstPlayer* _tmp0_;
#line 263 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_player;
#line 264 "../src/Controllers/PlayerController.vala"
	gst_player_stop (_tmp0_);
#line 671 "PlayerController.c"
}

/**
     * Shuffles the current playlist.
     *
     * This method randomizes the order of the tracks in the current playlist.
     */
void
tuner_player_controller_shuffle (TunerPlayerController* self)
{
#line 273 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/Controllers/PlayerController.vala"
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_SHUFFLE_REQUESTED_SIG_SIGNAL], 0);
#line 686 "PlayerController.c"
}

TunerPlayerController*
tuner_player_controller_construct (GType object_type)
{
	TunerPlayerController * self = NULL;
#line 20 "../src/Controllers/PlayerController.vala"
	self = (TunerPlayerController*) g_object_new (object_type, NULL);
#line 20 "../src/Controllers/PlayerController.vala"
	return self;
#line 697 "PlayerController.c"
}

TunerPlayerController*
tuner_player_controller_new (void)
{
#line 20 "../src/Controllers/PlayerController.vala"
	return tuner_player_controller_construct (TUNER_TYPE_PLAYER_CONTROLLER);
#line 705 "PlayerController.c"
}

gboolean
tuner_player_controller_get_play_error (TunerPlayerController* self)
{
	gboolean result;
#line 55 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/Controllers/PlayerController.vala"
	result = self->priv->_play_error;
#line 55 "../src/Controllers/PlayerController.vala"
	return result;
#line 718 "PlayerController.c"
}

static void
tuner_player_controller_set_play_error (TunerPlayerController* self,
                                        gboolean value)
{
	gboolean old_value;
#line 55 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Controllers/PlayerController.vala"
	old_value = tuner_player_controller_get_play_error (self);
#line 55 "../src/Controllers/PlayerController.vala"
	if (old_value != value) {
#line 55 "../src/Controllers/PlayerController.vala"
		self->priv->_play_error = value;
#line 55 "../src/Controllers/PlayerController.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY]);
#line 736 "PlayerController.c"
	}
}

TunerPlayerControllerIs
tuner_player_controller_get_player_state (TunerPlayerController* self)
{
	TunerPlayerControllerIs result;
#line 155 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 156 "../src/Controllers/PlayerController.vala"
	result = self->priv->_player_state;
#line 156 "../src/Controllers/PlayerController.vala"
	return result;
#line 750 "PlayerController.c"
}

static gboolean
_tuner_player_controller_player_state_____lambda7_ (TunerPlayerController* self)
{
	TunerModelStation* _tmp0_;
	gboolean result;
#line 175 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_station;
#line 175 "../src/Controllers/PlayerController.vala"
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_TAPE_COUNTER_SIG_SIGNAL], 0, _tmp0_);
#line 176 "../src/Controllers/PlayerController.vala"
	result = G_SOURCE_CONTINUE;
#line 176 "../src/Controllers/PlayerController.vala"
	return result;
#line 766 "PlayerController.c"
}

static gboolean
__tuner_player_controller_player_state_____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = _tuner_player_controller_player_state_____lambda7_ ((TunerPlayerController*) self);
#line 173 "../src/Controllers/PlayerController.vala"
	return result;
#line 776 "PlayerController.c"
}

static void
tuner_player_controller_set_player_state (TunerPlayerController* self,
                                          TunerPlayerControllerIs value)
{
	TunerModelStation* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 159 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/Controllers/PlayerController.vala"
	self->priv->_player_state = value;
#line 161 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_station;
#line 161 "../src/Controllers/PlayerController.vala"
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIG_SIGNAL], 0, _tmp0_, value);
#line 163 "../src/Controllers/PlayerController.vala"
	if (value == TUNER_PLAYER_CONTROLLER_IS_STOPPED) {
#line 163 "../src/Controllers/PlayerController.vala"
		_tmp1_ = TRUE;
#line 797 "PlayerController.c"
	} else {
#line 163 "../src/Controllers/PlayerController.vala"
		_tmp1_ = value == TUNER_PLAYER_CONTROLLER_IS_STOPPED_ERROR;
#line 801 "PlayerController.c"
	}
#line 163 "../src/Controllers/PlayerController.vala"
	if (_tmp1_) {
#line 165 "../src/Controllers/PlayerController.vala"
		if (self->priv->_tape_counter_id > ((guint) 0)) {
#line 167 "../src/Controllers/PlayerController.vala"
			g_source_remove (self->priv->_tape_counter_id);
#line 168 "../src/Controllers/PlayerController.vala"
			self->priv->_tape_counter_id = (guint) 0;
#line 811 "PlayerController.c"
		}
	} else {
#line 171 "../src/Controllers/PlayerController.vala"
		if (value == TUNER_PLAYER_CONTROLLER_IS_PLAYING) {
#line 173 "../src/Controllers/PlayerController.vala"
			self->priv->_tape_counter_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, TUNER_PLAYER_CONTROLLER_TEN_MINUTES_IN_SECONDS, __tuner_player_controller_player_state_____lambda7__gsource_func, g_object_ref (self), g_object_unref);
#line 818 "PlayerController.c"
		}
	}
#line 159 "../src/Controllers/PlayerController.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY]);
#line 823 "PlayerController.c"
}

TunerModelStation*
tuner_player_controller_get_station (TunerPlayerController* self)
{
	TunerModelStation* result;
	TunerModelStation* _tmp0_;
#line 188 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_station;
#line 189 "../src/Controllers/PlayerController.vala"
	result = _tmp0_;
#line 189 "../src/Controllers/PlayerController.vala"
	return result;
#line 839 "PlayerController.c"
}

void
tuner_player_controller_set_station (TunerPlayerController* self,
                                     TunerModelStation* value)
{
	gboolean _tmp0_ = FALSE;
	TunerModelStation* _tmp1_;
#line 191 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 192 "../src/Controllers/PlayerController.vala"
	_tmp1_ = self->priv->_station;
#line 192 "../src/Controllers/PlayerController.vala"
	if (_tmp1_ == NULL) {
#line 192 "../src/Controllers/PlayerController.vala"
		_tmp0_ = TRUE;
#line 856 "PlayerController.c"
	} else {
		TunerModelStation* _tmp2_;
#line 192 "../src/Controllers/PlayerController.vala"
		_tmp2_ = self->priv->_station;
#line 192 "../src/Controllers/PlayerController.vala"
		_tmp0_ = _tmp2_ != value;
#line 863 "PlayerController.c"
	}
#line 192 "../src/Controllers/PlayerController.vala"
	if (_tmp0_) {
#line 867 "PlayerController.c"
		TunerModelMetadata* _tmp3_;
		TunerModelStation* _tmp4_;
		TunerModelStation* _tmp5_;
#line 194 "../src/Controllers/PlayerController.vala"
		_tmp3_ = tuner_model_metadata_new ();
#line 194 "../src/Controllers/PlayerController.vala"
		_g_object_unref0 (self->priv->_metadata);
#line 194 "../src/Controllers/PlayerController.vala"
		self->priv->_metadata = _tmp3_;
#line 195 "../src/Controllers/PlayerController.vala"
		_tmp4_ = _g_object_ref0 (value);
#line 195 "../src/Controllers/PlayerController.vala"
		_g_object_unref0 (self->priv->_station);
#line 195 "../src/Controllers/PlayerController.vala"
		self->priv->_station = _tmp4_;
#line 196 "../src/Controllers/PlayerController.vala"
		_tmp5_ = self->priv->_station;
#line 196 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_play_station (self, _tmp5_);
#line 887 "PlayerController.c"
	}
#line 191 "../src/Controllers/PlayerController.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_STATION_PROPERTY]);
#line 891 "PlayerController.c"
}

gdouble
tuner_player_controller_get_volume (TunerPlayerController* self)
{
	gdouble result;
	GstPlayer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 207 "../src/Controllers/PlayerController.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 207 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_player;
#line 207 "../src/Controllers/PlayerController.vala"
	_tmp1_ = gst_player_get_volume (_tmp0_);
#line 207 "../src/Controllers/PlayerController.vala"
	_tmp2_ = _tmp1_;
#line 207 "../src/Controllers/PlayerController.vala"
	result = _tmp2_;
#line 207 "../src/Controllers/PlayerController.vala"
	return result;
#line 913 "PlayerController.c"
}

void
tuner_player_controller_set_volume (TunerPlayerController* self,
                                    gdouble value)
{
	GstPlayer* _tmp0_;
#line 208 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_player;
#line 208 "../src/Controllers/PlayerController.vala"
	gst_player_set_volume (_tmp0_, value);
#line 208 "../src/Controllers/PlayerController.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY]);
#line 929 "PlayerController.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 20 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (n_param_values == 3);
#line 20 "../src/Controllers/PlayerController.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 20 "../src/Controllers/PlayerController.vala"
		data1 = closure->data;
#line 20 "../src/Controllers/PlayerController.vala"
		data2 = param_values->data[0].v_pointer;
#line 954 "PlayerController.c"
	} else {
#line 20 "../src/Controllers/PlayerController.vala"
		data1 = param_values->data[0].v_pointer;
#line 20 "../src/Controllers/PlayerController.vala"
		data2 = closure->data;
#line 960 "PlayerController.c"
	}
#line 20 "../src/Controllers/PlayerController.vala"
	callback = (GMarshalFunc_VOID__OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 20 "../src/Controllers/PlayerController.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), data2);
#line 966 "PlayerController.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 20 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (n_param_values == 3);
#line 20 "../src/Controllers/PlayerController.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 20 "../src/Controllers/PlayerController.vala"
		data1 = closure->data;
#line 20 "../src/Controllers/PlayerController.vala"
		data2 = param_values->data[0].v_pointer;
#line 991 "PlayerController.c"
	} else {
#line 20 "../src/Controllers/PlayerController.vala"
		data1 = param_values->data[0].v_pointer;
#line 20 "../src/Controllers/PlayerController.vala"
		data2 = closure->data;
#line 997 "PlayerController.c"
	}
#line 20 "../src/Controllers/PlayerController.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 20 "../src/Controllers/PlayerController.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1003 "PlayerController.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 1016 "PlayerController.c"
}

static void
_tuner_player_controller___lambda12_ (TunerPlayerController* self,
                                      GError* _error_)
{
	GstPlayer* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 71 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (_error_ != NULL);
#line 74 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_set_play_error (self, TRUE);
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_player;
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp1_ = gst_player_get_uri (_tmp0_);
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp2_ = _tmp1_;
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp3_ = _tmp2_;
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp4_ = string_to_string (_tmp3_);
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp5_ = _error_->message;
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp6_ = string_to_string (_tmp5_);
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp7_ = g_strconcat ("player error on url ", _tmp4_, ": ", _tmp6_, NULL);
#line 75 "../src/Controllers/PlayerController.vala"
	_tmp8_ = _tmp7_;
#line 75 "../src/Controllers/PlayerController.vala"
	g_info ("PlayerController.vala:75: %s", _tmp8_);
#line 75 "../src/Controllers/PlayerController.vala"
	_g_free0 (_tmp8_);
#line 75 "../src/Controllers/PlayerController.vala"
	_g_free0 (_tmp3_);
#line 1060 "PlayerController.c"
}

static void
__tuner_player_controller___lambda12__gst_player_error (GstPlayer* _sender,
                                                        GError* object,
                                                        gpointer self)
{
#line 71 "../src/Controllers/PlayerController.vala"
	_tuner_player_controller___lambda12_ ((TunerPlayerController*) self, object);
#line 1070 "PlayerController.c"
}

static void
_tuner_player_controller___lambda13_ (TunerPlayerController* self,
                                      GstPlayerMediaInfo* obj)
{
	TunerModelMetadata* _tmp0_;
#line 78 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (obj != NULL);
#line 81 "../src/Controllers/PlayerController.vala"
	_tmp0_ = self->priv->_metadata;
#line 81 "../src/Controllers/PlayerController.vala"
	if (tuner_model_metadata_process_media_info_update (_tmp0_, obj)) {
#line 1084 "PlayerController.c"
		TunerModelStation* _tmp1_;
		TunerModelMetadata* _tmp2_;
#line 82 "../src/Controllers/PlayerController.vala"
		_tmp1_ = self->priv->_station;
#line 82 "../src/Controllers/PlayerController.vala"
		_tmp2_ = self->priv->_metadata;
#line 82 "../src/Controllers/PlayerController.vala"
		g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_METADATA_CHANGED_SIG_SIGNAL], 0, _tmp1_, _tmp2_);
#line 1093 "PlayerController.c"
	}
}

static void
__tuner_player_controller___lambda13__gst_player_media_info_updated (GstPlayer* _sender,
                                                                     GstPlayerMediaInfo* object,
                                                                     gpointer self)
{
#line 78 "../src/Controllers/PlayerController.vala"
	_tuner_player_controller___lambda13_ ((TunerPlayerController*) self, object);
#line 1104 "PlayerController.c"
}

static void
_tuner_player_controller___lambda14_ (TunerPlayerController* self,
                                      GstPlayer* obj)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	TunerApplication* _tmp2_;
	TunerApplication* _tmp3_;
	TunerSettings* _tmp4_;
	TunerSettings* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
#line 85 "../src/Controllers/PlayerController.vala"
	g_return_if_fail (obj != NULL);
#line 88 "../src/Controllers/PlayerController.vala"
	_tmp0_ = gst_player_get_volume (obj);
#line 88 "../src/Controllers/PlayerController.vala"
	_tmp1_ = _tmp0_;
#line 88 "../src/Controllers/PlayerController.vala"
	g_signal_emit (self, tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIG_SIGNAL], 0, _tmp1_);
#line 89 "../src/Controllers/PlayerController.vala"
	_tmp2_ = tuner_app ();
#line 89 "../src/Controllers/PlayerController.vala"
	_tmp3_ = _tmp2_;
#line 89 "../src/Controllers/PlayerController.vala"
	_tmp4_ = tuner_application_get_settings (_tmp3_);
#line 89 "../src/Controllers/PlayerController.vala"
	_tmp5_ = _tmp4_;
#line 89 "../src/Controllers/PlayerController.vala"
	_tmp6_ = gst_player_get_volume (obj);
#line 89 "../src/Controllers/PlayerController.vala"
	_tmp7_ = _tmp6_;
#line 89 "../src/Controllers/PlayerController.vala"
	tuner_settings_set_volume (_tmp5_, _tmp7_);
#line 89 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (_tmp3_);
#line 1143 "PlayerController.c"
}

static void
__tuner_player_controller___lambda14__gst_player_volume_changed (GstPlayer* _sender,
                                                                 gpointer self)
{
#line 85 "../src/Controllers/PlayerController.vala"
	_tuner_player_controller___lambda14_ ((TunerPlayerController*) self, _sender);
#line 1152 "PlayerController.c"
}

static void
_tuner_player_controller___lambda15_ (TunerPlayerController* self,
                                      GstPlayerState state)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 96 "../src/Controllers/PlayerController.vala"
	if (state == GST_PLAYER_STATE_PLAYING) {
#line 96 "../src/Controllers/PlayerController.vala"
		_tmp1_ = state == GST_PLAYER_STATE_BUFFERING;
#line 1165 "PlayerController.c"
	} else {
#line 96 "../src/Controllers/PlayerController.vala"
		_tmp1_ = FALSE;
#line 1169 "PlayerController.c"
	}
#line 96 "../src/Controllers/PlayerController.vala"
	if (!_tmp1_) {
#line 1173 "PlayerController.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 97 "../src/Controllers/PlayerController.vala"
		_tmp2_ = self->priv->_player_state_name;
#line 97 "../src/Controllers/PlayerController.vala"
		_tmp3_ = gst_player_state_get_name (state);
#line 97 "../src/Controllers/PlayerController.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, _tmp3_) != 0;
#line 1182 "PlayerController.c"
	} else {
#line 96 "../src/Controllers/PlayerController.vala"
		_tmp0_ = FALSE;
#line 1186 "PlayerController.c"
	}
#line 96 "../src/Controllers/PlayerController.vala"
	if (_tmp0_) {
#line 1190 "PlayerController.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 99 "../src/Controllers/PlayerController.vala"
		_tmp4_ = gst_player_state_get_name (state);
#line 99 "../src/Controllers/PlayerController.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 99 "../src/Controllers/PlayerController.vala"
		_g_free0 (self->priv->_player_state_name);
#line 99 "../src/Controllers/PlayerController.vala"
		self->priv->_player_state_name = _tmp5_;
#line 100 "../src/Controllers/PlayerController.vala"
		_tmp6_ = gst_player_state_get_name (state);
#line 100 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_set_play_state (self, _tmp6_);
#line 1206 "PlayerController.c"
	}
}

static void
__tuner_player_controller___lambda15__gst_player_state_changed (GstPlayer* _sender,
                                                                GstPlayerState object,
                                                                gpointer self)
{
#line 92 "../src/Controllers/PlayerController.vala"
	_tuner_player_controller___lambda15_ ((TunerPlayerController*) self, object);
#line 1217 "PlayerController.c"
}

static GObject *
tuner_player_controller_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerPlayerController * self;
	GstPlayer* _tmp0_;
	GstPlayer* _tmp1_;
	GstPlayer* _tmp2_;
	GstPlayer* _tmp3_;
	GstPlayer* _tmp4_;
#line 67 "../src/Controllers/PlayerController.vala"
	parent_class = G_OBJECT_CLASS (tuner_player_controller_parent_class);
#line 67 "../src/Controllers/PlayerController.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 67 "../src/Controllers/PlayerController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
#line 69 "../src/Controllers/PlayerController.vala"
	_tmp0_ = gst_player_new (NULL, NULL);
#line 69 "../src/Controllers/PlayerController.vala"
	g_object_ref_sink (_tmp0_);
#line 69 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->priv->_player);
#line 69 "../src/Controllers/PlayerController.vala"
	self->priv->_player = _tmp0_;
#line 71 "../src/Controllers/PlayerController.vala"
	_tmp1_ = self->priv->_player;
#line 71 "../src/Controllers/PlayerController.vala"
	g_signal_connect_object (_tmp1_, "error", (GCallback) __tuner_player_controller___lambda12__gst_player_error, self, 0);
#line 78 "../src/Controllers/PlayerController.vala"
	_tmp2_ = self->priv->_player;
#line 78 "../src/Controllers/PlayerController.vala"
	g_signal_connect_object (_tmp2_, "media-info-updated", (GCallback) __tuner_player_controller___lambda13__gst_player_media_info_updated, self, 0);
#line 85 "../src/Controllers/PlayerController.vala"
	_tmp3_ = self->priv->_player;
#line 85 "../src/Controllers/PlayerController.vala"
	g_signal_connect_object (_tmp3_, "volume-changed", (GCallback) __tuner_player_controller___lambda14__gst_player_volume_changed, self, 0);
#line 92 "../src/Controllers/PlayerController.vala"
	_tmp4_ = self->priv->_player;
#line 92 "../src/Controllers/PlayerController.vala"
	g_signal_connect_object (_tmp4_, "state-changed", (GCallback) __tuner_player_controller___lambda15__gst_player_state_changed, self, 0);
#line 67 "../src/Controllers/PlayerController.vala"
	return obj;
#line 1265 "PlayerController.c"
}

static void
tuner_player_controller_class_init (TunerPlayerControllerClass * klass,
                                    gpointer klass_data)
{
#line 20 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Controllers/PlayerController.vala"
	g_type_class_adjust_private_offset (klass, &TunerPlayerController_private_offset);
#line 20 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_player_controller_get_property;
#line 20 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_player_controller_set_property;
#line 20 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (klass)->constructor = tuner_player_controller_constructor;
#line 20 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_player_controller_finalize;
#line 1284 "PlayerController.c"
	/** The error received when playing, if any */
#line 20 "../src/Controllers/PlayerController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY] = g_param_spec_boolean ("play-error", "play-error", "play-error", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1288 "PlayerController.c"
	/** 
	     * @brief Player State getter/setter
	     * 
	     * Set by player signal. Does the tape counter emit
	     */
#line 20 "../src/Controllers/PlayerController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY] = g_param_spec_enum ("player-state", "player-state", "player-state", TUNER_PLAYER_CONTROLLER_TYPE_IS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1296 "PlayerController.c"
	/** 
	     * @brief Station
	     * @return The current station being played.
	     */
#line 20 "../src/Controllers/PlayerController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_STATION_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_STATION_PROPERTY] = g_param_spec_object ("station", "station", "station", TUNER_MODEL_TYPE_STATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1303 "PlayerController.c"
	/** 
	     * @brief Volume
	     * @return The current volume of the player.
	     */
#line 20 "../src/Controllers/PlayerController.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY, tuner_player_controller_properties[TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1310 "PlayerController.c"
	/** Signal emitted when the station changes. */
#line 20 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATION_CHANGED_SIG_SIGNAL] = g_signal_new ("station-changed-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNER_MODEL_TYPE_STATION);
#line 1314 "PlayerController.c"
	/** Signal emitted when the player state changes. */
#line 20 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_STATE_CHANGED_SIG_SIGNAL] = g_signal_new ("state-changed-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM, G_TYPE_NONE, 2, TUNER_MODEL_TYPE_STATION, TUNER_PLAYER_CONTROLLER_TYPE_IS);
#line 20 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_METADATA_CHANGED_SIG_SIGNAL] = g_signal_new ("metadata-changed-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TUNER_MODEL_TYPE_STATION, TUNER_MODEL_TYPE_METADATA);
#line 1320 "PlayerController.c"
	/** Signal emitted when the volume changes. */
#line 20 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_VOLUME_CHANGED_SIG_SIGNAL] = g_signal_new ("volume-changed-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 1324 "PlayerController.c"
	/** Signal emitted every ten minutes that a station has been playing continuously. */
#line 20 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_TAPE_COUNTER_SIG_SIGNAL] = g_signal_new ("tape-counter-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TUNER_MODEL_TYPE_STATION);
#line 1328 "PlayerController.c"
	/** @brief Signal emitted when the shuffle is requested   */
#line 20 "../src/Controllers/PlayerController.vala"
	tuner_player_controller_signals[TUNER_PLAYER_CONTROLLER_SHUFFLE_REQUESTED_SIG_SIGNAL] = g_signal_new ("shuffle-requested-sig", TUNER_TYPE_PLAYER_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1332 "PlayerController.c"
}

static void
tuner_player_controller_instance_init (TunerPlayerController * self,
                                       gpointer klass)
{
#line 20 "../src/Controllers/PlayerController.vala"
	self->priv = tuner_player_controller_get_instance_private (self);
#line 64 "../src/Controllers/PlayerController.vala"
	self->priv->_tape_counter_id = (guint) 0;
#line 1343 "PlayerController.c"
}

static void
tuner_player_controller_finalize (GObject * obj)
{
	TunerPlayerController * self;
#line 20 "../src/Controllers/PlayerController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
#line 59 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->priv->_player);
#line 60 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->priv->_station);
#line 61 "../src/Controllers/PlayerController.vala"
	_g_object_unref0 (self->priv->_metadata);
#line 63 "../src/Controllers/PlayerController.vala"
	_g_free0 (self->priv->_player_state_name);
#line 20 "../src/Controllers/PlayerController.vala"
	G_OBJECT_CLASS (tuner_player_controller_parent_class)->finalize (obj);
#line 1362 "PlayerController.c"
}

/**
 * @class Tuner.PlayerController
 * @brief Manages the playback of radio stations.
 *
 * This class handles the player state, volume control, and metadata extraction
 * from the media stream. It emits signals when the station, state, title,
 * or volume changes.
 */
static GType
tuner_player_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerPlayerControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_player_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerPlayerController), 0, (GInstanceInitFunc) tuner_player_controller_instance_init, NULL };
	GType tuner_player_controller_type_id;
	tuner_player_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerPlayerController", &g_define_type_info, 0);
	TunerPlayerController_private_offset = g_type_add_instance_private (tuner_player_controller_type_id, sizeof (TunerPlayerControllerPrivate));
	return tuner_player_controller_type_id;
}

GType
tuner_player_controller_get_type (void)
{
	static volatile gsize tuner_player_controller_type_id__once = 0;
	if (g_once_init_enter (&tuner_player_controller_type_id__once)) {
		GType tuner_player_controller_type_id;
		tuner_player_controller_type_id = tuner_player_controller_get_type_once ();
		g_once_init_leave (&tuner_player_controller_type_id__once, tuner_player_controller_type_id);
	}
	return tuner_player_controller_type_id__once;
}

static void
_vala_tuner_player_controller_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
#line 20 "../src/Controllers/PlayerController.vala"
	switch (property_id) {
#line 20 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY:
#line 20 "../src/Controllers/PlayerController.vala"
		g_value_set_boolean (value, tuner_player_controller_get_play_error (self));
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 20 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY:
#line 20 "../src/Controllers/PlayerController.vala"
		g_value_set_enum (value, tuner_player_controller_get_player_state (self));
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 20 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_STATION_PROPERTY:
#line 20 "../src/Controllers/PlayerController.vala"
		g_value_set_object (value, tuner_player_controller_get_station (self));
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 20 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY:
#line 20 "../src/Controllers/PlayerController.vala"
		g_value_set_double (value, tuner_player_controller_get_volume (self));
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 1429 "PlayerController.c"
		default:
#line 20 "../src/Controllers/PlayerController.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 1435 "PlayerController.c"
	}
}

static void
_vala_tuner_player_controller_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	TunerPlayerController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_PLAYER_CONTROLLER, TunerPlayerController);
#line 20 "../src/Controllers/PlayerController.vala"
	switch (property_id) {
#line 20 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_PLAY_ERROR_PROPERTY:
#line 20 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_set_play_error (self, g_value_get_boolean (value));
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 20 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_PLAYER_STATE_PROPERTY:
#line 20 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_set_player_state (self, g_value_get_enum (value));
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 20 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_STATION_PROPERTY:
#line 20 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_set_station (self, g_value_get_object (value));
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 20 "../src/Controllers/PlayerController.vala"
		case TUNER_PLAYER_CONTROLLER_VOLUME_PROPERTY:
#line 20 "../src/Controllers/PlayerController.vala"
		tuner_player_controller_set_volume (self, g_value_get_double (value));
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 1473 "PlayerController.c"
		default:
#line 20 "../src/Controllers/PlayerController.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Controllers/PlayerController.vala"
		break;
#line 1479 "PlayerController.c"
	}
}

