/* SearchController.c generated by valac 0.56.17, the Vala compiler
 * generated from SearchController.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file SearchController.vala
 *
 * @since 2.0.0
 *
 * @brief Defines the below-headerbar display of stations in the Tuner application.
 *
 * This file contains the Display class, which implements various
 * features such as a source list, content stack that display and manage Station
 * settings and handles user actions like station selection.
 *
 * @see Tuner.DirectoryController
 * @see Tuner.StationListHookup
 * @see Tuner.StationListBox
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>

#define TUNER_SEARCH_CONTROLLER_SEARCH_DELAY ((guint) 333)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_SEARCH_CONTROLLER (tuner_search_controller_get_type ())
#define TUNER_SEARCH_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_SEARCH_CONTROLLER, TunerSearchController))
#define TUNER_SEARCH_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_SEARCH_CONTROLLER, TunerSearchControllerClass))
#define TUNER_IS_SEARCH_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_SEARCH_CONTROLLER))
#define TUNER_IS_SEARCH_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_SEARCH_CONTROLLER))
#define TUNER_SEARCH_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_SEARCH_CONTROLLER, TunerSearchControllerClass))

typedef struct _TunerSearchController TunerSearchController;
typedef struct _TunerSearchControllerClass TunerSearchControllerClass;
typedef struct _TunerSearchControllerPrivate TunerSearchControllerPrivate;

#define TUNER_TYPE_DIRECTORY_CONTROLLER (tuner_directory_controller_get_type ())
#define TUNER_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryController))
#define TUNER_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))
#define TUNER_IS_DIRECTORY_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_IS_DIRECTORY_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_DIRECTORY_CONTROLLER))
#define TUNER_DIRECTORY_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_DIRECTORY_CONTROLLER, TunerDirectoryControllerClass))

typedef struct _TunerDirectoryController TunerDirectoryController;
typedef struct _TunerDirectoryControllerClass TunerDirectoryControllerClass;

#define TUNER_TYPE_STATION_LIST_BOX (tuner_station_list_box_get_type ())
#define TUNER_STATION_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_LIST_BOX, TunerStationListBox))
#define TUNER_STATION_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_LIST_BOX, TunerStationListBoxClass))
#define TUNER_IS_STATION_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_LIST_BOX))
#define TUNER_IS_STATION_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_LIST_BOX))
#define TUNER_STATION_LIST_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_LIST_BOX, TunerStationListBoxClass))

typedef struct _TunerStationListBox TunerStationListBox;
typedef struct _TunerStationListBoxClass TunerStationListBoxClass;

#define TUNER_TYPE_STATION_LIST_HOOKUP (tuner_station_list_hookup_get_type ())
#define TUNER_STATION_LIST_HOOKUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_LIST_HOOKUP, TunerStationListHookup))
#define TUNER_IS_STATION_LIST_HOOKUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_LIST_HOOKUP))
#define TUNER_STATION_LIST_HOOKUP_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TUNER_TYPE_STATION_LIST_HOOKUP, TunerStationListHookupIface))

typedef struct _TunerStationListHookup TunerStationListHookup;
typedef struct _TunerStationListHookupIface TunerStationListHookupIface;

#define TUNER_TYPE_LIST_FLOW_BOX (tuner_list_flow_box_get_type ())
#define TUNER_LIST_FLOW_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_LIST_FLOW_BOX, TunerListFlowBox))
#define TUNER_LIST_FLOW_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_LIST_FLOW_BOX, TunerListFlowBoxClass))
#define TUNER_IS_LIST_FLOW_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_LIST_FLOW_BOX))
#define TUNER_IS_LIST_FLOW_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_LIST_FLOW_BOX))
#define TUNER_LIST_FLOW_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_LIST_FLOW_BOX, TunerListFlowBoxClass))

typedef struct _TunerListFlowBox TunerListFlowBox;
typedef struct _TunerListFlowBoxClass TunerListFlowBoxClass;

#define TUNER_TYPE_STATION_LIST (tuner_station_list_get_type ())
#define TUNER_STATION_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_LIST, TunerStationList))
#define TUNER_STATION_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_LIST, TunerStationListClass))
#define TUNER_IS_STATION_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_LIST))
#define TUNER_IS_STATION_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_LIST))
#define TUNER_STATION_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_LIST, TunerStationListClass))

typedef struct _TunerStationList TunerStationList;
typedef struct _TunerStationListClass TunerStationListClass;
enum  {
	TUNER_SEARCH_CONTROLLER_0_PROPERTY,
	TUNER_SEARCH_CONTROLLER_NUM_PROPERTIES
};
static GParamSpec* tuner_search_controller_properties[TUNER_SEARCH_CONTROLLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;

#define TYPE_SOURCE_ERROR (source_error_get_type ())

#define TUNER_TYPE_STATION_SET (tuner_station_set_get_type ())
#define TUNER_STATION_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STATION_SET, TunerStationSet))
#define TUNER_STATION_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STATION_SET, TunerStationSetClass))
#define TUNER_IS_STATION_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STATION_SET))
#define TUNER_IS_STATION_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STATION_SET))
#define TUNER_STATION_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STATION_SET, TunerStationSetClass))

typedef struct _TunerStationSet TunerStationSet;
typedef struct _TunerStationSetClass TunerStationSetClass;

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
typedef struct _TunerSearchControllerLoadStationSearchResultsData TunerSearchControllerLoadStationSearchResultsData;
enum  {
	TUNER_SEARCH_CONTROLLER_SEARCH_FOR_SIG_SIGNAL,
	TUNER_SEARCH_CONTROLLER_NUM_SIGNALS
};
static guint tuner_search_controller_signals[TUNER_SEARCH_CONTROLLER_NUM_SIGNALS] = {0};

struct _TunerSearchController {
	GObject parent_instance;
	TunerSearchControllerPrivate * priv;
};

struct _TunerSearchControllerClass {
	GObjectClass parent_class;
};

struct _TunerStationListHookupIface {
	GTypeInterface parent_iface;
	void (*station_list_hookup) (TunerStationListHookup* self, TunerStationList* station_list);
};

struct _TunerSearchControllerPrivate {
	TunerDirectoryController* _directory;
	TunerStationListBox* _station_list_box;
	TunerStationListHookup* _station_list_hookup;
	guint _max_search_results;
	guint _search_handler_id;
	gchar* _current_search_term;
};

struct _Block2Data {
	int _ref_count_;
	TunerSearchController* self;
	gchar* search;
};

typedef enum  {
	SOURCE_ERROR_UNAVAILABLE
} SourceError;
#define SOURCE_ERROR source_error_quark ()

struct _TunerSearchControllerLoadStationSearchResultsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerSearchController* self;
	gchar* search_term;
	TunerStationListBox* results_box;
	TunerStationSet* station_set;
	TunerDirectoryController* _tmp0_;
	TunerStationSet* _tmp1_;
	GeeSet* stations;
	GeeSet* _tmp2_;
	gboolean _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	TunerStationList* _slist;
	TunerStationList* _tmp6_;
	TunerStationListHookup* _tmp7_;
	TunerStationList* _tmp8_;
	TunerStationList* _tmp9_;
	GError* _inner_error0_;
};

static gint TunerSearchController_private_offset;
static gpointer tuner_search_controller_parent_class = NULL;

VALA_EXTERN GType tuner_search_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerSearchController, g_object_unref)
VALA_EXTERN GType tuner_directory_controller_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDirectoryController, g_object_unref)
VALA_EXTERN GType tuner_station_list_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationListBox, g_object_unref)
VALA_EXTERN GType tuner_list_flow_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerListFlowBox, g_object_unref)
VALA_EXTERN GType tuner_station_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationList, g_object_unref)
VALA_EXTERN GType tuner_station_list_hookup_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationListHookup, g_object_unref)
VALA_EXTERN TunerSearchController* tuner_search_controller_new (TunerDirectoryController* dc,
                                                    TunerStationListHookup* slh,
                                                    TunerStationListBox* slb,
                                                    guint max_search_results);
VALA_EXTERN TunerSearchController* tuner_search_controller_construct (GType object_type,
                                                          TunerDirectoryController* dc,
                                                          TunerStationListHookup* slh,
                                                          TunerStationListBox* slb,
                                                          guint max_search_results);
VALA_EXTERN void tuner_search_controller_handle_search_for (TunerSearchController* self,
                                                const gchar* search_term);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda70_ (Block2Data* _data2_);
static void tuner_search_controller_load_station_search_results (TunerSearchController* self,
                                                          const gchar* search_term,
                                                          TunerStationListBox* results_box,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
VALA_EXTERN GQuark source_error_quark (void);
VALA_EXTERN GType source_error_get_type (void) G_GNUC_CONST ;
static void tuner_search_controller_load_station_search_results_finish (TunerSearchController* self,
                                                                 GAsyncResult* _res_,
                                                                 GError** error);
static gboolean ___lambda70__gsource_func (gpointer self);
static void tuner_search_controller_load_station_search_results_data_free (gpointer _data);
static gboolean tuner_search_controller_load_station_search_results_co (TunerSearchControllerLoadStationSearchResultsData* _data_);
VALA_EXTERN GType tuner_station_set_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStationSet, g_object_unref)
VALA_EXTERN TunerStationSet* tuner_directory_controller_load_search_stations (TunerDirectoryController* self,
                                                                  const gchar* utext,
                                                                  guint limit);
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN void tuner_station_set_next_page_async (TunerStationSet* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
VALA_EXTERN GeeSet* tuner_station_set_next_page_finish (TunerStationSet* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static void tuner_search_controller_load_station_search_results_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
VALA_EXTERN void tuner_station_list_box_show_nothing_found (TunerStationListBox* self);
VALA_EXTERN TunerStationList* tuner_station_list_with_stations (GeeCollection* stations);
VALA_EXTERN void tuner_station_list_hookup_station_list_hookup (TunerStationListHookup* self,
                                                    TunerStationList* station_list);
VALA_EXTERN void tuner_station_list_box_set_parameter (TunerStationListBox* self,
                                           const gchar* value);
VALA_EXTERN void tuner_station_list_box_set_content (TunerStationListBox* self,
                                         TunerListFlowBox* value);
VALA_EXTERN void tuner_station_list_box_show_alert (TunerStationListBox* self);
static void tuner_search_controller_finalize (GObject * obj);
static GType tuner_search_controller_get_type_once (void);

static inline gpointer
tuner_search_controller_get_instance_private (TunerSearchController* self)
{
	return G_STRUCT_MEMBER_P (self, TunerSearchController_private_offset);
}

/**
* Controller class for handling station search functionality.
*
* @param dc The directory controller instance to manage station directories
* @param slh The station list hookup instance for station data binding
* @param slb The station list box widget instance to display search results
* @param max_search_results Maximum number of search results to display (defaults to 100)
*/
static gpointer
_g_object_ref0 (gpointer self)
{
#line 52 "../src/Controllers/SearchController.vala"
	return self ? g_object_ref (self) : NULL;
#line 306 "SearchController.c"
}

TunerSearchController*
tuner_search_controller_construct (GType object_type,
                                   TunerDirectoryController* dc,
                                   TunerStationListHookup* slh,
                                   TunerStationListBox* slb,
                                   guint max_search_results)
{
	TunerSearchController * self = NULL;
	TunerDirectoryController* _tmp0_;
	TunerStationListHookup* _tmp1_;
	TunerStationListBox* _tmp2_;
#line 49 "../src/Controllers/SearchController.vala"
	g_return_val_if_fail (dc != NULL, NULL);
#line 49 "../src/Controllers/SearchController.vala"
	g_return_val_if_fail (slh != NULL, NULL);
#line 49 "../src/Controllers/SearchController.vala"
	g_return_val_if_fail (slb != NULL, NULL);
#line 51 "../src/Controllers/SearchController.vala"
	self = (TunerSearchController*) g_object_new (object_type, NULL);
#line 52 "../src/Controllers/SearchController.vala"
	_tmp0_ = _g_object_ref0 (dc);
#line 52 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (self->priv->_directory);
#line 52 "../src/Controllers/SearchController.vala"
	self->priv->_directory = _tmp0_;
#line 53 "../src/Controllers/SearchController.vala"
	_tmp1_ = _g_object_ref0 (slh);
#line 53 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (self->priv->_station_list_hookup);
#line 53 "../src/Controllers/SearchController.vala"
	self->priv->_station_list_hookup = _tmp1_;
#line 54 "../src/Controllers/SearchController.vala"
	_tmp2_ = _g_object_ref0 (slb);
#line 54 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (self->priv->_station_list_box);
#line 54 "../src/Controllers/SearchController.vala"
	self->priv->_station_list_box = _tmp2_;
#line 55 "../src/Controllers/SearchController.vala"
	self->priv->_max_search_results = max_search_results;
#line 49 "../src/Controllers/SearchController.vala"
	return self;
#line 350 "SearchController.c"
}

TunerSearchController*
tuner_search_controller_new (TunerDirectoryController* dc,
                             TunerStationListHookup* slh,
                             TunerStationListBox* slb,
                             guint max_search_results)
{
#line 49 "../src/Controllers/SearchController.vala"
	return tuner_search_controller_construct (TUNER_TYPE_SEARCH_CONTROLLER, dc, slh, slb, max_search_results);
#line 361 "SearchController.c"
}

/**
* @brief Handles a search request.
*
* This method is called when the user types in the search entry.
* It cancels any ongoing search and starts a new search after a brief delay.
*
* @param search_term The search term to search for.
*/
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 66 "../src/Controllers/SearchController.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 66 "../src/Controllers/SearchController.vala"
	return _data2_;
#line 379 "SearchController.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 66 "../src/Controllers/SearchController.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 389 "SearchController.c"
		TunerSearchController* self;
#line 66 "../src/Controllers/SearchController.vala"
		self = _data2_->self;
#line 66 "../src/Controllers/SearchController.vala"
		_g_free0 (_data2_->search);
#line 66 "../src/Controllers/SearchController.vala"
		_g_object_unref0 (self);
#line 66 "../src/Controllers/SearchController.vala"
		g_slice_free (Block2Data, _data2_);
#line 399 "SearchController.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 421 "SearchController.c"
}

static gboolean
__lambda70_ (Block2Data* _data2_)
{
	TunerSearchController* self;
	const gchar* _tmp0_;
	TunerStationListBox* _tmp1_;
	gboolean result;
#line 81 "../src/Controllers/SearchController.vala"
	self = _data2_->self;
#line 84 "../src/Controllers/SearchController.vala"
	self->priv->_search_handler_id = (guint) 0;
#line 85 "../src/Controllers/SearchController.vala"
	_tmp0_ = _data2_->search;
#line 85 "../src/Controllers/SearchController.vala"
	_tmp1_ = self->priv->_station_list_box;
#line 85 "../src/Controllers/SearchController.vala"
	tuner_search_controller_load_station_search_results (self, _tmp0_, _tmp1_, NULL, NULL);
#line 86 "../src/Controllers/SearchController.vala"
	result = G_SOURCE_REMOVE;
#line 86 "../src/Controllers/SearchController.vala"
	return result;
#line 445 "SearchController.c"
}

static gboolean
___lambda70__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda70_ (self);
#line 81 "../src/Controllers/SearchController.vala"
	return result;
#line 455 "SearchController.c"
}

void
tuner_search_controller_handle_search_for (TunerSearchController* self,
                                           const gchar* search_term)
{
	Block2Data* _data2_;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 66 "../src/Controllers/SearchController.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/Controllers/SearchController.vala"
	g_return_if_fail (search_term != NULL);
#line 66 "../src/Controllers/SearchController.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 66 "../src/Controllers/SearchController.vala"
	_data2_->_ref_count_ = 1;
#line 66 "../src/Controllers/SearchController.vala"
	_data2_->self = g_object_ref (self);
#line 68 "../src/Controllers/SearchController.vala"
	_tmp0_ = string_strip (search_term);
#line 68 "../src/Controllers/SearchController.vala"
	_data2_->search = _tmp0_;
#line 69 "../src/Controllers/SearchController.vala"
	_tmp2_ = _data2_->search;
#line 69 "../src/Controllers/SearchController.vala"
	_tmp3_ = strlen (_tmp2_);
#line 69 "../src/Controllers/SearchController.vala"
	_tmp4_ = _tmp3_;
#line 69 "../src/Controllers/SearchController.vala"
	if (_tmp4_ == 0) {
#line 69 "../src/Controllers/SearchController.vala"
		_tmp1_ = TRUE;
#line 494 "SearchController.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 69 "../src/Controllers/SearchController.vala"
		_tmp5_ = self->priv->_current_search_term;
#line 69 "../src/Controllers/SearchController.vala"
		_tmp6_ = _data2_->search;
#line 69 "../src/Controllers/SearchController.vala"
		_tmp1_ = g_strcmp0 (_tmp5_, _tmp6_) == 0;
#line 504 "SearchController.c"
	}
#line 69 "../src/Controllers/SearchController.vala"
	if (_tmp1_) {
#line 70 "../src/Controllers/SearchController.vala"
		block2_data_unref (_data2_);
#line 70 "../src/Controllers/SearchController.vala"
		_data2_ = NULL;
#line 70 "../src/Controllers/SearchController.vala"
		return;
#line 514 "SearchController.c"
	}
#line 72 "../src/Controllers/SearchController.vala"
	_tmp7_ = _data2_->search;
#line 72 "../src/Controllers/SearchController.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 72 "../src/Controllers/SearchController.vala"
	_g_free0 (self->priv->_current_search_term);
#line 72 "../src/Controllers/SearchController.vala"
	self->priv->_current_search_term = _tmp8_;
#line 74 "../src/Controllers/SearchController.vala"
	if (self->priv->_search_handler_id > ((guint) 0)) {
#line 77 "../src/Controllers/SearchController.vala"
		g_source_remove (self->priv->_search_handler_id);
#line 78 "../src/Controllers/SearchController.vala"
		self->priv->_search_handler_id = (guint) 0;
#line 530 "SearchController.c"
	}
#line 81 "../src/Controllers/SearchController.vala"
	self->priv->_search_handler_id = g_timeout_add_full (G_PRIORITY_DEFAULT, TUNER_SEARCH_CONTROLLER_SEARCH_DELAY, ___lambda70__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 66 "../src/Controllers/SearchController.vala"
	block2_data_unref (_data2_);
#line 66 "../src/Controllers/SearchController.vala"
	_data2_ = NULL;
#line 538 "SearchController.c"
}

static void
tuner_search_controller_load_station_search_results_data_free (gpointer _data)
{
	TunerSearchControllerLoadStationSearchResultsData* _data_;
	_data_ = _data;
#line 29 "../src/Controllers/SearchController.vala"
	_g_free0 (_data_->search_term);
#line 29 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (_data_->results_box);
#line 29 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/Controllers/SearchController.vala"
	g_slice_free (TunerSearchControllerLoadStationSearchResultsData, _data_);
#line 554 "SearchController.c"
}

static void
tuner_search_controller_load_station_search_results (TunerSearchController* self,
                                                     const gchar* search_term,
                                                     TunerStationListBox* results_box,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	TunerSearchControllerLoadStationSearchResultsData* _data_;
	TunerSearchController* _tmp0_;
	gchar* _tmp1_;
	TunerStationListBox* _tmp2_;
#line 29 "../src/Controllers/SearchController.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Controllers/SearchController.vala"
	g_return_if_fail (search_term != NULL);
#line 29 "../src/Controllers/SearchController.vala"
	g_return_if_fail (results_box != NULL);
#line 29 "../src/Controllers/SearchController.vala"
	_data_ = g_slice_new0 (TunerSearchControllerLoadStationSearchResultsData);
#line 29 "../src/Controllers/SearchController.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/Controllers/SearchController.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tuner_search_controller_load_station_search_results_data_free);
#line 29 "../src/Controllers/SearchController.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/Controllers/SearchController.vala"
	_data_->self = _tmp0_;
#line 29 "../src/Controllers/SearchController.vala"
	_tmp1_ = g_strdup (search_term);
#line 29 "../src/Controllers/SearchController.vala"
	_g_free0 (_data_->search_term);
#line 29 "../src/Controllers/SearchController.vala"
	_data_->search_term = _tmp1_;
#line 29 "../src/Controllers/SearchController.vala"
	_tmp2_ = _g_object_ref0 (results_box);
#line 29 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (_data_->results_box);
#line 29 "../src/Controllers/SearchController.vala"
	_data_->results_box = _tmp2_;
#line 29 "../src/Controllers/SearchController.vala"
	tuner_search_controller_load_station_search_results_co (_data_);
#line 598 "SearchController.c"
}

static void
tuner_search_controller_load_station_search_results_finish (TunerSearchController* self,
                                                            GAsyncResult* _res_,
                                                            GError** error)
{
	TunerSearchControllerLoadStationSearchResultsData* _data_;
#line 29 "../src/Controllers/SearchController.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 29 "../src/Controllers/SearchController.vala"
	if (NULL == _data_) {
#line 29 "../src/Controllers/SearchController.vala"
		return;
#line 613 "SearchController.c"
	}
}

/**
* @brief Loads search stations based on the provided text and updates the content box.
*
* Async since 1.5.5 so that UI is responsive during long searches
* @param search_term The text to search for stations.
* @param results_box The ContentBox to update with the search results.
*/
static void
tuner_search_controller_load_station_search_results_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	TunerSearchControllerLoadStationSearchResultsData* _data_;
#line 104 "../src/Controllers/SearchController.vala"
	_data_ = _user_data_;
#line 104 "../src/Controllers/SearchController.vala"
	_data_->_source_object_ = source_object;
#line 104 "../src/Controllers/SearchController.vala"
	_data_->_res_ = _res_;
#line 104 "../src/Controllers/SearchController.vala"
	tuner_search_controller_load_station_search_results_co (_data_);
#line 638 "SearchController.c"
}

static gboolean
tuner_search_controller_load_station_search_results_co (TunerSearchControllerLoadStationSearchResultsData* _data_)
{
#line 97 "../src/Controllers/SearchController.vala"
	switch (_data_->_state_) {
#line 97 "../src/Controllers/SearchController.vala"
		case 0:
#line 648 "SearchController.c"
		goto _state_0;
#line 97 "../src/Controllers/SearchController.vala"
		case 1:
#line 652 "SearchController.c"
		goto _state_1;
		default:
#line 97 "../src/Controllers/SearchController.vala"
		g_assert_not_reached ();
#line 657 "SearchController.c"
	}
	_state_0:
#line 100 "../src/Controllers/SearchController.vala"
	_data_->_tmp0_ = _data_->self->priv->_directory;
#line 100 "../src/Controllers/SearchController.vala"
	_data_->_tmp1_ = tuner_directory_controller_load_search_stations (_data_->_tmp0_, _data_->search_term, (guint) 100);
#line 100 "../src/Controllers/SearchController.vala"
	_data_->station_set = _data_->_tmp1_;
#line 666 "SearchController.c"
	{
#line 104 "../src/Controllers/SearchController.vala"
		_data_->_state_ = 1;
#line 104 "../src/Controllers/SearchController.vala"
		tuner_station_set_next_page_async (_data_->station_set, tuner_search_controller_load_station_search_results_ready, _data_);
#line 104 "../src/Controllers/SearchController.vala"
		return FALSE;
#line 674 "SearchController.c"
		_state_1:
#line 104 "../src/Controllers/SearchController.vala"
		_data_->_tmp2_ = tuner_station_set_next_page_finish (_data_->station_set, _data_->_res_, &_data_->_inner_error0_);
#line 104 "../src/Controllers/SearchController.vala"
		_data_->stations = _data_->_tmp2_;
#line 104 "../src/Controllers/SearchController.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 104 "../src/Controllers/SearchController.vala"
			if (_data_->_inner_error0_->domain == SOURCE_ERROR) {
#line 684 "SearchController.c"
				goto __catch0_source_error;
			}
#line 104 "../src/Controllers/SearchController.vala"
			_g_object_unref0 (_data_->station_set);
#line 104 "../src/Controllers/SearchController.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 104 "../src/Controllers/SearchController.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 104 "../src/Controllers/SearchController.vala"
			g_object_unref (_data_->_async_result);
#line 104 "../src/Controllers/SearchController.vala"
			return FALSE;
#line 697 "SearchController.c"
		}
#line 106 "../src/Controllers/SearchController.vala"
		if (_data_->stations == NULL) {
#line 106 "../src/Controllers/SearchController.vala"
			_data_->_tmp3_ = TRUE;
#line 703 "SearchController.c"
		} else {
#line 106 "../src/Controllers/SearchController.vala"
			_data_->_tmp4_ = gee_collection_get_size ((GeeCollection*) _data_->stations);
#line 106 "../src/Controllers/SearchController.vala"
			_data_->_tmp5_ = _data_->_tmp4_;
#line 106 "../src/Controllers/SearchController.vala"
			_data_->_tmp3_ = _data_->_tmp5_ == 0;
#line 711 "SearchController.c"
		}
#line 106 "../src/Controllers/SearchController.vala"
		if (_data_->_tmp3_) {
#line 108 "../src/Controllers/SearchController.vala"
			tuner_station_list_box_show_nothing_found (_data_->results_box);
#line 717 "SearchController.c"
		} else {
#line 112 "../src/Controllers/SearchController.vala"
			_data_->_tmp6_ = tuner_station_list_with_stations ((GeeCollection*) _data_->stations);
#line 112 "../src/Controllers/SearchController.vala"
			_data_->_slist = _data_->_tmp6_;
#line 113 "../src/Controllers/SearchController.vala"
			_data_->_tmp7_ = _data_->self->priv->_station_list_hookup;
#line 113 "../src/Controllers/SearchController.vala"
			_data_->_tmp8_ = _data_->_slist;
#line 113 "../src/Controllers/SearchController.vala"
			tuner_station_list_hookup_station_list_hookup (_data_->_tmp7_, _data_->_tmp8_);
#line 114 "../src/Controllers/SearchController.vala"
			tuner_station_list_box_set_parameter (_data_->results_box, _data_->search_term);
#line 115 "../src/Controllers/SearchController.vala"
			_data_->_tmp9_ = _data_->_slist;
#line 115 "../src/Controllers/SearchController.vala"
			tuner_station_list_box_set_content (_data_->results_box, (TunerListFlowBox*) _data_->_tmp9_);
#line 106 "../src/Controllers/SearchController.vala"
			_g_object_unref0 (_data_->_slist);
#line 737 "SearchController.c"
		}
#line 102 "../src/Controllers/SearchController.vala"
		_g_object_unref0 (_data_->stations);
#line 741 "SearchController.c"
	}
	goto __finally0;
	__catch0_source_error:
	{
#line 102 "../src/Controllers/SearchController.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 119 "../src/Controllers/SearchController.vala"
		tuner_station_list_box_show_alert (_data_->results_box);
#line 750 "SearchController.c"
	}
	__finally0:
#line 102 "../src/Controllers/SearchController.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 102 "../src/Controllers/SearchController.vala"
		if (_data_->_inner_error0_->domain == SOURCE_ERROR) {
#line 102 "../src/Controllers/SearchController.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 102 "../src/Controllers/SearchController.vala"
			_g_object_unref0 (_data_->station_set);
#line 102 "../src/Controllers/SearchController.vala"
			g_object_unref (_data_->_async_result);
#line 102 "../src/Controllers/SearchController.vala"
			return FALSE;
#line 765 "SearchController.c"
		} else {
#line 102 "../src/Controllers/SearchController.vala"
			_g_object_unref0 (_data_->station_set);
#line 102 "../src/Controllers/SearchController.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 102 "../src/Controllers/SearchController.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 102 "../src/Controllers/SearchController.vala"
			g_object_unref (_data_->_async_result);
#line 102 "../src/Controllers/SearchController.vala"
			return FALSE;
#line 777 "SearchController.c"
		}
	}
#line 121 "../src/Controllers/SearchController.vala"
	gtk_widget_show_all ((GtkWidget*) _data_->results_box);
#line 97 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (_data_->station_set);
#line 97 "../src/Controllers/SearchController.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 97 "../src/Controllers/SearchController.vala"
	if (_data_->_state_ != 0) {
#line 97 "../src/Controllers/SearchController.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 97 "../src/Controllers/SearchController.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 792 "SearchController.c"
		}
	}
#line 97 "../src/Controllers/SearchController.vala"
	g_object_unref (_data_->_async_result);
#line 97 "../src/Controllers/SearchController.vala"
	return FALSE;
#line 799 "SearchController.c"
}

static void
tuner_search_controller_class_init (TunerSearchControllerClass * klass,
                                    gpointer klass_data)
{
#line 29 "../src/Controllers/SearchController.vala"
	tuner_search_controller_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Controllers/SearchController.vala"
	g_type_class_adjust_private_offset (klass, &TunerSearchController_private_offset);
#line 29 "../src/Controllers/SearchController.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_search_controller_finalize;
#line 29 "../src/Controllers/SearchController.vala"
	tuner_search_controller_signals[TUNER_SEARCH_CONTROLLER_SEARCH_FOR_SIG_SIGNAL] = g_signal_new ("search-for-sig", TUNER_TYPE_SEARCH_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 814 "SearchController.c"
}

static void
tuner_search_controller_instance_init (TunerSearchController * self,
                                       gpointer klass)
{
#line 29 "../src/Controllers/SearchController.vala"
	self->priv = tuner_search_controller_get_instance_private (self);
#line 38 "../src/Controllers/SearchController.vala"
	self->priv->_search_handler_id = (guint) 0;
#line 825 "SearchController.c"
}

static void
tuner_search_controller_finalize (GObject * obj)
{
	TunerSearchController * self;
#line 29 "../src/Controllers/SearchController.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_SEARCH_CONTROLLER, TunerSearchController);
#line 34 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (self->priv->_directory);
#line 35 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (self->priv->_station_list_box);
#line 36 "../src/Controllers/SearchController.vala"
	_g_object_unref0 (self->priv->_station_list_hookup);
#line 39 "../src/Controllers/SearchController.vala"
	_g_free0 (self->priv->_current_search_term);
#line 29 "../src/Controllers/SearchController.vala"
	G_OBJECT_CLASS (tuner_search_controller_parent_class)->finalize (obj);
#line 844 "SearchController.c"
}

/**
 * A controller class that handles searching functionality within the Tuner application.
 *
 * This class manages search operations and provides an interface for performing
 * searches within the application.
 */
static GType
tuner_search_controller_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerSearchControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_search_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerSearchController), 0, (GInstanceInitFunc) tuner_search_controller_instance_init, NULL };
	GType tuner_search_controller_type_id;
	tuner_search_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerSearchController", &g_define_type_info, 0);
	TunerSearchController_private_offset = g_type_add_instance_private (tuner_search_controller_type_id, sizeof (TunerSearchControllerPrivate));
	return tuner_search_controller_type_id;
}

GType
tuner_search_controller_get_type (void)
{
	static volatile gsize tuner_search_controller_type_id__once = 0;
	if (g_once_init_enter (&tuner_search_controller_type_id__once)) {
		GType tuner_search_controller_type_id;
		tuner_search_controller_type_id = tuner_search_controller_get_type_once ();
		g_once_init_leave (&tuner_search_controller_type_id__once, tuner_search_controller_type_id);
	}
	return tuner_search_controller_type_id__once;
}

