/* Favicon.c generated by valac 0.56.17, the Vala compiler
 * generated from Favicon.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file Favicon.vala
 *
 * @brief Favicon index, loading and caching
 * 
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gee.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <glib/gstdio.h>

#define TUNER_MODEL_FAVICON_FADE_MS 400
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;
typedef struct _TunerModelFaviconPrivate TunerModelFaviconPrivate;
enum  {
	TUNER_MODEL_FAVICON_0_PROPERTY,
	TUNER_MODEL_FAVICON_FAVICON_PROPERTY,
	TUNER_MODEL_FAVICON_NUM_PROPERTIES
};
static GParamSpec* tuner_model_favicon_properties[TUNER_MODEL_FAVICON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TunerModelFaviconUpdateFaviconImageData TunerModelFaviconUpdateFaviconImageData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _TunerModelFaviconLoadFaviconAsyncData TunerModelFaviconLoadFaviconAsyncData;
enum  {
	TUNER_MODEL_FAVICON_FAVICON_SIG_SIGNAL,
	TUNER_MODEL_FAVICON_NUM_SIGNALS
};
static guint tuner_model_favicon_signals[TUNER_MODEL_FAVICON_NUM_SIGNALS] = {0};

struct _TunerModelFavicon {
	GObject parent_instance;
	TunerModelFaviconPrivate * priv;
};

struct _TunerModelFaviconClass {
	GObjectClass parent_class;
	gchar* (*favicon_cache_file) (TunerModelFavicon* self);
};

struct _TunerModelFaviconPrivate {
	gchar* _favicon;
	GUri* _favicon_uri;
	gint _favicon_loaded;
	GdkPixbuf* _favicon_pixbuf;
};

struct _TunerModelFaviconUpdateFaviconImageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerModelFavicon* self;
	GtkImage* favicon_image;
	gboolean reload;
	gchar* defaulticon;
	gboolean result;
	gboolean reloading;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GdkPixbuf* _tmp2_;
	GeeSet* _tmp3_;
	const gchar* _tmp4_;
	GdkPixbuf* _tmp5_;
	gboolean _tmp6_;
	GeeSet* _tmp7_;
	const gchar* _tmp8_;
	GError* _inner_error0_;
};

struct _TunerModelFaviconLoadFaviconAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerModelFavicon* self;
	gboolean reload;
	gboolean _tmp0_;
	GUri* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeSet* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GdkPixbuf* pixbuf;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* _tmp13_;
	GdkPixbuf* _tmp14_;
	gint _tmp15_;
	GError* e;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GError* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GUri* _tmp23_;
	guint status_code;
	GInputStream* stream;
	GUri* _tmp24_;
	guint _tmp25_;
	GInputStream* _tmp26_;
	gboolean _tmp27_;
	GInputStream* _tmp28_;
	GdkPixbuf* _vala1_pixbuf;
	GInputStream* _tmp29_;
	GdkPixbuf* _tmp30_;
	GdkPixbuf* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GdkPixbuf* _tmp34_;
	GdkPixbuf* _tmp35_;
	gint _tmp36_;
	GError* _vala1_e;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	GUri* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	const gchar* _tmp42_;
	GError* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	GUri* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	const gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	GeeSet* _tmp58_;
	const gchar* _tmp59_;
	GError* _inner_error0_;
};

static gint TunerModelFavicon_private_offset;
static gpointer tuner_model_favicon_parent_class = NULL;
static GeeSet* tuner_model_favicon_FAILING_FAVICON;
static GeeSet* tuner_model_favicon_FAILING_FAVICON = NULL;

VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN gchar* tuner_model_favicon_favicon_cache_file (TunerModelFavicon* self);
static gchar* tuner_model_favicon_real_favicon_cache_file (TunerModelFavicon* self);
VALA_EXTERN gint tuner_model_favicon_favicon_loaded (TunerModelFavicon* self);
static void tuner_model_favicon_update_favicon_image_data_free (gpointer _data);
VALA_EXTERN void tuner_model_favicon_update_favicon_image (TunerModelFavicon* self,
                                               GtkImage* favicon_image,
                                               gboolean reload,
                                               const gchar* defaulticon,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
VALA_EXTERN gboolean tuner_model_favicon_update_favicon_image_finish (TunerModelFavicon* self,
                                                          GAsyncResult* _res_);
static gboolean tuner_model_favicon_update_favicon_image_co (TunerModelFaviconUpdateFaviconImageData* _data_);
VALA_EXTERN void tuner_fade (GtkImage* image,
                 guint duration_ms,
                 gboolean fading_in,
                 GAsyncReadyCallback _callback_,
                 gpointer _user_data_);
VALA_EXTERN void tuner_fade_finish (GAsyncResult* _res_);
static void tuner_model_favicon_update_favicon_image_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
VALA_EXTERN void tuner_model_favicon_load_favicon_async (TunerModelFavicon* self,
                                             gboolean reload,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void tuner_model_favicon_load_favicon_finish (TunerModelFavicon* self,
                                              GAsyncResult* _res_);
static void tuner_model_favicon_load_favicon_async_data_free (gpointer _data);
static gboolean tuner_model_favicon_load_favicon_async_co (TunerModelFaviconLoadFaviconAsyncData* _data_);
VALA_EXTERN void tuner_http_client_GETasync (GUri* uri,
                                 gint priority,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN GInputStream* tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                                 guint* status_code);
static void tuner_model_favicon_load_favicon_async_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
VALA_EXTERN TunerModelFavicon* tuner_model_favicon_construct (GType object_type);
VALA_EXTERN const gchar* tuner_model_favicon_get_favicon (TunerModelFavicon* self);
VALA_EXTERN void tuner_model_favicon_set_favicon (TunerModelFavicon* self,
                                      const gchar* value);
static void tuner_model_favicon_finalize (GObject * obj);
static GType tuner_model_favicon_get_type_once (void);
static void _vala_tuner_model_favicon_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_tuner_model_favicon_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
tuner_model_favicon_get_instance_private (TunerModelFavicon* self)
{
	return G_STRUCT_MEMBER_P (self, TunerModelFavicon_private_offset);
}

/**
     * @brief Abstract method to get the file path of the favicon cache.
     *
     * This method should be implemented by subclasses to provide the specific
     * file path where the favicon cache is stored.
     *
     * @return A string representing the file path of the favicon cache.
     */
static gchar*
tuner_model_favicon_real_favicon_cache_file (TunerModelFavicon* self)
{
#line 78 "../src/Models/Favicon.vala"
	g_critical ("Type `%s' does not implement abstract method `tuner_model_favicon_favicon_cache_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 78 "../src/Models/Favicon.vala"
	return NULL;
#line 274 "Favicon.c"
}

gchar*
tuner_model_favicon_favicon_cache_file (TunerModelFavicon* self)
{
	TunerModelFaviconClass* _klass_;
#line 78 "../src/Models/Favicon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../src/Models/Favicon.vala"
	_klass_ = TUNER_MODEL_FAVICON_GET_CLASS (self);
#line 78 "../src/Models/Favicon.vala"
	if (_klass_->favicon_cache_file) {
#line 78 "../src/Models/Favicon.vala"
		return _klass_->favicon_cache_file (self);
#line 289 "Favicon.c"
	}
#line 78 "../src/Models/Favicon.vala"
	return NULL;
#line 293 "Favicon.c"
}

/**
     * @brief Has favicon been loaded.
     *
     * @return An integer indicating the status of the favicon loading process.
     */
gint
tuner_model_favicon_favicon_loaded (TunerModelFavicon* self)
{
	gint result;
#line 86 "../src/Models/Favicon.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 88 "../src/Models/Favicon.vala"
	result = self->priv->_favicon_loaded;
#line 88 "../src/Models/Favicon.vala"
	return result;
#line 311 "Favicon.c"
}

static void
tuner_model_favicon_update_favicon_image_data_free (gpointer _data)
{
	TunerModelFaviconUpdateFaviconImageData* _data_;
	_data_ = _data;
#line 19 "../src/Models/Favicon.vala"
	_g_object_unref0 (_data_->favicon_image);
#line 19 "../src/Models/Favicon.vala"
	_g_free0 (_data_->defaulticon);
#line 19 "../src/Models/Favicon.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/Models/Favicon.vala"
	g_slice_free (TunerModelFaviconUpdateFaviconImageData, _data_);
#line 327 "Favicon.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/Models/Favicon.vala"
	return self ? g_object_ref (self) : NULL;
#line 335 "Favicon.c"
}

void
tuner_model_favicon_update_favicon_image (TunerModelFavicon* self,
                                          GtkImage* favicon_image,
                                          gboolean reload,
                                          const gchar* defaulticon,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	TunerModelFaviconUpdateFaviconImageData* _data_;
	TunerModelFavicon* _tmp0_;
	GtkImage* _tmp1_;
	gchar* _tmp2_;
#line 19 "../src/Models/Favicon.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Models/Favicon.vala"
	g_return_if_fail (favicon_image != NULL);
#line 19 "../src/Models/Favicon.vala"
	g_return_if_fail (defaulticon != NULL);
#line 19 "../src/Models/Favicon.vala"
	_data_ = g_slice_new0 (TunerModelFaviconUpdateFaviconImageData);
#line 19 "../src/Models/Favicon.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/Models/Favicon.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tuner_model_favicon_update_favicon_image_data_free);
#line 19 "../src/Models/Favicon.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/Models/Favicon.vala"
	_data_->self = _tmp0_;
#line 19 "../src/Models/Favicon.vala"
	_tmp1_ = _g_object_ref0 (favicon_image);
#line 19 "../src/Models/Favicon.vala"
	_g_object_unref0 (_data_->favicon_image);
#line 19 "../src/Models/Favicon.vala"
	_data_->favicon_image = _tmp1_;
#line 19 "../src/Models/Favicon.vala"
	_data_->reload = reload;
#line 19 "../src/Models/Favicon.vala"
	_tmp2_ = g_strdup (defaulticon);
#line 19 "../src/Models/Favicon.vala"
	_g_free0 (_data_->defaulticon);
#line 19 "../src/Models/Favicon.vala"
	_data_->defaulticon = _tmp2_;
#line 19 "../src/Models/Favicon.vala"
	tuner_model_favicon_update_favicon_image_co (_data_);
#line 382 "Favicon.c"
}

gboolean
tuner_model_favicon_update_favicon_image_finish (TunerModelFavicon* self,
                                                 GAsyncResult* _res_)
{
	gboolean result;
	TunerModelFaviconUpdateFaviconImageData* _data_;
#line 19 "../src/Models/Favicon.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 19 "../src/Models/Favicon.vala"
	result = _data_->result;
#line 19 "../src/Models/Favicon.vala"
	return result;
#line 397 "Favicon.c"
}

/**
     * @brief Asynchronously sets the given image to the station favicon, if available.
     *
     * Load the known icons first, and if reload, go around after trying the favicon url
     *
     * @param {Image} favicon_image - The favicon image to be updated.
     * @param {bool} reload - Whether to force reload the favicon from source.
     * @return {bool} True if the favicon was available and the image updated.
     */
static void
tuner_model_favicon_update_favicon_image_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	TunerModelFaviconUpdateFaviconImageData* _data_;
#line 108 "../src/Models/Favicon.vala"
	_data_ = _user_data_;
#line 108 "../src/Models/Favicon.vala"
	_data_->_source_object_ = source_object;
#line 108 "../src/Models/Favicon.vala"
	_data_->_res_ = _res_;
#line 108 "../src/Models/Favicon.vala"
	tuner_model_favicon_update_favicon_image_co (_data_);
#line 423 "Favicon.c"
}

static gboolean
tuner_model_favicon_update_favicon_image_co (TunerModelFaviconUpdateFaviconImageData* _data_)
{
#line 101 "../src/Models/Favicon.vala"
	switch (_data_->_state_) {
#line 101 "../src/Models/Favicon.vala"
		case 0:
#line 433 "Favicon.c"
		goto _state_0;
#line 101 "../src/Models/Favicon.vala"
		case 1:
#line 437 "Favicon.c"
		goto _state_1;
#line 101 "../src/Models/Favicon.vala"
		case 2:
#line 441 "Favicon.c"
		goto _state_2;
#line 101 "../src/Models/Favicon.vala"
		case 3:
#line 445 "Favicon.c"
		goto _state_3;
#line 101 "../src/Models/Favicon.vala"
		case 4:
#line 449 "Favicon.c"
		goto _state_4;
#line 101 "../src/Models/Favicon.vala"
		case 5:
#line 453 "Favicon.c"
		goto _state_5;
		default:
#line 101 "../src/Models/Favicon.vala"
		g_assert_not_reached ();
#line 458 "Favicon.c"
	}
	_state_0:
#line 103 "../src/Models/Favicon.vala"
	_data_->reloading = FALSE;
#line 463 "Favicon.c"
	{
#line 104 "../src/Models/Favicon.vala"
		_data_->_tmp0_ = TRUE;
#line 104 "../src/Models/Favicon.vala"
		while (TRUE) {
#line 104 "../src/Models/Favicon.vala"
			if (!_data_->_tmp0_) {
#line 133 "../src/Models/Favicon.vala"
				if (!_data_->reloading) {
#line 133 "../src/Models/Favicon.vala"
					break;
#line 475 "Favicon.c"
				}
			}
#line 104 "../src/Models/Favicon.vala"
			_data_->_tmp0_ = FALSE;
#line 480 "Favicon.c"
			{
#line 106 "../src/Models/Favicon.vala"
				_data_->_tmp2_ = _data_->self->priv->_favicon_pixbuf;
#line 106 "../src/Models/Favicon.vala"
				if (_data_->_tmp2_ == NULL) {
#line 106 "../src/Models/Favicon.vala"
					_data_->_tmp1_ = TRUE;
#line 488 "Favicon.c"
				} else {
#line 106 "../src/Models/Favicon.vala"
					_data_->_tmp3_ = tuner_model_favicon_FAILING_FAVICON;
#line 106 "../src/Models/Favicon.vala"
					_data_->_tmp4_ = _data_->self->priv->_favicon;
#line 106 "../src/Models/Favicon.vala"
					_data_->_tmp1_ = gee_collection_contains ((GeeCollection*) _data_->_tmp3_, _data_->_tmp4_);
#line 496 "Favicon.c"
				}
#line 106 "../src/Models/Favicon.vala"
				if (_data_->_tmp1_) {
#line 108 "../src/Models/Favicon.vala"
					_data_->_state_ = 1;
#line 108 "../src/Models/Favicon.vala"
					tuner_fade (_data_->favicon_image, (guint) TUNER_MODEL_FAVICON_FADE_MS, FALSE, tuner_model_favicon_update_favicon_image_ready, _data_);
#line 108 "../src/Models/Favicon.vala"
					return FALSE;
#line 506 "Favicon.c"
					_state_1:
#line 108 "../src/Models/Favicon.vala"
					tuner_fade_finish (_data_->_res_);
#line 109 "../src/Models/Favicon.vala"
					gtk_image_set_from_icon_name (_data_->favicon_image, _data_->defaulticon, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 110 "../src/Models/Favicon.vala"
					_data_->_state_ = 2;
#line 110 "../src/Models/Favicon.vala"
					tuner_fade (_data_->favicon_image, (guint) TUNER_MODEL_FAVICON_FADE_MS, TRUE, tuner_model_favicon_update_favicon_image_ready, _data_);
#line 110 "../src/Models/Favicon.vala"
					return FALSE;
#line 518 "Favicon.c"
					_state_2:
#line 110 "../src/Models/Favicon.vala"
					tuner_fade_finish (_data_->_res_);
#line 522 "Favicon.c"
				} else {
#line 114 "../src/Models/Favicon.vala"
					_data_->_state_ = 3;
#line 114 "../src/Models/Favicon.vala"
					tuner_fade (_data_->favicon_image, (guint) TUNER_MODEL_FAVICON_FADE_MS, FALSE, tuner_model_favicon_update_favicon_image_ready, _data_);
#line 114 "../src/Models/Favicon.vala"
					return FALSE;
#line 530 "Favicon.c"
					_state_3:
#line 114 "../src/Models/Favicon.vala"
					tuner_fade_finish (_data_->_res_);
#line 115 "../src/Models/Favicon.vala"
					_data_->_tmp5_ = _data_->self->priv->_favicon_pixbuf;
#line 115 "../src/Models/Favicon.vala"
					gtk_image_set_from_pixbuf (_data_->favicon_image, _data_->_tmp5_);
#line 116 "../src/Models/Favicon.vala"
					_data_->_state_ = 4;
#line 116 "../src/Models/Favicon.vala"
					tuner_fade (_data_->favicon_image, (guint) TUNER_MODEL_FAVICON_FADE_MS, TRUE, tuner_model_favicon_update_favicon_image_ready, _data_);
#line 116 "../src/Models/Favicon.vala"
					return FALSE;
#line 544 "Favicon.c"
					_state_4:
#line 116 "../src/Models/Favicon.vala"
					tuner_fade_finish (_data_->_res_);
#line 548 "Favicon.c"
				}
			}
			__finally0:
			{
#line 119 "../src/Models/Favicon.vala"
				gtk_widget_set_opacity ((GtkWidget*) _data_->favicon_image, (gdouble) 1);
#line 120 "../src/Models/Favicon.vala"
				_data_->reloading = FALSE;
#line 557 "Favicon.c"
			}
#line 105 "../src/Models/Favicon.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 105 "../src/Models/Favicon.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 105 "../src/Models/Favicon.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 105 "../src/Models/Favicon.vala"
				g_object_unref (_data_->_async_result);
#line 105 "../src/Models/Favicon.vala"
				return FALSE;
#line 569 "Favicon.c"
			}
#line 123 "../src/Models/Favicon.vala"
			if (_data_->reload) {
#line 123 "../src/Models/Favicon.vala"
				_data_->_tmp6_ = _data_->self->priv->_favicon_loaded < 2;
#line 575 "Favicon.c"
			} else {
#line 123 "../src/Models/Favicon.vala"
				_data_->_tmp6_ = FALSE;
#line 579 "Favicon.c"
			}
#line 123 "../src/Models/Favicon.vala"
			if (_data_->_tmp6_) {
#line 128 "../src/Models/Favicon.vala"
				_data_->_tmp7_ = tuner_model_favicon_FAILING_FAVICON;
#line 128 "../src/Models/Favicon.vala"
				_data_->_tmp8_ = _data_->self->priv->_favicon;
#line 128 "../src/Models/Favicon.vala"
				gee_collection_remove ((GeeCollection*) _data_->_tmp7_, _data_->_tmp8_);
#line 129 "../src/Models/Favicon.vala"
				_data_->_state_ = 5;
#line 129 "../src/Models/Favicon.vala"
				tuner_model_favicon_load_favicon_async (_data_->self, TRUE, tuner_model_favicon_update_favicon_image_ready, _data_);
#line 129 "../src/Models/Favicon.vala"
				return FALSE;
#line 595 "Favicon.c"
				_state_5:
#line 129 "../src/Models/Favicon.vala"
				tuner_model_favicon_load_favicon_finish (_data_->self, _data_->_res_);
#line 130 "../src/Models/Favicon.vala"
				_data_->reloading = TRUE;
#line 131 "../src/Models/Favicon.vala"
				_data_->reload = FALSE;
#line 603 "Favicon.c"
			}
		}
	}
#line 134 "../src/Models/Favicon.vala"
	_data_->result = TRUE;
#line 134 "../src/Models/Favicon.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 134 "../src/Models/Favicon.vala"
	if (_data_->_state_ != 0) {
#line 134 "../src/Models/Favicon.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 134 "../src/Models/Favicon.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 617 "Favicon.c"
		}
	}
#line 134 "../src/Models/Favicon.vala"
	g_object_unref (_data_->_async_result);
#line 134 "../src/Models/Favicon.vala"
	return FALSE;
#line 624 "Favicon.c"
}

static void
tuner_model_favicon_load_favicon_async_data_free (gpointer _data)
{
	TunerModelFaviconLoadFaviconAsyncData* _data_;
	_data_ = _data;
#line 19 "../src/Models/Favicon.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/Models/Favicon.vala"
	g_slice_free (TunerModelFaviconLoadFaviconAsyncData, _data_);
#line 636 "Favicon.c"
}

void
tuner_model_favicon_load_favicon_async (TunerModelFavicon* self,
                                        gboolean reload,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	TunerModelFaviconLoadFaviconAsyncData* _data_;
	TunerModelFavicon* _tmp0_;
#line 19 "../src/Models/Favicon.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Models/Favicon.vala"
	_data_ = g_slice_new0 (TunerModelFaviconLoadFaviconAsyncData);
#line 19 "../src/Models/Favicon.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/Models/Favicon.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tuner_model_favicon_load_favicon_async_data_free);
#line 19 "../src/Models/Favicon.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/Models/Favicon.vala"
	_data_->self = _tmp0_;
#line 19 "../src/Models/Favicon.vala"
	_data_->reload = reload;
#line 19 "../src/Models/Favicon.vala"
	tuner_model_favicon_load_favicon_async_co (_data_);
#line 663 "Favicon.c"
}

void
tuner_model_favicon_load_favicon_finish (TunerModelFavicon* self,
                                         GAsyncResult* _res_)
{
	TunerModelFaviconLoadFaviconAsyncData* _data_;
#line 19 "../src/Models/Favicon.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 673 "Favicon.c"
}

/**
     * @brief Asynchronously loads the favicon for the station.
     *
     * Loads from cache is not requesting reload and cache exists
     * Otherwise async calls to the website to download the favicon,
     * then stores it in the cache and replaces the Station favicon
     *
     * @param {bool} reload - Whether to force reload the favicon.
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 695 "Favicon.c"
}

static void
tuner_model_favicon_load_favicon_async_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	TunerModelFaviconLoadFaviconAsyncData* _data_;
#line 174 "../src/Models/Favicon.vala"
	_data_ = _user_data_;
#line 174 "../src/Models/Favicon.vala"
	_data_->_source_object_ = source_object;
#line 174 "../src/Models/Favicon.vala"
	_data_->_res_ = _res_;
#line 174 "../src/Models/Favicon.vala"
	tuner_model_favicon_load_favicon_async_co (_data_);
#line 712 "Favicon.c"
}

static gboolean
tuner_model_favicon_load_favicon_async_co (TunerModelFaviconLoadFaviconAsyncData* _data_)
{
#line 147 "../src/Models/Favicon.vala"
	switch (_data_->_state_) {
#line 147 "../src/Models/Favicon.vala"
		case 0:
#line 722 "Favicon.c"
		goto _state_0;
#line 147 "../src/Models/Favicon.vala"
		case 1:
#line 726 "Favicon.c"
		goto _state_1;
#line 147 "../src/Models/Favicon.vala"
		case 2:
#line 730 "Favicon.c"
		goto _state_2;
		default:
#line 147 "../src/Models/Favicon.vala"
		g_assert_not_reached ();
#line 735 "Favicon.c"
	}
	_state_0:
#line 149 "../src/Models/Favicon.vala"
	_data_->_tmp1_ = _data_->self->priv->_favicon_uri;
#line 149 "../src/Models/Favicon.vala"
	if (_data_->_tmp1_ == NULL) {
#line 149 "../src/Models/Favicon.vala"
		_data_->_tmp0_ = TRUE;
#line 744 "Favicon.c"
	} else {
#line 149 "../src/Models/Favicon.vala"
		if (!_data_->reload) {
#line 149 "../src/Models/Favicon.vala"
			_data_->_tmp2_ = _data_->self->priv->_favicon_loaded > 0;
#line 750 "Favicon.c"
		} else {
#line 149 "../src/Models/Favicon.vala"
			_data_->_tmp2_ = FALSE;
#line 754 "Favicon.c"
		}
#line 149 "../src/Models/Favicon.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 758 "Favicon.c"
	}
#line 149 "../src/Models/Favicon.vala"
	if (_data_->_tmp0_) {
#line 149 "../src/Models/Favicon.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 149 "../src/Models/Favicon.vala"
		if (_data_->_state_ != 0) {
#line 149 "../src/Models/Favicon.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 149 "../src/Models/Favicon.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 770 "Favicon.c"
			}
		}
#line 149 "../src/Models/Favicon.vala"
		g_object_unref (_data_->_async_result);
#line 149 "../src/Models/Favicon.vala"
		return FALSE;
#line 777 "Favicon.c"
	}
#line 155 "../src/Models/Favicon.vala"
	if (!_data_->reload) {
#line 155 "../src/Models/Favicon.vala"
		_data_->_tmp4_ = TRUE;
#line 783 "Favicon.c"
	} else {
#line 155 "../src/Models/Favicon.vala"
		_data_->_tmp5_ = tuner_model_favicon_FAILING_FAVICON;
#line 155 "../src/Models/Favicon.vala"
		_data_->_tmp6_ = _data_->self->priv->_favicon;
#line 155 "../src/Models/Favicon.vala"
		_data_->_tmp4_ = gee_collection_contains ((GeeCollection*) _data_->_tmp5_, _data_->_tmp6_);
#line 791 "Favicon.c"
	}
#line 155 "../src/Models/Favicon.vala"
	if (_data_->_tmp4_) {
#line 156 "../src/Models/Favicon.vala"
		_data_->_tmp7_ = tuner_model_favicon_favicon_cache_file (_data_->self);
#line 156 "../src/Models/Favicon.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 156 "../src/Models/Favicon.vala"
		_data_->_tmp3_ = g_file_test (_data_->_tmp8_, G_FILE_TEST_EXISTS);
#line 156 "../src/Models/Favicon.vala"
		_g_free0 (_data_->_tmp8_);
#line 803 "Favicon.c"
	} else {
#line 155 "../src/Models/Favicon.vala"
		_data_->_tmp3_ = FALSE;
#line 807 "Favicon.c"
	}
#line 155 "../src/Models/Favicon.vala"
	if (_data_->_tmp3_) {
#line 811 "Favicon.c"
		{
#line 159 "../src/Models/Favicon.vala"
			_data_->_tmp9_ = tuner_model_favicon_favicon_cache_file (_data_->self);
#line 159 "../src/Models/Favicon.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 159 "../src/Models/Favicon.vala"
			_data_->_tmp11_ = gdk_pixbuf_new_from_file_at_scale (_data_->_tmp10_, 48, 48, TRUE, &_data_->_inner_error0_);
#line 159 "../src/Models/Favicon.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 159 "../src/Models/Favicon.vala"
			_g_free0 (_data_->_tmp10_);
#line 159 "../src/Models/Favicon.vala"
			_data_->pixbuf = _data_->_tmp12_;
#line 159 "../src/Models/Favicon.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 827 "Favicon.c"
				goto __catch0_g_error;
			}
#line 160 "../src/Models/Favicon.vala"
			_data_->_tmp13_ = _data_->pixbuf;
#line 160 "../src/Models/Favicon.vala"
			_data_->_tmp14_ = _g_object_ref0 (_data_->_tmp13_);
#line 160 "../src/Models/Favicon.vala"
			_g_object_unref0 (_data_->self->priv->_favicon_pixbuf);
#line 160 "../src/Models/Favicon.vala"
			_data_->self->priv->_favicon_pixbuf = _data_->_tmp14_;
#line 161 "../src/Models/Favicon.vala"
			_data_->_tmp15_ = _data_->self->priv->_favicon_loaded;
#line 161 "../src/Models/Favicon.vala"
			_data_->self->priv->_favicon_loaded = _data_->_tmp15_ + 1;
#line 162 "../src/Models/Favicon.vala"
			g_signal_emit (_data_->self, tuner_model_favicon_signals[TUNER_MODEL_FAVICON_FAVICON_SIG_SIGNAL], 0);
#line 163 "../src/Models/Favicon.vala"
			_g_object_unref0 (_data_->pixbuf);
#line 163 "../src/Models/Favicon.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 163 "../src/Models/Favicon.vala"
			if (_data_->_state_ != 0) {
#line 163 "../src/Models/Favicon.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 163 "../src/Models/Favicon.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 854 "Favicon.c"
				}
			}
#line 163 "../src/Models/Favicon.vala"
			g_object_unref (_data_->_async_result);
#line 163 "../src/Models/Favicon.vala"
			return FALSE;
#line 861 "Favicon.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 158 "../src/Models/Favicon.vala"
			_data_->e = _data_->_inner_error0_;
#line 158 "../src/Models/Favicon.vala"
			_data_->_inner_error0_ = NULL;
#line 165 "../src/Models/Favicon.vala"
			_data_->_tmp16_ = _data_->self->priv->_favicon;
#line 165 "../src/Models/Favicon.vala"
			_data_->_tmp17_ = string_to_string (_data_->_tmp16_);
#line 165 "../src/Models/Favicon.vala"
			_data_->_tmp18_ = _data_->e;
#line 165 "../src/Models/Favicon.vala"
			_data_->_tmp19_ = _data_->_tmp18_->message;
#line 165 "../src/Models/Favicon.vala"
			_data_->_tmp20_ = string_to_string (_data_->_tmp19_);
#line 165 "../src/Models/Favicon.vala"
			_data_->_tmp21_ = g_strconcat (_data_->_tmp17_, " - Failed to load cached favicon: ", _data_->_tmp20_, NULL);
#line 165 "../src/Models/Favicon.vala"
			_data_->_tmp22_ = _data_->_tmp21_;
#line 165 "../src/Models/Favicon.vala"
			g_info ("Favicon.vala:165: %s", _data_->_tmp22_);
#line 165 "../src/Models/Favicon.vala"
			_g_free0 (_data_->_tmp22_);
#line 158 "../src/Models/Favicon.vala"
			_g_error_free0 (_data_->e);
#line 890 "Favicon.c"
		}
		__finally0:
#line 158 "../src/Models/Favicon.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 158 "../src/Models/Favicon.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 158 "../src/Models/Favicon.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 158 "../src/Models/Favicon.vala"
			g_object_unref (_data_->_async_result);
#line 158 "../src/Models/Favicon.vala"
			return FALSE;
#line 903 "Favicon.c"
		}
	}
#line 169 "../src/Models/Favicon.vala"
	_data_->_tmp23_ = _data_->self->priv->_favicon_uri;
#line 169 "../src/Models/Favicon.vala"
	if (_data_->_tmp23_ == NULL) {
#line 170 "../src/Models/Favicon.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 170 "../src/Models/Favicon.vala"
		if (_data_->_state_ != 0) {
#line 170 "../src/Models/Favicon.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 170 "../src/Models/Favicon.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 918 "Favicon.c"
			}
		}
#line 170 "../src/Models/Favicon.vala"
		g_object_unref (_data_->_async_result);
#line 170 "../src/Models/Favicon.vala"
		return FALSE;
#line 925 "Favicon.c"
	}
#line 174 "../src/Models/Favicon.vala"
	_data_->_tmp24_ = _data_->self->priv->_favicon_uri;
#line 174 "../src/Models/Favicon.vala"
	_data_->_tmp25_ = 0U;
#line 174 "../src/Models/Favicon.vala"
	_data_->_state_ = 1;
#line 174 "../src/Models/Favicon.vala"
	tuner_http_client_GETasync (_data_->_tmp24_, G_PRIORITY_LOW, tuner_model_favicon_load_favicon_async_ready, _data_);
#line 174 "../src/Models/Favicon.vala"
	return FALSE;
#line 937 "Favicon.c"
	_state_1:
#line 174 "../src/Models/Favicon.vala"
	_data_->_tmp26_ = tuner_http_client_GETasync_finish (_data_->_res_, &_data_->_tmp25_);
#line 174 "../src/Models/Favicon.vala"
	_data_->status_code = _data_->_tmp25_;
#line 174 "../src/Models/Favicon.vala"
	_data_->stream = _data_->_tmp26_;
#line 176 "../src/Models/Favicon.vala"
	_data_->_tmp28_ = _data_->stream;
#line 176 "../src/Models/Favicon.vala"
	if (_data_->_tmp28_ != NULL) {
#line 176 "../src/Models/Favicon.vala"
		_data_->_tmp27_ = _data_->status_code == ((guint) 200);
#line 951 "Favicon.c"
	} else {
#line 176 "../src/Models/Favicon.vala"
		_data_->_tmp27_ = FALSE;
#line 955 "Favicon.c"
	}
#line 176 "../src/Models/Favicon.vala"
	if (_data_->_tmp27_) {
#line 959 "Favicon.c"
		{
#line 182 "../src/Models/Favicon.vala"
			_data_->_tmp29_ = _data_->stream;
#line 182 "../src/Models/Favicon.vala"
			_data_->_state_ = 2;
#line 182 "../src/Models/Favicon.vala"
			gdk_pixbuf_new_from_stream_at_scale_async (_data_->_tmp29_, 48, 48, TRUE, NULL, tuner_model_favicon_load_favicon_async_ready, _data_);
#line 182 "../src/Models/Favicon.vala"
			return FALSE;
#line 969 "Favicon.c"
			_state_2:
#line 182 "../src/Models/Favicon.vala"
			_data_->_tmp30_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
#line 182 "../src/Models/Favicon.vala"
			_data_->_vala1_pixbuf = _data_->_tmp30_;
#line 182 "../src/Models/Favicon.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 977 "Favicon.c"
				goto __catch1_g_error;
			}
#line 183 "../src/Models/Favicon.vala"
			_data_->_tmp31_ = _data_->_vala1_pixbuf;
#line 183 "../src/Models/Favicon.vala"
			_data_->_tmp32_ = tuner_model_favicon_favicon_cache_file (_data_->self);
#line 183 "../src/Models/Favicon.vala"
			_data_->_tmp33_ = _data_->_tmp32_;
#line 183 "../src/Models/Favicon.vala"
			gdk_pixbuf_save (_data_->_tmp31_, _data_->_tmp33_, "png", &_data_->_inner_error0_, NULL);
#line 183 "../src/Models/Favicon.vala"
			_g_free0 (_data_->_tmp33_);
#line 183 "../src/Models/Favicon.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 183 "../src/Models/Favicon.vala"
				_g_object_unref0 (_data_->_vala1_pixbuf);
#line 994 "Favicon.c"
				goto __catch1_g_error;
			}
#line 184 "../src/Models/Favicon.vala"
			_data_->_tmp34_ = _data_->_vala1_pixbuf;
#line 184 "../src/Models/Favicon.vala"
			_data_->_tmp35_ = _g_object_ref0 (_data_->_tmp34_);
#line 184 "../src/Models/Favicon.vala"
			_g_object_unref0 (_data_->self->priv->_favicon_pixbuf);
#line 184 "../src/Models/Favicon.vala"
			_data_->self->priv->_favicon_pixbuf = _data_->_tmp35_;
#line 185 "../src/Models/Favicon.vala"
			_data_->_tmp36_ = _data_->self->priv->_favicon_loaded;
#line 185 "../src/Models/Favicon.vala"
			_data_->self->priv->_favicon_loaded = _data_->_tmp36_ + 1;
#line 186 "../src/Models/Favicon.vala"
			g_signal_emit (_data_->self, tuner_model_favicon_signals[TUNER_MODEL_FAVICON_FAVICON_SIG_SIGNAL], 0);
#line 187 "../src/Models/Favicon.vala"
			_g_object_unref0 (_data_->_vala1_pixbuf);
#line 187 "../src/Models/Favicon.vala"
			_g_object_unref0 (_data_->stream);
#line 187 "../src/Models/Favicon.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 187 "../src/Models/Favicon.vala"
			if (_data_->_state_ != 0) {
#line 187 "../src/Models/Favicon.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 187 "../src/Models/Favicon.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1023 "Favicon.c"
				}
			}
#line 187 "../src/Models/Favicon.vala"
			g_object_unref (_data_->_async_result);
#line 187 "../src/Models/Favicon.vala"
			return FALSE;
#line 1030 "Favicon.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 181 "../src/Models/Favicon.vala"
			_data_->_vala1_e = _data_->_inner_error0_;
#line 181 "../src/Models/Favicon.vala"
			_data_->_inner_error0_ = NULL;
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp37_ = _data_->self->priv->_favicon;
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp38_ = string_to_string (_data_->_tmp37_);
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp39_ = _data_->self->priv->_favicon_uri;
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp40_ = g_uri_to_string (_data_->_tmp39_);
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp41_ = _data_->_tmp40_;
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp42_ = string_to_string (_data_->_tmp41_);
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp43_ = _data_->_vala1_e;
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp44_ = _data_->_tmp43_->message;
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp45_ = string_to_string (_data_->_tmp44_);
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp46_ = g_strconcat (_data_->_tmp38_, " - Failed to process favicon ", _data_->_tmp42_, " - ", _data_->_tmp45_, NULL);
#line 190 "../src/Models/Favicon.vala"
			_data_->_tmp47_ = _data_->_tmp46_;
#line 190 "../src/Models/Favicon.vala"
			g_debug ("Favicon.vala:190: %s", _data_->_tmp47_);
#line 190 "../src/Models/Favicon.vala"
			_g_free0 (_data_->_tmp47_);
#line 190 "../src/Models/Favicon.vala"
			_g_free0 (_data_->_tmp41_);
#line 181 "../src/Models/Favicon.vala"
			_g_error_free0 (_data_->_vala1_e);
#line 1069 "Favicon.c"
		}
		__finally1:
#line 181 "../src/Models/Favicon.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 181 "../src/Models/Favicon.vala"
			_g_object_unref0 (_data_->stream);
#line 181 "../src/Models/Favicon.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 181 "../src/Models/Favicon.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 181 "../src/Models/Favicon.vala"
			g_object_unref (_data_->_async_result);
#line 181 "../src/Models/Favicon.vala"
			return FALSE;
#line 1084 "Favicon.c"
		}
	}
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp48_ = _data_->self->priv->_favicon;
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp49_ = string_to_string (_data_->_tmp48_);
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp50_ = _data_->self->priv->_favicon_uri;
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp51_ = g_uri_to_string (_data_->_tmp50_);
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp52_ = _data_->_tmp51_;
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp53_ = string_to_string (_data_->_tmp52_);
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp54_ = g_strdup_printf ("%u", _data_->status_code);
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp55_ = _data_->_tmp54_;
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp56_ = g_strconcat (_data_->_tmp49_, " - Failed to load favicon ", _data_->_tmp53_, " - Status code: ", _data_->_tmp55_, NULL);
#line 193 "../src/Models/Favicon.vala"
	_data_->_tmp57_ = _data_->_tmp56_;
#line 193 "../src/Models/Favicon.vala"
	g_info ("Favicon.vala:193: %s", _data_->_tmp57_);
#line 193 "../src/Models/Favicon.vala"
	_g_free0 (_data_->_tmp57_);
#line 193 "../src/Models/Favicon.vala"
	_g_free0 (_data_->_tmp55_);
#line 193 "../src/Models/Favicon.vala"
	_g_free0 (_data_->_tmp52_);
#line 194 "../src/Models/Favicon.vala"
	_data_->_tmp58_ = tuner_model_favicon_FAILING_FAVICON;
#line 194 "../src/Models/Favicon.vala"
	_data_->_tmp59_ = _data_->self->priv->_favicon;
#line 194 "../src/Models/Favicon.vala"
	gee_collection_add ((GeeCollection*) _data_->_tmp58_, _data_->_tmp59_);
#line 147 "../src/Models/Favicon.vala"
	_g_object_unref0 (_data_->stream);
#line 147 "../src/Models/Favicon.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 147 "../src/Models/Favicon.vala"
	if (_data_->_state_ != 0) {
#line 147 "../src/Models/Favicon.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 147 "../src/Models/Favicon.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1131 "Favicon.c"
		}
	}
#line 147 "../src/Models/Favicon.vala"
	g_object_unref (_data_->_async_result);
#line 147 "../src/Models/Favicon.vala"
	return FALSE;
#line 1138 "Favicon.c"
}

TunerModelFavicon*
tuner_model_favicon_construct (GType object_type)
{
	TunerModelFavicon * self = NULL;
#line 19 "../src/Models/Favicon.vala"
	self = (TunerModelFavicon*) g_object_new (object_type, NULL);
#line 19 "../src/Models/Favicon.vala"
	return self;
#line 1149 "Favicon.c"
}

const gchar*
tuner_model_favicon_get_favicon (TunerModelFavicon* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "../src/Models/Favicon.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/Models/Favicon.vala"
	_tmp0_ = self->priv->_favicon;
#line 42 "../src/Models/Favicon.vala"
	result = _tmp0_;
#line 42 "../src/Models/Favicon.vala"
	return result;
#line 1165 "Favicon.c"
}

void
tuner_model_favicon_set_favicon (TunerModelFavicon* self,
                                 const gchar* value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 43 "../src/Models/Favicon.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Models/Favicon.vala"
	if (value == NULL) {
#line 44 "../src/Models/Favicon.vala"
		_tmp1_ = TRUE;
#line 1182 "Favicon.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 44 "../src/Models/Favicon.vala"
		_tmp2_ = strlen (value);
#line 44 "../src/Models/Favicon.vala"
		_tmp3_ = _tmp2_;
#line 44 "../src/Models/Favicon.vala"
		_tmp1_ = _tmp3_ == 0;
#line 1192 "Favicon.c"
	}
#line 44 "../src/Models/Favicon.vala"
	if (_tmp1_) {
#line 44 "../src/Models/Favicon.vala"
		_tmp0_ = TRUE;
#line 1198 "Favicon.c"
	} else {
		const gchar* _tmp4_;
#line 44 "../src/Models/Favicon.vala"
		_tmp4_ = self->priv->_favicon;
#line 44 "../src/Models/Favicon.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, value) == 0;
#line 1205 "Favicon.c"
	}
#line 44 "../src/Models/Favicon.vala"
	if (_tmp0_) {
#line 44 "../src/Models/Favicon.vala"
		return;
#line 1211 "Favicon.c"
	}
#line 45 "../src/Models/Favicon.vala"
	_tmp5_ = g_strdup (value);
#line 45 "../src/Models/Favicon.vala"
	_g_free0 (self->priv->_favicon);
#line 45 "../src/Models/Favicon.vala"
	self->priv->_favicon = _tmp5_;
#line 1219 "Favicon.c"
	{
		GUri* _tmp6_ = NULL;
		GUri* _tmp7_;
		GUri* _tmp8_;
#line 48 "../src/Models/Favicon.vala"
		_tmp7_ = g_uri_parse (value, G_URI_FLAGS_NONE, &_inner_error0_);
#line 48 "../src/Models/Favicon.vala"
		_tmp6_ = _tmp7_;
#line 48 "../src/Models/Favicon.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../src/Models/Favicon.vala"
			if (_inner_error0_->domain == G_URI_ERROR) {
#line 1232 "Favicon.c"
				goto __catch0_g_uri_error;
			}
#line 48 "../src/Models/Favicon.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../src/Models/Favicon.vala"
			g_clear_error (&_inner_error0_);
#line 48 "../src/Models/Favicon.vala"
			return;
#line 1241 "Favicon.c"
		}
#line 48 "../src/Models/Favicon.vala"
		_tmp8_ = _tmp6_;
#line 48 "../src/Models/Favicon.vala"
		_tmp6_ = NULL;
#line 48 "../src/Models/Favicon.vala"
		_g_uri_unref0 (self->priv->_favicon_uri);
#line 48 "../src/Models/Favicon.vala"
		self->priv->_favicon_uri = _tmp8_;
#line 46 "../src/Models/Favicon.vala"
		_g_uri_unref0 (_tmp6_);
#line 1253 "Favicon.c"
	}
	goto __finally0;
	__catch0_g_uri_error:
	{
		GeeSet* _tmp9_;
#line 46 "../src/Models/Favicon.vala"
		g_clear_error (&_inner_error0_);
#line 51 "../src/Models/Favicon.vala"
		_tmp9_ = tuner_model_favicon_FAILING_FAVICON;
#line 51 "../src/Models/Favicon.vala"
		gee_collection_add ((GeeCollection*) _tmp9_, value);
#line 1265 "Favicon.c"
	}
	__finally0:
#line 46 "../src/Models/Favicon.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/Models/Favicon.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/Models/Favicon.vala"
		g_clear_error (&_inner_error0_);
#line 46 "../src/Models/Favicon.vala"
		return;
#line 1276 "Favicon.c"
	}
#line 43 "../src/Models/Favicon.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_model_favicon_properties[TUNER_MODEL_FAVICON_FAVICON_PROPERTY]);
#line 1280 "Favicon.c"
}

static void
tuner_model_favicon_class_init (TunerModelFaviconClass * klass,
                                gpointer klass_data)
{
	GeeHashSet* _tmp0_;
#line 19 "../src/Models/Favicon.vala"
	tuner_model_favicon_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/Models/Favicon.vala"
	g_type_class_adjust_private_offset (klass, &TunerModelFavicon_private_offset);
#line 19 "../src/Models/Favicon.vala"
	((TunerModelFaviconClass *) klass)->favicon_cache_file = (gchar* (*) (TunerModelFavicon*)) tuner_model_favicon_real_favicon_cache_file;
#line 19 "../src/Models/Favicon.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_model_favicon_get_property;
#line 19 "../src/Models/Favicon.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_model_favicon_set_property;
#line 19 "../src/Models/Favicon.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_model_favicon_finalize;
#line 19 "../src/Models/Favicon.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_FAVICON_FAVICON_PROPERTY, tuner_model_favicon_properties[TUNER_MODEL_FAVICON_FAVICON_PROPERTY] = g_param_spec_string ("favicon", "favicon", "favicon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/Models/Favicon.vala"
	tuner_model_favicon_signals[TUNER_MODEL_FAVICON_FAVICON_SIG_SIGNAL] = g_signal_new ("favicon-sig", TUNER_MODEL_TYPE_FAVICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 28 "../src/Models/Favicon.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 28 "../src/Models/Favicon.vala"
	tuner_model_favicon_FAILING_FAVICON = (GeeSet*) _tmp0_;
#line 1308 "Favicon.c"
}

static void
tuner_model_favicon_instance_init (TunerModelFavicon * self,
                                   gpointer klass)
{
#line 19 "../src/Models/Favicon.vala"
	self->priv = tuner_model_favicon_get_instance_private (self);
#line 62 "../src/Models/Favicon.vala"
	self->priv->_favicon_loaded = 0;
#line 1319 "Favicon.c"
}

static void
tuner_model_favicon_finalize (GObject * obj)
{
	TunerModelFavicon * self;
#line 19 "../src/Models/Favicon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon);
#line 39 "../src/Models/Favicon.vala"
	_g_free0 (self->priv->_favicon);
#line 61 "../src/Models/Favicon.vala"
	_g_uri_unref0 (self->priv->_favicon_uri);
#line 63 "../src/Models/Favicon.vala"
	_g_object_unref0 (self->priv->_favicon_pixbuf);
#line 19 "../src/Models/Favicon.vala"
	G_OBJECT_CLASS (tuner_model_favicon_parent_class)->finalize (obj);
#line 1336 "Favicon.c"
}

/**
 * @class Favicon
 * @brief Favicon location and loading.
 */
static GType
tuner_model_favicon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerModelFaviconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_model_favicon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerModelFavicon), 0, (GInstanceInitFunc) tuner_model_favicon_instance_init, NULL };
	GType tuner_model_favicon_type_id;
	tuner_model_favicon_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerModelFavicon", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	TunerModelFavicon_private_offset = g_type_add_instance_private (tuner_model_favicon_type_id, sizeof (TunerModelFaviconPrivate));
	return tuner_model_favicon_type_id;
}

GType
tuner_model_favicon_get_type (void)
{
	static volatile gsize tuner_model_favicon_type_id__once = 0;
	if (g_once_init_enter (&tuner_model_favicon_type_id__once)) {
		GType tuner_model_favicon_type_id;
		tuner_model_favicon_type_id = tuner_model_favicon_get_type_once ();
		g_once_init_leave (&tuner_model_favicon_type_id__once, tuner_model_favicon_type_id);
	}
	return tuner_model_favicon_type_id__once;
}

static void
_vala_tuner_model_favicon_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	TunerModelFavicon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon);
#line 19 "../src/Models/Favicon.vala"
	switch (property_id) {
#line 19 "../src/Models/Favicon.vala"
		case TUNER_MODEL_FAVICON_FAVICON_PROPERTY:
#line 19 "../src/Models/Favicon.vala"
		g_value_set_string (value, tuner_model_favicon_get_favicon (self));
#line 19 "../src/Models/Favicon.vala"
		break;
#line 1381 "Favicon.c"
		default:
#line 19 "../src/Models/Favicon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Models/Favicon.vala"
		break;
#line 1387 "Favicon.c"
	}
}

static void
_vala_tuner_model_favicon_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	TunerModelFavicon * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon);
#line 19 "../src/Models/Favicon.vala"
	switch (property_id) {
#line 19 "../src/Models/Favicon.vala"
		case TUNER_MODEL_FAVICON_FAVICON_PROPERTY:
#line 19 "../src/Models/Favicon.vala"
		tuner_model_favicon_set_favicon (self, g_value_get_string (value));
#line 19 "../src/Models/Favicon.vala"
		break;
#line 1407 "Favicon.c"
		default:
#line 19 "../src/Models/Favicon.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Models/Favicon.vala"
		break;
#line 1413 "Favicon.c"
	}
}

