/* Station.c generated by valac 0.56.17, the Vala compiler
 * generated from Station.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file Station.vala
 *
 * @brief Station metadata and related cachable objects
 * 
 */
/** @property {string} favicon - Favicon URL of the station. */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <json-glib/json-glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;
typedef struct _TunerModelFaviconPrivate TunerModelFaviconPrivate;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;
typedef struct _TunerModelStationPrivate TunerModelStationPrivate;
enum  {
	TUNER_MODEL_STATION_0_PROPERTY,
	TUNER_MODEL_STATION_CHANGEUUID_PROPERTY,
	TUNER_MODEL_STATION_STATIONUUID_PROPERTY,
	TUNER_MODEL_STATION_NAME_PROPERTY,
	TUNER_MODEL_STATION_URL_PROPERTY,
	TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY,
	TUNER_MODEL_STATION_HOMEPAGE_PROPERTY,
	TUNER_MODEL_STATION_TAGS_PROPERTY,
	TUNER_MODEL_STATION_COUNTRY_PROPERTY,
	TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY,
	TUNER_MODEL_STATION_ISO_3166_2_PROPERTY,
	TUNER_MODEL_STATION_STATE_PROPERTY,
	TUNER_MODEL_STATION_LANGUAGE_PROPERTY,
	TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY,
	TUNER_MODEL_STATION_CODEC_PROPERTY,
	TUNER_MODEL_STATION_BITRATE_PROPERTY,
	TUNER_MODEL_STATION_HLS_PROPERTY,
	TUNER_MODEL_STATION_STARRED_PROPERTY,
	TUNER_MODEL_STATION_NUM_PROPERTIES
};
static GParamSpec* tuner_model_station_properties[TUNER_MODEL_STATION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;

#define TUNER_TYPE_STAR_STORE (tuner_star_store_get_type ())
#define TUNER_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STAR_STORE, TunerStarStore))
#define TUNER_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))
#define TUNER_IS_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STAR_STORE))
#define TUNER_IS_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STAR_STORE))
#define TUNER_STAR_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))

typedef struct _TunerStarStore TunerStarStore;
typedef struct _TunerStarStoreClass TunerStarStoreClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	TUNER_MODEL_STATION_STATION_STAR_CHANGED_SIG_SIGNAL,
	TUNER_MODEL_STATION_NUM_SIGNALS
};
static guint tuner_model_station_signals[TUNER_MODEL_STATION_NUM_SIGNALS] = {0};

struct _TunerModelFavicon {
	GObject parent_instance;
	TunerModelFaviconPrivate * priv;
};

struct _TunerModelFaviconClass {
	GObjectClass parent_class;
	gchar* (*favicon_cache_file) (TunerModelFavicon* self);
};

struct _TunerModelStation {
	TunerModelFavicon parent_instance;
	TunerModelStationPrivate * priv;
	gint votes;
	gchar* lastchangetime;
	gchar* lastchangetime_iso8601;
	gint lastcheckok;
	gchar* lastchecktime;
	gchar* lastchecktime_iso8601;
	gchar* lastcheckoktime;
	gchar* lastcheckoktime_iso8601;
	gchar* lastlocalchecktime;
	gchar* lastlocalchecktime_iso8601;
	gchar* clicktimestamp;
	gchar* clicktimestamp_iso8601;
	gint clickcount;
	gint clicktrend;
	gint ssl_error;
	gchar* geo_lat;
	gchar* geo_long;
	gboolean has_extended_info;
	gboolean is_in_index;
	gboolean is_up_to_date;
	gchar* up_to_date_difference;
};

struct _TunerModelStationClass {
	TunerModelFaviconClass parent_class;
};

struct _TunerModelStationPrivate {
	gchar* _changeuuid;
	gchar* _stationuuid;
	gchar* _name;
	gchar* _url;
	gchar* _urlResolved;
	gchar* _homepage;
	gchar* _tags;
	gchar* _country;
	gchar* _countrycode;
	gchar* _iso_3166_2;
	gchar* _state;
	gchar* _language;
	gchar* _languagecodes;
	gchar* _codec;
	gint _bitrate;
	gint _hls;
	gboolean _starred;
	gchar* _favicon_cache_file;
};

static gint TunerModelStation_private_offset;
static gpointer tuner_model_station_parent_class = NULL;
static GeeMap* tuner_model_station_STATIONS;
static GeeMap* tuner_model_station_STATIONS = NULL;

VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN gchar* tuner_model_favicon_favicon_cache_file (TunerModelFavicon* self);
VALA_EXTERN TunerModelStation* tuner_model_station_make (JsonNode* json_node);
VALA_EXTERN TunerModelStation* tuner_model_station_new_basic (JsonNode* json_node);
VALA_EXTERN TunerModelStation* tuner_model_station_construct_basic (GType object_type,
                                                        JsonNode* json_node);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN GType tuner_star_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStarStore, g_object_unref)
VALA_EXTERN TunerStarStore* tuner_application_get_stars (TunerApplication* self);
VALA_EXTERN gboolean tuner_star_store_contains (TunerStarStore* self,
                                    TunerModelStation* station);
VALA_EXTERN void tuner_model_station_set_starred (TunerModelStation* self,
                                      gboolean value);
VALA_EXTERN const gchar* tuner_model_station_get_stationuuid (TunerModelStation* self);
VALA_EXTERN void tuner_model_favicon_load_favicon_async (TunerModelFavicon* self,
                                             gboolean reload,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
VALA_EXTERN void tuner_model_favicon_load_favicon_finish (TunerModelFavicon* self,
                                              GAsyncResult* _res_);
static void __lambda32_ (TunerModelStation* self,
                  const gchar* log_domain,
                  GLogLevelFlags log_level,
                  const gchar* message);
static void ___lambda32__glog_func (const gchar* log_domain,
                             GLogLevelFlags log_levels,
                             const gchar* message,
                             gpointer self);
static void __lambda33_ (TunerModelStation* self,
                  const gchar* log_domain,
                  GLogLevelFlags log_level,
                  const gchar* message);
static void ___lambda33__glog_func (const gchar* log_domain,
                             GLogLevelFlags log_levels,
                             const gchar* message,
                             gpointer self);
static void tuner_model_station_set_changeuuid (TunerModelStation* self,
                                         const gchar* value);
static void tuner_model_station_set_stationuuid (TunerModelStation* self,
                                          const gchar* value);
static void tuner_model_station_set_name (TunerModelStation* self,
                                   const gchar* value);
static void tuner_model_station_set_url (TunerModelStation* self,
                                  const gchar* value);
static void tuner_model_station_set_urlResolved (TunerModelStation* self,
                                          const gchar* value);
static void tuner_model_station_set_homepage (TunerModelStation* self,
                                       const gchar* value);
VALA_EXTERN void tuner_model_favicon_set_favicon (TunerModelFavicon* self,
                                      const gchar* value);
static void tuner_model_station_set_tags (TunerModelStation* self,
                                   const gchar* value);
static void tuner_model_station_set_country (TunerModelStation* self,
                                      const gchar* value);
static void tuner_model_station_set_countrycode (TunerModelStation* self,
                                          const gchar* value);
static void tuner_model_station_set_iso_3166_2 (TunerModelStation* self,
                                         const gchar* value);
static void tuner_model_station_set_state (TunerModelStation* self,
                                    const gchar* value);
static void tuner_model_station_set_language (TunerModelStation* self,
                                       const gchar* value);
static void tuner_model_station_set_languagecodes (TunerModelStation* self,
                                            const gchar* value);
static void tuner_model_station_set_codec (TunerModelStation* self,
                                    const gchar* value);
static void tuner_model_station_set_bitrate (TunerModelStation* self,
                                      gint value);
static void tuner_model_station_set_hls (TunerModelStation* self,
                                  gint value);
VALA_EXTERN TunerApplication* tuner_application_get_instance (void);
VALA_EXTERN const gchar* tuner_application_get_cache_dir (TunerApplication* self);
VALA_EXTERN gboolean tuner_model_station_toggle_starred (TunerModelStation* self);
VALA_EXTERN gboolean tuner_model_station_get_starred (TunerModelStation* self);
VALA_EXTERN gchar* tuner_model_station_popularity (TunerModelStation* self);
VALA_EXTERN gchar* tuner_model_station_to_string (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_name (TunerModelStation* self);
VALA_EXTERN gboolean tuner_model_station_set_up_to_date_with (TunerModelStation* self,
                                                  TunerModelStation* p);
VALA_EXTERN const gchar* tuner_model_station_get_url (TunerModelStation* self);
VALA_EXTERN gint tuner_model_station_get_bitrate (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_codec (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_urlResolved (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_favicon_get_favicon (TunerModelFavicon* self);
VALA_EXTERN const gchar* tuner_model_station_get_homepage (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_tags (TunerModelStation* self);
VALA_EXTERN TunerModelStation* tuner_model_station_updated (TunerModelStation* self);
VALA_EXTERN gboolean tuner_model_station_equals (TunerModelStation* self,
                                     TunerModelStation* other);
static gchar* tuner_model_station_real_favicon_cache_file (TunerModelFavicon* base);
VALA_EXTERN TunerModelStation* tuner_model_station_new (void);
VALA_EXTERN TunerModelStation* tuner_model_station_construct (GType object_type);
VALA_EXTERN TunerModelFavicon* tuner_model_favicon_construct (GType object_type);
VALA_EXTERN const gchar* tuner_model_station_get_changeuuid (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_country (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_countrycode (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_iso_3166_2 (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_state (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_language (TunerModelStation* self);
VALA_EXTERN const gchar* tuner_model_station_get_languagecodes (TunerModelStation* self);
VALA_EXTERN gint tuner_model_station_get_hls (TunerModelStation* self);
static void tuner_model_station_finalize (GObject * obj);
static GType tuner_model_station_get_type_once (void);
static void _vala_tuner_model_station_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_tuner_model_station_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
tuner_model_station_get_instance_private (TunerModelStation* self)
{
	return G_STRUCT_MEMBER_P (self, TunerModelStation_private_offset);
}

/**
* @brief Returns a unique, initiated Station instance for a given JSON node.
*
* If station has already been initiated based on stationuuid, returns the existing Station
    * Checks with StarStore and sets stations starred status
*
* @param {Json.Node} json_node - The JSON node containing station data.
* @return {Station} The created Station instance.
*/
TunerModelStation*
tuner_model_station_make (JsonNode* json_node)
{
	TunerModelStation* station = NULL;
	TunerModelStation* _tmp0_;
	TunerModelStation* _tmp1_;
	TunerModelStation* _tmp2_;
	TunerModelStation* _tmp3_;
	gchar* _tmp4_;
	TunerModelStation* _tmp5_;
	TunerApplication* _tmp6_;
	TunerApplication* _tmp7_;
	TunerStarStore* _tmp8_;
	TunerStarStore* _tmp9_;
	TunerModelStation* _tmp10_;
	GeeMap* _tmp11_;
	TunerModelStation* _tmp12_;
	const gchar* _tmp13_;
	GeeMap* _tmp19_;
	TunerModelStation* _tmp20_;
	const gchar* _tmp21_;
	gpointer _tmp22_;
	TunerModelStation* result;
#line 158 "../src/Models/Station.vala"
	g_return_val_if_fail (json_node != NULL, NULL);
#line 160 "../src/Models/Station.vala"
	_tmp0_ = tuner_model_station_new_basic (json_node);
#line 160 "../src/Models/Station.vala"
	station = _tmp0_;
#line 161 "../src/Models/Station.vala"
	_tmp1_ = station;
#line 161 "../src/Models/Station.vala"
	_tmp1_->is_in_index = TRUE;
#line 162 "../src/Models/Station.vala"
	_tmp2_ = station;
#line 162 "../src/Models/Station.vala"
	_tmp2_->is_up_to_date = TRUE;
#line 163 "../src/Models/Station.vala"
	_tmp3_ = station;
#line 163 "../src/Models/Station.vala"
	_tmp4_ = g_strdup ("");
#line 163 "../src/Models/Station.vala"
	_g_free0 (_tmp3_->up_to_date_difference);
#line 163 "../src/Models/Station.vala"
	_tmp3_->up_to_date_difference = _tmp4_;
#line 164 "../src/Models/Station.vala"
	_tmp5_ = station;
#line 164 "../src/Models/Station.vala"
	_tmp6_ = tuner_app ();
#line 164 "../src/Models/Station.vala"
	_tmp7_ = _tmp6_;
#line 164 "../src/Models/Station.vala"
	_tmp8_ = tuner_application_get_stars (_tmp7_);
#line 164 "../src/Models/Station.vala"
	_tmp9_ = _tmp8_;
#line 164 "../src/Models/Station.vala"
	_tmp10_ = station;
#line 164 "../src/Models/Station.vala"
	tuner_model_station_set_starred (_tmp5_, tuner_star_store_contains (_tmp9_, _tmp10_));
#line 164 "../src/Models/Station.vala"
	_g_object_unref0 (_tmp7_);
#line 166 "../src/Models/Station.vala"
	_tmp11_ = tuner_model_station_STATIONS;
#line 166 "../src/Models/Station.vala"
	_tmp12_ = station;
#line 166 "../src/Models/Station.vala"
	_tmp13_ = _tmp12_->priv->_stationuuid;
#line 166 "../src/Models/Station.vala"
	if (!gee_map_has_key (_tmp11_, _tmp13_)) {
#line 387 "Station.c"
		GeeMap* _tmp14_;
		TunerModelStation* _tmp15_;
		const gchar* _tmp16_;
		TunerModelStation* _tmp17_;
		TunerModelStation* _tmp18_;
#line 171 "../src/Models/Station.vala"
		_tmp14_ = tuner_model_station_STATIONS;
#line 171 "../src/Models/Station.vala"
		_tmp15_ = station;
#line 171 "../src/Models/Station.vala"
		_tmp16_ = _tmp15_->priv->_stationuuid;
#line 171 "../src/Models/Station.vala"
		_tmp17_ = station;
#line 171 "../src/Models/Station.vala"
		gee_map_set (_tmp14_, _tmp16_, _tmp17_);
#line 172 "../src/Models/Station.vala"
		_tmp18_ = station;
#line 172 "../src/Models/Station.vala"
		tuner_model_favicon_load_favicon_async ((TunerModelFavicon*) _tmp18_, FALSE, NULL, NULL);
#line 407 "Station.c"
	}
#line 175 "../src/Models/Station.vala"
	_tmp19_ = tuner_model_station_STATIONS;
#line 175 "../src/Models/Station.vala"
	_tmp20_ = station;
#line 175 "../src/Models/Station.vala"
	_tmp21_ = _tmp20_->priv->_stationuuid;
#line 175 "../src/Models/Station.vala"
	_tmp22_ = gee_map_get (_tmp19_, _tmp21_);
#line 175 "../src/Models/Station.vala"
	result = (TunerModelStation*) _tmp22_;
#line 175 "../src/Models/Station.vala"
	_g_object_unref0 (station);
#line 175 "../src/Models/Station.vala"
	return result;
#line 423 "Station.c"
}

/**
     * @brief Constructor a basic Station instance from a JSON node.
     *
     * @param {Json.Node} json_node - The JSON node containing station data.
     */
static gpointer
_json_object_ref0 (gpointer self)
{
#line 194 "../src/Models/Station.vala"
	return self ? json_object_ref (self) : NULL;
#line 436 "Station.c"
}

static void
__lambda32_ (TunerModelStation* self,
             const gchar* log_domain,
             GLogLevelFlags log_level,
             const gchar* message)
{
#line 202 "../src/Models/Station.vala"
	g_return_if_fail (message != NULL);
#line 447 "Station.c"
}

static void
___lambda32__glog_func (const gchar* log_domain,
                        GLogLevelFlags log_levels,
                        const gchar* message,
                        gpointer self)
{
#line 199 "../src/Models/Station.vala"
	__lambda32_ ((TunerModelStation*) self, log_domain, log_levels, message);
#line 458 "Station.c"
}

static void
__lambda33_ (TunerModelStation* self,
             const gchar* log_domain,
             GLogLevelFlags log_level,
             const gchar* message)
{
#line 210 "../src/Models/Station.vala"
	g_return_if_fail (message != NULL);
#line 469 "Station.c"
}

static void
___lambda33__glog_func (const gchar* log_domain,
                        GLogLevelFlags log_levels,
                        const gchar* message,
                        gpointer self)
{
#line 207 "../src/Models/Station.vala"
	__lambda33_ ((TunerModelStation*) self, log_domain, log_levels, message);
#line 480 "Station.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 501 "Station.c"
}

TunerModelStation*
tuner_model_station_construct_basic (GType object_type,
                                     JsonNode* json_node)
{
	TunerModelStation * self = NULL;
	JsonObject* json_object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	guint log_handler_1 = 0U;
	guint log_handler_2 = 0U;
	TunerApplication* _tmp138_;
	TunerApplication* _tmp139_;
	const gchar* _tmp140_;
	const gchar* _tmp141_;
	const gchar* _tmp142_;
	gchar* _tmp143_;
	GError* _inner_error0_ = NULL;
#line 184 "../src/Models/Station.vala"
	g_return_val_if_fail (json_node != NULL, NULL);
#line 186 "../src/Models/Station.vala"
	self = (TunerModelStation*) g_object_new (object_type, NULL);
#line 188 "../src/Models/Station.vala"
	if (json_node == NULL) {
#line 190 "../src/Models/Station.vala"
		g_warning ("Station.vala:190: %s", "Station - no JSON");
#line 191 "../src/Models/Station.vala"
		return self;
#line 531 "Station.c"
	}
#line 194 "../src/Models/Station.vala"
	_tmp0_ = json_node_get_object (json_node);
#line 194 "../src/Models/Station.vala"
	_tmp1_ = _json_object_ref0 (_tmp0_);
#line 194 "../src/Models/Station.vala"
	json_object = _tmp1_;
#line 199 "../src/Models/Station.vala"
	log_handler_1 = g_log_set_handler ("Json", G_LOG_LEVEL_CRITICAL, ___lambda32__glog_func, self);
#line 207 "../src/Models/Station.vala"
	log_handler_2 = g_log_set_handler (NULL, G_LOG_LEVEL_CRITICAL, ___lambda33__glog_func, self);
#line 543 "Station.c"
	{
		JsonObject* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		JsonObject* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		JsonObject* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		JsonObject* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		JsonObject* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		JsonObject* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		JsonObject* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		JsonObject* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		JsonObject* _tmp34_;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		JsonObject* _tmp38_;
		const gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		JsonObject* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		JsonObject* _tmp46_;
		const gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		JsonObject* _tmp50_;
		const gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		JsonObject* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		JsonObject* _tmp58_;
		JsonObject* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		JsonObject* _tmp62_;
		const gchar* _tmp63_;
		gchar* _tmp64_;
		JsonObject* _tmp65_;
		const gchar* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
		JsonObject* _tmp69_;
		JsonObject* _tmp70_;
		JsonObject* _tmp71_;
		JsonObject* _tmp72_;
		const gchar* _tmp73_;
		gchar* _tmp74_;
		JsonObject* _tmp75_;
		const gchar* _tmp76_;
		gchar* _tmp77_;
		JsonObject* _tmp78_;
		const gchar* _tmp79_;
		gchar* _tmp80_;
		JsonObject* _tmp81_;
		const gchar* _tmp82_;
		gchar* _tmp83_;
		JsonObject* _tmp84_;
		const gchar* _tmp85_;
		gchar* _tmp86_;
		JsonObject* _tmp87_;
		const gchar* _tmp88_;
		gchar* _tmp89_;
		JsonObject* _tmp90_;
		const gchar* _tmp91_;
		gchar* _tmp92_;
		JsonObject* _tmp93_;
		const gchar* _tmp94_;
		gchar* _tmp95_;
		JsonObject* _tmp96_;
		const gchar* _tmp97_;
		gchar* _tmp98_;
		JsonObject* _tmp99_;
		JsonObject* _tmp100_;
		JsonObject* _tmp101_;
		JsonObject* _tmp102_;
		const gchar* _tmp103_;
		gchar* _tmp104_;
		JsonObject* _tmp105_;
		const gchar* _tmp106_;
		gchar* _tmp107_;
		JsonObject* _tmp108_;
		gchar* go_serial_fudge = NULL;
		JsonObject* _tmp109_;
		const gchar* _tmp110_;
		gchar* _tmp111_;
		gboolean _tmp112_ = FALSE;
		const gchar* _tmp113_;
		JsonObject* _tmp116_;
		JsonObject* _tmp118_;
		JsonObject* _tmp123_;
		JsonObject* _tmp128_;
		JsonObject* _tmp133_;
#line 219 "../src/Models/Station.vala"
		_tmp2_ = json_object;
#line 219 "../src/Models/Station.vala"
		_tmp3_ = json_object_get_string_member (_tmp2_, "changeuuid");
#line 219 "../src/Models/Station.vala"
		_tmp4_ = string_strip (_tmp3_);
#line 219 "../src/Models/Station.vala"
		_tmp5_ = _tmp4_;
#line 219 "../src/Models/Station.vala"
		tuner_model_station_set_changeuuid (self, _tmp5_);
#line 219 "../src/Models/Station.vala"
		_g_free0 (_tmp5_);
#line 220 "../src/Models/Station.vala"
		_tmp6_ = json_object;
#line 220 "../src/Models/Station.vala"
		_tmp7_ = json_object_get_string_member (_tmp6_, "stationuuid");
#line 220 "../src/Models/Station.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 220 "../src/Models/Station.vala"
		_tmp9_ = _tmp8_;
#line 220 "../src/Models/Station.vala"
		tuner_model_station_set_stationuuid (self, _tmp9_);
#line 220 "../src/Models/Station.vala"
		_g_free0 (_tmp9_);
#line 221 "../src/Models/Station.vala"
		_tmp10_ = json_object;
#line 221 "../src/Models/Station.vala"
		_tmp11_ = json_object_get_string_member (_tmp10_, "name");
#line 221 "../src/Models/Station.vala"
		_tmp12_ = string_strip (_tmp11_);
#line 221 "../src/Models/Station.vala"
		_tmp13_ = _tmp12_;
#line 221 "../src/Models/Station.vala"
		tuner_model_station_set_name (self, _tmp13_);
#line 221 "../src/Models/Station.vala"
		_g_free0 (_tmp13_);
#line 222 "../src/Models/Station.vala"
		_tmp14_ = json_object;
#line 222 "../src/Models/Station.vala"
		_tmp15_ = json_object_get_string_member (_tmp14_, "url");
#line 222 "../src/Models/Station.vala"
		_tmp16_ = string_strip (_tmp15_);
#line 222 "../src/Models/Station.vala"
		_tmp17_ = _tmp16_;
#line 222 "../src/Models/Station.vala"
		tuner_model_station_set_url (self, _tmp17_);
#line 222 "../src/Models/Station.vala"
		_g_free0 (_tmp17_);
#line 223 "../src/Models/Station.vala"
		_tmp18_ = json_object;
#line 223 "../src/Models/Station.vala"
		_tmp19_ = json_object_get_string_member (_tmp18_, "url_resolved");
#line 223 "../src/Models/Station.vala"
		_tmp20_ = string_strip (_tmp19_);
#line 223 "../src/Models/Station.vala"
		_tmp21_ = _tmp20_;
#line 223 "../src/Models/Station.vala"
		tuner_model_station_set_urlResolved (self, _tmp21_);
#line 223 "../src/Models/Station.vala"
		_g_free0 (_tmp21_);
#line 224 "../src/Models/Station.vala"
		_tmp22_ = json_object;
#line 224 "../src/Models/Station.vala"
		_tmp23_ = json_object_get_string_member (_tmp22_, "homepage");
#line 224 "../src/Models/Station.vala"
		_tmp24_ = string_strip (_tmp23_);
#line 224 "../src/Models/Station.vala"
		_tmp25_ = _tmp24_;
#line 224 "../src/Models/Station.vala"
		tuner_model_station_set_homepage (self, _tmp25_);
#line 224 "../src/Models/Station.vala"
		_g_free0 (_tmp25_);
#line 225 "../src/Models/Station.vala"
		_tmp26_ = json_object;
#line 225 "../src/Models/Station.vala"
		_tmp27_ = json_object_get_string_member (_tmp26_, "favicon");
#line 225 "../src/Models/Station.vala"
		_tmp28_ = string_strip (_tmp27_);
#line 225 "../src/Models/Station.vala"
		_tmp29_ = _tmp28_;
#line 225 "../src/Models/Station.vala"
		tuner_model_favicon_set_favicon ((TunerModelFavicon*) self, _tmp29_);
#line 225 "../src/Models/Station.vala"
		_g_free0 (_tmp29_);
#line 226 "../src/Models/Station.vala"
		_tmp30_ = json_object;
#line 226 "../src/Models/Station.vala"
		_tmp31_ = json_object_get_string_member (_tmp30_, "tags");
#line 226 "../src/Models/Station.vala"
		_tmp32_ = string_strip (_tmp31_);
#line 226 "../src/Models/Station.vala"
		_tmp33_ = _tmp32_;
#line 226 "../src/Models/Station.vala"
		tuner_model_station_set_tags (self, _tmp33_);
#line 226 "../src/Models/Station.vala"
		_g_free0 (_tmp33_);
#line 227 "../src/Models/Station.vala"
		_tmp34_ = json_object;
#line 227 "../src/Models/Station.vala"
		_tmp35_ = json_object_get_string_member (_tmp34_, "country");
#line 227 "../src/Models/Station.vala"
		_tmp36_ = string_strip (_tmp35_);
#line 227 "../src/Models/Station.vala"
		_tmp37_ = _tmp36_;
#line 227 "../src/Models/Station.vala"
		tuner_model_station_set_country (self, _tmp37_);
#line 227 "../src/Models/Station.vala"
		_g_free0 (_tmp37_);
#line 228 "../src/Models/Station.vala"
		_tmp38_ = json_object;
#line 228 "../src/Models/Station.vala"
		_tmp39_ = json_object_get_string_member (_tmp38_, "countrycode");
#line 228 "../src/Models/Station.vala"
		_tmp40_ = string_strip (_tmp39_);
#line 228 "../src/Models/Station.vala"
		_tmp41_ = _tmp40_;
#line 228 "../src/Models/Station.vala"
		tuner_model_station_set_countrycode (self, _tmp41_);
#line 228 "../src/Models/Station.vala"
		_g_free0 (_tmp41_);
#line 229 "../src/Models/Station.vala"
		_tmp42_ = json_object;
#line 229 "../src/Models/Station.vala"
		_tmp43_ = json_object_get_string_member (_tmp42_, "iso_3166_2");
#line 229 "../src/Models/Station.vala"
		_tmp44_ = string_strip (_tmp43_);
#line 229 "../src/Models/Station.vala"
		_tmp45_ = _tmp44_;
#line 229 "../src/Models/Station.vala"
		tuner_model_station_set_iso_3166_2 (self, _tmp45_);
#line 229 "../src/Models/Station.vala"
		_g_free0 (_tmp45_);
#line 230 "../src/Models/Station.vala"
		_tmp46_ = json_object;
#line 230 "../src/Models/Station.vala"
		_tmp47_ = json_object_get_string_member (_tmp46_, "state");
#line 230 "../src/Models/Station.vala"
		_tmp48_ = string_strip (_tmp47_);
#line 230 "../src/Models/Station.vala"
		_tmp49_ = _tmp48_;
#line 230 "../src/Models/Station.vala"
		tuner_model_station_set_state (self, _tmp49_);
#line 230 "../src/Models/Station.vala"
		_g_free0 (_tmp49_);
#line 231 "../src/Models/Station.vala"
		_tmp50_ = json_object;
#line 231 "../src/Models/Station.vala"
		_tmp51_ = json_object_get_string_member (_tmp50_, "language");
#line 231 "../src/Models/Station.vala"
		_tmp52_ = string_strip (_tmp51_);
#line 231 "../src/Models/Station.vala"
		_tmp53_ = _tmp52_;
#line 231 "../src/Models/Station.vala"
		tuner_model_station_set_language (self, _tmp53_);
#line 231 "../src/Models/Station.vala"
		_g_free0 (_tmp53_);
#line 232 "../src/Models/Station.vala"
		_tmp54_ = json_object;
#line 232 "../src/Models/Station.vala"
		_tmp55_ = json_object_get_string_member (_tmp54_, "languagecodes");
#line 232 "../src/Models/Station.vala"
		_tmp56_ = string_strip (_tmp55_);
#line 232 "../src/Models/Station.vala"
		_tmp57_ = _tmp56_;
#line 232 "../src/Models/Station.vala"
		tuner_model_station_set_languagecodes (self, _tmp57_);
#line 232 "../src/Models/Station.vala"
		_g_free0 (_tmp57_);
#line 233 "../src/Models/Station.vala"
		_tmp58_ = json_object;
#line 233 "../src/Models/Station.vala"
		self->votes = (gint) json_object_get_int_member (_tmp58_, "votes");
#line 234 "../src/Models/Station.vala"
		_tmp59_ = json_object;
#line 234 "../src/Models/Station.vala"
		_tmp60_ = json_object_get_string_member (_tmp59_, "lastchangetime");
#line 234 "../src/Models/Station.vala"
		_tmp61_ = string_strip (_tmp60_);
#line 234 "../src/Models/Station.vala"
		_g_free0 (self->lastchangetime);
#line 234 "../src/Models/Station.vala"
		self->lastchangetime = _tmp61_;
#line 235 "../src/Models/Station.vala"
		_tmp62_ = json_object;
#line 235 "../src/Models/Station.vala"
		_tmp63_ = json_object_get_string_member (_tmp62_, "lastchangetime_iso8601");
#line 235 "../src/Models/Station.vala"
		_tmp64_ = string_strip (_tmp63_);
#line 235 "../src/Models/Station.vala"
		_g_free0 (self->lastchangetime_iso8601);
#line 235 "../src/Models/Station.vala"
		self->lastchangetime_iso8601 = _tmp64_;
#line 236 "../src/Models/Station.vala"
		_tmp65_ = json_object;
#line 236 "../src/Models/Station.vala"
		_tmp66_ = json_object_get_string_member (_tmp65_, "codec");
#line 236 "../src/Models/Station.vala"
		_tmp67_ = string_strip (_tmp66_);
#line 236 "../src/Models/Station.vala"
		_tmp68_ = _tmp67_;
#line 236 "../src/Models/Station.vala"
		tuner_model_station_set_codec (self, _tmp68_);
#line 236 "../src/Models/Station.vala"
		_g_free0 (_tmp68_);
#line 237 "../src/Models/Station.vala"
		_tmp69_ = json_object;
#line 237 "../src/Models/Station.vala"
		tuner_model_station_set_bitrate (self, (gint) json_object_get_int_member (_tmp69_, "bitrate"));
#line 238 "../src/Models/Station.vala"
		_tmp70_ = json_object;
#line 238 "../src/Models/Station.vala"
		tuner_model_station_set_hls (self, (gint) json_object_get_int_member (_tmp70_, "hls"));
#line 239 "../src/Models/Station.vala"
		_tmp71_ = json_object;
#line 239 "../src/Models/Station.vala"
		self->lastcheckok = (gint) json_object_get_int_member (_tmp71_, "lastcheckok");
#line 240 "../src/Models/Station.vala"
		_tmp72_ = json_object;
#line 240 "../src/Models/Station.vala"
		_tmp73_ = json_object_get_string_member (_tmp72_, "lastchecktime");
#line 240 "../src/Models/Station.vala"
		_tmp74_ = string_strip (_tmp73_);
#line 240 "../src/Models/Station.vala"
		_g_free0 (self->lastchecktime);
#line 240 "../src/Models/Station.vala"
		self->lastchecktime = _tmp74_;
#line 241 "../src/Models/Station.vala"
		_tmp75_ = json_object;
#line 241 "../src/Models/Station.vala"
		_tmp76_ = json_object_get_string_member (_tmp75_, "lastchecktime_iso8601");
#line 241 "../src/Models/Station.vala"
		_tmp77_ = string_strip (_tmp76_);
#line 241 "../src/Models/Station.vala"
		_g_free0 (self->lastchecktime_iso8601);
#line 241 "../src/Models/Station.vala"
		self->lastchecktime_iso8601 = _tmp77_;
#line 242 "../src/Models/Station.vala"
		_tmp78_ = json_object;
#line 242 "../src/Models/Station.vala"
		_tmp79_ = json_object_get_string_member (_tmp78_, "lastcheckoktime");
#line 242 "../src/Models/Station.vala"
		_tmp80_ = string_strip (_tmp79_);
#line 242 "../src/Models/Station.vala"
		_g_free0 (self->lastcheckoktime);
#line 242 "../src/Models/Station.vala"
		self->lastcheckoktime = _tmp80_;
#line 243 "../src/Models/Station.vala"
		_tmp81_ = json_object;
#line 243 "../src/Models/Station.vala"
		_tmp82_ = json_object_get_string_member (_tmp81_, "lastcheckoktime_iso8601");
#line 243 "../src/Models/Station.vala"
		_tmp83_ = string_strip (_tmp82_);
#line 243 "../src/Models/Station.vala"
		_g_free0 (self->lastcheckoktime_iso8601);
#line 243 "../src/Models/Station.vala"
		self->lastcheckoktime_iso8601 = _tmp83_;
#line 244 "../src/Models/Station.vala"
		_tmp84_ = json_object;
#line 244 "../src/Models/Station.vala"
		_tmp85_ = json_object_get_string_member (_tmp84_, "lastlocalchecktime");
#line 244 "../src/Models/Station.vala"
		_tmp86_ = string_strip (_tmp85_);
#line 244 "../src/Models/Station.vala"
		_g_free0 (self->lastlocalchecktime);
#line 244 "../src/Models/Station.vala"
		self->lastlocalchecktime = _tmp86_;
#line 245 "../src/Models/Station.vala"
		_tmp87_ = json_object;
#line 245 "../src/Models/Station.vala"
		_tmp88_ = json_object_get_string_member (_tmp87_, "lastlocalchecktime_iso8601");
#line 245 "../src/Models/Station.vala"
		_tmp89_ = string_strip (_tmp88_);
#line 245 "../src/Models/Station.vala"
		_g_free0 (self->lastlocalchecktime_iso8601);
#line 245 "../src/Models/Station.vala"
		self->lastlocalchecktime_iso8601 = _tmp89_;
#line 246 "../src/Models/Station.vala"
		_tmp90_ = json_object;
#line 246 "../src/Models/Station.vala"
		_tmp91_ = json_object_get_string_member (_tmp90_, "has_extended_info");
#line 246 "../src/Models/Station.vala"
		_tmp92_ = string_strip (_tmp91_);
#line 246 "../src/Models/Station.vala"
		_g_free0 (self->lastlocalchecktime_iso8601);
#line 246 "../src/Models/Station.vala"
		self->lastlocalchecktime_iso8601 = _tmp92_;
#line 247 "../src/Models/Station.vala"
		_tmp93_ = json_object;
#line 247 "../src/Models/Station.vala"
		_tmp94_ = json_object_get_string_member (_tmp93_, "clicktimestamp");
#line 247 "../src/Models/Station.vala"
		_tmp95_ = string_strip (_tmp94_);
#line 247 "../src/Models/Station.vala"
		_g_free0 (self->clicktimestamp);
#line 247 "../src/Models/Station.vala"
		self->clicktimestamp = _tmp95_;
#line 248 "../src/Models/Station.vala"
		_tmp96_ = json_object;
#line 248 "../src/Models/Station.vala"
		_tmp97_ = json_object_get_string_member (_tmp96_, "clicktimestamp_iso8601");
#line 248 "../src/Models/Station.vala"
		_tmp98_ = string_strip (_tmp97_);
#line 248 "../src/Models/Station.vala"
		_g_free0 (self->clicktimestamp_iso8601);
#line 248 "../src/Models/Station.vala"
		self->clicktimestamp_iso8601 = _tmp98_;
#line 249 "../src/Models/Station.vala"
		_tmp99_ = json_object;
#line 249 "../src/Models/Station.vala"
		self->clickcount = (gint) json_object_get_int_member (_tmp99_, "clickcount");
#line 250 "../src/Models/Station.vala"
		_tmp100_ = json_object;
#line 250 "../src/Models/Station.vala"
		self->clicktrend = (gint) json_object_get_int_member (_tmp100_, "clicktrend");
#line 251 "../src/Models/Station.vala"
		_tmp101_ = json_object;
#line 251 "../src/Models/Station.vala"
		self->ssl_error = (gint) json_object_get_int_member (_tmp101_, "ssl_error");
#line 252 "../src/Models/Station.vala"
		_tmp102_ = json_object;
#line 252 "../src/Models/Station.vala"
		_tmp103_ = json_object_get_string_member (_tmp102_, "geo_lat");
#line 252 "../src/Models/Station.vala"
		_tmp104_ = string_strip (_tmp103_);
#line 252 "../src/Models/Station.vala"
		_g_free0 (self->geo_lat);
#line 252 "../src/Models/Station.vala"
		self->geo_lat = _tmp104_;
#line 253 "../src/Models/Station.vala"
		_tmp105_ = json_object;
#line 253 "../src/Models/Station.vala"
		_tmp106_ = json_object_get_string_member (_tmp105_, "geo_long");
#line 253 "../src/Models/Station.vala"
		_tmp107_ = string_strip (_tmp106_);
#line 253 "../src/Models/Station.vala"
		_g_free0 (self->geo_long);
#line 253 "../src/Models/Station.vala"
		self->geo_long = _tmp107_;
#line 254 "../src/Models/Station.vala"
		_tmp108_ = json_object;
#line 254 "../src/Models/Station.vala"
		self->has_extended_info = json_object_get_boolean_member (_tmp108_, "has_extended_info");
#line 256 "../src/Models/Station.vala"
		_tmp109_ = json_object;
#line 256 "../src/Models/Station.vala"
		_tmp110_ = json_object_get_string_member (_tmp109_, "urlResolved");
#line 256 "../src/Models/Station.vala"
		_tmp111_ = string_strip (_tmp110_);
#line 256 "../src/Models/Station.vala"
		go_serial_fudge = _tmp111_;
#line 257 "../src/Models/Station.vala"
		_tmp113_ = go_serial_fudge;
#line 257 "../src/Models/Station.vala"
		if (_tmp113_ != NULL) {
#line 1017 "Station.c"
			const gchar* _tmp114_;
#line 257 "../src/Models/Station.vala"
			_tmp114_ = go_serial_fudge;
#line 257 "../src/Models/Station.vala"
			_tmp112_ = g_strcmp0 (_tmp114_, "") != 0;
#line 1023 "Station.c"
		} else {
#line 257 "../src/Models/Station.vala"
			_tmp112_ = FALSE;
#line 1027 "Station.c"
		}
#line 257 "../src/Models/Station.vala"
		if (_tmp112_) {
#line 1031 "Station.c"
			const gchar* _tmp115_;
#line 259 "../src/Models/Station.vala"
			_tmp115_ = go_serial_fudge;
#line 259 "../src/Models/Station.vala"
			tuner_model_station_set_urlResolved (self, _tmp115_);
#line 1037 "Station.c"
		}
#line 263 "../src/Models/Station.vala"
		_tmp116_ = json_object;
#line 263 "../src/Models/Station.vala"
		if (json_object_has_member (_tmp116_, "starred")) {
#line 1043 "Station.c"
			JsonObject* _tmp117_;
#line 265 "../src/Models/Station.vala"
			_tmp117_ = json_object;
#line 265 "../src/Models/Station.vala"
			self->priv->_starred = json_object_get_boolean_member (_tmp117_, "starred");
#line 1049 "Station.c"
		}
#line 272 "../src/Models/Station.vala"
		_tmp118_ = json_object;
#line 272 "../src/Models/Station.vala"
		if (json_object_has_member (_tmp118_, "id")) {
#line 1055 "Station.c"
			JsonObject* _tmp119_;
			const gchar* _tmp120_;
			gchar* _tmp121_;
			gchar* _tmp122_;
#line 274 "../src/Models/Station.vala"
			_tmp119_ = json_object;
#line 274 "../src/Models/Station.vala"
			_tmp120_ = json_object_get_string_member (_tmp119_, "id");
#line 274 "../src/Models/Station.vala"
			_tmp121_ = string_strip (_tmp120_);
#line 274 "../src/Models/Station.vala"
			_tmp122_ = _tmp121_;
#line 274 "../src/Models/Station.vala"
			tuner_model_station_set_stationuuid (self, _tmp122_);
#line 274 "../src/Models/Station.vala"
			_g_free0 (_tmp122_);
#line 1072 "Station.c"
		}
#line 277 "../src/Models/Station.vala"
		_tmp123_ = json_object;
#line 277 "../src/Models/Station.vala"
		if (json_object_has_member (_tmp123_, "favicon-url")) {
#line 1078 "Station.c"
			JsonObject* _tmp124_;
			const gchar* _tmp125_;
			gchar* _tmp126_;
			gchar* _tmp127_;
#line 279 "../src/Models/Station.vala"
			_tmp124_ = json_object;
#line 279 "../src/Models/Station.vala"
			_tmp125_ = json_object_get_string_member (_tmp124_, "favicon-url");
#line 279 "../src/Models/Station.vala"
			_tmp126_ = string_strip (_tmp125_);
#line 279 "../src/Models/Station.vala"
			_tmp127_ = _tmp126_;
#line 279 "../src/Models/Station.vala"
			tuner_model_favicon_set_favicon ((TunerModelFavicon*) self, _tmp127_);
#line 279 "../src/Models/Station.vala"
			_g_free0 (_tmp127_);
#line 1095 "Station.c"
		}
#line 282 "../src/Models/Station.vala"
		_tmp128_ = json_object;
#line 282 "../src/Models/Station.vala"
		if (json_object_has_member (_tmp128_, "location")) {
#line 1101 "Station.c"
			JsonObject* _tmp129_;
			const gchar* _tmp130_;
			gchar* _tmp131_;
			gchar* _tmp132_;
#line 284 "../src/Models/Station.vala"
			_tmp129_ = json_object;
#line 284 "../src/Models/Station.vala"
			_tmp130_ = json_object_get_string_member (_tmp129_, "location");
#line 284 "../src/Models/Station.vala"
			_tmp131_ = string_strip (_tmp130_);
#line 284 "../src/Models/Station.vala"
			_tmp132_ = _tmp131_;
#line 284 "../src/Models/Station.vala"
			tuner_model_station_set_country (self, _tmp132_);
#line 284 "../src/Models/Station.vala"
			_g_free0 (_tmp132_);
#line 1118 "Station.c"
		}
#line 287 "../src/Models/Station.vala"
		_tmp133_ = json_object;
#line 287 "../src/Models/Station.vala"
		if (json_object_has_member (_tmp133_, "title")) {
#line 1124 "Station.c"
			JsonObject* _tmp134_;
			const gchar* _tmp135_;
			gchar* _tmp136_;
			gchar* _tmp137_;
#line 289 "../src/Models/Station.vala"
			_tmp134_ = json_object;
#line 289 "../src/Models/Station.vala"
			_tmp135_ = json_object_get_string_member (_tmp134_, "title");
#line 289 "../src/Models/Station.vala"
			_tmp136_ = string_strip (_tmp135_);
#line 289 "../src/Models/Station.vala"
			_tmp137_ = _tmp136_;
#line 289 "../src/Models/Station.vala"
			tuner_model_station_set_name (self, _tmp137_);
#line 289 "../src/Models/Station.vala"
			_g_free0 (_tmp137_);
#line 1141 "Station.c"
		}
#line 215 "../src/Models/Station.vala"
		_g_free0 (go_serial_fudge);
#line 1145 "Station.c"
	}
	__finally0:
	{
#line 292 "../src/Models/Station.vala"
		g_log_remove_handler (NULL, log_handler_2);
#line 293 "../src/Models/Station.vala"
		g_log_remove_handler ("Json", log_handler_1);
#line 1153 "Station.c"
	}
#line 215 "../src/Models/Station.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "../src/Models/Station.vala"
		_json_object_unref0 (json_object);
#line 215 "../src/Models/Station.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 215 "../src/Models/Station.vala"
		g_clear_error (&_inner_error0_);
#line 215 "../src/Models/Station.vala"
		return NULL;
#line 1165 "Station.c"
	}
#line 296 "../src/Models/Station.vala"
	self->is_in_index = FALSE;
#line 297 "../src/Models/Station.vala"
	self->is_up_to_date = FALSE;
#line 302 "../src/Models/Station.vala"
	_tmp138_ = tuner_application_get_instance ();
#line 302 "../src/Models/Station.vala"
	_tmp139_ = _tmp138_;
#line 302 "../src/Models/Station.vala"
	_tmp140_ = tuner_application_get_cache_dir (_tmp139_);
#line 302 "../src/Models/Station.vala"
	_tmp141_ = _tmp140_;
#line 302 "../src/Models/Station.vala"
	_tmp142_ = self->priv->_stationuuid;
#line 302 "../src/Models/Station.vala"
	_tmp143_ = g_build_filename (_tmp141_, _tmp142_, NULL);
#line 302 "../src/Models/Station.vala"
	_g_free0 (self->priv->_favicon_cache_file);
#line 302 "../src/Models/Station.vala"
	self->priv->_favicon_cache_file = _tmp143_;
#line 303 "../src/Models/Station.vala"
	tuner_model_favicon_load_favicon_async ((TunerModelFavicon*) self, FALSE, NULL, NULL);
#line 184 "../src/Models/Station.vala"
	_json_object_unref0 (json_object);
#line 184 "../src/Models/Station.vala"
	return self;
#line 1193 "Station.c"
}

TunerModelStation*
tuner_model_station_new_basic (JsonNode* json_node)
{
#line 184 "../src/Models/Station.vala"
	return tuner_model_station_construct_basic (TUNER_MODEL_TYPE_STATION, json_node);
#line 1201 "Station.c"
}

/**
     * @brief Toggles the Starred status of the station
     * @return {bool} True if Station is Starred.
     */
gboolean
tuner_model_station_toggle_starred (TunerModelStation* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 311 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 313 "../src/Models/Station.vala"
	_tmp0_ = tuner_model_station_get_starred (self);
#line 313 "../src/Models/Station.vala"
	_tmp1_ = _tmp0_;
#line 313 "../src/Models/Station.vala"
	tuner_model_station_set_starred (self, !_tmp1_);
#line 314 "../src/Models/Station.vala"
	result = self->priv->_starred;
#line 314 "../src/Models/Station.vala"
	return result;
#line 1226 "Station.c"
}

/**
     * @brief Returns a string representation of the station.
     * @return {string} A string in the format "[id] title".
     */
gchar*
tuner_model_station_popularity (TunerModelStation* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 322 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../src/Models/Station.vala"
	_tmp0_ = g_strdup_printf ("%i", self->votes);
#line 323 "../src/Models/Station.vala"
	_tmp1_ = _tmp0_;
#line 323 "../src/Models/Station.vala"
	_tmp2_ = g_strdup_printf ("%i", self->clickcount);
#line 323 "../src/Models/Station.vala"
	_tmp3_ = _tmp2_;
#line 323 "../src/Models/Station.vala"
	_tmp4_ = g_strdup_printf ("%i", self->clicktrend);
#line 323 "../src/Models/Station.vala"
	_tmp5_ = _tmp4_;
#line 323 "../src/Models/Station.vala"
	_tmp6_ = g_strconcat ("Votes: ", _tmp1_, "\t Clicks: ", _tmp3_, "\t Trend: ", _tmp5_, NULL);
#line 323 "../src/Models/Station.vala"
	_tmp7_ = _tmp6_;
#line 323 "../src/Models/Station.vala"
	_tmp8_ = g_strdup (_ (_tmp7_));
#line 323 "../src/Models/Station.vala"
	_tmp9_ = _tmp8_;
#line 323 "../src/Models/Station.vala"
	_g_free0 (_tmp7_);
#line 323 "../src/Models/Station.vala"
	_g_free0 (_tmp5_);
#line 323 "../src/Models/Station.vala"
	_g_free0 (_tmp3_);
#line 323 "../src/Models/Station.vala"
	_g_free0 (_tmp1_);
#line 323 "../src/Models/Station.vala"
	result = _tmp9_;
#line 323 "../src/Models/Station.vala"
	return result;
#line 1281 "Station.c"
}

/**
     * @brief Returns a string representation of the station.
     * @return {string} A string in the format "[id] title".
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 1298 "Station.c"
}

gchar*
tuner_model_station_to_string (TunerModelStation* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 331 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_stationuuid;
#line 332 "../src/Models/Station.vala"
	_tmp1_ = string_to_string (_tmp0_);
#line 332 "../src/Models/Station.vala"
	_tmp2_ = self->priv->_name;
#line 332 "../src/Models/Station.vala"
	_tmp3_ = string_to_string (_tmp2_);
#line 332 "../src/Models/Station.vala"
	_tmp4_ = g_strconcat ("[", _tmp1_, "] ", _tmp3_, NULL);
#line 332 "../src/Models/Station.vala"
	result = _tmp4_;
#line 332 "../src/Models/Station.vala"
	return result;
#line 1326 "Station.c"
}

/**
     * @brief Sets the station up-to-date status based on the given station.
     *
     * @param {Station} p - The station to compare with.
     * @return {bool} True if the station is up-to-date with the given station.
     */
gboolean
tuner_model_station_set_up_to_date_with (TunerModelStation* self,
                                         TunerModelStation* p)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 342 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 344 "../src/Models/Station.vala"
	if (p == NULL) {
#line 344 "../src/Models/Station.vala"
		_tmp0_ = TRUE;
#line 1351 "Station.c"
	} else {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 344 "../src/Models/Station.vala"
		_tmp1_ = self->priv->_stationuuid;
#line 344 "../src/Models/Station.vala"
		_tmp2_ = p->priv->_stationuuid;
#line 344 "../src/Models/Station.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, _tmp2_) != 0;
#line 1361 "Station.c"
	}
#line 344 "../src/Models/Station.vala"
	if (_tmp0_) {
#line 344 "../src/Models/Station.vala"
		result = FALSE;
#line 344 "../src/Models/Station.vala"
		return result;
#line 1369 "Station.c"
	}
#line 346 "../src/Models/Station.vala"
	_tmp5_ = self->priv->_url;
#line 346 "../src/Models/Station.vala"
	_tmp6_ = p->priv->_url;
#line 346 "../src/Models/Station.vala"
	if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
#line 1377 "Station.c"
		gint _tmp7_;
		gint _tmp8_;
#line 347 "../src/Models/Station.vala"
		_tmp7_ = self->priv->_bitrate;
#line 347 "../src/Models/Station.vala"
		_tmp8_ = p->priv->_bitrate;
#line 347 "../src/Models/Station.vala"
		_tmp4_ = _tmp7_ == _tmp8_;
#line 1386 "Station.c"
	} else {
#line 346 "../src/Models/Station.vala"
		_tmp4_ = FALSE;
#line 1390 "Station.c"
	}
#line 346 "../src/Models/Station.vala"
	if (_tmp4_) {
#line 1394 "Station.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 348 "../src/Models/Station.vala"
		_tmp9_ = self->priv->_codec;
#line 348 "../src/Models/Station.vala"
		_tmp10_ = p->priv->_codec;
#line 348 "../src/Models/Station.vala"
		_tmp3_ = g_strcmp0 (_tmp9_, _tmp10_) == 0;
#line 1403 "Station.c"
	} else {
#line 346 "../src/Models/Station.vala"
		_tmp3_ = FALSE;
#line 1407 "Station.c"
	}
#line 345 "../src/Models/Station.vala"
	if (_tmp3_) {
#line 1411 "Station.c"
		gchar* _tmp11_;
#line 352 "../src/Models/Station.vala"
		self->is_up_to_date = TRUE;
#line 353 "../src/Models/Station.vala"
		_tmp11_ = g_strdup ("");
#line 353 "../src/Models/Station.vala"
		_g_free0 (self->up_to_date_difference);
#line 353 "../src/Models/Station.vala"
		self->up_to_date_difference = _tmp11_;
#line 1421 "Station.c"
	} else {
		GString* sb = NULL;
		GString* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		gint _tmp30_;
		gint _tmp31_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		GString* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
#line 357 "../src/Models/Station.vala"
		_tmp12_ = g_string_new (_ ("Changes:"));
#line 357 "../src/Models/Station.vala"
		sb = _tmp12_;
#line 358 "../src/Models/Station.vala"
		_tmp13_ = self->priv->_url;
#line 358 "../src/Models/Station.vala"
		_tmp14_ = p->priv->_url;
#line 358 "../src/Models/Station.vala"
		if (g_strcmp0 (_tmp13_, _tmp14_) != 0) {
#line 1454 "Station.c"
			GString* _tmp15_;
#line 358 "../src/Models/Station.vala"
			_tmp15_ = sb;
#line 358 "../src/Models/Station.vala"
			g_string_append (_tmp15_, _ ("\n\tStream Url"));
#line 1460 "Station.c"
		}
#line 359 "../src/Models/Station.vala"
		_tmp16_ = self->priv->_urlResolved;
#line 359 "../src/Models/Station.vala"
		_tmp17_ = p->priv->_urlResolved;
#line 359 "../src/Models/Station.vala"
		if (g_strcmp0 (_tmp16_, _tmp17_) != 0) {
#line 1468 "Station.c"
			GString* _tmp18_;
#line 359 "../src/Models/Station.vala"
			_tmp18_ = sb;
#line 359 "../src/Models/Station.vala"
			g_string_append (_tmp18_, _ ("\n\tStream Resolved Url"));
#line 1474 "Station.c"
		}
#line 360 "../src/Models/Station.vala"
		_tmp19_ = tuner_model_favicon_get_favicon ((TunerModelFavicon*) self);
#line 360 "../src/Models/Station.vala"
		_tmp20_ = _tmp19_;
#line 360 "../src/Models/Station.vala"
		_tmp21_ = tuner_model_favicon_get_favicon ((TunerModelFavicon*) p);
#line 360 "../src/Models/Station.vala"
		_tmp22_ = _tmp21_;
#line 360 "../src/Models/Station.vala"
		if (g_strcmp0 (_tmp20_, _tmp22_) != 0) {
#line 1486 "Station.c"
			GString* _tmp23_;
#line 360 "../src/Models/Station.vala"
			_tmp23_ = sb;
#line 360 "../src/Models/Station.vala"
			g_string_append (_tmp23_, _ ("\n\tFavicon address"));
#line 1492 "Station.c"
		}
#line 361 "../src/Models/Station.vala"
		_tmp24_ = self->priv->_homepage;
#line 361 "../src/Models/Station.vala"
		_tmp25_ = p->priv->_homepage;
#line 361 "../src/Models/Station.vala"
		if (g_strcmp0 (_tmp24_, _tmp25_) != 0) {
#line 1500 "Station.c"
			GString* _tmp26_;
#line 361 "../src/Models/Station.vala"
			_tmp26_ = sb;
#line 361 "../src/Models/Station.vala"
			g_string_append (_tmp26_, _ ("\n\tHomepage address"));
#line 1506 "Station.c"
		}
#line 362 "../src/Models/Station.vala"
		_tmp27_ = self->priv->_tags;
#line 362 "../src/Models/Station.vala"
		_tmp28_ = p->priv->_tags;
#line 362 "../src/Models/Station.vala"
		if (g_strcmp0 (_tmp27_, _tmp28_) != 0) {
#line 1514 "Station.c"
			GString* _tmp29_;
#line 362 "../src/Models/Station.vala"
			_tmp29_ = sb;
#line 362 "../src/Models/Station.vala"
			g_string_append (_tmp29_, _ ("\n\tStation tags"));
#line 1520 "Station.c"
		}
#line 363 "../src/Models/Station.vala"
		_tmp30_ = self->priv->_bitrate;
#line 363 "../src/Models/Station.vala"
		_tmp31_ = p->priv->_bitrate;
#line 363 "../src/Models/Station.vala"
		if (_tmp30_ != _tmp31_) {
#line 1528 "Station.c"
			GString* _tmp32_;
#line 363 "../src/Models/Station.vala"
			_tmp32_ = sb;
#line 363 "../src/Models/Station.vala"
			g_string_append (_tmp32_, _ ("\n\tBitrate: $(this.bitrate) > $(p.bitrate)"));
#line 1534 "Station.c"
		}
#line 364 "../src/Models/Station.vala"
		_tmp33_ = self->priv->_codec;
#line 364 "../src/Models/Station.vala"
		_tmp34_ = p->priv->_codec;
#line 364 "../src/Models/Station.vala"
		if (g_strcmp0 (_tmp33_, _tmp34_) != 0) {
#line 1542 "Station.c"
			GString* _tmp35_;
#line 364 "../src/Models/Station.vala"
			_tmp35_ = sb;
#line 364 "../src/Models/Station.vala"
			g_string_append (_tmp35_, _ ("\n\todec: $(this.codec) > $(p.codec)"));
#line 1548 "Station.c"
		}
#line 371 "../src/Models/Station.vala"
		_tmp36_ = sb;
#line 371 "../src/Models/Station.vala"
		_tmp37_ = _tmp36_->str;
#line 371 "../src/Models/Station.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 371 "../src/Models/Station.vala"
		_g_free0 (self->up_to_date_difference);
#line 371 "../src/Models/Station.vala"
		self->up_to_date_difference = _tmp38_;
#line 372 "../src/Models/Station.vala"
		self->is_up_to_date = FALSE;
#line 345 "../src/Models/Station.vala"
		_g_string_free0 (sb);
#line 1564 "Station.c"
	}
#line 374 "../src/Models/Station.vala"
	result = TRUE;
#line 374 "../src/Models/Station.vala"
	return result;
#line 1570 "Station.c"
}

/**
     * Returns a copy of the current station from the Provider.
     * 
     * @return A new {@link Station} instance with the current properties
     */
TunerModelStation*
tuner_model_station_updated (TunerModelStation* self)
{
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	gpointer _tmp2_;
	TunerModelStation* result;
#line 383 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 385 "../src/Models/Station.vala"
	_tmp0_ = tuner_model_station_STATIONS;
#line 385 "../src/Models/Station.vala"
	_tmp1_ = self->priv->_stationuuid;
#line 385 "../src/Models/Station.vala"
	_tmp2_ = gee_map_get (_tmp0_, _tmp1_);
#line 385 "../src/Models/Station.vala"
	result = (TunerModelStation*) _tmp2_;
#line 385 "../src/Models/Station.vala"
	return result;
#line 1597 "Station.c"
}

/**
     * @brief Compares this station with another station.
     * @param other The station to compare with.
     * @return {bool} True if stations are equal.
     */
gboolean
tuner_model_station_equals (TunerModelStation* self,
                            TunerModelStation* other)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 394 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 394 "../src/Models/Station.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 396 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_stationuuid;
#line 396 "../src/Models/Station.vala"
	_tmp1_ = other->priv->_stationuuid;
#line 396 "../src/Models/Station.vala"
	result = g_strcmp0 (_tmp0_, _tmp1_) == 0;
#line 396 "../src/Models/Station.vala"
	return result;
#line 1624 "Station.c"
}

static gchar*
tuner_model_station_real_favicon_cache_file (TunerModelFavicon* base)
{
	TunerModelStation * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 400 "../src/Models/Station.vala"
	self = (TunerModelStation*) base;
#line 402 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_favicon_cache_file;
#line 402 "../src/Models/Station.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 402 "../src/Models/Station.vala"
	result = _tmp1_;
#line 402 "../src/Models/Station.vala"
	return result;
#line 1644 "Station.c"
}

TunerModelStation*
tuner_model_station_construct (GType object_type)
{
	TunerModelStation * self = NULL;
#line 19 "../src/Models/Station.vala"
	self = (TunerModelStation*) tuner_model_favicon_construct (object_type);
#line 19 "../src/Models/Station.vala"
	return self;
#line 1655 "Station.c"
}

TunerModelStation*
tuner_model_station_new (void)
{
#line 19 "../src/Models/Station.vala"
	return tuner_model_station_construct (TUNER_MODEL_TYPE_STATION);
#line 1663 "Station.c"
}

const gchar*
tuner_model_station_get_changeuuid (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_changeuuid;
#line 42 "../src/Models/Station.vala"
	result = _tmp0_;
#line 42 "../src/Models/Station.vala"
	return result;
#line 1679 "Station.c"
}

static void
tuner_model_station_set_changeuuid (TunerModelStation* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 42 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_changeuuid (self);
#line 42 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1693 "Station.c"
		gchar* _tmp0_;
#line 42 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 42 "../src/Models/Station.vala"
		_g_free0 (self->priv->_changeuuid);
#line 42 "../src/Models/Station.vala"
		self->priv->_changeuuid = _tmp0_;
#line 42 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_CHANGEUUID_PROPERTY]);
#line 1703 "Station.c"
	}
}

const gchar*
tuner_model_station_get_stationuuid (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_stationuuid;
#line 44 "../src/Models/Station.vala"
	result = _tmp0_;
#line 44 "../src/Models/Station.vala"
	return result;
#line 1720 "Station.c"
}

static void
tuner_model_station_set_stationuuid (TunerModelStation* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 44 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_stationuuid (self);
#line 44 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1734 "Station.c"
		gchar* _tmp0_;
#line 44 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 44 "../src/Models/Station.vala"
		_g_free0 (self->priv->_stationuuid);
#line 44 "../src/Models/Station.vala"
		self->priv->_stationuuid = _tmp0_;
#line 44 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_STATIONUUID_PROPERTY]);
#line 1744 "Station.c"
	}
}

const gchar*
tuner_model_station_get_name (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 46 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_name;
#line 46 "../src/Models/Station.vala"
	result = _tmp0_;
#line 46 "../src/Models/Station.vala"
	return result;
#line 1761 "Station.c"
}

static void
tuner_model_station_set_name (TunerModelStation* self,
                              const gchar* value)
{
	gchar* old_value;
#line 46 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_name (self);
#line 46 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1775 "Station.c"
		gchar* _tmp0_;
#line 46 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 46 "../src/Models/Station.vala"
		_g_free0 (self->priv->_name);
#line 46 "../src/Models/Station.vala"
		self->priv->_name = _tmp0_;
#line 46 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_NAME_PROPERTY]);
#line 1785 "Station.c"
	}
}

const gchar*
tuner_model_station_get_url (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_url;
#line 48 "../src/Models/Station.vala"
	result = _tmp0_;
#line 48 "../src/Models/Station.vala"
	return result;
#line 1802 "Station.c"
}

static void
tuner_model_station_set_url (TunerModelStation* self,
                             const gchar* value)
{
	gchar* old_value;
#line 48 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_url (self);
#line 48 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1816 "Station.c"
		gchar* _tmp0_;
#line 48 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 48 "../src/Models/Station.vala"
		_g_free0 (self->priv->_url);
#line 48 "../src/Models/Station.vala"
		self->priv->_url = _tmp0_;
#line 48 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_URL_PROPERTY]);
#line 1826 "Station.c"
	}
}

const gchar*
tuner_model_station_get_urlResolved (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_urlResolved;
#line 50 "../src/Models/Station.vala"
	result = _tmp0_;
#line 50 "../src/Models/Station.vala"
	return result;
#line 1843 "Station.c"
}

static void
tuner_model_station_set_urlResolved (TunerModelStation* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 50 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_urlResolved (self);
#line 50 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1857 "Station.c"
		gchar* _tmp0_;
#line 50 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/Models/Station.vala"
		_g_free0 (self->priv->_urlResolved);
#line 50 "../src/Models/Station.vala"
		self->priv->_urlResolved = _tmp0_;
#line 50 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY]);
#line 1867 "Station.c"
	}
}

const gchar*
tuner_model_station_get_homepage (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_homepage;
#line 52 "../src/Models/Station.vala"
	result = _tmp0_;
#line 52 "../src/Models/Station.vala"
	return result;
#line 1884 "Station.c"
}

static void
tuner_model_station_set_homepage (TunerModelStation* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 52 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_homepage (self);
#line 52 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1898 "Station.c"
		gchar* _tmp0_;
#line 52 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../src/Models/Station.vala"
		_g_free0 (self->priv->_homepage);
#line 52 "../src/Models/Station.vala"
		self->priv->_homepage = _tmp0_;
#line 52 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_HOMEPAGE_PROPERTY]);
#line 1908 "Station.c"
	}
}

const gchar*
tuner_model_station_get_tags (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 56 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_tags;
#line 56 "../src/Models/Station.vala"
	result = _tmp0_;
#line 56 "../src/Models/Station.vala"
	return result;
#line 1925 "Station.c"
}

static void
tuner_model_station_set_tags (TunerModelStation* self,
                              const gchar* value)
{
	gchar* old_value;
#line 56 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_tags (self);
#line 56 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1939 "Station.c"
		gchar* _tmp0_;
#line 56 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 56 "../src/Models/Station.vala"
		_g_free0 (self->priv->_tags);
#line 56 "../src/Models/Station.vala"
		self->priv->_tags = _tmp0_;
#line 56 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_TAGS_PROPERTY]);
#line 1949 "Station.c"
	}
}

const gchar*
tuner_model_station_get_country (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 58 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_country;
#line 58 "../src/Models/Station.vala"
	result = _tmp0_;
#line 58 "../src/Models/Station.vala"
	return result;
#line 1966 "Station.c"
}

static void
tuner_model_station_set_country (TunerModelStation* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 58 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_country (self);
#line 58 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1980 "Station.c"
		gchar* _tmp0_;
#line 58 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 58 "../src/Models/Station.vala"
		_g_free0 (self->priv->_country);
#line 58 "../src/Models/Station.vala"
		self->priv->_country = _tmp0_;
#line 58 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_COUNTRY_PROPERTY]);
#line 1990 "Station.c"
	}
}

const gchar*
tuner_model_station_get_countrycode (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 60 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_countrycode;
#line 60 "../src/Models/Station.vala"
	result = _tmp0_;
#line 60 "../src/Models/Station.vala"
	return result;
#line 2007 "Station.c"
}

static void
tuner_model_station_set_countrycode (TunerModelStation* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 60 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_countrycode (self);
#line 60 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2021 "Station.c"
		gchar* _tmp0_;
#line 60 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 60 "../src/Models/Station.vala"
		_g_free0 (self->priv->_countrycode);
#line 60 "../src/Models/Station.vala"
		self->priv->_countrycode = _tmp0_;
#line 60 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY]);
#line 2031 "Station.c"
	}
}

const gchar*
tuner_model_station_get_iso_3166_2 (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 62 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_iso_3166_2;
#line 62 "../src/Models/Station.vala"
	result = _tmp0_;
#line 62 "../src/Models/Station.vala"
	return result;
#line 2048 "Station.c"
}

static void
tuner_model_station_set_iso_3166_2 (TunerModelStation* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 62 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_iso_3166_2 (self);
#line 62 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2062 "Station.c"
		gchar* _tmp0_;
#line 62 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 62 "../src/Models/Station.vala"
		_g_free0 (self->priv->_iso_3166_2);
#line 62 "../src/Models/Station.vala"
		self->priv->_iso_3166_2 = _tmp0_;
#line 62 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_ISO_3166_2_PROPERTY]);
#line 2072 "Station.c"
	}
}

const gchar*
tuner_model_station_get_state (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 64 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_state;
#line 64 "../src/Models/Station.vala"
	result = _tmp0_;
#line 64 "../src/Models/Station.vala"
	return result;
#line 2089 "Station.c"
}

static void
tuner_model_station_set_state (TunerModelStation* self,
                               const gchar* value)
{
	gchar* old_value;
#line 64 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_state (self);
#line 64 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2103 "Station.c"
		gchar* _tmp0_;
#line 64 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 64 "../src/Models/Station.vala"
		_g_free0 (self->priv->_state);
#line 64 "../src/Models/Station.vala"
		self->priv->_state = _tmp0_;
#line 64 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_STATE_PROPERTY]);
#line 2113 "Station.c"
	}
}

const gchar*
tuner_model_station_get_language (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 66 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_language;
#line 66 "../src/Models/Station.vala"
	result = _tmp0_;
#line 66 "../src/Models/Station.vala"
	return result;
#line 2130 "Station.c"
}

static void
tuner_model_station_set_language (TunerModelStation* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 66 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_language (self);
#line 66 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2144 "Station.c"
		gchar* _tmp0_;
#line 66 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 66 "../src/Models/Station.vala"
		_g_free0 (self->priv->_language);
#line 66 "../src/Models/Station.vala"
		self->priv->_language = _tmp0_;
#line 66 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_LANGUAGE_PROPERTY]);
#line 2154 "Station.c"
	}
}

const gchar*
tuner_model_station_get_languagecodes (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 68 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_languagecodes;
#line 68 "../src/Models/Station.vala"
	result = _tmp0_;
#line 68 "../src/Models/Station.vala"
	return result;
#line 2171 "Station.c"
}

static void
tuner_model_station_set_languagecodes (TunerModelStation* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 68 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_languagecodes (self);
#line 68 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2185 "Station.c"
		gchar* _tmp0_;
#line 68 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 68 "../src/Models/Station.vala"
		_g_free0 (self->priv->_languagecodes);
#line 68 "../src/Models/Station.vala"
		self->priv->_languagecodes = _tmp0_;
#line 68 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY]);
#line 2195 "Station.c"
	}
}

const gchar*
tuner_model_station_get_codec (TunerModelStation* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 70 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/Models/Station.vala"
	_tmp0_ = self->priv->_codec;
#line 70 "../src/Models/Station.vala"
	result = _tmp0_;
#line 70 "../src/Models/Station.vala"
	return result;
#line 2212 "Station.c"
}

static void
tuner_model_station_set_codec (TunerModelStation* self,
                               const gchar* value)
{
	gchar* old_value;
#line 70 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_codec (self);
#line 70 "../src/Models/Station.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2226 "Station.c"
		gchar* _tmp0_;
#line 70 "../src/Models/Station.vala"
		_tmp0_ = g_strdup (value);
#line 70 "../src/Models/Station.vala"
		_g_free0 (self->priv->_codec);
#line 70 "../src/Models/Station.vala"
		self->priv->_codec = _tmp0_;
#line 70 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_CODEC_PROPERTY]);
#line 2236 "Station.c"
	}
}

gint
tuner_model_station_get_bitrate (TunerModelStation* self)
{
	gint result;
#line 72 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 72 "../src/Models/Station.vala"
	result = self->priv->_bitrate;
#line 72 "../src/Models/Station.vala"
	return result;
#line 2250 "Station.c"
}

static void
tuner_model_station_set_bitrate (TunerModelStation* self,
                                 gint value)
{
	gint old_value;
#line 72 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_bitrate (self);
#line 72 "../src/Models/Station.vala"
	if (old_value != value) {
#line 72 "../src/Models/Station.vala"
		self->priv->_bitrate = value;
#line 72 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_BITRATE_PROPERTY]);
#line 2268 "Station.c"
	}
}

gint
tuner_model_station_get_hls (TunerModelStation* self)
{
	gint result;
#line 74 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 74 "../src/Models/Station.vala"
	result = self->priv->_hls;
#line 74 "../src/Models/Station.vala"
	return result;
#line 2282 "Station.c"
}

static void
tuner_model_station_set_hls (TunerModelStation* self,
                             gint value)
{
	gint old_value;
#line 74 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/Models/Station.vala"
	old_value = tuner_model_station_get_hls (self);
#line 74 "../src/Models/Station.vala"
	if (old_value != value) {
#line 74 "../src/Models/Station.vala"
		self->priv->_hls = value;
#line 74 "../src/Models/Station.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_HLS_PROPERTY]);
#line 2300 "Station.c"
	}
}

gboolean
tuner_model_station_get_starred (TunerModelStation* self)
{
	gboolean result;
#line 121 "../src/Models/Station.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 121 "../src/Models/Station.vala"
	result = self->priv->_starred;
#line 121 "../src/Models/Station.vala"
	return result;
#line 2314 "Station.c"
}

void
tuner_model_station_set_starred (TunerModelStation* self,
                                 gboolean value)
{
#line 122 "../src/Models/Station.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/Models/Station.vala"
	if (self->priv->_starred == value) {
#line 123 "../src/Models/Station.vala"
		return;
#line 2327 "Station.c"
	}
#line 124 "../src/Models/Station.vala"
	self->priv->_starred = value;
#line 125 "../src/Models/Station.vala"
	g_signal_emit (self, tuner_model_station_signals[TUNER_MODEL_STATION_STATION_STAR_CHANGED_SIG_SIGNAL], 0, self->priv->_starred);
#line 122 "../src/Models/Station.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_model_station_properties[TUNER_MODEL_STATION_STARRED_PROPERTY]);
#line 2335 "Station.c"
}

static void
tuner_model_station_class_init (TunerModelStationClass * klass,
                                gpointer klass_data)
{
	GeeHashMap* _tmp0_;
#line 19 "../src/Models/Station.vala"
	tuner_model_station_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/Models/Station.vala"
	g_type_class_adjust_private_offset (klass, &TunerModelStation_private_offset);
#line 19 "../src/Models/Station.vala"
	((TunerModelFaviconClass *) klass)->favicon_cache_file = (gchar* (*) (TunerModelFavicon*)) tuner_model_station_real_favicon_cache_file;
#line 19 "../src/Models/Station.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_model_station_get_property;
#line 19 "../src/Models/Station.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_model_station_set_property;
#line 19 "../src/Models/Station.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_model_station_finalize;
#line 2355 "Station.c"
	/** @property {string} changeuuid - Unique identifier for the change. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_CHANGEUUID_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_CHANGEUUID_PROPERTY] = g_param_spec_string ("changeuuid", "changeuuid", "changeuuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2359 "Station.c"
	/** @property {string} stationuuid - Unique identifier for the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_STATIONUUID_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_STATIONUUID_PROPERTY] = g_param_spec_string ("stationuuid", "stationuuid", "stationuuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2363 "Station.c"
	/** @property {string} name - Name of the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_NAME_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2367 "Station.c"
	/** @property {string} url - URL of the station stream. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_URL_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2371 "Station.c"
	/** @property {string} url_resolved - Resolved URL of the station stream. Camel case so goobject serialize is OK*/
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY] = g_param_spec_string ("urlResolved", "urlResolved", "urlResolved", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2375 "Station.c"
	/** @property {string} homepage - Homepage of the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_HOMEPAGE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_HOMEPAGE_PROPERTY] = g_param_spec_string ("homepage", "homepage", "homepage", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2379 "Station.c"
	/** @property {string} tags - Tags associated with the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_TAGS_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_TAGS_PROPERTY] = g_param_spec_string ("tags", "tags", "tags", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2383 "Station.c"
	/** @property {string} country - Country where the station is located. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_COUNTRY_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_COUNTRY_PROPERTY] = g_param_spec_string ("country", "country", "country", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2387 "Station.c"
	/** @property {string} countrycode - Country code of the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY] = g_param_spec_string ("countrycode", "countrycode", "countrycode", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2391 "Station.c"
	/** @property {string} iso_3166_2 - ISO 3166-2 code for the station's location. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_ISO_3166_2_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_ISO_3166_2_PROPERTY] = g_param_spec_string ("iso-3166-2", "iso-3166-2", "iso-3166-2", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2395 "Station.c"
	/** @property {string} state - State where the station is located. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_STATE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_STATE_PROPERTY] = g_param_spec_string ("state", "state", "state", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2399 "Station.c"
	/** @property {string} language - Language of the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_LANGUAGE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_LANGUAGE_PROPERTY] = g_param_spec_string ("language", "language", "language", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2403 "Station.c"
	/** @property {string} languagecodes - Language codes associated with the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY] = g_param_spec_string ("languagecodes", "languagecodes", "languagecodes", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2407 "Station.c"
	/** @property {string} codec - Audio codec used by the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_CODEC_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_CODEC_PROPERTY] = g_param_spec_string ("codec", "codec", "codec", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2411 "Station.c"
	/** @property {int} bitrate - Bitrate of the station stream. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_BITRATE_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_BITRATE_PROPERTY] = g_param_spec_int ("bitrate", "bitrate", "bitrate", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2415 "Station.c"
	/** @property {int} hls - HLS status of the station. */
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_HLS_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_HLS_PROPERTY] = g_param_spec_int ("hls", "hls", "hls", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2419 "Station.c"
	/** @property {bool} starred - Indicates if the station is starred. Only set by Favorites*/
#line 19 "../src/Models/Station.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_STATION_STARRED_PROPERTY, tuner_model_station_properties[TUNER_MODEL_STATION_STARRED_PROPERTY] = g_param_spec_boolean ("starred", "starred", "starred", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/Models/Station.vala"
	tuner_model_station_signals[TUNER_MODEL_STATION_STATION_STAR_CHANGED_SIG_SIGNAL] = g_signal_new ("station-star-changed-sig", TUNER_MODEL_TYPE_STATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 30 "../src/Models/Station.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 30 "../src/Models/Station.vala"
	tuner_model_station_STATIONS = (GeeMap*) _tmp0_;
#line 2429 "Station.c"
}

static void
tuner_model_station_instance_init (TunerModelStation * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
#line 19 "../src/Models/Station.vala"
	self->priv = tuner_model_station_get_instance_private (self);
#line 133 "../src/Models/Station.vala"
	_tmp0_ = g_strdup (_ ("Station no longer in the index"));
#line 133 "../src/Models/Station.vala"
	self->up_to_date_difference = _tmp0_;
#line 2443 "Station.c"
}

static void
tuner_model_station_finalize (GObject * obj)
{
	TunerModelStation * self;
#line 19 "../src/Models/Station.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_MODEL_TYPE_STATION, TunerModelStation);
#line 42 "../src/Models/Station.vala"
	_g_free0 (self->priv->_changeuuid);
#line 44 "../src/Models/Station.vala"
	_g_free0 (self->priv->_stationuuid);
#line 46 "../src/Models/Station.vala"
	_g_free0 (self->priv->_name);
#line 48 "../src/Models/Station.vala"
	_g_free0 (self->priv->_url);
#line 50 "../src/Models/Station.vala"
	_g_free0 (self->priv->_urlResolved);
#line 52 "../src/Models/Station.vala"
	_g_free0 (self->priv->_homepage);
#line 56 "../src/Models/Station.vala"
	_g_free0 (self->priv->_tags);
#line 58 "../src/Models/Station.vala"
	_g_free0 (self->priv->_country);
#line 60 "../src/Models/Station.vala"
	_g_free0 (self->priv->_countrycode);
#line 62 "../src/Models/Station.vala"
	_g_free0 (self->priv->_iso_3166_2);
#line 64 "../src/Models/Station.vala"
	_g_free0 (self->priv->_state);
#line 66 "../src/Models/Station.vala"
	_g_free0 (self->priv->_language);
#line 68 "../src/Models/Station.vala"
	_g_free0 (self->priv->_languagecodes);
#line 70 "../src/Models/Station.vala"
	_g_free0 (self->priv->_codec);
#line 84 "../src/Models/Station.vala"
	_g_free0 (self->lastchangetime);
#line 86 "../src/Models/Station.vala"
	_g_free0 (self->lastchangetime_iso8601);
#line 90 "../src/Models/Station.vala"
	_g_free0 (self->lastchecktime);
#line 92 "../src/Models/Station.vala"
	_g_free0 (self->lastchecktime_iso8601);
#line 94 "../src/Models/Station.vala"
	_g_free0 (self->lastcheckoktime);
#line 96 "../src/Models/Station.vala"
	_g_free0 (self->lastcheckoktime_iso8601);
#line 98 "../src/Models/Station.vala"
	_g_free0 (self->lastlocalchecktime);
#line 100 "../src/Models/Station.vala"
	_g_free0 (self->lastlocalchecktime_iso8601);
#line 102 "../src/Models/Station.vala"
	_g_free0 (self->clicktimestamp);
#line 104 "../src/Models/Station.vala"
	_g_free0 (self->clicktimestamp_iso8601);
#line 112 "../src/Models/Station.vala"
	_g_free0 (self->geo_lat);
#line 114 "../src/Models/Station.vala"
	_g_free0 (self->geo_long);
#line 133 "../src/Models/Station.vala"
	_g_free0 (self->up_to_date_difference);
#line 142 "../src/Models/Station.vala"
	_g_free0 (self->priv->_favicon_cache_file);
#line 19 "../src/Models/Station.vala"
	G_OBJECT_CLASS (tuner_model_station_parent_class)->finalize (obj);
#line 2510 "Station.c"
}

/**
 * @class Station
 * @brief Represents a radio station with various properties.
 */
static GType
tuner_model_station_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerModelStationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_model_station_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerModelStation), 0, (GInstanceInitFunc) tuner_model_station_instance_init, NULL };
	GType tuner_model_station_type_id;
	tuner_model_station_type_id = g_type_register_static (TUNER_MODEL_TYPE_FAVICON, "TunerModelStation", &g_define_type_info, 0);
	TunerModelStation_private_offset = g_type_add_instance_private (tuner_model_station_type_id, sizeof (TunerModelStationPrivate));
	return tuner_model_station_type_id;
}

GType
tuner_model_station_get_type (void)
{
	static volatile gsize tuner_model_station_type_id__once = 0;
	if (g_once_init_enter (&tuner_model_station_type_id__once)) {
		GType tuner_model_station_type_id;
		tuner_model_station_type_id = tuner_model_station_get_type_once ();
		g_once_init_leave (&tuner_model_station_type_id__once, tuner_model_station_type_id);
	}
	return tuner_model_station_type_id__once;
}

static void
_vala_tuner_model_station_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	TunerModelStation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_STATION, TunerModelStation);
#line 19 "../src/Models/Station.vala"
	switch (property_id) {
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_CHANGEUUID_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_changeuuid (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_STATIONUUID_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_stationuuid (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_NAME_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_name (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_URL_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_url (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_urlResolved (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_HOMEPAGE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_homepage (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_TAGS_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_tags (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_COUNTRY_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_country (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_countrycode (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_ISO_3166_2_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_iso_3166_2 (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_STATE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_state (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_LANGUAGE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_language (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_languagecodes (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_CODEC_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_string (value, tuner_model_station_get_codec (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_BITRATE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_int (value, tuner_model_station_get_bitrate (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_HLS_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_int (value, tuner_model_station_get_hls (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_STARRED_PROPERTY:
#line 19 "../src/Models/Station.vala"
		g_value_set_boolean (value, tuner_model_station_get_starred (self));
#line 19 "../src/Models/Station.vala"
		break;
#line 2651 "Station.c"
		default:
#line 19 "../src/Models/Station.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Models/Station.vala"
		break;
#line 2657 "Station.c"
	}
}

static void
_vala_tuner_model_station_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	TunerModelStation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_STATION, TunerModelStation);
#line 19 "../src/Models/Station.vala"
	switch (property_id) {
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_CHANGEUUID_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_changeuuid (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_STATIONUUID_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_stationuuid (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_NAME_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_name (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_URL_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_url (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_URL_RESOLVED_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_urlResolved (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_HOMEPAGE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_homepage (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_TAGS_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_tags (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_COUNTRY_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_country (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_COUNTRYCODE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_countrycode (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_ISO_3166_2_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_iso_3166_2 (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_STATE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_state (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_LANGUAGE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_language (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_LANGUAGECODES_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_languagecodes (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_CODEC_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_codec (self, g_value_get_string (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_BITRATE_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_bitrate (self, g_value_get_int (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_HLS_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_hls (self, g_value_get_int (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 19 "../src/Models/Station.vala"
		case TUNER_MODEL_STATION_STARRED_PROPERTY:
#line 19 "../src/Models/Station.vala"
		tuner_model_station_set_starred (self, g_value_get_boolean (value));
#line 19 "../src/Models/Station.vala"
		break;
#line 2773 "Station.c"
		default:
#line 19 "../src/Models/Station.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/Models/Station.vala"
		break;
#line 2779 "Station.c"
	}
}

