/* StreamMetadata.c generated by valac 0.56.17, the Vala compiler
 * generated from StreamMetadata.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file PlayerController.vala
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gst/player/player.h>
#include <gst/gst.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_MODEL_TYPE_METADATA (tuner_model_metadata_get_type ())
#define TUNER_MODEL_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_METADATA, TunerModelMetadata))
#define TUNER_MODEL_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_METADATA, TunerModelMetadataClass))
#define TUNER_MODEL_IS_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_METADATA))
#define TUNER_MODEL_IS_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_METADATA))
#define TUNER_MODEL_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_METADATA, TunerModelMetadataClass))

typedef struct _TunerModelMetadata TunerModelMetadata;
typedef struct _TunerModelMetadataClass TunerModelMetadataClass;
typedef struct _TunerModelMetadataPrivate TunerModelMetadataPrivate;
enum  {
	TUNER_MODEL_METADATA_0_PROPERTY,
	TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY,
	TUNER_MODEL_METADATA_TITLE_PROPERTY,
	TUNER_MODEL_METADATA_ARTIST_PROPERTY,
	TUNER_MODEL_METADATA_IMAGE_PROPERTY,
	TUNER_MODEL_METADATA_GENRE_PROPERTY,
	TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY,
	TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY,
	TUNER_MODEL_METADATA_ORG_LOC_PROPERTY,
	TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY,
	TUNER_MODEL_METADATA_NUM_PROPERTIES
};
static GParamSpec* tuner_model_metadata_properties[TUNER_MODEL_METADATA_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _gst_tag_list_unref0(var) ((var == NULL) ? NULL : (var = (gst_tag_list_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _TunerModelMetadata {
	GObject parent_instance;
	TunerModelMetadataPrivate * priv;
};

struct _TunerModelMetadataClass {
	GObjectClass parent_class;
};

struct _TunerModelMetadataPrivate {
	gchar* _all_tags;
	gchar* _title;
	gchar* _artist;
	gchar* _image;
	gchar* _genre;
	gchar* _homepage;
	gchar* _audio_info;
	gchar* _org_loc;
	gchar* _pretty_print;
	GeeMap* _metadata_values;
};

struct _Block3Data {
	int _ref_count_;
	TunerModelMetadata* self;
	gchar* s;
	gboolean b;
	guint u;
};

static gint TunerModelMetadata_private_offset;
static gpointer tuner_model_metadata_parent_class = NULL;
static gchar** tuner_model_metadata_METADATA_TITLES;
static gint tuner_model_metadata_METADATA_TITLES_length1;
static gint tuner_model_metadata_METADATA_TITLES_length2;
static gchar** tuner_model_metadata_METADATA_TITLES = NULL;
static gint tuner_model_metadata_METADATA_TITLES_length1 = 0;
static gint tuner_model_metadata_METADATA_TITLES_length2 = 0;
static GeeList* tuner_model_metadata_METADATA_TAGS;
static GeeList* tuner_model_metadata_METADATA_TAGS = NULL;

VALA_EXTERN GType tuner_model_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelMetadata, g_object_unref)
VALA_EXTERN gboolean tuner_model_metadata_process_media_info_update (TunerModelMetadata* self,
                                                         GstPlayerMediaInfo* media_info);
static void tuner_model_metadata_set_title (TunerModelMetadata* self,
                                     const gchar* value);
static void tuner_model_metadata_set_artist (TunerModelMetadata* self,
                                      const gchar* value);
static void tuner_model_metadata_set_image (TunerModelMetadata* self,
                                     const gchar* value);
static void tuner_model_metadata_set_genre (TunerModelMetadata* self,
                                     const gchar* value);
static void tuner_model_metadata_set_homepage (TunerModelMetadata* self,
                                        const gchar* value);
static void tuner_model_metadata_set_audio_info (TunerModelMetadata* self,
                                          const gchar* value);
static void tuner_model_metadata_set_org_loc (TunerModelMetadata* self,
                                       const gchar* value);
static void tuner_model_metadata_set_pretty_print (TunerModelMetadata* self,
                                            const gchar* value);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
VALA_EXTERN const gchar* tuner_model_metadata_get_all_tags (TunerModelMetadata* self);
static void tuner_model_metadata_set_all_tags (TunerModelMetadata* self,
                                        const gchar* value);
static void ____lambda5_ (Block3Data* _data3_,
                   GstTagList* list,
                   const gchar* tag);
static void _____lambda5__gst_tag_foreach_func (GstTagList* list,
                                         const gchar* tag,
                                         gpointer self);
VALA_EXTERN const gchar* tuner_safestrip (const gchar* text);
VALA_EXTERN TunerModelMetadata* tuner_model_metadata_new (void);
VALA_EXTERN TunerModelMetadata* tuner_model_metadata_construct (GType object_type);
VALA_EXTERN const gchar* tuner_model_metadata_get_title (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_artist (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_image (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_genre (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_homepage (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_audio_info (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_org_loc (TunerModelMetadata* self);
VALA_EXTERN const gchar* tuner_model_metadata_get_pretty_print (TunerModelMetadata* self);
static void tuner_model_metadata_finalize (GObject * obj);
static GType tuner_model_metadata_get_type_once (void);
static void _vala_tuner_model_metadata_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_tuner_model_metadata_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
tuner_model_metadata_get_instance_private (TunerModelMetadata* self)
{
	return G_STRUCT_MEMBER_P (self, TunerModelMetadata_private_offset);
}

/**
    * Extracts the metadata from the media stream.
    *
    * @param media_info The media information stream
    * @return true if the metadata has changed
    */
static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 94 "../src/Models/StreamMetadata.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 94 "../src/Models/StreamMetadata.vala"
	return _data3_;
#line 184 "StreamMetadata.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 94 "../src/Models/StreamMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 194 "StreamMetadata.c"
		TunerModelMetadata* self;
#line 94 "../src/Models/StreamMetadata.vala"
		self = _data3_->self;
#line 94 "../src/Models/StreamMetadata.vala"
		_g_free0 (_data3_->s);
#line 94 "../src/Models/StreamMetadata.vala"
		_g_object_unref0 (self);
#line 94 "../src/Models/StreamMetadata.vala"
		g_slice_free (Block3Data, _data3_);
#line 204 "StreamMetadata.c"
	}
}

static gpointer
_gst_tag_list_ref0 (gpointer self)
{
#line 96 "../src/Models/StreamMetadata.vala"
	return self ? gst_tag_list_ref (self) : NULL;
#line 213 "StreamMetadata.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 226 "StreamMetadata.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 235 "StreamMetadata.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 243 "StreamMetadata.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 252 "StreamMetadata.c"
	}
}

static void
____lambda5_ (Block3Data* _data3_,
              GstTagList* list,
              const gchar* tag)
{
	TunerModelMetadata* self;
	gint index = 0;
	GeeList* _tmp0_;
	GType type = 0UL;
	GValue _tmp4_;
#line 111 "../src/Models/StreamMetadata.vala"
	self = _data3_->self;
#line 111 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (list != NULL);
#line 111 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 113 "../src/Models/StreamMetadata.vala"
	_tmp0_ = tuner_model_metadata_METADATA_TAGS;
#line 113 "../src/Models/StreamMetadata.vala"
	index = gee_list_index_of (_tmp0_, tag);
#line 115 "../src/Models/StreamMetadata.vala"
	if (index == -1) {
#line 278 "StreamMetadata.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 117 "../src/Models/StreamMetadata.vala"
		_tmp1_ = string_to_string (tag);
#line 117 "../src/Models/StreamMetadata.vala"
		_tmp2_ = g_strconcat ("New meta tag: ", _tmp1_, NULL);
#line 117 "../src/Models/StreamMetadata.vala"
		_tmp3_ = _tmp2_;
#line 117 "../src/Models/StreamMetadata.vala"
		g_warning ("StreamMetadata.vala:117: %s", _tmp3_);
#line 117 "../src/Models/StreamMetadata.vala"
		_g_free0 (_tmp3_);
#line 118 "../src/Models/StreamMetadata.vala"
		return;
#line 294 "StreamMetadata.c"
	}
#line 121 "../src/Models/StreamMetadata.vala"
	_tmp4_ = *gst_tag_list_get_value_index (list, tag, (guint) 0);
#line 121 "../src/Models/StreamMetadata.vala"
	type = G_VALUE_TYPE (&_tmp4_);
#line 123 "../src/Models/StreamMetadata.vala"
	switch (type) {
#line 123 "../src/Models/StreamMetadata.vala"
		case G_TYPE_STRING:
#line 304 "StreamMetadata.c"
		{
			gchar* _tmp5_ = NULL;
			GeeMap* _tmp6_;
			const gchar* _tmp7_;
#line 126 "../src/Models/StreamMetadata.vala"
			gst_tag_list_get_string (list, tag, &_tmp5_);
#line 126 "../src/Models/StreamMetadata.vala"
			_g_free0 (_data3_->s);
#line 126 "../src/Models/StreamMetadata.vala"
			_data3_->s = _tmp5_;
#line 127 "../src/Models/StreamMetadata.vala"
			_tmp6_ = self->priv->_metadata_values;
#line 127 "../src/Models/StreamMetadata.vala"
			_tmp7_ = _data3_->s;
#line 127 "../src/Models/StreamMetadata.vala"
			gee_map_set (_tmp6_, tag, _tmp7_);
#line 128 "../src/Models/StreamMetadata.vala"
			break;
#line 323 "StreamMetadata.c"
		}
#line 123 "../src/Models/StreamMetadata.vala"
		case G_TYPE_UINT:
#line 327 "StreamMetadata.c"
		{
			guint _tmp8_ = 0U;
#line 130 "../src/Models/StreamMetadata.vala"
			gst_tag_list_get_uint (list, tag, &_tmp8_);
#line 130 "../src/Models/StreamMetadata.vala"
			_data3_->u = _tmp8_;
#line 131 "../src/Models/StreamMetadata.vala"
			if (_data3_->u > ((guint) 1000)) {
#line 336 "StreamMetadata.c"
				GeeMap* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
#line 132 "../src/Models/StreamMetadata.vala"
				_tmp9_ = self->priv->_metadata_values;
#line 132 "../src/Models/StreamMetadata.vala"
				_tmp10_ = g_strdup_printf ("%u", _data3_->u / 1000);
#line 132 "../src/Models/StreamMetadata.vala"
				_tmp11_ = _tmp10_;
#line 132 "../src/Models/StreamMetadata.vala"
				_tmp12_ = g_strconcat (_tmp11_, "K", NULL);
#line 132 "../src/Models/StreamMetadata.vala"
				_tmp13_ = _tmp12_;
#line 132 "../src/Models/StreamMetadata.vala"
				gee_map_set (_tmp9_, tag, _tmp13_);
#line 132 "../src/Models/StreamMetadata.vala"
				_g_free0 (_tmp13_);
#line 132 "../src/Models/StreamMetadata.vala"
				_g_free0 (_tmp11_);
#line 358 "StreamMetadata.c"
			} else {
				GeeMap* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
#line 134 "../src/Models/StreamMetadata.vala"
				_tmp14_ = self->priv->_metadata_values;
#line 134 "../src/Models/StreamMetadata.vala"
				_tmp15_ = g_strdup_printf ("%u", _data3_->u);
#line 134 "../src/Models/StreamMetadata.vala"
				_tmp16_ = _tmp15_;
#line 134 "../src/Models/StreamMetadata.vala"
				gee_map_set (_tmp14_, tag, _tmp16_);
#line 134 "../src/Models/StreamMetadata.vala"
				_g_free0 (_tmp16_);
#line 373 "StreamMetadata.c"
			}
#line 135 "../src/Models/StreamMetadata.vala"
			break;
#line 377 "StreamMetadata.c"
		}
#line 123 "../src/Models/StreamMetadata.vala"
		case G_TYPE_BOOLEAN:
#line 381 "StreamMetadata.c"
		{
			gboolean _tmp17_ = FALSE;
			GeeMap* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
#line 137 "../src/Models/StreamMetadata.vala"
			gst_tag_list_get_boolean (list, tag, &_tmp17_);
#line 137 "../src/Models/StreamMetadata.vala"
			_data3_->b = _tmp17_;
#line 138 "../src/Models/StreamMetadata.vala"
			_tmp18_ = self->priv->_metadata_values;
#line 138 "../src/Models/StreamMetadata.vala"
			_tmp19_ = bool_to_string (_data3_->b);
#line 138 "../src/Models/StreamMetadata.vala"
			_tmp20_ = _tmp19_;
#line 138 "../src/Models/StreamMetadata.vala"
			gee_map_set (_tmp18_, tag, _tmp20_);
#line 138 "../src/Models/StreamMetadata.vala"
			_g_free0 (_tmp20_);
#line 139 "../src/Models/StreamMetadata.vala"
			break;
#line 403 "StreamMetadata.c"
		}
		default:
		{
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 141 "../src/Models/StreamMetadata.vala"
			_tmp21_ = g_type_name (type);
#line 141 "../src/Models/StreamMetadata.vala"
			_tmp22_ = string_to_string (_tmp21_);
#line 141 "../src/Models/StreamMetadata.vala"
			_tmp23_ = g_strconcat ("New Tag type: ", _tmp22_, NULL);
#line 141 "../src/Models/StreamMetadata.vala"
			_tmp24_ = _tmp23_;
#line 141 "../src/Models/StreamMetadata.vala"
			g_warning ("StreamMetadata.vala:141: %s", _tmp24_);
#line 141 "../src/Models/StreamMetadata.vala"
			_g_free0 (_tmp24_);
#line 142 "../src/Models/StreamMetadata.vala"
			break;
#line 425 "StreamMetadata.c"
		}
	}
}

static void
_____lambda5__gst_tag_foreach_func (GstTagList* list,
                                    const gchar* tag,
                                    gpointer self)
{
#line 111 "../src/Models/StreamMetadata.vala"
	____lambda5_ (self, list, tag);
#line 437 "StreamMetadata.c"
}

gboolean
tuner_model_metadata_process_media_info_update (TunerModelMetadata* self,
                                                GstPlayerMediaInfo* media_info)
{
	GList* streamlist = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gboolean result;
#line 81 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (media_info != NULL, FALSE);
#line 83 "../src/Models/StreamMetadata.vala"
	_tmp0_ = gst_player_media_info_get_stream_list (media_info);
#line 83 "../src/Models/StreamMetadata.vala"
	_tmp1_ = g_list_copy (_tmp0_);
#line 83 "../src/Models/StreamMetadata.vala"
	streamlist = _tmp1_;
#line 85 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_set_title (self, "");
#line 86 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_set_artist (self, "");
#line 87 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_set_image (self, "");
#line 88 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_set_genre (self, "");
#line 89 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_set_homepage (self, "");
#line 90 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_set_audio_info (self, "");
#line 91 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_set_org_loc (self, "");
#line 92 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_set_pretty_print (self, "");
#line 94 "../src/Models/StreamMetadata.vala"
	_tmp2_ = streamlist;
#line 477 "StreamMetadata.c"
	{
		GList* stream_collection = NULL;
		GList* stream_it = NULL;
#line 94 "../src/Models/StreamMetadata.vala"
		stream_collection = _tmp2_;
#line 94 "../src/Models/StreamMetadata.vala"
		for (stream_it = stream_collection; stream_it != NULL; stream_it = stream_it->next) {
#line 485 "StreamMetadata.c"
			GstPlayerStreamInfo* stream = NULL;
#line 94 "../src/Models/StreamMetadata.vala"
			stream = (GstPlayerStreamInfo*) stream_it->data;
#line 489 "StreamMetadata.c"
			{
				Block3Data* _data3_;
				GstTagList* tags = NULL;
				GstPlayerStreamInfo* _tmp3_;
				GstTagList* _tmp4_;
				GstTagList* _tmp5_;
				GstTagList* _tmp6_;
				const gchar* _tmp7_;
				GstTagList* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gboolean _tmp11_;
				GstTagList* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				GstTagList* _tmp19_;
				GeeMap* _tmp20_;
				GeeMap* _tmp23_;
				GeeMap* _tmp26_;
				GeeMap* _tmp29_;
				GeeMap* _tmp32_;
				GeeMap* _tmp35_;
				GeeMap* _tmp38_;
				GeeMap* _tmp44_;
				gboolean _tmp50_ = FALSE;
				const gchar* _tmp51_;
				GeeMap* _tmp58_;
				GeeMap* _tmp61_;
				gboolean _tmp67_ = FALSE;
				const gchar* _tmp68_;
				GString* sb = NULL;
				GString* _tmp74_;
				GString* _tmp97_;
				GString* _tmp98_;
				GString* _tmp99_;
				const gchar* _tmp100_;
#line 94 "../src/Models/StreamMetadata.vala"
				_data3_ = g_slice_new0 (Block3Data);
#line 94 "../src/Models/StreamMetadata.vala"
				_data3_->_ref_count_ = 1;
#line 94 "../src/Models/StreamMetadata.vala"
				_data3_->self = g_object_ref (self);
#line 96 "../src/Models/StreamMetadata.vala"
				_tmp3_ = stream;
#line 96 "../src/Models/StreamMetadata.vala"
				_tmp4_ = gst_player_stream_info_get_tags (_tmp3_);
#line 96 "../src/Models/StreamMetadata.vala"
				_tmp5_ = _gst_tag_list_ref0 (_tmp4_);
#line 96 "../src/Models/StreamMetadata.vala"
				tags = _tmp5_;
#line 98 "../src/Models/StreamMetadata.vala"
				_tmp6_ = tags;
#line 98 "../src/Models/StreamMetadata.vala"
				if (_tmp6_ == NULL) {
#line 99 "../src/Models/StreamMetadata.vala"
					_gst_tag_list_unref0 (tags);
#line 99 "../src/Models/StreamMetadata.vala"
					block3_data_unref (_data3_);
#line 99 "../src/Models/StreamMetadata.vala"
					_data3_ = NULL;
#line 99 "../src/Models/StreamMetadata.vala"
					break;
#line 556 "StreamMetadata.c"
				}
#line 101 "../src/Models/StreamMetadata.vala"
				_tmp7_ = self->priv->_all_tags;
#line 101 "../src/Models/StreamMetadata.vala"
				_tmp8_ = tags;
#line 101 "../src/Models/StreamMetadata.vala"
				_tmp9_ = gst_tag_list_to_string (_tmp8_);
#line 101 "../src/Models/StreamMetadata.vala"
				_tmp10_ = _tmp9_;
#line 101 "../src/Models/StreamMetadata.vala"
				_tmp11_ = g_strcmp0 (_tmp7_, _tmp10_) == 0;
#line 101 "../src/Models/StreamMetadata.vala"
				_g_free0 (_tmp10_);
#line 101 "../src/Models/StreamMetadata.vala"
				if (_tmp11_) {
#line 102 "../src/Models/StreamMetadata.vala"
					result = FALSE;
#line 102 "../src/Models/StreamMetadata.vala"
					_gst_tag_list_unref0 (tags);
#line 102 "../src/Models/StreamMetadata.vala"
					block3_data_unref (_data3_);
#line 102 "../src/Models/StreamMetadata.vala"
					_data3_ = NULL;
#line 102 "../src/Models/StreamMetadata.vala"
					(streamlist == NULL) ? NULL : (streamlist = (g_list_free (streamlist), NULL));
#line 102 "../src/Models/StreamMetadata.vala"
					return result;
#line 584 "StreamMetadata.c"
				}
#line 104 "../src/Models/StreamMetadata.vala"
				_tmp12_ = tags;
#line 104 "../src/Models/StreamMetadata.vala"
				_tmp13_ = gst_tag_list_to_string (_tmp12_);
#line 104 "../src/Models/StreamMetadata.vala"
				_tmp14_ = _tmp13_;
#line 104 "../src/Models/StreamMetadata.vala"
				tuner_model_metadata_set_all_tags (self, _tmp14_);
#line 104 "../src/Models/StreamMetadata.vala"
				_g_free0 (_tmp14_);
#line 105 "../src/Models/StreamMetadata.vala"
				_tmp15_ = self->priv->_all_tags;
#line 105 "../src/Models/StreamMetadata.vala"
				_tmp16_ = string_to_string (_tmp15_);
#line 105 "../src/Models/StreamMetadata.vala"
				_tmp17_ = g_strconcat ("All Tags: ", _tmp16_, NULL);
#line 105 "../src/Models/StreamMetadata.vala"
				_tmp18_ = _tmp17_;
#line 105 "../src/Models/StreamMetadata.vala"
				g_debug ("StreamMetadata.vala:105: %s", _tmp18_);
#line 105 "../src/Models/StreamMetadata.vala"
				_g_free0 (_tmp18_);
#line 107 "../src/Models/StreamMetadata.vala"
				_data3_->s = NULL;
#line 108 "../src/Models/StreamMetadata.vala"
				_data3_->b = FALSE;
#line 109 "../src/Models/StreamMetadata.vala"
				_data3_->u = (guint) 0;
#line 111 "../src/Models/StreamMetadata.vala"
				_tmp19_ = tags;
#line 111 "../src/Models/StreamMetadata.vala"
				gst_tag_list_foreach (_tmp19_, _____lambda5__gst_tag_foreach_func, _data3_);
#line 146 "../src/Models/StreamMetadata.vala"
				_tmp20_ = self->priv->_metadata_values;
#line 146 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp20_, "title")) {
#line 622 "StreamMetadata.c"
					GeeMap* _tmp21_;
					gpointer _tmp22_;
#line 147 "../src/Models/StreamMetadata.vala"
					_tmp21_ = self->priv->_metadata_values;
#line 147 "../src/Models/StreamMetadata.vala"
					_tmp22_ = gee_map_get (_tmp21_, "title");
#line 147 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_title);
#line 147 "../src/Models/StreamMetadata.vala"
					self->priv->_title = (gchar*) _tmp22_;
#line 633 "StreamMetadata.c"
				}
#line 148 "../src/Models/StreamMetadata.vala"
				_tmp23_ = self->priv->_metadata_values;
#line 148 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp23_, "artist")) {
#line 639 "StreamMetadata.c"
					GeeMap* _tmp24_;
					gpointer _tmp25_;
#line 149 "../src/Models/StreamMetadata.vala"
					_tmp24_ = self->priv->_metadata_values;
#line 149 "../src/Models/StreamMetadata.vala"
					_tmp25_ = gee_map_get (_tmp24_, "artist");
#line 149 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_artist);
#line 149 "../src/Models/StreamMetadata.vala"
					self->priv->_artist = (gchar*) _tmp25_;
#line 650 "StreamMetadata.c"
				}
#line 150 "../src/Models/StreamMetadata.vala"
				_tmp26_ = self->priv->_metadata_values;
#line 150 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp26_, "image")) {
#line 656 "StreamMetadata.c"
					GeeMap* _tmp27_;
					gpointer _tmp28_;
#line 151 "../src/Models/StreamMetadata.vala"
					_tmp27_ = self->priv->_metadata_values;
#line 151 "../src/Models/StreamMetadata.vala"
					_tmp28_ = gee_map_get (_tmp27_, "image");
#line 151 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_image);
#line 151 "../src/Models/StreamMetadata.vala"
					self->priv->_image = (gchar*) _tmp28_;
#line 667 "StreamMetadata.c"
				}
#line 152 "../src/Models/StreamMetadata.vala"
				_tmp29_ = self->priv->_metadata_values;
#line 152 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp29_, "genre")) {
#line 673 "StreamMetadata.c"
					GeeMap* _tmp30_;
					gpointer _tmp31_;
#line 153 "../src/Models/StreamMetadata.vala"
					_tmp30_ = self->priv->_metadata_values;
#line 153 "../src/Models/StreamMetadata.vala"
					_tmp31_ = gee_map_get (_tmp30_, "genre");
#line 153 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_genre);
#line 153 "../src/Models/StreamMetadata.vala"
					self->priv->_genre = (gchar*) _tmp31_;
#line 684 "StreamMetadata.c"
				}
#line 154 "../src/Models/StreamMetadata.vala"
				_tmp32_ = self->priv->_metadata_values;
#line 154 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp32_, "homepage")) {
#line 690 "StreamMetadata.c"
					GeeMap* _tmp33_;
					gpointer _tmp34_;
#line 155 "../src/Models/StreamMetadata.vala"
					_tmp33_ = self->priv->_metadata_values;
#line 155 "../src/Models/StreamMetadata.vala"
					_tmp34_ = gee_map_get (_tmp33_, "homepage");
#line 155 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_homepage);
#line 155 "../src/Models/StreamMetadata.vala"
					self->priv->_homepage = (gchar*) _tmp34_;
#line 701 "StreamMetadata.c"
				}
#line 157 "../src/Models/StreamMetadata.vala"
				_tmp35_ = self->priv->_metadata_values;
#line 157 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp35_, "audio_codec")) {
#line 707 "StreamMetadata.c"
					GeeMap* _tmp36_;
					gpointer _tmp37_;
#line 158 "../src/Models/StreamMetadata.vala"
					_tmp36_ = self->priv->_metadata_values;
#line 158 "../src/Models/StreamMetadata.vala"
					_tmp37_ = gee_map_get (_tmp36_, "audio_codec ");
#line 158 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_audio_info);
#line 158 "../src/Models/StreamMetadata.vala"
					self->priv->_audio_info = (gchar*) _tmp37_;
#line 718 "StreamMetadata.c"
				}
#line 159 "../src/Models/StreamMetadata.vala"
				_tmp38_ = self->priv->_metadata_values;
#line 159 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp38_, "bitrate")) {
#line 724 "StreamMetadata.c"
					const gchar* _tmp39_;
					GeeMap* _tmp40_;
					gpointer _tmp41_;
					gchar* _tmp42_;
					gchar* _tmp43_;
#line 160 "../src/Models/StreamMetadata.vala"
					_tmp39_ = self->priv->_audio_info;
#line 160 "../src/Models/StreamMetadata.vala"
					_tmp40_ = self->priv->_metadata_values;
#line 160 "../src/Models/StreamMetadata.vala"
					_tmp41_ = gee_map_get (_tmp40_, "bitrate ");
#line 160 "../src/Models/StreamMetadata.vala"
					_tmp42_ = (gchar*) _tmp41_;
#line 160 "../src/Models/StreamMetadata.vala"
					_tmp43_ = g_strconcat (_tmp39_, _tmp42_, NULL);
#line 160 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_audio_info);
#line 160 "../src/Models/StreamMetadata.vala"
					self->priv->_audio_info = _tmp43_;
#line 160 "../src/Models/StreamMetadata.vala"
					_g_free0 (_tmp42_);
#line 746 "StreamMetadata.c"
				}
#line 161 "../src/Models/StreamMetadata.vala"
				_tmp44_ = self->priv->_metadata_values;
#line 161 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp44_, "channel_mode")) {
#line 752 "StreamMetadata.c"
					const gchar* _tmp45_;
					GeeMap* _tmp46_;
					gpointer _tmp47_;
					gchar* _tmp48_;
					gchar* _tmp49_;
#line 162 "../src/Models/StreamMetadata.vala"
					_tmp45_ = self->priv->_audio_info;
#line 162 "../src/Models/StreamMetadata.vala"
					_tmp46_ = self->priv->_metadata_values;
#line 162 "../src/Models/StreamMetadata.vala"
					_tmp47_ = gee_map_get (_tmp46_, "channel_mode");
#line 162 "../src/Models/StreamMetadata.vala"
					_tmp48_ = (gchar*) _tmp47_;
#line 162 "../src/Models/StreamMetadata.vala"
					_tmp49_ = g_strconcat (_tmp45_, _tmp48_, NULL);
#line 162 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_audio_info);
#line 162 "../src/Models/StreamMetadata.vala"
					self->priv->_audio_info = _tmp49_;
#line 162 "../src/Models/StreamMetadata.vala"
					_g_free0 (_tmp48_);
#line 774 "StreamMetadata.c"
				}
#line 163 "../src/Models/StreamMetadata.vala"
				_tmp51_ = self->priv->_audio_info;
#line 163 "../src/Models/StreamMetadata.vala"
				if (_tmp51_ != NULL) {
#line 780 "StreamMetadata.c"
					const gchar* _tmp52_;
					gint _tmp53_;
					gint _tmp54_;
#line 163 "../src/Models/StreamMetadata.vala"
					_tmp52_ = self->priv->_audio_info;
#line 163 "../src/Models/StreamMetadata.vala"
					_tmp53_ = strlen (_tmp52_);
#line 163 "../src/Models/StreamMetadata.vala"
					_tmp54_ = _tmp53_;
#line 163 "../src/Models/StreamMetadata.vala"
					_tmp50_ = _tmp54_ > 0;
#line 792 "StreamMetadata.c"
				} else {
#line 163 "../src/Models/StreamMetadata.vala"
					_tmp50_ = FALSE;
#line 796 "StreamMetadata.c"
				}
#line 163 "../src/Models/StreamMetadata.vala"
				if (_tmp50_) {
#line 800 "StreamMetadata.c"
					const gchar* _tmp55_;
					const gchar* _tmp56_;
					gchar* _tmp57_;
#line 164 "../src/Models/StreamMetadata.vala"
					_tmp55_ = self->priv->_audio_info;
#line 164 "../src/Models/StreamMetadata.vala"
					_tmp56_ = tuner_safestrip (_tmp55_);
#line 164 "../src/Models/StreamMetadata.vala"
					_tmp57_ = g_strdup (_tmp56_);
#line 164 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_audio_info);
#line 164 "../src/Models/StreamMetadata.vala"
					self->priv->_audio_info = _tmp57_;
#line 814 "StreamMetadata.c"
				}
#line 166 "../src/Models/StreamMetadata.vala"
				_tmp58_ = self->priv->_metadata_values;
#line 166 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp58_, "organization")) {
#line 820 "StreamMetadata.c"
					GeeMap* _tmp59_;
					gpointer _tmp60_;
#line 167 "../src/Models/StreamMetadata.vala"
					_tmp59_ = self->priv->_metadata_values;
#line 167 "../src/Models/StreamMetadata.vala"
					_tmp60_ = gee_map_get (_tmp59_, "organization ");
#line 167 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_org_loc);
#line 167 "../src/Models/StreamMetadata.vala"
					self->priv->_org_loc = (gchar*) _tmp60_;
#line 831 "StreamMetadata.c"
				}
#line 168 "../src/Models/StreamMetadata.vala"
				_tmp61_ = self->priv->_metadata_values;
#line 168 "../src/Models/StreamMetadata.vala"
				if (gee_map_has_key (_tmp61_, "location")) {
#line 837 "StreamMetadata.c"
					const gchar* _tmp62_;
					GeeMap* _tmp63_;
					gpointer _tmp64_;
					gchar* _tmp65_;
					gchar* _tmp66_;
#line 169 "../src/Models/StreamMetadata.vala"
					_tmp62_ = self->priv->_org_loc;
#line 169 "../src/Models/StreamMetadata.vala"
					_tmp63_ = self->priv->_metadata_values;
#line 169 "../src/Models/StreamMetadata.vala"
					_tmp64_ = gee_map_get (_tmp63_, "location");
#line 169 "../src/Models/StreamMetadata.vala"
					_tmp65_ = (gchar*) _tmp64_;
#line 169 "../src/Models/StreamMetadata.vala"
					_tmp66_ = g_strconcat (_tmp62_, _tmp65_, NULL);
#line 169 "../src/Models/StreamMetadata.vala"
					_g_free0 (self->priv->_org_loc);
#line 169 "../src/Models/StreamMetadata.vala"
					self->priv->_org_loc = _tmp66_;
#line 169 "../src/Models/StreamMetadata.vala"
					_g_free0 (_tmp65_);
#line 859 "StreamMetadata.c"
				}
#line 170 "../src/Models/StreamMetadata.vala"
				_tmp68_ = self->priv->_org_loc;
#line 170 "../src/Models/StreamMetadata.vala"
				if (_tmp68_ != NULL) {
#line 865 "StreamMetadata.c"
					const gchar* _tmp69_;
					gint _tmp70_;
					gint _tmp71_;
#line 170 "../src/Models/StreamMetadata.vala"
					_tmp69_ = self->priv->_org_loc;
#line 170 "../src/Models/StreamMetadata.vala"
					_tmp70_ = strlen (_tmp69_);
#line 170 "../src/Models/StreamMetadata.vala"
					_tmp71_ = _tmp70_;
#line 170 "../src/Models/StreamMetadata.vala"
					_tmp67_ = _tmp71_ > 0;
#line 877 "StreamMetadata.c"
				} else {
#line 170 "../src/Models/StreamMetadata.vala"
					_tmp67_ = FALSE;
#line 881 "StreamMetadata.c"
				}
#line 170 "../src/Models/StreamMetadata.vala"
				if (_tmp67_) {
#line 885 "StreamMetadata.c"
					const gchar* _tmp72_;
					const gchar* _tmp73_;
#line 171 "../src/Models/StreamMetadata.vala"
					_tmp72_ = self->priv->_org_loc;
#line 171 "../src/Models/StreamMetadata.vala"
					_tmp73_ = tuner_safestrip (_tmp72_);
#line 171 "../src/Models/StreamMetadata.vala"
					tuner_model_metadata_set_org_loc (self, _tmp73_);
#line 894 "StreamMetadata.c"
				}
#line 173 "../src/Models/StreamMetadata.vala"
				_tmp74_ = g_string_new ("");
#line 173 "../src/Models/StreamMetadata.vala"
				sb = _tmp74_;
#line 900 "StreamMetadata.c"
				{
					GeeList* _tag_list = NULL;
					GeeList* _tmp75_;
					gint _tag_size = 0;
					GeeList* _tmp76_;
					gint _tmp77_;
					gint _tmp78_;
					gint _tag_index = 0;
#line 174 "../src/Models/StreamMetadata.vala"
					_tmp75_ = tuner_model_metadata_METADATA_TAGS;
#line 174 "../src/Models/StreamMetadata.vala"
					_tag_list = _tmp75_;
#line 174 "../src/Models/StreamMetadata.vala"
					_tmp76_ = _tag_list;
#line 174 "../src/Models/StreamMetadata.vala"
					_tmp77_ = gee_collection_get_size ((GeeCollection*) _tmp76_);
#line 174 "../src/Models/StreamMetadata.vala"
					_tmp78_ = _tmp77_;
#line 174 "../src/Models/StreamMetadata.vala"
					_tag_size = _tmp78_;
#line 174 "../src/Models/StreamMetadata.vala"
					_tag_index = -1;
#line 174 "../src/Models/StreamMetadata.vala"
					while (TRUE) {
#line 925 "StreamMetadata.c"
						gint _tmp79_;
						gint _tmp80_;
						gchar* tag = NULL;
						GeeList* _tmp81_;
						gpointer _tmp82_;
						GeeMap* _tmp83_;
						const gchar* _tmp84_;
#line 174 "../src/Models/StreamMetadata.vala"
						_tag_index = _tag_index + 1;
#line 174 "../src/Models/StreamMetadata.vala"
						_tmp79_ = _tag_index;
#line 174 "../src/Models/StreamMetadata.vala"
						_tmp80_ = _tag_size;
#line 174 "../src/Models/StreamMetadata.vala"
						if (!(_tmp79_ < _tmp80_)) {
#line 174 "../src/Models/StreamMetadata.vala"
							break;
#line 943 "StreamMetadata.c"
						}
#line 174 "../src/Models/StreamMetadata.vala"
						_tmp81_ = _tag_list;
#line 174 "../src/Models/StreamMetadata.vala"
						_tmp82_ = gee_list_get (_tmp81_, _tag_index);
#line 174 "../src/Models/StreamMetadata.vala"
						tag = (gchar*) _tmp82_;
#line 177 "../src/Models/StreamMetadata.vala"
						_tmp83_ = self->priv->_metadata_values;
#line 177 "../src/Models/StreamMetadata.vala"
						_tmp84_ = tag;
#line 177 "../src/Models/StreamMetadata.vala"
						if (gee_map_has_key (_tmp83_, _tmp84_)) {
#line 957 "StreamMetadata.c"
							GString* _tmp85_;
							gchar** _tmp86_;
							gint _tmp86__length1;
							gint _tmp86__length2;
							GeeList* _tmp87_;
							const gchar* _tmp88_;
							const gchar* _tmp89_;
							GString* _tmp90_;
							GString* _tmp91_;
							GeeMap* _tmp92_;
							const gchar* _tmp93_;
							gpointer _tmp94_;
							gchar* _tmp95_;
							GString* _tmp96_;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp85_ = sb;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp86_ = tuner_model_metadata_METADATA_TITLES;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp86__length1 = tuner_model_metadata_METADATA_TITLES_length1;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp86__length2 = tuner_model_metadata_METADATA_TITLES_length2;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp87_ = tuner_model_metadata_METADATA_TAGS;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp88_ = tag;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp89_ = _tmp86_[(gee_list_index_of (_tmp87_, _tmp88_) * _tmp86__length2) + 1];
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp90_ = g_string_append (_tmp85_, _tmp89_);
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp91_ = g_string_append (_tmp90_, " : ");
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp92_ = self->priv->_metadata_values;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp93_ = tag;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp94_ = gee_map_get (_tmp92_, _tmp93_);
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp95_ = (gchar*) _tmp94_;
#line 179 "../src/Models/StreamMetadata.vala"
							_tmp96_ = g_string_append (_tmp91_, _tmp95_);
#line 179 "../src/Models/StreamMetadata.vala"
							g_string_append (_tmp96_, "\n");
#line 179 "../src/Models/StreamMetadata.vala"
							_g_free0 (_tmp95_);
#line 1004 "StreamMetadata.c"
						}
#line 174 "../src/Models/StreamMetadata.vala"
						_g_free0 (tag);
#line 1008 "StreamMetadata.c"
					}
				}
#line 185 "../src/Models/StreamMetadata.vala"
				_tmp97_ = sb;
#line 185 "../src/Models/StreamMetadata.vala"
				_tmp98_ = sb;
#line 185 "../src/Models/StreamMetadata.vala"
				_tmp99_ = g_string_truncate (_tmp97_, (gsize) (_tmp98_->len - 1));
#line 185 "../src/Models/StreamMetadata.vala"
				_tmp100_ = _tmp99_->str;
#line 185 "../src/Models/StreamMetadata.vala"
				tuner_model_metadata_set_pretty_print (self, _tmp100_);
#line 94 "../src/Models/StreamMetadata.vala"
				_g_string_free0 (sb);
#line 94 "../src/Models/StreamMetadata.vala"
				_gst_tag_list_unref0 (tags);
#line 94 "../src/Models/StreamMetadata.vala"
				block3_data_unref (_data3_);
#line 94 "../src/Models/StreamMetadata.vala"
				_data3_ = NULL;
#line 1029 "StreamMetadata.c"
			}
		}
	}
#line 188 "../src/Models/StreamMetadata.vala"
	result = TRUE;
#line 188 "../src/Models/StreamMetadata.vala"
	(streamlist == NULL) ? NULL : (streamlist = (g_list_free (streamlist), NULL));
#line 188 "../src/Models/StreamMetadata.vala"
	return result;
#line 1039 "StreamMetadata.c"
}

TunerModelMetadata*
tuner_model_metadata_construct (GType object_type)
{
	TunerModelMetadata * self = NULL;
#line 18 "../src/Models/StreamMetadata.vala"
	self = (TunerModelMetadata*) g_object_new (object_type, NULL);
#line 18 "../src/Models/StreamMetadata.vala"
	return self;
#line 1050 "StreamMetadata.c"
}

TunerModelMetadata*
tuner_model_metadata_new (void)
{
#line 18 "../src/Models/StreamMetadata.vala"
	return tuner_model_metadata_construct (TUNER_MODEL_TYPE_METADATA);
#line 1058 "StreamMetadata.c"
}

const gchar*
tuner_model_metadata_get_all_tags (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 62 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_all_tags;
#line 62 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 62 "../src/Models/StreamMetadata.vala"
	return result;
#line 1074 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_all_tags (TunerModelMetadata* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 62 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_all_tags (self);
#line 62 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1088 "StreamMetadata.c"
		gchar* _tmp0_;
#line 62 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 62 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_all_tags);
#line 62 "../src/Models/StreamMetadata.vala"
		self->priv->_all_tags = _tmp0_;
#line 62 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY]);
#line 1098 "StreamMetadata.c"
	}
}

const gchar*
tuner_model_metadata_get_title (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 63 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_title;
#line 63 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 63 "../src/Models/StreamMetadata.vala"
	return result;
#line 1115 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_title (TunerModelMetadata* self,
                                const gchar* value)
{
	gchar* old_value;
#line 63 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_title (self);
#line 63 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1129 "StreamMetadata.c"
		gchar* _tmp0_;
#line 63 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 63 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_title);
#line 63 "../src/Models/StreamMetadata.vala"
		self->priv->_title = _tmp0_;
#line 63 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_TITLE_PROPERTY]);
#line 1139 "StreamMetadata.c"
	}
}

const gchar*
tuner_model_metadata_get_artist (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 64 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_artist;
#line 64 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 64 "../src/Models/StreamMetadata.vala"
	return result;
#line 1156 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_artist (TunerModelMetadata* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 64 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_artist (self);
#line 64 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1170 "StreamMetadata.c"
		gchar* _tmp0_;
#line 64 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 64 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_artist);
#line 64 "../src/Models/StreamMetadata.vala"
		self->priv->_artist = _tmp0_;
#line 64 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ARTIST_PROPERTY]);
#line 1180 "StreamMetadata.c"
	}
}

const gchar*
tuner_model_metadata_get_image (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 65 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_image;
#line 65 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 65 "../src/Models/StreamMetadata.vala"
	return result;
#line 1197 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_image (TunerModelMetadata* self,
                                const gchar* value)
{
	gchar* old_value;
#line 65 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_image (self);
#line 65 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1211 "StreamMetadata.c"
		gchar* _tmp0_;
#line 65 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 65 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_image);
#line 65 "../src/Models/StreamMetadata.vala"
		self->priv->_image = _tmp0_;
#line 65 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_IMAGE_PROPERTY]);
#line 1221 "StreamMetadata.c"
	}
}

const gchar*
tuner_model_metadata_get_genre (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 66 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_genre;
#line 66 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 66 "../src/Models/StreamMetadata.vala"
	return result;
#line 1238 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_genre (TunerModelMetadata* self,
                                const gchar* value)
{
	gchar* old_value;
#line 66 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_genre (self);
#line 66 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1252 "StreamMetadata.c"
		gchar* _tmp0_;
#line 66 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 66 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_genre);
#line 66 "../src/Models/StreamMetadata.vala"
		self->priv->_genre = _tmp0_;
#line 66 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_GENRE_PROPERTY]);
#line 1262 "StreamMetadata.c"
	}
}

const gchar*
tuner_model_metadata_get_homepage (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 67 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_homepage;
#line 67 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 67 "../src/Models/StreamMetadata.vala"
	return result;
#line 1279 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_homepage (TunerModelMetadata* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 67 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_homepage (self);
#line 67 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1293 "StreamMetadata.c"
		gchar* _tmp0_;
#line 67 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 67 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_homepage);
#line 67 "../src/Models/StreamMetadata.vala"
		self->priv->_homepage = _tmp0_;
#line 67 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY]);
#line 1303 "StreamMetadata.c"
	}
}

const gchar*
tuner_model_metadata_get_audio_info (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 68 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 68 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_audio_info;
#line 68 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 68 "../src/Models/StreamMetadata.vala"
	return result;
#line 1320 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_audio_info (TunerModelMetadata* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 68 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_audio_info (self);
#line 68 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1334 "StreamMetadata.c"
		gchar* _tmp0_;
#line 68 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 68 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_audio_info);
#line 68 "../src/Models/StreamMetadata.vala"
		self->priv->_audio_info = _tmp0_;
#line 68 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY]);
#line 1344 "StreamMetadata.c"
	}
}

const gchar*
tuner_model_metadata_get_org_loc (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 69 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_org_loc;
#line 69 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 69 "../src/Models/StreamMetadata.vala"
	return result;
#line 1361 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_org_loc (TunerModelMetadata* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 69 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_org_loc (self);
#line 69 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1375 "StreamMetadata.c"
		gchar* _tmp0_;
#line 69 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 69 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_org_loc);
#line 69 "../src/Models/StreamMetadata.vala"
		self->priv->_org_loc = _tmp0_;
#line 69 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ORG_LOC_PROPERTY]);
#line 1385 "StreamMetadata.c"
	}
}

const gchar*
tuner_model_metadata_get_pretty_print (TunerModelMetadata* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 70 "../src/Models/StreamMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/Models/StreamMetadata.vala"
	_tmp0_ = self->priv->_pretty_print;
#line 70 "../src/Models/StreamMetadata.vala"
	result = _tmp0_;
#line 70 "../src/Models/StreamMetadata.vala"
	return result;
#line 1402 "StreamMetadata.c"
}

static void
tuner_model_metadata_set_pretty_print (TunerModelMetadata* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 70 "../src/Models/StreamMetadata.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/Models/StreamMetadata.vala"
	old_value = tuner_model_metadata_get_pretty_print (self);
#line 70 "../src/Models/StreamMetadata.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1416 "StreamMetadata.c"
		gchar* _tmp0_;
#line 70 "../src/Models/StreamMetadata.vala"
		_tmp0_ = g_strdup (value);
#line 70 "../src/Models/StreamMetadata.vala"
		_g_free0 (self->priv->_pretty_print);
#line 70 "../src/Models/StreamMetadata.vala"
		self->priv->_pretty_print = _tmp0_;
#line 70 "../src/Models/StreamMetadata.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_model_metadata_properties[TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY]);
#line 1426 "StreamMetadata.c"
	}
}

static void
tuner_model_metadata_class_init (TunerModelMetadataClass * klass,
                                 gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar** _tmp48_;
	GeeArrayList* _tmp49_;
	guint8 tag_index = 0U;
	gchar** _tmp50_;
	gint _tmp50__length1;
	gint _tmp50__length2;
#line 18 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Models/StreamMetadata.vala"
	g_type_class_adjust_private_offset (klass, &TunerModelMetadata_private_offset);
#line 18 "../src/Models/StreamMetadata.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_model_metadata_get_property;
#line 18 "../src/Models/StreamMetadata.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_model_metadata_set_property;
#line 18 "../src/Models/StreamMetadata.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_model_metadata_finalize;
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY] = g_param_spec_string ("all-tags", "all-tags", "all-tags", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_TITLE_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_ARTIST_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_IMAGE_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_IMAGE_PROPERTY] = g_param_spec_string ("image", "image", "image", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_GENRE_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY] = g_param_spec_string ("homepage", "homepage", "homepage", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY] = g_param_spec_string ("audio-info", "audio-info", "audio-info", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_ORG_LOC_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_ORG_LOC_PROPERTY] = g_param_spec_string ("org-loc", "org-loc", "org-loc", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Models/StreamMetadata.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY, tuner_model_metadata_properties[TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY] = g_param_spec_string ("pretty-print", "pretty-print", "pretty-print", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp0_ = g_strdup ("title");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp1_ = g_strdup (_ ("Title"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp2_ = g_strdup ("artist");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp3_ = g_strdup (_ ("Artist"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp4_ = g_strdup ("album");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp5_ = g_strdup (_ ("Album"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp6_ = g_strdup ("image");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp7_ = g_strdup (_ ("Image"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp8_ = g_strdup ("genre");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp9_ = g_strdup (_ ("Genre"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp10_ = g_strdup ("homepage");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp11_ = g_strdup (_ ("Homepage"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp12_ = g_strdup ("organization");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp13_ = g_strdup (_ ("Organization"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp14_ = g_strdup ("location");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp15_ = g_strdup (_ ("Location"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp16_ = g_strdup ("extended-comment");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp17_ = g_strdup (_ ("Extended Comment"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp18_ = g_strdup ("bitrate");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp19_ = g_strdup (_ ("Bitrate"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp20_ = g_strdup ("audio-codec");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp21_ = g_strdup (_ ("Audio Codec"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp22_ = g_strdup ("channel-mode");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp23_ = g_strdup (_ ("Channel Mode"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp24_ = g_strdup ("track-number");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp25_ = g_strdup (_ ("Track Number"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp26_ = g_strdup ("track-count");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp27_ = g_strdup (_ ("Track Count"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp28_ = g_strdup ("nominal-bitrate");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp29_ = g_strdup (_ ("Nominal Bitrate"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp30_ = g_strdup ("minimum-bitrate");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp31_ = g_strdup (_ ("Minimum Bitrate"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp32_ = g_strdup ("maximum-bitrate");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp33_ = g_strdup (_ ("Maximim Bitrate"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp34_ = g_strdup ("container-format");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp35_ = g_strdup ("Container Format");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp36_ = g_strdup ("application-name");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp37_ = g_strdup (_ ("Application Name"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp38_ = g_strdup ("encoder");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp39_ = g_strdup (_ ("Encoder"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp40_ = g_strdup ("encoder-version");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp41_ = g_strdup (_ ("Encoder Version"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp42_ = g_strdup ("datetime");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp43_ = g_strdup (_ ("Date Time"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp44_ = g_strdup ("private-data");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp45_ = g_strdup (_ ("Private Data"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp46_ = g_strdup ("has-crc");
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp47_ = g_strdup (_ ("Has CRC"));
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_ = g_new0 (gchar*, (24 * 2) + 1);
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[0] = _tmp0_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[1] = _tmp1_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[2] = _tmp2_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[3] = _tmp3_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[4] = _tmp4_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[5] = _tmp5_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[6] = _tmp6_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[7] = _tmp7_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[8] = _tmp8_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[9] = _tmp9_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[10] = _tmp10_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[11] = _tmp11_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[12] = _tmp12_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[13] = _tmp13_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[14] = _tmp14_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[15] = _tmp15_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[16] = _tmp16_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[17] = _tmp17_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[18] = _tmp18_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[19] = _tmp19_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[20] = _tmp20_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[21] = _tmp21_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[22] = _tmp22_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[23] = _tmp23_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[24] = _tmp24_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[25] = _tmp25_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[26] = _tmp26_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[27] = _tmp27_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[28] = _tmp28_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[29] = _tmp29_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[30] = _tmp30_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[31] = _tmp31_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[32] = _tmp32_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[33] = _tmp33_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[34] = _tmp34_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[35] = _tmp35_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[36] = _tmp36_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[37] = _tmp37_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[38] = _tmp38_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[39] = _tmp39_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[40] = _tmp40_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[41] = _tmp41_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[42] = _tmp42_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[43] = _tmp43_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[44] = _tmp44_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[45] = _tmp45_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[46] = _tmp46_;
#line 20 "../src/Models/StreamMetadata.vala"
	_tmp48_[47] = _tmp47_;
#line 20 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_METADATA_TITLES = _tmp48_;
#line 20 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_METADATA_TITLES_length1 = 24;
#line 20 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_METADATA_TITLES_length2 = 2;
#line 49 "../src/Models/StreamMetadata.vala"
	_tmp49_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 49 "../src/Models/StreamMetadata.vala"
	tuner_model_metadata_METADATA_TAGS = (GeeList*) _tmp49_;
#line 53 "../src/Models/StreamMetadata.vala"
	tag_index = (guint8) 0;
#line 54 "../src/Models/StreamMetadata.vala"
	_tmp50_ = tuner_model_metadata_METADATA_TITLES;
#line 54 "../src/Models/StreamMetadata.vala"
	_tmp50__length1 = tuner_model_metadata_METADATA_TITLES_length1;
#line 54 "../src/Models/StreamMetadata.vala"
	_tmp50__length2 = tuner_model_metadata_METADATA_TITLES_length2;
#line 1728 "StreamMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint tag_collection_length2 = 0;
		gint tag_it = 0;
#line 54 "../src/Models/StreamMetadata.vala"
		tag_collection = _tmp50_;
#line 54 "../src/Models/StreamMetadata.vala"
		tag_collection_length1 = _tmp50__length1 * _tmp50__length2;
#line 54 "../src/Models/StreamMetadata.vala"
		for (tag_it = 0; tag_it < tag_collection_length1; tag_it = tag_it + 1) {
#line 1740 "StreamMetadata.c"
			gchar* _tmp51_;
			gchar* tag = NULL;
#line 54 "../src/Models/StreamMetadata.vala"
			_tmp51_ = g_strdup (tag_collection[tag_it]);
#line 54 "../src/Models/StreamMetadata.vala"
			tag = _tmp51_;
#line 1747 "StreamMetadata.c"
			{
				guint8 _tmp52_;
#line 57 "../src/Models/StreamMetadata.vala"
				_tmp52_ = tag_index;
#line 57 "../src/Models/StreamMetadata.vala"
				tag_index = _tmp52_ + 1;
#line 57 "../src/Models/StreamMetadata.vala"
				if ((_tmp52_ % 2) == 0) {
#line 1756 "StreamMetadata.c"
					GeeList* _tmp53_;
					const gchar* _tmp54_;
#line 58 "../src/Models/StreamMetadata.vala"
					_tmp53_ = tuner_model_metadata_METADATA_TAGS;
#line 58 "../src/Models/StreamMetadata.vala"
					_tmp54_ = tag;
#line 58 "../src/Models/StreamMetadata.vala"
					gee_list_insert (_tmp53_, tag_index / 2, _tmp54_);
#line 1765 "StreamMetadata.c"
				}
#line 54 "../src/Models/StreamMetadata.vala"
				_g_free0 (tag);
#line 1769 "StreamMetadata.c"
			}
		}
	}
}

static void
tuner_model_metadata_instance_init (TunerModelMetadata * self,
                                    gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GeeHashMap* _tmp9_;
#line 18 "../src/Models/StreamMetadata.vala"
	self->priv = tuner_model_metadata_get_instance_private (self);
#line 62 "../src/Models/StreamMetadata.vala"
	_tmp0_ = g_strdup ("");
#line 62 "../src/Models/StreamMetadata.vala"
	self->priv->_all_tags = _tmp0_;
#line 63 "../src/Models/StreamMetadata.vala"
	_tmp1_ = g_strdup ("");
#line 63 "../src/Models/StreamMetadata.vala"
	self->priv->_title = _tmp1_;
#line 64 "../src/Models/StreamMetadata.vala"
	_tmp2_ = g_strdup ("");
#line 64 "../src/Models/StreamMetadata.vala"
	self->priv->_artist = _tmp2_;
#line 65 "../src/Models/StreamMetadata.vala"
	_tmp3_ = g_strdup ("");
#line 65 "../src/Models/StreamMetadata.vala"
	self->priv->_image = _tmp3_;
#line 66 "../src/Models/StreamMetadata.vala"
	_tmp4_ = g_strdup ("");
#line 66 "../src/Models/StreamMetadata.vala"
	self->priv->_genre = _tmp4_;
#line 67 "../src/Models/StreamMetadata.vala"
	_tmp5_ = g_strdup ("");
#line 67 "../src/Models/StreamMetadata.vala"
	self->priv->_homepage = _tmp5_;
#line 68 "../src/Models/StreamMetadata.vala"
	_tmp6_ = g_strdup ("");
#line 68 "../src/Models/StreamMetadata.vala"
	self->priv->_audio_info = _tmp6_;
#line 69 "../src/Models/StreamMetadata.vala"
	_tmp7_ = g_strdup ("");
#line 69 "../src/Models/StreamMetadata.vala"
	self->priv->_org_loc = _tmp7_;
#line 70 "../src/Models/StreamMetadata.vala"
	_tmp8_ = g_strdup ("");
#line 70 "../src/Models/StreamMetadata.vala"
	self->priv->_pretty_print = _tmp8_;
#line 72 "../src/Models/StreamMetadata.vala"
	_tmp9_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 72 "../src/Models/StreamMetadata.vala"
	self->priv->_metadata_values = (GeeMap*) _tmp9_;
#line 1831 "StreamMetadata.c"
}

static void
tuner_model_metadata_finalize (GObject * obj)
{
	TunerModelMetadata * self;
#line 18 "../src/Models/StreamMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_MODEL_TYPE_METADATA, TunerModelMetadata);
#line 62 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_all_tags);
#line 63 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_title);
#line 64 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_artist);
#line 65 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_image);
#line 66 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_genre);
#line 67 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_homepage);
#line 68 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_audio_info);
#line 69 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_org_loc);
#line 70 "../src/Models/StreamMetadata.vala"
	_g_free0 (self->priv->_pretty_print);
#line 72 "../src/Models/StreamMetadata.vala"
	_g_object_unref0 (self->priv->_metadata_values);
#line 18 "../src/Models/StreamMetadata.vala"
	G_OBJECT_CLASS (tuner_model_metadata_parent_class)->finalize (obj);
#line 1862 "StreamMetadata.c"
}

/**
 * @class Metadata
 *
 * @brief Stream Metadata transform
 *
 */
static GType
tuner_model_metadata_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerModelMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_model_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerModelMetadata), 0, (GInstanceInitFunc) tuner_model_metadata_instance_init, NULL };
	GType tuner_model_metadata_type_id;
	tuner_model_metadata_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerModelMetadata", &g_define_type_info, 0);
	TunerModelMetadata_private_offset = g_type_add_instance_private (tuner_model_metadata_type_id, sizeof (TunerModelMetadataPrivate));
	return tuner_model_metadata_type_id;
}

GType
tuner_model_metadata_get_type (void)
{
	static volatile gsize tuner_model_metadata_type_id__once = 0;
	if (g_once_init_enter (&tuner_model_metadata_type_id__once)) {
		GType tuner_model_metadata_type_id;
		tuner_model_metadata_type_id = tuner_model_metadata_get_type_once ();
		g_once_init_leave (&tuner_model_metadata_type_id__once, tuner_model_metadata_type_id);
	}
	return tuner_model_metadata_type_id__once;
}

static void
_vala_tuner_model_metadata_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	TunerModelMetadata * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_METADATA, TunerModelMetadata);
#line 18 "../src/Models/StreamMetadata.vala"
	switch (property_id) {
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_all_tags (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_TITLE_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_title (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_ARTIST_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_artist (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_IMAGE_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_image (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_GENRE_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_genre (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_homepage (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_audio_info (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_ORG_LOC_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_org_loc (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		g_value_set_string (value, tuner_model_metadata_get_pretty_print (self));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 1957 "StreamMetadata.c"
		default:
#line 18 "../src/Models/StreamMetadata.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 1963 "StreamMetadata.c"
	}
}

static void
_vala_tuner_model_metadata_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	TunerModelMetadata * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_MODEL_TYPE_METADATA, TunerModelMetadata);
#line 18 "../src/Models/StreamMetadata.vala"
	switch (property_id) {
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_ALL_TAGS_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_all_tags (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_TITLE_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_title (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_ARTIST_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_artist (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_IMAGE_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_image (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_GENRE_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_genre (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_HOMEPAGE_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_homepage (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_AUDIO_INFO_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_audio_info (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_ORG_LOC_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_org_loc (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 18 "../src/Models/StreamMetadata.vala"
		case TUNER_MODEL_METADATA_PRETTY_PRINT_PROPERTY:
#line 18 "../src/Models/StreamMetadata.vala"
		tuner_model_metadata_set_pretty_print (self, g_value_get_string (value));
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 2031 "StreamMetadata.c"
		default:
#line 18 "../src/Models/StreamMetadata.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Models/StreamMetadata.vala"
		break;
#line 2037 "StreamMetadata.c"
	}
}

