/* PreferencesPopover.c generated by valac 0.56.17, the Vala compiler
 * generated from PreferencesPopover.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file PreferencesPopover.vala
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <gdk/gdk.h>

#define TUNER_WINDOW_ACTION_PREFIX "win."
#define TUNER_WINDOW_ACTION_ABOUT "action_about"
#define TUNER_WINDOW_ACTION_DISABLE_TRACKING "action_disable_tracking"
#define TUNER_WINDOW_ACTION_ENABLE_AUTOPLAY "action_enable_autoplay"
#define TUNER_WINDOW_ACTION_START_ON_STARRED "action_starred_start"
#define TUNER_WINDOW_ACTION_STREAM_INFO "action_stream_info"
#define TUNER_WINDOW_ACTION_STREAM_INFO_FAST "action_stream_info_fast"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_PREFERENCES_POPOVER (tuner_preferences_popover_get_type ())
#define TUNER_PREFERENCES_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_PREFERENCES_POPOVER, TunerPreferencesPopover))
#define TUNER_PREFERENCES_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_PREFERENCES_POPOVER, TunerPreferencesPopoverClass))
#define TUNER_IS_PREFERENCES_POPOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_PREFERENCES_POPOVER))
#define TUNER_IS_PREFERENCES_POPOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_PREFERENCES_POPOVER))
#define TUNER_PREFERENCES_POPOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_PREFERENCES_POPOVER, TunerPreferencesPopoverClass))

typedef struct _TunerPreferencesPopover TunerPreferencesPopover;
typedef struct _TunerPreferencesPopoverClass TunerPreferencesPopoverClass;
typedef struct _TunerPreferencesPopoverPrivate TunerPreferencesPopoverPrivate;
enum  {
	TUNER_PREFERENCES_POPOVER_0_PROPERTY,
	TUNER_PREFERENCES_POPOVER_NUM_PROPERTIES
};
static GParamSpec* tuner_preferences_popover_properties[TUNER_PREFERENCES_POPOVER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;

#define TUNER_TYPE_STAR_STORE (tuner_star_store_get_type ())
#define TUNER_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STAR_STORE, TunerStarStore))
#define TUNER_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))
#define TUNER_IS_STAR_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STAR_STORE))
#define TUNER_IS_STAR_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STAR_STORE))
#define TUNER_STAR_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STAR_STORE, TunerStarStoreClass))

typedef struct _TunerStarStore TunerStarStore;
typedef struct _TunerStarStoreClass TunerStarStoreClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TUNER_TYPE_WINDOW (tuner_window_get_type ())
#define TUNER_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_WINDOW, TunerWindow))
#define TUNER_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_WINDOW, TunerWindowClass))
#define TUNER_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_WINDOW))
#define TUNER_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_WINDOW))
#define TUNER_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_WINDOW, TunerWindowClass))

typedef struct _TunerWindow TunerWindow;
typedef struct _TunerWindowClass TunerWindowClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	TUNER_THEME_SYSTEM,
	TUNER_THEME_LIGHT,
	TUNER_THEME_DARK
} TunerTHEME;

#define TUNER_TYPE_THEME (tuner_theme_get_type ())

#define TUNER_TYPE_SETTINGS (tuner_settings_get_type ())
#define TUNER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_SETTINGS, TunerSettings))
#define TUNER_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_SETTINGS, TunerSettingsClass))
#define TUNER_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_SETTINGS))
#define TUNER_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_SETTINGS))
#define TUNER_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_SETTINGS, TunerSettingsClass))

typedef struct _TunerSettings TunerSettings;
typedef struct _TunerSettingsClass TunerSettingsClass;

struct _TunerPreferencesPopover {
	GtkPopover parent_instance;
	TunerPreferencesPopoverPrivate * priv;
};

struct _TunerPreferencesPopoverClass {
	GtkPopoverClass parent_class;
};

static gpointer tuner_preferences_popover_parent_class = NULL;
VALA_EXTERN GeeCollection* tuner_application_LANGUAGES;

VALA_EXTERN GType tuner_preferences_popover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerPreferencesPopover, g_object_unref)
VALA_EXTERN void tuner_preferences_popover_export_m3u8 (TunerPreferencesPopover* self);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN GType tuner_star_store_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStarStore, g_object_unref)
VALA_EXTERN TunerStarStore* tuner_application_get_stars (TunerApplication* self);
VALA_EXTERN gchar* tuner_star_store_export_m3u8 (TunerStarStore* self);
VALA_EXTERN void tuner_preferences_popover_import_stationuuids (TunerPreferencesPopover* self);
VALA_EXTERN GType tuner_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerWindow, g_object_unref)
VALA_EXTERN TunerWindow* tuner_application_get_window (TunerApplication* self);
VALA_EXTERN void tuner_star_store_import_stationuuids (TunerStarStore* self,
                                           GDataInputStream* data_stream,
                                           GError** error);
VALA_EXTERN TunerPreferencesPopover* tuner_preferences_popover_new (void);
VALA_EXTERN TunerPreferencesPopover* tuner_preferences_popover_construct (GType object_type);
static GObject * tuner_preferences_popover_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
VALA_EXTERN GType tuner_theme_get_type (void) G_GNUC_CONST ;
VALA_EXTERN const gchar* tuner_theme_get_name (TunerTHEME self);
VALA_EXTERN GType tuner_settings_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerSettings, g_object_unref)
VALA_EXTERN TunerSettings* tuner_application_get_settings (TunerApplication* self);
VALA_EXTERN const gchar* tuner_settings_get_theme_mode (TunerSettings* self);
static void _tuner_preferences_popover___lambda51_ (TunerPreferencesPopover* self,
                                             GtkComboBox* elem);
VALA_EXTERN void tuner_apply_theme_name (const gchar* requested_theme);
VALA_EXTERN void tuner_settings_set_theme_mode (TunerSettings* self,
                                    const gchar* value);
static void __tuner_preferences_popover___lambda51__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                    gpointer self);
VALA_EXTERN const gchar* tuner_settings_get_language (TunerSettings* self);
static void _tuner_preferences_popover___lambda52_ (TunerPreferencesPopover* self,
                                             GtkComboBox* elem);
VALA_EXTERN void tuner_application_set_language (TunerApplication* self,
                                     const gchar* value);
static void __tuner_preferences_popover___lambda52__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                    gpointer self);
static gboolean _tuner_preferences_popover___lambda53_ (TunerPreferencesPopover* self);
static gboolean __tuner_preferences_popover___lambda53__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                GdkEventButton* event,
                                                                                gpointer self);
static gboolean _tuner_preferences_popover___lambda54_ (TunerPreferencesPopover* self);
static gboolean __tuner_preferences_popover___lambda54__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                GdkEventButton* event,
                                                                                gpointer self);
static GType tuner_preferences_popover_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

/**
 * @brief Export Starred Stations as a m3u playlist
 *
 *
 */
void
tuner_preferences_popover_export_m3u8 (TunerPreferencesPopover* self)
{
	GError* _inner_error0_ = NULL;
#line 162 "../src/Widgets/PreferencesPopover.vala"
	g_return_if_fail (self != NULL);
#line 193 "PreferencesPopover.c"
	{
		gchar* temp_file = NULL;
		gchar* _tmp0_ = NULL;
		const gchar* _tmp1_;
		TunerApplication* _tmp2_;
		TunerApplication* _tmp3_;
		TunerStarStore* _tmp4_;
		TunerStarStore* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GtkFileChooserDialog* dialog = NULL;
		GtkFileChooserDialog* _tmp8_;
		GtkFileChooserDialog* _tmp9_;
		GtkFileChooserDialog* _tmp10_;
		GtkFileChooserDialog* _tmp11_;
		GtkFileChooserDialog* _tmp12_;
		GtkFileChooserDialog* _tmp21_;
#line 167 "../src/Widgets/PreferencesPopover.vala"
		g_file_open_tmp ("XXXXXX.starred.m3u8", &_tmp0_, &_inner_error0_);
#line 167 "../src/Widgets/PreferencesPopover.vala"
		_g_free0 (temp_file);
#line 167 "../src/Widgets/PreferencesPopover.vala"
		temp_file = _tmp0_;
#line 167 "../src/Widgets/PreferencesPopover.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "../src/Widgets/PreferencesPopover.vala"
			_g_free0 (temp_file);
#line 221 "PreferencesPopover.c"
			goto __catch0_g_error;
		}
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_tmp1_ = temp_file;
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_tmp2_ = tuner_app ();
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_tmp3_ = _tmp2_;
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_tmp4_ = tuner_application_get_stars (_tmp3_);
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_tmp5_ = _tmp4_;
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_tmp6_ = tuner_star_store_export_m3u8 (_tmp5_);
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_tmp7_ = _tmp6_;
#line 168 "../src/Widgets/PreferencesPopover.vala"
		g_file_set_contents (_tmp1_, _tmp7_, (gssize) -1, &_inner_error0_);
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_g_free0 (_tmp7_);
#line 168 "../src/Widgets/PreferencesPopover.vala"
		_g_object_unref0 (_tmp3_);
#line 168 "../src/Widgets/PreferencesPopover.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 168 "../src/Widgets/PreferencesPopover.vala"
			_g_free0 (temp_file);
#line 248 "PreferencesPopover.c"
			goto __catch0_g_error;
		}
#line 171 "../src/Widgets/PreferencesPopover.vala"
		_tmp8_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new ("Save File", NULL, GTK_FILE_CHOOSER_ACTION_SAVE, NULL);
#line 171 "../src/Widgets/PreferencesPopover.vala"
		g_object_ref_sink (_tmp8_);
#line 171 "../src/Widgets/PreferencesPopover.vala"
		dialog = _tmp8_;
#line 178 "../src/Widgets/PreferencesPopover.vala"
		_tmp9_ = dialog;
#line 178 "../src/Widgets/PreferencesPopover.vala"
		gtk_dialog_add_button ((GtkDialog*) _tmp9_, "_Cancel", (gint) GTK_RESPONSE_CANCEL);
#line 179 "../src/Widgets/PreferencesPopover.vala"
		_tmp10_ = dialog;
#line 179 "../src/Widgets/PreferencesPopover.vala"
		gtk_dialog_add_button ((GtkDialog*) _tmp10_, "_Save", (gint) GTK_RESPONSE_ACCEPT);
#line 182 "../src/Widgets/PreferencesPopover.vala"
		_tmp11_ = dialog;
#line 182 "../src/Widgets/PreferencesPopover.vala"
		gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp11_, "tuner-starred.m3u8");
#line 184 "../src/Widgets/PreferencesPopover.vala"
		_tmp12_ = dialog;
#line 184 "../src/Widgets/PreferencesPopover.vala"
		if (gtk_dialog_run ((GtkDialog*) _tmp12_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 273 "PreferencesPopover.c"
			gchar* save_path = NULL;
			GtkFileChooserDialog* _tmp13_;
			gchar* _tmp14_;
			GFile* source_file = NULL;
			const gchar* _tmp15_;
			GFile* _tmp16_;
			GFile* dest_file = NULL;
			const gchar* _tmp17_;
			GFile* _tmp18_;
			GFile* _tmp19_;
			GFile* _tmp20_;
#line 186 "../src/Widgets/PreferencesPopover.vala"
			_tmp13_ = dialog;
#line 186 "../src/Widgets/PreferencesPopover.vala"
			_tmp14_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp13_);
#line 186 "../src/Widgets/PreferencesPopover.vala"
			save_path = _tmp14_;
#line 188 "../src/Widgets/PreferencesPopover.vala"
			_tmp15_ = temp_file;
#line 188 "../src/Widgets/PreferencesPopover.vala"
			_tmp16_ = g_file_new_for_path (_tmp15_);
#line 188 "../src/Widgets/PreferencesPopover.vala"
			source_file = _tmp16_;
#line 189 "../src/Widgets/PreferencesPopover.vala"
			_tmp17_ = save_path;
#line 189 "../src/Widgets/PreferencesPopover.vala"
			_tmp18_ = g_file_new_for_path (_tmp17_);
#line 189 "../src/Widgets/PreferencesPopover.vala"
			dest_file = _tmp18_;
#line 190 "../src/Widgets/PreferencesPopover.vala"
			_tmp19_ = source_file;
#line 190 "../src/Widgets/PreferencesPopover.vala"
			_tmp20_ = dest_file;
#line 190 "../src/Widgets/PreferencesPopover.vala"
			g_file_copy (_tmp19_, _tmp20_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 190 "../src/Widgets/PreferencesPopover.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (dest_file);
#line 190 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (source_file);
#line 190 "../src/Widgets/PreferencesPopover.vala"
				_g_free0 (save_path);
#line 190 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (dialog);
#line 190 "../src/Widgets/PreferencesPopover.vala"
				_g_free0 (temp_file);
#line 321 "PreferencesPopover.c"
				goto __catch0_g_error;
			}
#line 184 "../src/Widgets/PreferencesPopover.vala"
			_g_object_unref0 (dest_file);
#line 184 "../src/Widgets/PreferencesPopover.vala"
			_g_object_unref0 (source_file);
#line 184 "../src/Widgets/PreferencesPopover.vala"
			_g_free0 (save_path);
#line 330 "PreferencesPopover.c"
		}
#line 193 "../src/Widgets/PreferencesPopover.vala"
		_tmp21_ = dialog;
#line 193 "../src/Widgets/PreferencesPopover.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp21_);
#line 164 "../src/Widgets/PreferencesPopover.vala"
		_g_object_unref0 (dialog);
#line 164 "../src/Widgets/PreferencesPopover.vala"
		_g_free0 (temp_file);
#line 340 "PreferencesPopover.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 164 "../src/Widgets/PreferencesPopover.vala"
		g_clear_error (&_inner_error0_);
#line 197 "../src/Widgets/PreferencesPopover.vala"
		g_warning ("PreferencesPopover.vala:197: Error: $(e.message)");
#line 349 "PreferencesPopover.c"
	}
	__finally0:
#line 164 "../src/Widgets/PreferencesPopover.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../src/Widgets/PreferencesPopover.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../src/Widgets/PreferencesPopover.vala"
		g_clear_error (&_inner_error0_);
#line 164 "../src/Widgets/PreferencesPopover.vala"
		return;
#line 360 "PreferencesPopover.c"
	}
}

/**
 * @brief Select and read a file for Station UUIDs to be imported as Satrred
 *
 *
 */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 379 "PreferencesPopover.c"
}

void
tuner_preferences_popover_import_stationuuids (TunerPreferencesPopover* self)
{
	GtkFileChooserDialog* dialog = NULL;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	TunerWindow* _tmp2_;
	TunerWindow* _tmp3_;
	GtkFileChooserDialog* _tmp4_;
	GtkFileChooserDialog* _tmp5_;
	gchar* filepath = NULL;
	GtkFileChooserDialog* _tmp6_;
	GtkFileChooserDialog* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 207 "../src/Widgets/PreferencesPopover.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/Widgets/PreferencesPopover.vala"
	_tmp0_ = tuner_app ();
#line 209 "../src/Widgets/PreferencesPopover.vala"
	_tmp1_ = _tmp0_;
#line 209 "../src/Widgets/PreferencesPopover.vala"
	_tmp2_ = tuner_application_get_window (_tmp1_);
#line 209 "../src/Widgets/PreferencesPopover.vala"
	_tmp3_ = _tmp2_;
#line 209 "../src/Widgets/PreferencesPopover.vala"
	_tmp4_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Choose a file"), (GtkWindow*) _tmp3_, GTK_FILE_CHOOSER_ACTION_OPEN, "_Cancel", GTK_RESPONSE_CANCEL, "_Open", GTK_RESPONSE_ACCEPT, NULL);
#line 209 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp4_);
#line 209 "../src/Widgets/PreferencesPopover.vala"
	_tmp5_ = _tmp4_;
#line 209 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp1_);
#line 209 "../src/Widgets/PreferencesPopover.vala"
	dialog = _tmp5_;
#line 218 "../src/Widgets/PreferencesPopover.vala"
	_tmp6_ = dialog;
#line 218 "../src/Widgets/PreferencesPopover.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp6_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 420 "PreferencesPopover.c"
		GtkFileChooserDialog* _tmp7_;
		gchar* _tmp8_;
#line 220 "../src/Widgets/PreferencesPopover.vala"
		_tmp7_ = dialog;
#line 220 "../src/Widgets/PreferencesPopover.vala"
		_tmp8_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp7_);
#line 220 "../src/Widgets/PreferencesPopover.vala"
		_g_free0 (filepath);
#line 220 "../src/Widgets/PreferencesPopover.vala"
		filepath = _tmp8_;
#line 431 "PreferencesPopover.c"
		{
			GFile* file = NULL;
			const gchar* _tmp9_;
			GFile* _tmp10_;
			GFileInputStream* stream = NULL;
			GFile* _tmp11_;
			GFileInputStream* _tmp12_;
			GDataInputStream* data_stream = NULL;
			GFileInputStream* _tmp13_;
			GDataInputStream* _tmp14_;
			TunerApplication* _tmp15_;
			TunerApplication* _tmp16_;
			TunerStarStore* _tmp17_;
			TunerStarStore* _tmp18_;
			GDataInputStream* _tmp19_;
			GFileInputStream* _tmp20_;
#line 224 "../src/Widgets/PreferencesPopover.vala"
			_tmp9_ = filepath;
#line 224 "../src/Widgets/PreferencesPopover.vala"
			_tmp10_ = g_file_new_for_path (_tmp9_);
#line 224 "../src/Widgets/PreferencesPopover.vala"
			file = _tmp10_;
#line 225 "../src/Widgets/PreferencesPopover.vala"
			_tmp11_ = file;
#line 225 "../src/Widgets/PreferencesPopover.vala"
			_tmp12_ = g_file_read (_tmp11_, NULL, &_inner_error0_);
#line 225 "../src/Widgets/PreferencesPopover.vala"
			stream = _tmp12_;
#line 225 "../src/Widgets/PreferencesPopover.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 225 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (file);
#line 464 "PreferencesPopover.c"
				goto __catch0_g_error;
			}
#line 228 "../src/Widgets/PreferencesPopover.vala"
			_tmp13_ = stream;
#line 228 "../src/Widgets/PreferencesPopover.vala"
			_tmp14_ = g_data_input_stream_new ((GInputStream*) _tmp13_);
#line 228 "../src/Widgets/PreferencesPopover.vala"
			data_stream = _tmp14_;
#line 230 "../src/Widgets/PreferencesPopover.vala"
			_tmp15_ = tuner_app ();
#line 230 "../src/Widgets/PreferencesPopover.vala"
			_tmp16_ = _tmp15_;
#line 230 "../src/Widgets/PreferencesPopover.vala"
			_tmp17_ = tuner_application_get_stars (_tmp16_);
#line 230 "../src/Widgets/PreferencesPopover.vala"
			_tmp18_ = _tmp17_;
#line 230 "../src/Widgets/PreferencesPopover.vala"
			_tmp19_ = data_stream;
#line 230 "../src/Widgets/PreferencesPopover.vala"
			tuner_star_store_import_stationuuids (_tmp18_, _tmp19_, &_inner_error0_);
#line 230 "../src/Widgets/PreferencesPopover.vala"
			_g_object_unref0 (_tmp16_);
#line 230 "../src/Widgets/PreferencesPopover.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (data_stream);
#line 230 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (stream);
#line 230 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (file);
#line 495 "PreferencesPopover.c"
				goto __catch0_g_error;
			}
#line 232 "../src/Widgets/PreferencesPopover.vala"
			_tmp20_ = stream;
#line 232 "../src/Widgets/PreferencesPopover.vala"
			g_input_stream_close ((GInputStream*) _tmp20_, NULL, &_inner_error0_);
#line 232 "../src/Widgets/PreferencesPopover.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 232 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (data_stream);
#line 232 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (stream);
#line 232 "../src/Widgets/PreferencesPopover.vala"
				_g_object_unref0 (file);
#line 510 "PreferencesPopover.c"
				goto __catch0_g_error;
			}
#line 222 "../src/Widgets/PreferencesPopover.vala"
			_g_object_unref0 (data_stream);
#line 222 "../src/Widgets/PreferencesPopover.vala"
			_g_object_unref0 (stream);
#line 222 "../src/Widgets/PreferencesPopover.vala"
			_g_object_unref0 (file);
#line 519 "PreferencesPopover.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 222 "../src/Widgets/PreferencesPopover.vala"
			e = _inner_error0_;
#line 222 "../src/Widgets/PreferencesPopover.vala"
			_inner_error0_ = NULL;
#line 235 "../src/Widgets/PreferencesPopover.vala"
			_tmp21_ = e;
#line 235 "../src/Widgets/PreferencesPopover.vala"
			_tmp22_ = _tmp21_->message;
#line 235 "../src/Widgets/PreferencesPopover.vala"
			_tmp23_ = string_to_string (_tmp22_);
#line 235 "../src/Widgets/PreferencesPopover.vala"
			_tmp24_ = g_strconcat ("Error reading file: ", _tmp23_, NULL);
#line 235 "../src/Widgets/PreferencesPopover.vala"
			_tmp25_ = _tmp24_;
#line 235 "../src/Widgets/PreferencesPopover.vala"
			g_warning ("PreferencesPopover.vala:235: %s", _tmp25_);
#line 235 "../src/Widgets/PreferencesPopover.vala"
			_g_free0 (_tmp25_);
#line 222 "../src/Widgets/PreferencesPopover.vala"
			_g_error_free0 (e);
#line 550 "PreferencesPopover.c"
		}
		__finally0:
#line 222 "../src/Widgets/PreferencesPopover.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/Widgets/PreferencesPopover.vala"
			_g_free0 (filepath);
#line 222 "../src/Widgets/PreferencesPopover.vala"
			_g_object_unref0 (dialog);
#line 222 "../src/Widgets/PreferencesPopover.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/Widgets/PreferencesPopover.vala"
			g_clear_error (&_inner_error0_);
#line 222 "../src/Widgets/PreferencesPopover.vala"
			return;
#line 565 "PreferencesPopover.c"
		}
	}
#line 239 "../src/Widgets/PreferencesPopover.vala"
	_tmp26_ = dialog;
#line 239 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp26_);
#line 207 "../src/Widgets/PreferencesPopover.vala"
	_g_free0 (filepath);
#line 207 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (dialog);
#line 576 "PreferencesPopover.c"
}

TunerPreferencesPopover*
tuner_preferences_popover_construct (GType object_type)
{
	TunerPreferencesPopover * self = NULL;
#line 15 "../src/Widgets/PreferencesPopover.vala"
	self = (TunerPreferencesPopover*) g_object_new (object_type, NULL);
#line 15 "../src/Widgets/PreferencesPopover.vala"
	return self;
#line 587 "PreferencesPopover.c"
}

TunerPreferencesPopover*
tuner_preferences_popover_new (void)
{
#line 15 "../src/Widgets/PreferencesPopover.vala"
	return tuner_preferences_popover_construct (TUNER_TYPE_PREFERENCES_POPOVER);
#line 595 "PreferencesPopover.c"
}

static void
_tuner_preferences_popover___lambda51_ (TunerPreferencesPopover* self,
                                        GtkComboBox* elem)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	TunerApplication* _tmp2_;
	TunerApplication* _tmp3_;
	TunerSettings* _tmp4_;
	TunerSettings* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 38 "../src/Widgets/PreferencesPopover.vala"
	g_return_if_fail (elem != NULL);
#line 39 "../src/Widgets/PreferencesPopover.vala"
	_tmp0_ = gtk_combo_box_get_active_id (elem);
#line 39 "../src/Widgets/PreferencesPopover.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/Widgets/PreferencesPopover.vala"
	tuner_apply_theme_name (_tmp1_);
#line 40 "../src/Widgets/PreferencesPopover.vala"
	_tmp2_ = tuner_app ();
#line 40 "../src/Widgets/PreferencesPopover.vala"
	_tmp3_ = _tmp2_;
#line 40 "../src/Widgets/PreferencesPopover.vala"
	_tmp4_ = tuner_application_get_settings (_tmp3_);
#line 40 "../src/Widgets/PreferencesPopover.vala"
	_tmp5_ = _tmp4_;
#line 40 "../src/Widgets/PreferencesPopover.vala"
	_tmp6_ = gtk_combo_box_get_active_id (elem);
#line 40 "../src/Widgets/PreferencesPopover.vala"
	_tmp7_ = _tmp6_;
#line 40 "../src/Widgets/PreferencesPopover.vala"
	tuner_settings_set_theme_mode (_tmp5_, _tmp7_);
#line 40 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp3_);
#line 634 "PreferencesPopover.c"
}

static void
__tuner_preferences_popover___lambda51__gtk_combo_box_changed (GtkComboBox* _sender,
                                                               gpointer self)
{
#line 38 "../src/Widgets/PreferencesPopover.vala"
	_tuner_preferences_popover___lambda51_ ((TunerPreferencesPopover*) self, _sender);
#line 643 "PreferencesPopover.c"
}

static void
_tuner_preferences_popover___lambda52_ (TunerPreferencesPopover* self,
                                        GtkComboBox* elem)
{
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 89 "../src/Widgets/PreferencesPopover.vala"
	g_return_if_fail (elem != NULL);
#line 90 "../src/Widgets/PreferencesPopover.vala"
	_tmp0_ = tuner_app ();
#line 90 "../src/Widgets/PreferencesPopover.vala"
	_tmp1_ = _tmp0_;
#line 90 "../src/Widgets/PreferencesPopover.vala"
	_tmp2_ = gtk_combo_box_get_active_id (elem);
#line 90 "../src/Widgets/PreferencesPopover.vala"
	_tmp3_ = _tmp2_;
#line 90 "../src/Widgets/PreferencesPopover.vala"
	tuner_application_set_language (_tmp1_, _tmp3_);
#line 90 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp1_);
#line 668 "PreferencesPopover.c"
}

static void
__tuner_preferences_popover___lambda52__gtk_combo_box_changed (GtkComboBox* _sender,
                                                               gpointer self)
{
#line 89 "../src/Widgets/PreferencesPopover.vala"
	_tuner_preferences_popover___lambda52_ ((TunerPreferencesPopover*) self, _sender);
#line 677 "PreferencesPopover.c"
}

static gboolean
_tuner_preferences_popover___lambda53_ (TunerPreferencesPopover* self)
{
#line 99 "../src/Widgets/PreferencesPopover.vala"
	tuner_preferences_popover_export_m3u8 (self);
#line 685 "PreferencesPopover.c"
}

static gboolean
__tuner_preferences_popover___lambda53__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self)
{
	gboolean result;
	result = _tuner_preferences_popover___lambda53_ ((TunerPreferencesPopover*) self);
#line 97 "../src/Widgets/PreferencesPopover.vala"
	return result;
#line 697 "PreferencesPopover.c"
}

static gboolean
_tuner_preferences_popover___lambda54_ (TunerPreferencesPopover* self)
{
#line 108 "../src/Widgets/PreferencesPopover.vala"
	tuner_preferences_popover_import_stationuuids (self);
#line 705 "PreferencesPopover.c"
}

static gboolean
__tuner_preferences_popover___lambda54__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self)
{
	gboolean result;
	result = _tuner_preferences_popover___lambda54_ ((TunerPreferencesPopover*) self);
#line 106 "../src/Widgets/PreferencesPopover.vala"
	return result;
#line 717 "PreferencesPopover.c"
}

static GObject *
tuner_preferences_popover_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerPreferencesPopover * self;
	GtkModelButton* about_menuitem = NULL;
	GtkModelButton* _tmp0_;
	GtkModelButton* _tmp1_;
	GtkModelButton* _tmp2_;
	GtkModelButton* disable_tracking_item = NULL;
	GtkModelButton* _tmp3_;
	GtkModelButton* _tmp4_;
	GtkModelButton* _tmp5_;
	GtkModelButton* _tmp6_;
	GtkComboBoxText* theme_combo = NULL;
	GtkComboBoxText* _tmp7_;
	GtkComboBoxText* _tmp8_;
	const gchar* _tmp9_;
	GtkComboBoxText* _tmp10_;
	const gchar* _tmp11_;
	GtkComboBoxText* _tmp12_;
	const gchar* _tmp13_;
	GtkComboBoxText* _tmp14_;
	GtkComboBoxText* _tmp15_;
	TunerApplication* _tmp16_;
	TunerApplication* _tmp17_;
	TunerSettings* _tmp18_;
	TunerSettings* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GtkComboBoxText* _tmp22_;
	GtkBox* theme_box = NULL;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkComboBoxText* _tmp25_;
	GtkBox* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkModelButton* autoplay_item = NULL;
	GtkModelButton* _tmp29_;
	GtkModelButton* _tmp30_;
	GtkModelButton* _tmp31_;
	GtkModelButton* _tmp32_;
	GtkModelButton* start_on_starred = NULL;
	GtkModelButton* _tmp33_;
	GtkModelButton* _tmp34_;
	GtkModelButton* _tmp35_;
	GtkModelButton* _tmp36_;
	GtkModelButton* stream_info = NULL;
	GtkModelButton* _tmp37_;
	GtkModelButton* _tmp38_;
	GtkModelButton* _tmp39_;
	GtkModelButton* _tmp40_;
	GtkModelButton* stream_info_fast = NULL;
	GtkModelButton* _tmp41_;
	GtkModelButton* _tmp42_;
	GtkModelButton* _tmp43_;
	GtkModelButton* _tmp44_;
	GtkComboBoxText* lang_combo = NULL;
	GtkComboBoxText* _tmp45_;
	GtkComboBoxText* _tmp46_;
	GtkComboBoxText* _tmp55_;
	GtkComboBoxText* _tmp56_;
	TunerApplication* _tmp57_;
	TunerApplication* _tmp58_;
	TunerSettings* _tmp59_;
	TunerSettings* _tmp60_;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	GtkBox* lang_box = NULL;
	GtkBox* _tmp63_;
	GtkBox* _tmp64_;
	GtkComboBoxText* _tmp65_;
	GtkBox* _tmp66_;
	GtkLabel* _tmp67_;
	GtkLabel* _tmp68_;
	GtkBox* _tmp69_;
	GtkComboBoxText* _tmp70_;
	GtkModelButton* export_starred = NULL;
	GtkModelButton* _tmp71_;
	GtkModelButton* _tmp72_;
	GtkModelButton* _tmp73_;
	GtkModelButton* import_starred = NULL;
	GtkModelButton* _tmp74_;
	GtkModelButton* _tmp75_;
	GtkModelButton* _tmp76_;
	guint8 vpos = 0U;
	GtkGrid* menu_grid = NULL;
	GtkGrid* _tmp77_;
	GtkGrid* _tmp78_;
	GtkGrid* _tmp79_;
	GtkGrid* _tmp80_;
	GtkGrid* _tmp81_;
	GtkGrid* _tmp82_;
	GtkGrid* _tmp83_;
	GtkGrid* _tmp84_;
	GtkBox* _tmp85_;
	guint8 _tmp86_;
	GtkGrid* _tmp87_;
	GtkSeparatorMenuItem* _tmp88_;
	GtkSeparatorMenuItem* _tmp89_;
	guint8 _tmp90_;
	GtkGrid* _tmp91_;
	GtkModelButton* _tmp92_;
	guint8 _tmp93_;
	GtkGrid* _tmp94_;
	GtkModelButton* _tmp95_;
	guint8 _tmp96_;
	GtkGrid* _tmp97_;
	GtkModelButton* _tmp98_;
	guint8 _tmp99_;
	GtkGrid* _tmp100_;
	GtkModelButton* _tmp101_;
	guint8 _tmp102_;
	GtkGrid* _tmp103_;
	GtkSeparatorMenuItem* _tmp104_;
	GtkSeparatorMenuItem* _tmp105_;
	guint8 _tmp106_;
	GtkGrid* _tmp107_;
	GtkModelButton* _tmp108_;
	guint8 _tmp109_;
	GtkGrid* _tmp110_;
	GtkSeparatorMenuItem* _tmp111_;
	GtkSeparatorMenuItem* _tmp112_;
	guint8 _tmp113_;
	GtkGrid* _tmp114_;
	GtkModelButton* _tmp115_;
	guint8 _tmp116_;
	GtkGrid* _tmp117_;
	GtkSeparatorMenuItem* _tmp118_;
	GtkSeparatorMenuItem* _tmp119_;
	guint8 _tmp120_;
	GtkGrid* _tmp121_;
	GtkModelButton* _tmp122_;
	guint8 _tmp123_;
	GtkGrid* _tmp124_;
	GtkSeparatorMenuItem* _tmp125_;
	GtkSeparatorMenuItem* _tmp126_;
	guint8 _tmp127_;
	GtkGrid* _tmp128_;
	GtkBox* _tmp129_;
	guint8 _tmp130_;
	GtkGrid* _tmp131_;
	GtkSeparatorMenuItem* _tmp132_;
	GtkSeparatorMenuItem* _tmp133_;
	guint8 _tmp134_;
	GtkGrid* _tmp135_;
	GtkModelButton* _tmp136_;
	guint8 _tmp137_;
	GtkGrid* _tmp138_;
	GtkGrid* _tmp139_;
#line 18 "../src/Widgets/PreferencesPopover.vala"
	parent_class = G_OBJECT_CLASS (tuner_preferences_popover_parent_class);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_PREFERENCES_POPOVER, TunerPreferencesPopover);
#line 19 "../src/Widgets/PreferencesPopover.vala"
	_tmp0_ = (GtkModelButton*) gtk_model_button_new ();
#line 19 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp0_);
#line 19 "../src/Widgets/PreferencesPopover.vala"
	about_menuitem = _tmp0_;
#line 20 "../src/Widgets/PreferencesPopover.vala"
	_tmp1_ = about_menuitem;
#line 20 "../src/Widgets/PreferencesPopover.vala"
	g_object_set (_tmp1_, "text", _ ("About"), NULL);
#line 21 "../src/Widgets/PreferencesPopover.vala"
	_tmp2_ = about_menuitem;
#line 21 "../src/Widgets/PreferencesPopover.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp2_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_ABOUT);
#line 24 "../src/Widgets/PreferencesPopover.vala"
	_tmp3_ = (GtkModelButton*) gtk_model_button_new ();
#line 24 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp3_);
#line 24 "../src/Widgets/PreferencesPopover.vala"
	disable_tracking_item = _tmp3_;
#line 25 "../src/Widgets/PreferencesPopover.vala"
	_tmp4_ = disable_tracking_item;
#line 25 "../src/Widgets/PreferencesPopover.vala"
	g_object_set (_tmp4_, "text", _ ("Do not participate in Station voting"), NULL);
#line 26 "../src/Widgets/PreferencesPopover.vala"
	_tmp5_ = disable_tracking_item;
#line 26 "../src/Widgets/PreferencesPopover.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp5_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_DISABLE_TRACKING);
#line 27 "../src/Widgets/PreferencesPopover.vala"
	_tmp6_ = disable_tracking_item;
#line 27 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, _ ("If checked, your starred and streamed stations will not be used to cal" \
"culate the Station index popularity vote, nor the popular and trending" \
" stations"));
#line 31 "../src/Widgets/PreferencesPopover.vala"
	_tmp7_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 31 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp7_);
#line 31 "../src/Widgets/PreferencesPopover.vala"
	theme_combo = _tmp7_;
#line 32 "../src/Widgets/PreferencesPopover.vala"
	_tmp8_ = theme_combo;
#line 32 "../src/Widgets/PreferencesPopover.vala"
	_tmp9_ = tuner_theme_get_name (TUNER_THEME_SYSTEM);
#line 32 "../src/Widgets/PreferencesPopover.vala"
	gtk_combo_box_text_append (_tmp8_, _tmp9_, _ ("System"));
#line 33 "../src/Widgets/PreferencesPopover.vala"
	_tmp10_ = theme_combo;
#line 33 "../src/Widgets/PreferencesPopover.vala"
	_tmp11_ = tuner_theme_get_name (TUNER_THEME_LIGHT);
#line 33 "../src/Widgets/PreferencesPopover.vala"
	gtk_combo_box_text_append (_tmp10_, _tmp11_, _ ("Light mode"));
#line 34 "../src/Widgets/PreferencesPopover.vala"
	_tmp12_ = theme_combo;
#line 34 "../src/Widgets/PreferencesPopover.vala"
	_tmp13_ = tuner_theme_get_name (TUNER_THEME_DARK);
#line 34 "../src/Widgets/PreferencesPopover.vala"
	gtk_combo_box_text_append (_tmp12_, _tmp13_, _ ("Dark mode"));
#line 35 "../src/Widgets/PreferencesPopover.vala"
	_tmp14_ = theme_combo;
#line 35 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
#line 36 "../src/Widgets/PreferencesPopover.vala"
	_tmp15_ = theme_combo;
#line 36 "../src/Widgets/PreferencesPopover.vala"
	_tmp16_ = tuner_app ();
#line 36 "../src/Widgets/PreferencesPopover.vala"
	_tmp17_ = _tmp16_;
#line 36 "../src/Widgets/PreferencesPopover.vala"
	_tmp18_ = tuner_application_get_settings (_tmp17_);
#line 36 "../src/Widgets/PreferencesPopover.vala"
	_tmp19_ = _tmp18_;
#line 36 "../src/Widgets/PreferencesPopover.vala"
	_tmp20_ = tuner_settings_get_theme_mode (_tmp19_);
#line 36 "../src/Widgets/PreferencesPopover.vala"
	_tmp21_ = _tmp20_;
#line 36 "../src/Widgets/PreferencesPopover.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp15_, _tmp21_);
#line 36 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp17_);
#line 38 "../src/Widgets/PreferencesPopover.vala"
	_tmp22_ = theme_combo;
#line 38 "../src/Widgets/PreferencesPopover.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp22_, "changed", (GCallback) __tuner_preferences_popover___lambda51__gtk_combo_box_changed, self, 0);
#line 43 "../src/Widgets/PreferencesPopover.vala"
	_tmp23_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 43 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp23_);
#line 43 "../src/Widgets/PreferencesPopover.vala"
	theme_box = _tmp23_;
#line 44 "../src/Widgets/PreferencesPopover.vala"
	_tmp24_ = theme_box;
#line 44 "../src/Widgets/PreferencesPopover.vala"
	_tmp25_ = theme_combo;
#line 44 "../src/Widgets/PreferencesPopover.vala"
	gtk_box_pack_end (_tmp24_, (GtkWidget*) _tmp25_, TRUE, TRUE, (guint) 5);
#line 45 "../src/Widgets/PreferencesPopover.vala"
	_tmp26_ = theme_box;
#line 45 "../src/Widgets/PreferencesPopover.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_ ("Theme"));
#line 45 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp27_);
#line 45 "../src/Widgets/PreferencesPopover.vala"
	_tmp28_ = _tmp27_;
#line 45 "../src/Widgets/PreferencesPopover.vala"
	gtk_box_pack_end (_tmp26_, (GtkWidget*) _tmp28_, FALSE, FALSE, (guint) 12);
#line 45 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp28_);
#line 49 "../src/Widgets/PreferencesPopover.vala"
	_tmp29_ = (GtkModelButton*) gtk_model_button_new ();
#line 49 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp29_);
#line 49 "../src/Widgets/PreferencesPopover.vala"
	autoplay_item = _tmp29_;
#line 50 "../src/Widgets/PreferencesPopover.vala"
	_tmp30_ = autoplay_item;
#line 50 "../src/Widgets/PreferencesPopover.vala"
	g_object_set (_tmp30_, "text", _ ("Auto-play last station on startup"), NULL);
#line 51 "../src/Widgets/PreferencesPopover.vala"
	_tmp31_ = autoplay_item;
#line 51 "../src/Widgets/PreferencesPopover.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp31_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_ENABLE_AUTOPLAY);
#line 52 "../src/Widgets/PreferencesPopover.vala"
	_tmp32_ = autoplay_item;
#line 52 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp32_, _ ("If enabled, when Tuner starts it will automatically start to play the " \
"last played station"));
#line 56 "../src/Widgets/PreferencesPopover.vala"
	_tmp33_ = (GtkModelButton*) gtk_model_button_new ();
#line 56 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp33_);
#line 56 "../src/Widgets/PreferencesPopover.vala"
	start_on_starred = _tmp33_;
#line 57 "../src/Widgets/PreferencesPopover.vala"
	_tmp34_ = start_on_starred;
#line 57 "../src/Widgets/PreferencesPopover.vala"
	g_object_set (_tmp34_, "text", _ ("Open to Starred Stations"), NULL);
#line 58 "../src/Widgets/PreferencesPopover.vala"
	_tmp35_ = start_on_starred;
#line 58 "../src/Widgets/PreferencesPopover.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp35_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_START_ON_STARRED);
#line 59 "../src/Widgets/PreferencesPopover.vala"
	_tmp36_ = start_on_starred;
#line 59 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp36_, _ ("If enabled, when Tuner starts it will open to the starred stations vie" \
"w"));
#line 63 "../src/Widgets/PreferencesPopover.vala"
	_tmp37_ = (GtkModelButton*) gtk_model_button_new ();
#line 63 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp37_);
#line 63 "../src/Widgets/PreferencesPopover.vala"
	stream_info = _tmp37_;
#line 64 "../src/Widgets/PreferencesPopover.vala"
	_tmp38_ = stream_info;
#line 64 "../src/Widgets/PreferencesPopover.vala"
	g_object_set (_tmp38_, "text", _ ("Show stream info when playing"), NULL);
#line 65 "../src/Widgets/PreferencesPopover.vala"
	_tmp39_ = stream_info;
#line 65 "../src/Widgets/PreferencesPopover.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp39_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_STREAM_INFO);
#line 66 "../src/Widgets/PreferencesPopover.vala"
	_tmp40_ = stream_info;
#line 66 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp40_, _ ("Cycle through the metadata from the playing stream"));
#line 68 "../src/Widgets/PreferencesPopover.vala"
	_tmp41_ = (GtkModelButton*) gtk_model_button_new ();
#line 68 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp41_);
#line 68 "../src/Widgets/PreferencesPopover.vala"
	stream_info_fast = _tmp41_;
#line 69 "../src/Widgets/PreferencesPopover.vala"
	_tmp42_ = stream_info_fast;
#line 69 "../src/Widgets/PreferencesPopover.vala"
	g_object_set (_tmp42_, "text", _ ("Faster cycling through stream info"), NULL);
#line 70 "../src/Widgets/PreferencesPopover.vala"
	_tmp43_ = stream_info_fast;
#line 70 "../src/Widgets/PreferencesPopover.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp43_, TUNER_WINDOW_ACTION_PREFIX TUNER_WINDOW_ACTION_STREAM_INFO_FAST);
#line 71 "../src/Widgets/PreferencesPopover.vala"
	_tmp44_ = stream_info_fast;
#line 71 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp44_, _ ("Fast cycle through the metadata from the playing stream if show stream" \
" info is enabled"));
#line 75 "../src/Widgets/PreferencesPopover.vala"
	_tmp45_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 75 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp45_);
#line 75 "../src/Widgets/PreferencesPopover.vala"
	lang_combo = _tmp45_;
#line 76 "../src/Widgets/PreferencesPopover.vala"
	_tmp46_ = lang_combo;
#line 76 "../src/Widgets/PreferencesPopover.vala"
	gtk_combo_box_text_append (_tmp46_, "", _ ("Default"));
#line 1068 "PreferencesPopover.c"
	{
		GeeIterator* _lang_it = NULL;
		GeeCollection* _tmp47_;
		GeeIterator* _tmp48_;
#line 77 "../src/Widgets/PreferencesPopover.vala"
		_tmp47_ = tuner_application_LANGUAGES;
#line 77 "../src/Widgets/PreferencesPopover.vala"
		_tmp48_ = gee_iterable_iterator ((GeeIterable*) _tmp47_);
#line 77 "../src/Widgets/PreferencesPopover.vala"
		_lang_it = _tmp48_;
#line 77 "../src/Widgets/PreferencesPopover.vala"
		while (TRUE) {
#line 1081 "PreferencesPopover.c"
			GeeIterator* _tmp49_;
			gchar* lang = NULL;
			GeeIterator* _tmp50_;
			gpointer _tmp51_;
			GtkComboBoxText* _tmp52_;
			const gchar* _tmp53_;
			const gchar* _tmp54_;
#line 77 "../src/Widgets/PreferencesPopover.vala"
			_tmp49_ = _lang_it;
#line 77 "../src/Widgets/PreferencesPopover.vala"
			if (!gee_iterator_next (_tmp49_)) {
#line 77 "../src/Widgets/PreferencesPopover.vala"
				break;
#line 1095 "PreferencesPopover.c"
			}
#line 77 "../src/Widgets/PreferencesPopover.vala"
			_tmp50_ = _lang_it;
#line 77 "../src/Widgets/PreferencesPopover.vala"
			_tmp51_ = gee_iterator_get (_tmp50_);
#line 77 "../src/Widgets/PreferencesPopover.vala"
			lang = (gchar*) _tmp51_;
#line 79 "../src/Widgets/PreferencesPopover.vala"
			_tmp52_ = lang_combo;
#line 79 "../src/Widgets/PreferencesPopover.vala"
			_tmp53_ = lang;
#line 79 "../src/Widgets/PreferencesPopover.vala"
			_tmp54_ = lang;
#line 79 "../src/Widgets/PreferencesPopover.vala"
			gtk_combo_box_text_append (_tmp52_, _tmp53_, _tmp54_);
#line 77 "../src/Widgets/PreferencesPopover.vala"
			_g_free0 (lang);
#line 1113 "PreferencesPopover.c"
		}
#line 77 "../src/Widgets/PreferencesPopover.vala"
		_g_object_unref0 (_lang_it);
#line 1117 "PreferencesPopover.c"
	}
#line 81 "../src/Widgets/PreferencesPopover.vala"
	_tmp55_ = lang_combo;
#line 81 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp55_, GTK_ALIGN_CENTER);
#line 82 "../src/Widgets/PreferencesPopover.vala"
	_tmp56_ = lang_combo;
#line 82 "../src/Widgets/PreferencesPopover.vala"
	_tmp57_ = tuner_app ();
#line 82 "../src/Widgets/PreferencesPopover.vala"
	_tmp58_ = _tmp57_;
#line 82 "../src/Widgets/PreferencesPopover.vala"
	_tmp59_ = tuner_application_get_settings (_tmp58_);
#line 82 "../src/Widgets/PreferencesPopover.vala"
	_tmp60_ = _tmp59_;
#line 82 "../src/Widgets/PreferencesPopover.vala"
	_tmp61_ = tuner_settings_get_language (_tmp60_);
#line 82 "../src/Widgets/PreferencesPopover.vala"
	_tmp62_ = _tmp61_;
#line 82 "../src/Widgets/PreferencesPopover.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp56_, _tmp62_);
#line 82 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp58_);
#line 84 "../src/Widgets/PreferencesPopover.vala"
	_tmp63_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 84 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp63_);
#line 84 "../src/Widgets/PreferencesPopover.vala"
	lang_box = _tmp63_;
#line 85 "../src/Widgets/PreferencesPopover.vala"
	_tmp64_ = lang_box;
#line 85 "../src/Widgets/PreferencesPopover.vala"
	_tmp65_ = lang_combo;
#line 85 "../src/Widgets/PreferencesPopover.vala"
	gtk_box_pack_end (_tmp64_, (GtkWidget*) _tmp65_, TRUE, TRUE, (guint) 5);
#line 86 "../src/Widgets/PreferencesPopover.vala"
	_tmp66_ = lang_box;
#line 86 "../src/Widgets/PreferencesPopover.vala"
	_tmp67_ = (GtkLabel*) gtk_label_new (_ ("Language"));
#line 86 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp67_);
#line 86 "../src/Widgets/PreferencesPopover.vala"
	_tmp68_ = _tmp67_;
#line 86 "../src/Widgets/PreferencesPopover.vala"
	gtk_box_pack_end (_tmp66_, (GtkWidget*) _tmp68_, FALSE, FALSE, (guint) 12);
#line 86 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp68_);
#line 87 "../src/Widgets/PreferencesPopover.vala"
	_tmp69_ = lang_box;
#line 87 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp69_, _ ("Requires restarting Tuner"));
#line 89 "../src/Widgets/PreferencesPopover.vala"
	_tmp70_ = lang_combo;
#line 89 "../src/Widgets/PreferencesPopover.vala"
	g_signal_connect_object ((GtkComboBox*) _tmp70_, "changed", (GCallback) __tuner_preferences_popover___lambda52__gtk_combo_box_changed, self, 0);
#line 95 "../src/Widgets/PreferencesPopover.vala"
	_tmp71_ = (GtkModelButton*) gtk_model_button_new ();
#line 95 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp71_);
#line 95 "../src/Widgets/PreferencesPopover.vala"
	export_starred = _tmp71_;
#line 96 "../src/Widgets/PreferencesPopover.vala"
	_tmp72_ = export_starred;
#line 96 "../src/Widgets/PreferencesPopover.vala"
	g_object_set (_tmp72_, "text", _ ("Export Starred Sations to Playlist"), NULL);
#line 97 "../src/Widgets/PreferencesPopover.vala"
	_tmp73_ = export_starred;
#line 97 "../src/Widgets/PreferencesPopover.vala"
	g_signal_connect_object ((GtkWidget*) _tmp73_, "button-press-event", (GCallback) __tuner_preferences_popover___lambda53__gtk_widget_button_press_event, self, 0);
#line 104 "../src/Widgets/PreferencesPopover.vala"
	_tmp74_ = (GtkModelButton*) gtk_model_button_new ();
#line 104 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp74_);
#line 104 "../src/Widgets/PreferencesPopover.vala"
	import_starred = _tmp74_;
#line 105 "../src/Widgets/PreferencesPopover.vala"
	_tmp75_ = import_starred;
#line 105 "../src/Widgets/PreferencesPopover.vala"
	g_object_set (_tmp75_, "text", _ ("Import Station UUIDs as Starred Sations"), NULL);
#line 106 "../src/Widgets/PreferencesPopover.vala"
	_tmp76_ = import_starred;
#line 106 "../src/Widgets/PreferencesPopover.vala"
	g_signal_connect_object ((GtkWidget*) _tmp76_, "button-press-event", (GCallback) __tuner_preferences_popover___lambda54__gtk_widget_button_press_event, self, 0);
#line 113 "../src/Widgets/PreferencesPopover.vala"
	vpos = (guint8) 0;
#line 114 "../src/Widgets/PreferencesPopover.vala"
	_tmp77_ = (GtkGrid*) gtk_grid_new ();
#line 114 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp77_);
#line 114 "../src/Widgets/PreferencesPopover.vala"
	menu_grid = _tmp77_;
#line 115 "../src/Widgets/PreferencesPopover.vala"
	_tmp78_ = menu_grid;
#line 115 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp78_, 10);
#line 116 "../src/Widgets/PreferencesPopover.vala"
	_tmp79_ = menu_grid;
#line 116 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp79_, 10);
#line 117 "../src/Widgets/PreferencesPopover.vala"
	_tmp80_ = menu_grid;
#line 117 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp80_, 5);
#line 118 "../src/Widgets/PreferencesPopover.vala"
	_tmp81_ = menu_grid;
#line 118 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp81_, 5);
#line 119 "../src/Widgets/PreferencesPopover.vala"
	_tmp82_ = menu_grid;
#line 119 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_set_row_spacing (_tmp82_, 3);
#line 120 "../src/Widgets/PreferencesPopover.vala"
	_tmp83_ = menu_grid;
#line 120 "../src/Widgets/PreferencesPopover.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp83_, GTK_ORIENTATION_VERTICAL);
#line 122 "../src/Widgets/PreferencesPopover.vala"
	_tmp84_ = menu_grid;
#line 122 "../src/Widgets/PreferencesPopover.vala"
	_tmp85_ = theme_box;
#line 122 "../src/Widgets/PreferencesPopover.vala"
	_tmp86_ = vpos;
#line 122 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp86_ + 1;
#line 122 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp84_, (GtkWidget*) _tmp85_, 0, (gint) _tmp86_, 1, 1);
#line 124 "../src/Widgets/PreferencesPopover.vala"
	_tmp87_ = menu_grid;
#line 124 "../src/Widgets/PreferencesPopover.vala"
	_tmp88_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 124 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp88_);
#line 124 "../src/Widgets/PreferencesPopover.vala"
	_tmp89_ = _tmp88_;
#line 124 "../src/Widgets/PreferencesPopover.vala"
	_tmp90_ = vpos;
#line 124 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp90_ + 1;
#line 124 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp87_, (GtkWidget*) _tmp89_, 0, (gint) _tmp90_, 4, 1);
#line 124 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp89_);
#line 126 "../src/Widgets/PreferencesPopover.vala"
	_tmp91_ = menu_grid;
#line 126 "../src/Widgets/PreferencesPopover.vala"
	_tmp92_ = autoplay_item;
#line 126 "../src/Widgets/PreferencesPopover.vala"
	_tmp93_ = vpos;
#line 126 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp93_ + 1;
#line 126 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp91_, (GtkWidget*) _tmp92_, 0, (gint) _tmp93_, 4, 1);
#line 127 "../src/Widgets/PreferencesPopover.vala"
	_tmp94_ = menu_grid;
#line 127 "../src/Widgets/PreferencesPopover.vala"
	_tmp95_ = start_on_starred;
#line 127 "../src/Widgets/PreferencesPopover.vala"
	_tmp96_ = vpos;
#line 127 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp96_ + 1;
#line 127 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp94_, (GtkWidget*) _tmp95_, 0, (gint) _tmp96_, 4, 1);
#line 128 "../src/Widgets/PreferencesPopover.vala"
	_tmp97_ = menu_grid;
#line 128 "../src/Widgets/PreferencesPopover.vala"
	_tmp98_ = stream_info;
#line 128 "../src/Widgets/PreferencesPopover.vala"
	_tmp99_ = vpos;
#line 128 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp99_ + 1;
#line 128 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp97_, (GtkWidget*) _tmp98_, 0, (gint) _tmp99_, 4, 1);
#line 129 "../src/Widgets/PreferencesPopover.vala"
	_tmp100_ = menu_grid;
#line 129 "../src/Widgets/PreferencesPopover.vala"
	_tmp101_ = stream_info_fast;
#line 129 "../src/Widgets/PreferencesPopover.vala"
	_tmp102_ = vpos;
#line 129 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp102_ + 1;
#line 129 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp100_, (GtkWidget*) _tmp101_, 0, (gint) _tmp102_, 4, 1);
#line 131 "../src/Widgets/PreferencesPopover.vala"
	_tmp103_ = menu_grid;
#line 131 "../src/Widgets/PreferencesPopover.vala"
	_tmp104_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 131 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp104_);
#line 131 "../src/Widgets/PreferencesPopover.vala"
	_tmp105_ = _tmp104_;
#line 131 "../src/Widgets/PreferencesPopover.vala"
	_tmp106_ = vpos;
#line 131 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp106_ + 1;
#line 131 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp103_, (GtkWidget*) _tmp105_, 0, (gint) _tmp106_, 4, 1);
#line 131 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp105_);
#line 133 "../src/Widgets/PreferencesPopover.vala"
	_tmp107_ = menu_grid;
#line 133 "../src/Widgets/PreferencesPopover.vala"
	_tmp108_ = export_starred;
#line 133 "../src/Widgets/PreferencesPopover.vala"
	_tmp109_ = vpos;
#line 133 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp109_ + 1;
#line 133 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp107_, (GtkWidget*) _tmp108_, 0, (gint) _tmp109_, 4, 1);
#line 135 "../src/Widgets/PreferencesPopover.vala"
	_tmp110_ = menu_grid;
#line 135 "../src/Widgets/PreferencesPopover.vala"
	_tmp111_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 135 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp111_);
#line 135 "../src/Widgets/PreferencesPopover.vala"
	_tmp112_ = _tmp111_;
#line 135 "../src/Widgets/PreferencesPopover.vala"
	_tmp113_ = vpos;
#line 135 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp113_ + 1;
#line 135 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp110_, (GtkWidget*) _tmp112_, 0, (gint) _tmp113_, 4, 1);
#line 135 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp112_);
#line 137 "../src/Widgets/PreferencesPopover.vala"
	_tmp114_ = menu_grid;
#line 137 "../src/Widgets/PreferencesPopover.vala"
	_tmp115_ = import_starred;
#line 137 "../src/Widgets/PreferencesPopover.vala"
	_tmp116_ = vpos;
#line 137 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp116_ + 1;
#line 137 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp114_, (GtkWidget*) _tmp115_, 0, (gint) _tmp116_, 4, 1);
#line 139 "../src/Widgets/PreferencesPopover.vala"
	_tmp117_ = menu_grid;
#line 139 "../src/Widgets/PreferencesPopover.vala"
	_tmp118_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 139 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp118_);
#line 139 "../src/Widgets/PreferencesPopover.vala"
	_tmp119_ = _tmp118_;
#line 139 "../src/Widgets/PreferencesPopover.vala"
	_tmp120_ = vpos;
#line 139 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp120_ + 1;
#line 139 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp117_, (GtkWidget*) _tmp119_, 0, (gint) _tmp120_, 4, 1);
#line 139 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp119_);
#line 141 "../src/Widgets/PreferencesPopover.vala"
	_tmp121_ = menu_grid;
#line 141 "../src/Widgets/PreferencesPopover.vala"
	_tmp122_ = disable_tracking_item;
#line 141 "../src/Widgets/PreferencesPopover.vala"
	_tmp123_ = vpos;
#line 141 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp123_ + 1;
#line 141 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp121_, (GtkWidget*) _tmp122_, 0, (gint) _tmp123_, 4, 1);
#line 143 "../src/Widgets/PreferencesPopover.vala"
	_tmp124_ = menu_grid;
#line 143 "../src/Widgets/PreferencesPopover.vala"
	_tmp125_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 143 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp125_);
#line 143 "../src/Widgets/PreferencesPopover.vala"
	_tmp126_ = _tmp125_;
#line 143 "../src/Widgets/PreferencesPopover.vala"
	_tmp127_ = vpos;
#line 143 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp127_ + 1;
#line 143 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp124_, (GtkWidget*) _tmp126_, 0, (gint) _tmp127_, 4, 1);
#line 143 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp126_);
#line 145 "../src/Widgets/PreferencesPopover.vala"
	_tmp128_ = menu_grid;
#line 145 "../src/Widgets/PreferencesPopover.vala"
	_tmp129_ = lang_box;
#line 145 "../src/Widgets/PreferencesPopover.vala"
	_tmp130_ = vpos;
#line 145 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp130_ + 1;
#line 145 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp128_, (GtkWidget*) _tmp129_, 0, (gint) _tmp130_, 4, 1);
#line 147 "../src/Widgets/PreferencesPopover.vala"
	_tmp131_ = menu_grid;
#line 147 "../src/Widgets/PreferencesPopover.vala"
	_tmp132_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 147 "../src/Widgets/PreferencesPopover.vala"
	g_object_ref_sink (_tmp132_);
#line 147 "../src/Widgets/PreferencesPopover.vala"
	_tmp133_ = _tmp132_;
#line 147 "../src/Widgets/PreferencesPopover.vala"
	_tmp134_ = vpos;
#line 147 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp134_ + 1;
#line 147 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp131_, (GtkWidget*) _tmp133_, 0, (gint) _tmp134_, 4, 1);
#line 147 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (_tmp133_);
#line 149 "../src/Widgets/PreferencesPopover.vala"
	_tmp135_ = menu_grid;
#line 149 "../src/Widgets/PreferencesPopover.vala"
	_tmp136_ = about_menuitem;
#line 149 "../src/Widgets/PreferencesPopover.vala"
	_tmp137_ = vpos;
#line 149 "../src/Widgets/PreferencesPopover.vala"
	vpos = _tmp137_ + 1;
#line 149 "../src/Widgets/PreferencesPopover.vala"
	gtk_grid_attach (_tmp135_, (GtkWidget*) _tmp136_, 0, (gint) _tmp137_, 4, 1);
#line 151 "../src/Widgets/PreferencesPopover.vala"
	_tmp138_ = menu_grid;
#line 151 "../src/Widgets/PreferencesPopover.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp138_);
#line 153 "../src/Widgets/PreferencesPopover.vala"
	_tmp139_ = menu_grid;
#line 153 "../src/Widgets/PreferencesPopover.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp139_);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (menu_grid);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (import_starred);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (export_starred);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (lang_box);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (lang_combo);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (stream_info_fast);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (stream_info);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (start_on_starred);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (autoplay_item);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (theme_box);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (theme_combo);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (disable_tracking_item);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	_g_object_unref0 (about_menuitem);
#line 18 "../src/Widgets/PreferencesPopover.vala"
	return obj;
#line 1465 "PreferencesPopover.c"
}

static void
tuner_preferences_popover_class_init (TunerPreferencesPopoverClass * klass,
                                      gpointer klass_data)
{
#line 15 "../src/Widgets/PreferencesPopover.vala"
	tuner_preferences_popover_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/Widgets/PreferencesPopover.vala"
	G_OBJECT_CLASS (klass)->constructor = tuner_preferences_popover_constructor;
#line 1476 "PreferencesPopover.c"
}

static void
tuner_preferences_popover_instance_init (TunerPreferencesPopover * self,
                                         gpointer klass)
{
}

/**
 *
 * @brief Tuner preferences and selections.
 */
static GType
tuner_preferences_popover_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerPreferencesPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_preferences_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerPreferencesPopover), 0, (GInstanceInitFunc) tuner_preferences_popover_instance_init, NULL };
	GType tuner_preferences_popover_type_id;
	tuner_preferences_popover_type_id = g_type_register_static (gtk_popover_get_type (), "TunerPreferencesPopover", &g_define_type_info, 0);
	return tuner_preferences_popover_type_id;
}

GType
tuner_preferences_popover_get_type (void)
{
	static volatile gsize tuner_preferences_popover_type_id__once = 0;
	if (g_once_init_enter (&tuner_preferences_popover_type_id__once)) {
		GType tuner_preferences_popover_type_id;
		tuner_preferences_popover_type_id = tuner_preferences_popover_get_type_once ();
		g_once_init_leave (&tuner_preferences_popover_type_id__once, tuner_preferences_popover_type_id);
	}
	return tuner_preferences_popover_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

