/* CyclingRevealLabel.c generated by valac 0.56.17, the Vala compiler
 * generated from CyclingRevealLabel.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file CyclingRevealLabel.vala
 */
/**
     * @brief Adds a sublabel at the given position
     *
     */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>

#define TUNER_CYCLING_REVEAL_LABEL_SUBTITLE_MIN_DISPLAY_SECONDS 3
#define TUNER_CYCLING_REVEAL_LABEL_LABEL_WIDTH_MIN 100
#define TUNER_CYCLING_REVEAL_LABEL_LABEL_RESIZE_BUFFER 10
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_REVEAL_LABEL (tuner_reveal_label_get_type ())
#define TUNER_REVEAL_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel))
#define TUNER_REVEAL_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabelClass))
#define TUNER_IS_REVEAL_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_REVEAL_LABEL))
#define TUNER_IS_REVEAL_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_REVEAL_LABEL))
#define TUNER_REVEAL_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_REVEAL_LABEL, TunerRevealLabelClass))

typedef struct _TunerRevealLabel TunerRevealLabel;
typedef struct _TunerRevealLabelClass TunerRevealLabelClass;
typedef struct _TunerRevealLabelPrivate TunerRevealLabelPrivate;

#define TUNER_TYPE_CYCLING_REVEAL_LABEL (tuner_cycling_reveal_label_get_type ())
#define TUNER_CYCLING_REVEAL_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_CYCLING_REVEAL_LABEL, TunerCyclingRevealLabel))
#define TUNER_CYCLING_REVEAL_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_CYCLING_REVEAL_LABEL, TunerCyclingRevealLabelClass))
#define TUNER_IS_CYCLING_REVEAL_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_CYCLING_REVEAL_LABEL))
#define TUNER_IS_CYCLING_REVEAL_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_CYCLING_REVEAL_LABEL))
#define TUNER_CYCLING_REVEAL_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_CYCLING_REVEAL_LABEL, TunerCyclingRevealLabelClass))

typedef struct _TunerCyclingRevealLabel TunerCyclingRevealLabel;
typedef struct _TunerCyclingRevealLabelClass TunerCyclingRevealLabelClass;
typedef struct _TunerCyclingRevealLabelPrivate TunerCyclingRevealLabelPrivate;
enum  {
	TUNER_CYCLING_REVEAL_LABEL_0_PROPERTY,
	TUNER_CYCLING_REVEAL_LABEL_SHOW_METADATA_PROPERTY,
	TUNER_CYCLING_REVEAL_LABEL_METADATA_FAST_CYCLE_PROPERTY,
	TUNER_CYCLING_REVEAL_LABEL_LABEL_PROPERTY,
	TUNER_CYCLING_REVEAL_LABEL_NUM_PROPERTIES
};
static GParamSpec* tuner_cycling_reveal_label_properties[TUNER_CYCLING_REVEAL_LABEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block8Data Block8Data;
enum  {
	TUNER_CYCLING_REVEAL_LABEL_FLOURISH_COMPLETE_SIG_SIGNAL,
	TUNER_CYCLING_REVEAL_LABEL_NUM_SIGNALS
};
static guint tuner_cycling_reveal_label_signals[TUNER_CYCLING_REVEAL_LABEL_NUM_SIGNALS] = {0};

struct _TunerRevealLabel {
	GtkRevealer parent_instance;
	TunerRevealLabelPrivate * priv;
};

struct _TunerRevealLabelClass {
	GtkRevealerClass parent_class;
};

struct _TunerCyclingRevealLabel {
	TunerRevealLabel parent_instance;
	TunerCyclingRevealLabelPrivate * priv;
};

struct _TunerCyclingRevealLabelClass {
	TunerRevealLabelClass parent_class;
};

struct _TunerCyclingRevealLabelPrivate {
	gboolean _show_metadata;
	gboolean _metadata_fast_cycle;
	gint _last_parent_width;
	gint _parent_unused_growth;
	gint _min_label_width;
	gint _peak_label_width;
	gboolean _followed_width_change;
	guint _label_cycle_id;
	guint _flourish_id;
	gint _min_count_down;
	guint16 _display_seconds;
	guint16* _cycle_phases_fast;
	gint _cycle_phases_fast_length1;
	gint __cycle_phases_fast_size_;
	guint16* _cycle_phases_slow;
	gint _cycle_phases_slow_length1;
	gint __cycle_phases_slow_size_;
	guint16* _cycle_phases;
	gint _cycle_phases_length1;
	gint __cycle_phases_size_;
	GeeMap* sublabels;
};

struct _Block8Data {
	int _ref_count_;
	TunerCyclingRevealLabel* self;
	guint last_position;
};

static gint TunerCyclingRevealLabel_private_offset;
static gpointer tuner_cycling_reveal_label_parent_class = NULL;

VALA_EXTERN GType tuner_reveal_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerRevealLabel, g_object_unref)
VALA_EXTERN GType tuner_cycling_reveal_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerCyclingRevealLabel, g_object_unref)
VALA_EXTERN TunerCyclingRevealLabel* tuner_cycling_reveal_label_new (GtkWidget* follow,
                                                         gint min_label_width,
                                                         const gchar* str);
VALA_EXTERN TunerCyclingRevealLabel* tuner_cycling_reveal_label_construct (GType object_type,
                                                               GtkWidget* follow,
                                                               gint min_label_width,
                                                               const gchar* str);
VALA_EXTERN GtkLabel* tuner_reveal_label_get_label_child (TunerRevealLabel* self);
static void __lambda24_ (TunerCyclingRevealLabel* self,
                  GtkWidget* widget,
                  GtkAllocation* allocation);
static void ___lambda24__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static void __lambda25_ (TunerCyclingRevealLabel* self,
                  GtkAllocation* allocation);
static void ___lambda25__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static guint16* _vala_array_dup1 (guint16* self,
                           gssize length);
VALA_EXTERN gboolean tuner_cycling_reveal_label_set_text (TunerCyclingRevealLabel* self,
                                              const gchar* text);
VALA_EXTERN const gchar* tuner_reveal_label_get_text (TunerRevealLabel* self);
VALA_EXTERN gboolean tuner_reveal_label_set_text (TunerRevealLabel* self,
                                      const gchar* text);
VALA_EXTERN void tuner_cycling_reveal_label_add_sublabel (TunerCyclingRevealLabel* self,
                                              gint position,
                                              const gchar* sublabel1,
                                              const gchar* sublabel2);
VALA_EXTERN void tuner_cycling_reveal_label_stop (TunerCyclingRevealLabel* self);
VALA_EXTERN void tuner_cycling_reveal_label_clear (TunerCyclingRevealLabel* self);
VALA_EXTERN void tuner_reveal_label_clear (TunerRevealLabel* self);
VALA_EXTERN void tuner_cycling_reveal_label_cycle (TunerCyclingRevealLabel* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean __lambda26_ (Block8Data* _data8_);
static gboolean __lambda27_ (Block8Data* _data8_);
VALA_EXTERN gboolean tuner_cycling_reveal_label_get_show_metadata (TunerCyclingRevealLabel* self);
static gboolean ___lambda27__gsource_func (gpointer self);
static gboolean ___lambda26__gsource_func (gpointer self);
VALA_EXTERN void tuner_cycling_reveal_label_set_show_metadata (TunerCyclingRevealLabel* self,
                                                   gboolean value);
VALA_EXTERN gboolean tuner_cycling_reveal_label_get_metadata_fast_cycle (TunerCyclingRevealLabel* self);
VALA_EXTERN void tuner_cycling_reveal_label_set_metadata_fast_cycle (TunerCyclingRevealLabel* self,
                                                         gboolean value);
static guint16* _vala_array_dup2 (guint16* self,
                           gssize length);
static guint16* _vala_array_dup3 (guint16* self,
                           gssize length);
VALA_EXTERN const gchar* tuner_cycling_reveal_label_get_label (TunerCyclingRevealLabel* self);
VALA_EXTERN void tuner_cycling_reveal_label_set_label (TunerCyclingRevealLabel* self,
                                           const gchar* value);
static void tuner_cycling_reveal_label_finalize (GObject * obj);
static GType tuner_cycling_reveal_label_get_type_once (void);
static void _vala_tuner_cycling_reveal_label_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_tuner_cycling_reveal_label_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
tuner_cycling_reveal_label_get_instance_private (TunerCyclingRevealLabel* self)
{
	return G_STRUCT_MEMBER_P (self, TunerCyclingRevealLabel_private_offset);
}

static void
__lambda24_ (TunerCyclingRevealLabel* self,
             GtkWidget* widget,
             GtkAllocation* allocation)
{
	gint delta = 0;
	GtkAllocation _tmp1_;
	GtkAllocation _tmp18_;
#line 83 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (widget != NULL);
#line 83 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (allocation != NULL);
#line 85 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (self->priv->_last_parent_width == 0) {
#line 225 "CyclingRevealLabel.c"
		GtkAllocation _tmp0_;
#line 85 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp0_ = *allocation;
#line 85 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_last_parent_width = _tmp0_.width;
#line 231 "CyclingRevealLabel.c"
	}
#line 86 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_ = *allocation;
#line 86 "../src/Widgets/base/CyclingRevealLabel.vala"
	delta = _tmp1_.width - self->priv->_last_parent_width;
#line 88 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (delta == 0) {
#line 88 "../src/Widgets/base/CyclingRevealLabel.vala"
		return;
#line 241 "CyclingRevealLabel.c"
	}
#line 90 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (delta > 0) {
#line 93 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_parent_unused_growth = self->priv->_parent_unused_growth + delta;
#line 247 "CyclingRevealLabel.c"
	} else {
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 98 "../src/Widgets/base/CyclingRevealLabel.vala"
		if ((-delta) <= self->priv->_parent_unused_growth) {
#line 261 "CyclingRevealLabel.c"
			gchar* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp2_ = g_strdup_printf ("%i", delta);
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp3_ = _tmp2_;
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp4_ = g_strdup_printf ("%i", self->priv->_parent_unused_growth);
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp5_ = _tmp4_;
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp6_ = g_strconcat ("Shrink delta: ", _tmp3_, " _parent_unused_growth: ", _tmp5_, NULL);
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp7_ = _tmp6_;
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			g_debug ("CyclingRevealLabel.vala:101: %s", _tmp7_);
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp7_);
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp5_);
#line 101 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp3_);
#line 102 "../src/Widgets/base/CyclingRevealLabel.vala"
			self->priv->_parent_unused_growth = self->priv->_parent_unused_growth + delta;
#line 103 "../src/Widgets/base/CyclingRevealLabel.vala"
			return;
#line 292 "CyclingRevealLabel.c"
		}
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp8_ = g_strdup_printf ("%i", delta);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp9_ = _tmp8_;
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp10_ = g_strdup_printf ("%i", self->priv->_peak_label_width);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp11_ = _tmp10_;
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp12_ = g_strdup_printf ("%i", (self->priv->_peak_label_width + delta) + self->priv->_parent_unused_growth);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp13_ = _tmp12_;
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp14_ = g_strdup_printf ("%i", self->priv->_last_parent_width);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp15_ = _tmp14_;
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp16_ = g_strconcat ("Delta: ", _tmp9_, "  Peak old: ", _tmp11_, " new: ", _tmp13_, "  follow: ", _tmp15_, NULL);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp17_ = _tmp16_;
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_debug ("CyclingRevealLabel.vala:106: %s", _tmp17_);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (_tmp17_);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (_tmp15_);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (_tmp13_);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (_tmp11_);
#line 106 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (_tmp9_);
#line 107 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_peak_label_width = self->priv->_peak_label_width + ((2 * delta) + self->priv->_parent_unused_growth);
#line 108 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_peak_label_width = MAX (self->priv->_peak_label_width, TUNER_CYCLING_REVEAL_LABEL_LABEL_WIDTH_MIN);
#line 109 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_parent_unused_growth = 0;
#line 110 "../src/Widgets/base/CyclingRevealLabel.vala"
		gtk_widget_set_size_request ((GtkWidget*) self, self->priv->_peak_label_width, -1);
#line 111 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_followed_width_change = TRUE;
#line 336 "CyclingRevealLabel.c"
	}
#line 113 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp18_ = *allocation;
#line 113 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_last_parent_width = _tmp18_.width;
#line 342 "CyclingRevealLabel.c"
}

static void
___lambda24__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 83 "../src/Widgets/base/CyclingRevealLabel.vala"
	__lambda24_ ((TunerCyclingRevealLabel*) self, _sender, allocation);
#line 352 "CyclingRevealLabel.c"
}

static void
__lambda25_ (TunerCyclingRevealLabel* self,
             GtkAllocation* allocation)
{
	gboolean _tmp0_ = FALSE;
	GtkAllocation _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkAllocation _tmp9_;
#line 116 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (allocation != NULL);
#line 118 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (!self->priv->_followed_width_change) {
#line 372 "CyclingRevealLabel.c"
		GtkAllocation _tmp1_;
#line 118 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp1_ = *allocation;
#line 118 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp0_ = _tmp1_.width <= (self->priv->_peak_label_width + TUNER_CYCLING_REVEAL_LABEL_LABEL_RESIZE_BUFFER);
#line 378 "CyclingRevealLabel.c"
	} else {
#line 118 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp0_ = FALSE;
#line 382 "CyclingRevealLabel.c"
	}
#line 118 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (_tmp0_) {
#line 120 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_followed_width_change = FALSE;
#line 121 "../src/Widgets/base/CyclingRevealLabel.vala"
		return;
#line 390 "CyclingRevealLabel.c"
	}
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp2_ = *allocation;
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp3_ = g_strdup_printf ("%i", _tmp2_.width);
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp4_ = _tmp3_;
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp5_ = g_strdup_printf ("%i", self->priv->_peak_label_width);
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp6_ = _tmp5_;
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp7_ = g_strconcat ("Size Alloc:  ", _tmp4_, " Peak: ", _tmp6_, NULL);
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp8_ = _tmp7_;
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_debug ("CyclingRevealLabel.vala:123: %s", _tmp8_);
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_g_free0 (_tmp8_);
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_g_free0 (_tmp6_);
#line 123 "../src/Widgets/base/CyclingRevealLabel.vala"
	_g_free0 (_tmp4_);
#line 124 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp9_ = *allocation;
#line 124 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_peak_label_width = MAX (self->priv->_peak_label_width, _tmp9_.width - TUNER_CYCLING_REVEAL_LABEL_LABEL_RESIZE_BUFFER);
#line 125 "../src/Widgets/base/CyclingRevealLabel.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, (9 * self->priv->_peak_label_width) / 10, -1);
#line 420 "CyclingRevealLabel.c"
}

static void
___lambda25__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 116 "../src/Widgets/base/CyclingRevealLabel.vala"
	__lambda25_ ((TunerCyclingRevealLabel*) self, allocation);
#line 430 "CyclingRevealLabel.c"
}

static guint16*
_vala_array_dup1 (guint16* self,
                  gssize length)
{
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (length > 0) {
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
		return _vala_memdup2 (self, length * sizeof (guint16));
#line 441 "CyclingRevealLabel.c"
	}
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	return NULL;
#line 445 "CyclingRevealLabel.c"
}

TunerCyclingRevealLabel*
tuner_cycling_reveal_label_construct (GType object_type,
                                      GtkWidget* follow,
                                      gint min_label_width,
                                      const gchar* str)
{
	TunerCyclingRevealLabel * self = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	guint16* _tmp6_;
	gint _tmp6__length1;
	guint16* _tmp7_;
	gint _tmp7__length1;
#line 73 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_val_if_fail (follow != NULL, NULL);
#line 75 "../src/Widgets/base/CyclingRevealLabel.vala"
	self = (TunerCyclingRevealLabel*) g_object_new (object_type, NULL);
#line 77 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_ = tuner_reveal_label_get_label_child ((TunerRevealLabel*) self);
#line 77 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_ = _tmp0_;
#line 77 "../src/Widgets/base/CyclingRevealLabel.vala"
	gtk_label_set_line_wrap (_tmp1_, FALSE);
#line 78 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp2_ = tuner_reveal_label_get_label_child ((TunerRevealLabel*) self);
#line 78 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp3_ = _tmp2_;
#line 78 "../src/Widgets/base/CyclingRevealLabel.vala"
	gtk_label_set_justify (_tmp3_, GTK_JUSTIFY_CENTER);
#line 79 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp4_ = tuner_reveal_label_get_label_child (G_TYPE_CHECK_INSTANCE_CAST (self, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel));
#line 79 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp5_ = _tmp4_;
#line 79 "../src/Widgets/base/CyclingRevealLabel.vala"
	gtk_label_set_text (_tmp5_, str);
#line 81 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_min_label_width = min_label_width;
#line 83 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_signal_connect_object (follow, "size-allocate", (GCallback) ___lambda24__gtk_widget_size_allocate, self, 0);
#line 116 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) ___lambda25__gtk_widget_size_allocate, self, 0);
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp6_ = self->priv->_cycle_phases_fast;
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp6__length1 = self->priv->_cycle_phases_fast_length1;
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup1 (_tmp6_, _tmp6__length1) : _tmp6_;
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp7__length1 = _tmp6__length1;
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases = (g_free (self->priv->_cycle_phases), NULL);
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases = _tmp7_;
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases_length1 = _tmp7__length1;
#line 128 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->__cycle_phases_size_ = self->priv->_cycle_phases_length1;
#line 73 "../src/Widgets/base/CyclingRevealLabel.vala"
	return self;
#line 511 "CyclingRevealLabel.c"
}

TunerCyclingRevealLabel*
tuner_cycling_reveal_label_new (GtkWidget* follow,
                                gint min_label_width,
                                const gchar* str)
{
#line 73 "../src/Widgets/base/CyclingRevealLabel.vala"
	return tuner_cycling_reveal_label_construct (TUNER_TYPE_CYCLING_REVEAL_LABEL, follow, min_label_width, str);
#line 521 "CyclingRevealLabel.c"
}

/**
     * @brief gets/Sets the label
     *
     */
static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 538 "CyclingRevealLabel.c"
}

gboolean
tuner_cycling_reveal_label_set_text (TunerCyclingRevealLabel* self,
                                     const gchar* text)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean result;
#line 142 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 144 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_ = tuner_reveal_label_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel));
#line 144 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (g_strcmp0 (text, _tmp0_) == 0) {
#line 144 "../src/Widgets/base/CyclingRevealLabel.vala"
		result = TRUE;
#line 144 "../src/Widgets/base/CyclingRevealLabel.vala"
		return result;
#line 567 "CyclingRevealLabel.c"
	}
#line 150 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_ = tuner_reveal_label_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel));
#line 150 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp2_ = string_to_string (_tmp1_);
#line 150 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp3_ = string_to_string (text);
#line 150 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp4_ = g_strconcat ("CL set text: ", _tmp2_, " > ", _tmp3_, NULL);
#line 150 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp5_ = _tmp4_;
#line 150 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_debug ("CyclingRevealLabel.vala:150: %s", _tmp5_);
#line 150 "../src/Widgets/base/CyclingRevealLabel.vala"
	_g_free0 (_tmp5_);
#line 151 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (tuner_reveal_label_set_text (G_TYPE_CHECK_INSTANCE_CAST (self, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel), text)) {
#line 585 "CyclingRevealLabel.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 154 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp6_ = string_to_string (text);
#line 154 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp7_ = g_strconcat ("CL set text - Success: ", _tmp6_, NULL);
#line 154 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp8_ = _tmp7_;
#line 154 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_debug ("CyclingRevealLabel.vala:154: %s", _tmp8_);
#line 154 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (_tmp8_);
#line 166 "../src/Widgets/base/CyclingRevealLabel.vala"
		result = TRUE;
#line 166 "../src/Widgets/base/CyclingRevealLabel.vala"
		return result;
#line 603 "CyclingRevealLabel.c"
	}
#line 169 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp9_ = string_to_string (text);
#line 169 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp10_ = g_strconcat ("CL set text - Failed: ", _tmp9_, NULL);
#line 169 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp11_ = _tmp10_;
#line 169 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_debug ("CyclingRevealLabel.vala:169: %s", _tmp11_);
#line 169 "../src/Widgets/base/CyclingRevealLabel.vala"
	_g_free0 (_tmp11_);
#line 170 "../src/Widgets/base/CyclingRevealLabel.vala"
	result = FALSE;
#line 170 "../src/Widgets/base/CyclingRevealLabel.vala"
	return result;
#line 619 "CyclingRevealLabel.c"
}

/**
     * @brief Adds a sublabel at the given position
     *
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 644 "CyclingRevealLabel.c"
}

void
tuner_cycling_reveal_label_add_sublabel (TunerCyclingRevealLabel* self,
                                         gint position,
                                         const gchar* sublabel1,
                                         const gchar* sublabel2)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 223 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (position <= 0) {
#line 225 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp0_ = TRUE;
#line 661 "CyclingRevealLabel.c"
	} else {
		guint16* _tmp1_;
		gint _tmp1__length1;
#line 225 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp1_ = self->priv->_cycle_phases;
#line 225 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp1__length1 = self->priv->_cycle_phases_length1;
#line 225 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp0_ = position >= _tmp1__length1;
#line 671 "CyclingRevealLabel.c"
	}
#line 225 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (_tmp0_) {
#line 225 "../src/Widgets/base/CyclingRevealLabel.vala"
		return;
#line 677 "CyclingRevealLabel.c"
	}
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (sublabel1 == NULL) {
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp2_ = TRUE;
#line 683 "CyclingRevealLabel.c"
	} else {
		gchar* _tmp3_;
		gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp3_ = string_strip (sublabel1);
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp4_ = _tmp3_;
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp5_ = strlen (_tmp4_);
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp6_ = _tmp5_;
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp2_ = _tmp6_ == 0;
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (_tmp4_);
#line 701 "CyclingRevealLabel.c"
	}
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (_tmp2_) {
#line 705 "CyclingRevealLabel.c"
		GeeMap* _tmp7_;
#line 229 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp7_ = self->priv->sublabels;
#line 229 "../src/Widgets/base/CyclingRevealLabel.vala"
		gee_map_unset (_tmp7_, (gpointer) ((guintptr) position), NULL);
#line 711 "CyclingRevealLabel.c"
	} else {
		gchar* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
		gchar* text = NULL;
		gchar* _tmp20_;
		GeeMap* _tmp21_;
		const gchar* _tmp22_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
		if (sublabel2 == NULL) {
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp9_ = TRUE;
#line 723 "CyclingRevealLabel.c"
		} else {
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp10_ = string_strip (sublabel2);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp11_ = _tmp10_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp9_ = g_strcmp0 (_tmp11_, "") == 0;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp11_);
#line 735 "CyclingRevealLabel.c"
		}
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
		if (_tmp9_) {
#line 739 "CyclingRevealLabel.c"
			gchar* _tmp12_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp12_ = string_strip (sublabel1);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp8_);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp8_ = _tmp12_;
#line 747 "CyclingRevealLabel.c"
		} else {
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp13_ = string_strip (sublabel1);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp14_ = _tmp13_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp15_ = g_strconcat (_tmp14_, " - ", NULL);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp16_ = _tmp15_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp17_ = string_strip (sublabel2);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp18_ = _tmp17_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp19_ = g_strconcat (_tmp16_, _tmp18_, NULL);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp8_);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp8_ = _tmp19_;
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp18_);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp16_);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
			_g_free0 (_tmp14_);
#line 780 "CyclingRevealLabel.c"
		}
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp20_ = g_strdup (_tmp8_);
#line 233 "../src/Widgets/base/CyclingRevealLabel.vala"
		text = _tmp20_;
#line 234 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp21_ = self->priv->sublabels;
#line 234 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp22_ = text;
#line 234 "../src/Widgets/base/CyclingRevealLabel.vala"
		gee_map_set (_tmp21_, (gpointer) ((guintptr) position), _tmp22_);
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (text);
#line 227 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_free0 (_tmp8_);
#line 796 "CyclingRevealLabel.c"
	}
}

/**
     * @brief Stops cycling the labels
     *
     */
void
tuner_cycling_reveal_label_stop (TunerCyclingRevealLabel* self)
{
#line 262 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (self->priv->_label_cycle_id > ((guint) 0)) {
#line 266 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_source_remove (self->priv->_label_cycle_id);
#line 267 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_label_cycle_id = (guint) 0;
#line 815 "CyclingRevealLabel.c"
	}
#line 270 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (self->priv->_flourish_id > ((guint) 0)) {
#line 272 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_source_remove (self->priv->_flourish_id);
#line 273 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_flourish_id = (guint) 0;
#line 823 "CyclingRevealLabel.c"
	}
}

/**
     * @brief Clears the cycling of the subtitles
     *
     */
void
tuner_cycling_reveal_label_clear (TunerCyclingRevealLabel* self)
{
	GeeMap* _tmp0_;
#line 282 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/Widgets/base/CyclingRevealLabel.vala"
	tuner_cycling_reveal_label_stop (self);
#line 285 "../src/Widgets/base/CyclingRevealLabel.vala"
	tuner_reveal_label_clear (G_TYPE_CHECK_INSTANCE_CAST (self, TUNER_TYPE_REVEAL_LABEL, TunerRevealLabel));
#line 286 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_ = self->priv->sublabels;
#line 286 "../src/Widgets/base/CyclingRevealLabel.vala"
	gee_map_clear (_tmp0_);
#line 287 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_peak_label_width = 0;
#line 288 "../src/Widgets/base/CyclingRevealLabel.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, TUNER_CYCLING_REVEAL_LABEL_LABEL_WIDTH_MIN, -1);
#line 849 "CyclingRevealLabel.c"
}

/**
     * @brief Cycles the labels
     *
     */
static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	return _data8_;
#line 863 "CyclingRevealLabel.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 873 "CyclingRevealLabel.c"
		TunerCyclingRevealLabel* self;
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
		self = _data8_->self;
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_object_unref0 (self);
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_slice_free (Block8Data, _data8_);
#line 881 "CyclingRevealLabel.c"
	}
}

static gboolean
__lambda27_ (Block8Data* _data8_)
{
	TunerCyclingRevealLabel* self;
	guint16 _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 305 "../src/Widgets/base/CyclingRevealLabel.vala"
	self = _data8_->self;
#line 308 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_ = self->priv->_display_seconds;
#line 308 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_display_seconds = _tmp0_ + 1;
#line 310 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_ = self->priv->_min_count_down;
#line 310 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_min_count_down = _tmp1_ - 1;
#line 310 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (0 < _tmp1_) {
#line 312 "../src/Widgets/base/CyclingRevealLabel.vala"
		result = G_SOURCE_CONTINUE;
#line 312 "../src/Widgets/base/CyclingRevealLabel.vala"
		return result;
#line 910 "CyclingRevealLabel.c"
	}
#line 315 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp2_ = gtk_revealer_get_child_revealed ((GtkRevealer*) self);
#line 315 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp3_ = _tmp2_;
#line 315 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (!_tmp3_) {
#line 317 "../src/Widgets/base/CyclingRevealLabel.vala"
		gtk_revealer_set_reveal_child ((GtkRevealer*) self, TRUE);
#line 318 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_min_count_down = TUNER_CYCLING_REVEAL_LABEL_SUBTITLE_MIN_DISPLAY_SECONDS;
#line 319 "../src/Widgets/base/CyclingRevealLabel.vala"
		result = G_SOURCE_CONTINUE;
#line 319 "../src/Widgets/base/CyclingRevealLabel.vala"
		return result;
#line 926 "CyclingRevealLabel.c"
	}
	{
		GeeIterator* _position_it = NULL;
		GeeMap* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp4_ = self->priv->sublabels;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp5_ = gee_map_get_keys (_tmp4_);
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp6_ = _tmp5_;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp7_ = _tmp6_;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp9_ = _tmp8_;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_object_unref0 (_tmp7_);
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_position_it = _tmp9_;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		while (TRUE) {
#line 954 "CyclingRevealLabel.c"
			GeeIterator* _tmp10_;
			guint position = 0U;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_;
			gboolean _tmp15_ = FALSE;
			guint16* _tmp16_;
			gint _tmp16__length1;
			guint16 _tmp17_;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp10_ = _position_it;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
				break;
#line 971 "CyclingRevealLabel.c"
			}
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp11_ = _position_it;
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
			position = (guint) ((guintptr) _tmp12_);
#line 324 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp14_ = self->priv->_show_metadata;
#line 324 "../src/Widgets/base/CyclingRevealLabel.vala"
			if (!_tmp14_) {
#line 324 "../src/Widgets/base/CyclingRevealLabel.vala"
				_tmp13_ = position != ((guint) 0);
#line 985 "CyclingRevealLabel.c"
			} else {
#line 324 "../src/Widgets/base/CyclingRevealLabel.vala"
				_tmp13_ = FALSE;
#line 989 "CyclingRevealLabel.c"
			}
#line 324 "../src/Widgets/base/CyclingRevealLabel.vala"
			if (_tmp13_) {
#line 324 "../src/Widgets/base/CyclingRevealLabel.vala"
				break;
#line 995 "CyclingRevealLabel.c"
			}
#line 326 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp16_ = self->priv->_cycle_phases;
#line 326 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp16__length1 = self->priv->_cycle_phases_length1;
#line 326 "../src/Widgets/base/CyclingRevealLabel.vala"
			_tmp17_ = _tmp16_[position];
#line 326 "../src/Widgets/base/CyclingRevealLabel.vala"
			if (((gint) (self->priv->_display_seconds % _tmp17_)) == 0) {
#line 327 "../src/Widgets/base/CyclingRevealLabel.vala"
				_tmp15_ = position != _data8_->last_position;
#line 1007 "CyclingRevealLabel.c"
			} else {
#line 326 "../src/Widgets/base/CyclingRevealLabel.vala"
				_tmp15_ = FALSE;
#line 1011 "CyclingRevealLabel.c"
			}
#line 326 "../src/Widgets/base/CyclingRevealLabel.vala"
			if (_tmp15_) {
#line 1015 "CyclingRevealLabel.c"
				GeeMap* _tmp18_;
				gpointer _tmp19_;
				gchar* _tmp20_;
#line 331 "../src/Widgets/base/CyclingRevealLabel.vala"
				_tmp18_ = self->priv->sublabels;
#line 331 "../src/Widgets/base/CyclingRevealLabel.vala"
				_tmp19_ = gee_map_get (_tmp18_, (gpointer) ((guintptr) position));
#line 331 "../src/Widgets/base/CyclingRevealLabel.vala"
				_tmp20_ = (gchar*) _tmp19_;
#line 331 "../src/Widgets/base/CyclingRevealLabel.vala"
				tuner_cycling_reveal_label_set_text (self, _tmp20_);
#line 331 "../src/Widgets/base/CyclingRevealLabel.vala"
				_g_free0 (_tmp20_);
#line 332 "../src/Widgets/base/CyclingRevealLabel.vala"
				_data8_->last_position = position;
#line 1031 "CyclingRevealLabel.c"
			}
		}
#line 322 "../src/Widgets/base/CyclingRevealLabel.vala"
		_g_object_unref0 (_position_it);
#line 1036 "CyclingRevealLabel.c"
	}
#line 335 "../src/Widgets/base/CyclingRevealLabel.vala"
	result = G_SOURCE_CONTINUE;
#line 335 "../src/Widgets/base/CyclingRevealLabel.vala"
	return result;
#line 1042 "CyclingRevealLabel.c"
}

static gboolean
___lambda27__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda27_ (self);
#line 305 "../src/Widgets/base/CyclingRevealLabel.vala"
	return result;
#line 1052 "CyclingRevealLabel.c"
}

static gboolean
__lambda26_ (Block8Data* _data8_)
{
	TunerCyclingRevealLabel* self;
	gboolean result;
#line 302 "../src/Widgets/base/CyclingRevealLabel.vala"
	self = _data8_->self;
#line 305 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_label_cycle_id = g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 1, ___lambda27__gsource_func, block8_data_ref (_data8_), block8_data_unref);
#line 338 "../src/Widgets/base/CyclingRevealLabel.vala"
	result = G_SOURCE_REMOVE;
#line 338 "../src/Widgets/base/CyclingRevealLabel.vala"
	return result;
#line 1068 "CyclingRevealLabel.c"
}

static gboolean
___lambda26__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda26_ (self);
#line 302 "../src/Widgets/base/CyclingRevealLabel.vala"
	return result;
#line 1078 "CyclingRevealLabel.c"
}

void
tuner_cycling_reveal_label_cycle (TunerCyclingRevealLabel* self)
{
	Block8Data* _data8_;
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	_data8_->_ref_count_ = 1;
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	_data8_->self = g_object_ref (self);
#line 298 "../src/Widgets/base/CyclingRevealLabel.vala"
	tuner_cycling_reveal_label_stop (self);
#line 300 "../src/Widgets/base/CyclingRevealLabel.vala"
	_data8_->last_position = (guint) 99;
#line 302 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda26__gsource_func, block8_data_ref (_data8_), block8_data_unref);
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	block8_data_unref (_data8_);
#line 296 "../src/Widgets/base/CyclingRevealLabel.vala"
	_data8_ = NULL;
#line 1103 "CyclingRevealLabel.c"
}

gboolean
tuner_cycling_reveal_label_get_show_metadata (TunerCyclingRevealLabel* self)
{
	gboolean result;
#line 31 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/Widgets/base/CyclingRevealLabel.vala"
	result = self->priv->_show_metadata;
#line 31 "../src/Widgets/base/CyclingRevealLabel.vala"
	return result;
#line 1116 "CyclingRevealLabel.c"
}

void
tuner_cycling_reveal_label_set_show_metadata (TunerCyclingRevealLabel* self,
                                              gboolean value)
{
	gboolean old_value;
#line 31 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Widgets/base/CyclingRevealLabel.vala"
	old_value = tuner_cycling_reveal_label_get_show_metadata (self);
#line 31 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (old_value != value) {
#line 31 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_show_metadata = value;
#line 31 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_cycling_reveal_label_properties[TUNER_CYCLING_REVEAL_LABEL_SHOW_METADATA_PROPERTY]);
#line 1134 "CyclingRevealLabel.c"
	}
}

gboolean
tuner_cycling_reveal_label_get_metadata_fast_cycle (TunerCyclingRevealLabel* self)
{
	gboolean result;
#line 34 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/Widgets/base/CyclingRevealLabel.vala"
	result = self->priv->_metadata_fast_cycle;
#line 34 "../src/Widgets/base/CyclingRevealLabel.vala"
	return result;
#line 1148 "CyclingRevealLabel.c"
}

static guint16*
_vala_array_dup2 (guint16* self,
                  gssize length)
{
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (length > 0) {
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		return _vala_memdup2 (self, length * sizeof (guint16));
#line 1159 "CyclingRevealLabel.c"
	}
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
	return NULL;
#line 1163 "CyclingRevealLabel.c"
}

static guint16*
_vala_array_dup3 (guint16* self,
                  gssize length)
{
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (length > 0) {
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		return _vala_memdup2 (self, length * sizeof (guint16));
#line 1174 "CyclingRevealLabel.c"
	}
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
	return NULL;
#line 1178 "CyclingRevealLabel.c"
}

void
tuner_cycling_reveal_label_set_metadata_fast_cycle (TunerCyclingRevealLabel* self,
                                                    gboolean value)
{
#line 35 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (self->priv->_metadata_fast_cycle == value) {
#line 36 "../src/Widgets/base/CyclingRevealLabel.vala"
		return;
#line 1191 "CyclingRevealLabel.c"
	}
#line 37 "../src/Widgets/base/CyclingRevealLabel.vala"
	if (value) {
#line 1195 "CyclingRevealLabel.c"
		guint16* _tmp0_;
		gint _tmp0__length1;
		guint16* _tmp1_;
		gint _tmp1__length1;
#line 40 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_metadata_fast_cycle = TRUE;
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp0_ = self->priv->_cycle_phases_fast;
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp0__length1 = self->priv->_cycle_phases_fast_length1;
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup2 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp1__length1 = _tmp0__length1;
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_cycle_phases = (g_free (self->priv->_cycle_phases), NULL);
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_cycle_phases = _tmp1_;
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_cycle_phases_length1 = _tmp1__length1;
#line 41 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->__cycle_phases_size_ = self->priv->_cycle_phases_length1;
#line 1218 "CyclingRevealLabel.c"
	} else {
		guint16* _tmp2_;
		gint _tmp2__length1;
		guint16* _tmp3_;
		gint _tmp3__length1;
#line 46 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_metadata_fast_cycle = FALSE;
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp2_ = self->priv->_cycle_phases_slow;
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp2__length1 = self->priv->_cycle_phases_slow_length1;
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup3 (_tmp2_, _tmp2__length1) : _tmp2_;
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		_tmp3__length1 = _tmp2__length1;
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_cycle_phases = (g_free (self->priv->_cycle_phases), NULL);
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_cycle_phases = _tmp3_;
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->_cycle_phases_length1 = _tmp3__length1;
#line 47 "../src/Widgets/base/CyclingRevealLabel.vala"
		self->priv->__cycle_phases_size_ = self->priv->_cycle_phases_length1;
#line 1242 "CyclingRevealLabel.c"
	}
#line 35 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_cycling_reveal_label_properties[TUNER_CYCLING_REVEAL_LABEL_METADATA_FAST_CYCLE_PROPERTY]);
#line 1246 "CyclingRevealLabel.c"
}

const gchar*
tuner_cycling_reveal_label_get_label (TunerCyclingRevealLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 133 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_ = tuner_reveal_label_get_text ((TunerRevealLabel*) self);
#line 133 "../src/Widgets/base/CyclingRevealLabel.vala"
	result = _tmp0_;
#line 133 "../src/Widgets/base/CyclingRevealLabel.vala"
	return result;
#line 1262 "CyclingRevealLabel.c"
}

void
tuner_cycling_reveal_label_set_label (TunerCyclingRevealLabel* self,
                                      const gchar* value)
{
#line 134 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/Widgets/base/CyclingRevealLabel.vala"
	tuner_cycling_reveal_label_set_text (self, value);
#line 134 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_object_notify_by_pspec ((GObject *) self, tuner_cycling_reveal_label_properties[TUNER_CYCLING_REVEAL_LABEL_LABEL_PROPERTY]);
#line 1275 "CyclingRevealLabel.c"
}

static void
tuner_cycling_reveal_label_class_init (TunerCyclingRevealLabelClass * klass,
                                       gpointer klass_data)
{
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	tuner_cycling_reveal_label_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_type_class_adjust_private_offset (klass, &TunerCyclingRevealLabel_private_offset);
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_cycling_reveal_label_get_property;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_cycling_reveal_label_set_property;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_cycling_reveal_label_finalize;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_CYCLING_REVEAL_LABEL_SHOW_METADATA_PROPERTY, tuner_cycling_reveal_label_properties[TUNER_CYCLING_REVEAL_LABEL_SHOW_METADATA_PROPERTY] = g_param_spec_boolean ("show-metadata", "show-metadata", "show-metadata", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_CYCLING_REVEAL_LABEL_METADATA_FAST_CYCLE_PROPERTY, tuner_cycling_reveal_label_properties[TUNER_CYCLING_REVEAL_LABEL_METADATA_FAST_CYCLE_PROPERTY] = g_param_spec_boolean ("metadata-fast-cycle", "metadata-fast-cycle", "metadata-fast-cycle", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_CYCLING_REVEAL_LABEL_LABEL_PROPERTY, tuner_cycling_reveal_label_properties[TUNER_CYCLING_REVEAL_LABEL_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	tuner_cycling_reveal_label_signals[TUNER_CYCLING_REVEAL_LABEL_FLOURISH_COMPLETE_SIG_SIGNAL] = g_signal_new ("flourish-complete-sig", TUNER_TYPE_CYCLING_REVEAL_LABEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1300 "CyclingRevealLabel.c"
}

static void
tuner_cycling_reveal_label_instance_init (TunerCyclingRevealLabel * self,
                                          gpointer klass)
{
	guint16* _tmp0_;
	guint16* _tmp1_;
	GeeHashMap* _tmp2_;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv = tuner_cycling_reveal_label_get_instance_private (self);
#line 55 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_last_parent_width = 0;
#line 56 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_parent_unused_growth = 0;
#line 62 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_label_cycle_id = (guint) 0;
#line 63 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_flourish_id = (guint) 0;
#line 65 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_display_seconds = (guint16) 0;
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_ = g_new0 (guint16, 5);
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_[0] = (guint16) 5;
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_[1] = (guint16) 11;
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_[2] = (guint16) 17;
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_[3] = (guint16) 19;
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp0_[4] = (guint16) 23;
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases_fast = _tmp0_;
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases_fast_length1 = 5;
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->__cycle_phases_fast_size_ = self->priv->_cycle_phases_fast_length1;
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_ = g_new0 (guint16, 5);
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_[0] = (guint16) 23;
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_[1] = (guint16) 37;
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_[2] = (guint16) 43;
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_[3] = (guint16) 47;
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp1_[4] = (guint16) 53;
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases_slow = _tmp1_;
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases_slow_length1 = 5;
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->__cycle_phases_slow_size_ = self->priv->_cycle_phases_slow_length1;
#line 70 "../src/Widgets/base/CyclingRevealLabel.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 70 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->sublabels = (GeeMap*) _tmp2_;
#line 1362 "CyclingRevealLabel.c"
}

static void
tuner_cycling_reveal_label_finalize (GObject * obj)
{
	TunerCyclingRevealLabel * self;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_CYCLING_REVEAL_LABEL, TunerCyclingRevealLabel);
#line 66 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases_fast = (g_free (self->priv->_cycle_phases_fast), NULL);
#line 67 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases_slow = (g_free (self->priv->_cycle_phases_slow), NULL);
#line 68 "../src/Widgets/base/CyclingRevealLabel.vala"
	self->priv->_cycle_phases = (g_free (self->priv->_cycle_phases), NULL);
#line 70 "../src/Widgets/base/CyclingRevealLabel.vala"
	_g_object_unref0 (self->priv->sublabels);
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	G_OBJECT_CLASS (tuner_cycling_reveal_label_parent_class)->finalize (obj);
#line 1381 "CyclingRevealLabel.c"
}

/**
 * @class CyclingRevealLabel
 * @brief A custom widget that reveals a cycling label with animation.
 *
 * This class extends Tuner.RevealLabel to add cycling through of label text
 * and with damping between the different labels so grids do not bounce too much
 *
 * @extends Tuner.RevealLabel
 */
static GType
tuner_cycling_reveal_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerCyclingRevealLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_cycling_reveal_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerCyclingRevealLabel), 0, (GInstanceInitFunc) tuner_cycling_reveal_label_instance_init, NULL };
	GType tuner_cycling_reveal_label_type_id;
	tuner_cycling_reveal_label_type_id = g_type_register_static (TUNER_TYPE_REVEAL_LABEL, "TunerCyclingRevealLabel", &g_define_type_info, 0);
	TunerCyclingRevealLabel_private_offset = g_type_add_instance_private (tuner_cycling_reveal_label_type_id, sizeof (TunerCyclingRevealLabelPrivate));
	return tuner_cycling_reveal_label_type_id;
}

GType
tuner_cycling_reveal_label_get_type (void)
{
	static volatile gsize tuner_cycling_reveal_label_type_id__once = 0;
	if (g_once_init_enter (&tuner_cycling_reveal_label_type_id__once)) {
		GType tuner_cycling_reveal_label_type_id;
		tuner_cycling_reveal_label_type_id = tuner_cycling_reveal_label_get_type_once ();
		g_once_init_leave (&tuner_cycling_reveal_label_type_id__once, tuner_cycling_reveal_label_type_id);
	}
	return tuner_cycling_reveal_label_type_id__once;
}

static void
_vala_tuner_cycling_reveal_label_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	TunerCyclingRevealLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_CYCLING_REVEAL_LABEL, TunerCyclingRevealLabel);
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	switch (property_id) {
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		case TUNER_CYCLING_REVEAL_LABEL_SHOW_METADATA_PROPERTY:
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_value_set_boolean (value, tuner_cycling_reveal_label_get_show_metadata (self));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		break;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		case TUNER_CYCLING_REVEAL_LABEL_METADATA_FAST_CYCLE_PROPERTY:
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_value_set_boolean (value, tuner_cycling_reveal_label_get_metadata_fast_cycle (self));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		break;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		case TUNER_CYCLING_REVEAL_LABEL_LABEL_PROPERTY:
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		g_value_set_string (value, tuner_cycling_reveal_label_get_label (self));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		break;
#line 1443 "CyclingRevealLabel.c"
		default:
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		break;
#line 1449 "CyclingRevealLabel.c"
	}
}

static void
_vala_tuner_cycling_reveal_label_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	TunerCyclingRevealLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_TYPE_CYCLING_REVEAL_LABEL, TunerCyclingRevealLabel);
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
	switch (property_id) {
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		case TUNER_CYCLING_REVEAL_LABEL_SHOW_METADATA_PROPERTY:
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		tuner_cycling_reveal_label_set_show_metadata (self, g_value_get_boolean (value));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		break;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		case TUNER_CYCLING_REVEAL_LABEL_METADATA_FAST_CYCLE_PROPERTY:
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		tuner_cycling_reveal_label_set_metadata_fast_cycle (self, g_value_get_boolean (value));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		break;
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		case TUNER_CYCLING_REVEAL_LABEL_LABEL_PROPERTY:
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		tuner_cycling_reveal_label_set_label (self, g_value_get_string (value));
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		break;
#line 1481 "CyclingRevealLabel.c"
		default:
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Widgets/base/CyclingRevealLabel.vala"
		break;
#line 1487 "CyclingRevealLabel.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

