/* StackLabel.c generated by valac 0.56.17, the Vala compiler
 * generated from StackLabel.vala, do not modify */

/*
 * SPDX-FileCopyrightText: 2020-2022 Louis Brauer <louis@brauer.family> 
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_TYPE_STACK_LABEL (tuner_stack_label_get_type ())
#define TUNER_STACK_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_STACK_LABEL, TunerStackLabel))
#define TUNER_STACK_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_STACK_LABEL, TunerStackLabelClass))
#define TUNER_IS_STACK_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_STACK_LABEL))
#define TUNER_IS_STACK_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_STACK_LABEL))
#define TUNER_STACK_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_STACK_LABEL, TunerStackLabelClass))

typedef struct _TunerStackLabel TunerStackLabel;
typedef struct _TunerStackLabelClass TunerStackLabelClass;
typedef struct _TunerStackLabelPrivate TunerStackLabelPrivate;
enum  {
	TUNER_STACK_LABEL_0_PROPERTY,
	TUNER_STACK_LABEL_NUM_PROPERTIES
};
static GParamSpec* tuner_stack_label_properties[TUNER_STACK_LABEL_NUM_PROPERTIES];

struct _TunerStackLabel {
	GtkLabel parent_instance;
	TunerStackLabelPrivate * priv;
};

struct _TunerStackLabelClass {
	GtkLabelClass parent_class;
};

static gpointer tuner_stack_label_parent_class = NULL;

VALA_EXTERN GType tuner_stack_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerStackLabel, g_object_unref)
VALA_EXTERN TunerStackLabel* tuner_stack_label_new (const gchar* label,
                                        gint xpad,
                                        gint ypad);
VALA_EXTERN TunerStackLabel* tuner_stack_label_construct (GType object_type,
                                              const gchar* label,
                                              gint xpad,
                                              gint ypad);
static GObject * tuner_stack_label_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static GType tuner_stack_label_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

TunerStackLabel*
tuner_stack_label_construct (GType object_type,
                             const gchar* label,
                             gint xpad,
                             gint ypad)
{
	TunerStackLabel * self = NULL;
#line 20 "../src/Widgets/base/StackLabel.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 22 "../src/Widgets/base/StackLabel.vala"
	self = (TunerStackLabel*) g_object_new (object_type, "label", label, "xpad", xpad, "ypad", ypad, NULL);
#line 20 "../src/Widgets/base/StackLabel.vala"
	return self;
#line 94 "StackLabel.c"
}

TunerStackLabel*
tuner_stack_label_new (const gchar* label,
                       gint xpad,
                       gint ypad)
{
#line 20 "../src/Widgets/base/StackLabel.vala"
	return tuner_stack_label_construct (TUNER_TYPE_STACK_LABEL, label, xpad, ypad);
#line 104 "StackLabel.c"
}

static GObject *
tuner_stack_label_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TunerStackLabel * self;
	GtkStyleContext* _tmp0_;
#line 29 "../src/Widgets/base/StackLabel.vala"
	parent_class = G_OBJECT_CLASS (tuner_stack_label_parent_class);
#line 29 "../src/Widgets/base/StackLabel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 29 "../src/Widgets/base/StackLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_TYPE_STACK_LABEL, TunerStackLabel);
#line 30 "../src/Widgets/base/StackLabel.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_START);
#line 31 "../src/Widgets/base/StackLabel.vala"
	gtk_label_set_xalign ((GtkLabel*) self, (gfloat) 0);
#line 32 "../src/Widgets/base/StackLabel.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 32 "../src/Widgets/base/StackLabel.vala"
	gtk_style_context_add_class (_tmp0_, "stack-label");
#line 29 "../src/Widgets/base/StackLabel.vala"
	return obj;
#line 132 "StackLabel.c"
}

static void
tuner_stack_label_class_init (TunerStackLabelClass * klass,
                              gpointer klass_data)
{
#line 17 "../src/Widgets/base/StackLabel.vala"
	tuner_stack_label_parent_class = g_type_class_peek_parent (klass);
#line 17 "../src/Widgets/base/StackLabel.vala"
	G_OBJECT_CLASS (klass)->constructor = tuner_stack_label_constructor;
#line 143 "StackLabel.c"
}

static void
tuner_stack_label_instance_init (TunerStackLabel * self,
                                 gpointer klass)
{
}

/**
 * @class StackLabel
 * @brief A custom label widget for stack headers.
 *
 * This class extends Gtk.Label to create a specialized label
 * for use as stack headers in the application.
 *
 * @extends Gtk.Label
 */
static GType
tuner_stack_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerStackLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_stack_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerStackLabel), 0, (GInstanceInitFunc) tuner_stack_label_instance_init, NULL };
	GType tuner_stack_label_type_id;
	tuner_stack_label_type_id = g_type_register_static (gtk_label_get_type (), "TunerStackLabel", &g_define_type_info, 0);
	return tuner_stack_label_type_id;
}

GType
tuner_stack_label_get_type (void)
{
	static volatile gsize tuner_stack_label_type_id__once = 0;
	if (g_once_init_enter (&tuner_stack_label_type_id__once)) {
		GType tuner_stack_label_type_id;
		tuner_stack_label_type_id = tuner_stack_label_get_type_once ();
		g_once_init_leave (&tuner_stack_label_type_id__once, tuner_stack_label_type_id);
	}
	return tuner_stack_label_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

