/* RadioBrowser.c generated by valac 0.56.17, the Vala compiler
 * generated from RadioBrowser.vala, do not modify */

/**
 * SPDX-FileCopyrightText: Copyright © 2020-2024 Louis Brauer <louis@brauer.family>
 * SPDX-FileCopyrightText: Copyright © 2024 technosf <https://github.com/technosf>
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @file RadioBrowser.vala
 *
 * @brief Interface to radio-browser.info API and servers
 * 
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <json-glib/json-glib.h>

#define TUNER_DATA_PROVIDER_SRV_SERVICE "api"
#define TUNER_DATA_PROVIDER_SRV_PROTOCOL "tcp"
#define TUNER_DATA_PROVIDER_SRV_DOMAIN "radio-browser.info"
#define TUNER_DATA_PROVIDER_RBI_ALL_API "all.api.radio-browser.info"
#define TUNER_DATA_PROVIDER_RBI_STATS "/json/stats"
#define TUNER_DATA_PROVIDER_RBI_SERVERS "/json/servers"
#define TUNER_DATA_PROVIDER_RBI_STATION "/json/url/$stationuuid"
#define TUNER_DATA_PROVIDER_RBI_SEARCH "/json/stations/search"
#define TUNER_DATA_PROVIDER_RBI_VOTE "/json/vote/$stationuuid"
#define TUNER_DATA_PROVIDER_RBI_UUID "/json/stations/byuuid"
#define TUNER_DATA_PROVIDER_RBI_URL "/json/stations/byurl"
#define TUNER_DATA_PROVIDER_RBI_TAGS "/json/tags"
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_CAPITAL 100
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_COST 7
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUNER_DATA_PROVIDER_TYPE_API (tuner_data_provider_api_get_type ())
#define TUNER_DATA_PROVIDER_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPI))
#define TUNER_DATA_PROVIDER_IS_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_API))
#define TUNER_DATA_PROVIDER_API_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TUNER_DATA_PROVIDER_TYPE_API, TunerDataProviderAPIIface))

typedef struct _TunerDataProviderAPI TunerDataProviderAPI;
typedef struct _TunerDataProviderAPIIface TunerDataProviderAPIIface;

#define TUNER_DATA_PROVIDER_TYPE_TAG (tuner_data_provider_tag_get_type ())
#define TUNER_DATA_PROVIDER_TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTag))
#define TUNER_DATA_PROVIDER_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))
#define TUNER_DATA_PROVIDER_IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_DATA_PROVIDER_TYPE_TAG))
#define TUNER_DATA_PROVIDER_TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_DATA_PROVIDER_TYPE_TAG, TunerDataProviderTagClass))

typedef struct _TunerDataProviderTag TunerDataProviderTag;
typedef struct _TunerDataProviderTagClass TunerDataProviderTagClass;

#define TUNER_DATA_PROVIDER_TYPE_DATA_ERROR (tuner_data_provider_data_error_get_type ())

#define TUNER_MODEL_TYPE_FAVICON (tuner_model_favicon_get_type ())
#define TUNER_MODEL_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFavicon))
#define TUNER_MODEL_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))
#define TUNER_MODEL_IS_FAVICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_IS_FAVICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_FAVICON))
#define TUNER_MODEL_FAVICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_FAVICON, TunerModelFaviconClass))

typedef struct _TunerModelFavicon TunerModelFavicon;
typedef struct _TunerModelFaviconClass TunerModelFaviconClass;

#define TUNER_MODEL_TYPE_STATION (tuner_model_station_get_type ())
#define TUNER_MODEL_STATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStation))
#define TUNER_MODEL_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))
#define TUNER_MODEL_IS_STATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_IS_STATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_MODEL_TYPE_STATION))
#define TUNER_MODEL_STATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_MODEL_TYPE_STATION, TunerModelStationClass))

typedef struct _TunerModelStation TunerModelStation;
typedef struct _TunerModelStationClass TunerModelStationClass;

#define TUNER_DATA_PROVIDER_TYPE_SEARCH_PARAMS (tuner_data_provider_search_params_get_type ())
typedef struct _TunerDataProviderSearchParams TunerDataProviderSearchParams;
typedef enum  {
	TUNER_DATA_PROVIDER_SORT_ORDER_NAME,
	TUNER_DATA_PROVIDER_SORT_ORDER_URL,
	TUNER_DATA_PROVIDER_SORT_ORDER_HOMEPAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_FAVICON,
	TUNER_DATA_PROVIDER_SORT_ORDER_TAGS,
	TUNER_DATA_PROVIDER_SORT_ORDER_COUNTRY,
	TUNER_DATA_PROVIDER_SORT_ORDER_STATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LANGUAGE,
	TUNER_DATA_PROVIDER_SORT_ORDER_VOTES,
	TUNER_DATA_PROVIDER_SORT_ORDER_CODEC,
	TUNER_DATA_PROVIDER_SORT_ORDER_BITRATE,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKOK,
	TUNER_DATA_PROVIDER_SORT_ORDER_LASTCHECKTIME,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTIMESTAMP,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKCOUNT,
	TUNER_DATA_PROVIDER_SORT_ORDER_CLICKTREND,
	TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM
} TunerDataProviderSortOrder;

#define TUNER_DATA_PROVIDER_TYPE_SORT_ORDER (tuner_data_provider_sort_order_get_type ())
typedef enum  {
	TUNER_DATA_PROVIDER_API_STATUS_OK,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST,
	TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED,
	TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE,
	TUNER_DATA_PROVIDER_API_STATUS_UNKNOW_ERROR
} TunerDataProviderAPIStatus;

#define TUNER_DATA_PROVIDER_API_TYPE_STATUS (tuner_data_provider_api_status_get_type ())

#define TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER (tuner_data_provider_radio_browser_get_type ())
#define TUNER_DATA_PROVIDER_RADIO_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser))
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowserClass))
#define TUNER_DATA_PROVIDER_IS_RADIO_BROWSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER))
#define TUNER_DATA_PROVIDER_IS_RADIO_BROWSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER))
#define TUNER_DATA_PROVIDER_RADIO_BROWSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowserClass))

typedef struct _TunerDataProviderRadioBrowser TunerDataProviderRadioBrowser;
typedef struct _TunerDataProviderRadioBrowserClass TunerDataProviderRadioBrowserClass;
typedef struct _TunerDataProviderRadioBrowserPrivate TunerDataProviderRadioBrowserPrivate;
enum  {
	TUNER_DATA_PROVIDER_RADIO_BROWSER_0_PROPERTY,
	TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY,
	TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY,
	TUNER_DATA_PROVIDER_RADIO_BROWSER_NUM_PROPERTIES
};
static GParamSpec* tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))

#define TUNER_TYPE_APPLICATION (tuner_application_get_type ())
#define TUNER_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUNER_TYPE_APPLICATION, TunerApplication))
#define TUNER_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUNER_TYPE_APPLICATION, TunerApplicationClass))
#define TUNER_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUNER_TYPE_APPLICATION))
#define TUNER_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUNER_TYPE_APPLICATION))
#define TUNER_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUNER_TYPE_APPLICATION, TunerApplicationClass))

typedef struct _TunerApplication TunerApplication;
typedef struct _TunerApplicationClass TunerApplicationClass;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _TunerDataProviderRadioBrowserSearchAsyncData TunerDataProviderRadioBrowserSearchAsyncData;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
typedef struct _TunerDataProviderRadioBrowserStationQueryAsyncData TunerDataProviderRadioBrowserStationQueryAsyncData;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
#define __vala_GSrvTarget_free0(var) ((var == NULL) ? NULL : (var = (_vala_GSrvTarget_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

typedef enum  {
	TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA,
	TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION
} TunerDataProviderDataError;
#define TUNER_DATA_PROVIDER_DATA_ERROR tuner_data_provider_data_error_quark ()

struct _TunerDataProviderSearchParams {
	gchar* text;
	GeeSet* tags;
	GeeSet* uuids;
	gchar* countrycode;
	TunerDataProviderSortOrder order;
	gboolean reverse;
};

struct _TunerDataProviderAPIIface {
	GTypeInterface parent_iface;
	void (*clear_last_error) (TunerDataProviderAPI* self);
	gchar* (*name) (TunerDataProviderAPI* self);
	gint (*available_stations) (TunerDataProviderAPI* self);
	gint (*available_tags) (TunerDataProviderAPI* self);
	gboolean (*initialize) (TunerDataProviderAPI* self);
	void (*click) (TunerDataProviderAPI* self, const gchar* stationuuid);
	void (*vote) (TunerDataProviderAPI* self, const gchar* stationuuid);
	GeeSet* (*get_tags) (TunerDataProviderAPI* self, gint offset, gint limit, GError** error);
	GeeSet* (*by_uuid) (TunerDataProviderAPI* self, const gchar* uuids, GError** error);
	GeeSet* (*by_uuids) (TunerDataProviderAPI* self, GeeCollection* uuids, GError** error);
	GeeSet* (*search) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GError** error);
	void (*search_async) (TunerDataProviderAPI* self, TunerDataProviderSearchParams* params, guint rowcount, guint offset, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeSet* (*search_finish) (TunerDataProviderAPI* self, GAsyncResult* _res_, GError** error);
	GError* (*get_last_data_error) (TunerDataProviderAPI* self);
	void (*set_last_data_error) (TunerDataProviderAPI* self, GError* value);
	TunerDataProviderAPIStatus (*get_status) (TunerDataProviderAPI* self);
	void (*set_status) (TunerDataProviderAPI* self, TunerDataProviderAPIStatus value);
};

struct _TunerDataProviderRadioBrowser {
	GObject parent_instance;
	TunerDataProviderRadioBrowserPrivate * priv;
};

struct _TunerDataProviderRadioBrowserClass {
	GObjectClass parent_class;
};

struct _TunerDataProviderRadioBrowserPrivate {
	gchar* _optionalservers;
	GeeArrayList* _servers;
	gchar* _current_server;
	gint _degrade;
	gint _available_stations;
	gint _available_tags;
	TunerDataProviderAPIStatus _status;
	GError* _last_data_error;
};

struct _TunerDataProviderRadioBrowserSearchAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerDataProviderRadioBrowser* self;
	TunerDataProviderSearchParams params;
	guint rowcount;
	guint offset;
	GeeSet* result;
	TunerDataProviderSearchParams _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	TunerDataProviderSearchParams _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	GeeSet* _tmp6_;
	gchar* query;
	TunerDataProviderSearchParams _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GeeSet* _tmp13_;
	const gchar* _tmp14_;
	GeeSet* _tmp15_;
	GeeSet* _tmp16_;
	GError* _inner_error0_;
};

struct _TunerDataProviderRadioBrowserStationQueryAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	TunerDataProviderRadioBrowser* self;
	gchar* path;
	gchar* query;
	GeeSet* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint status_code;
	GUri* uri;
	GUri* _tmp4_;
	GUri* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GInputStream* stream;
	GUri* _tmp11_;
	guint _tmp12_;
	GInputStream* _tmp13_;
	gboolean _tmp14_;
	GInputStream* _tmp15_;
	GeeSet* stations;
	GInputStream* _tmp16_;
	GeeSet* _tmp17_;
	GError* e;
	GError* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GUri* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GUri* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GeeHashSet* _tmp34_;
	GError* _inner_error0_;
};

struct _Block4Data {
	int _ref_count_;
	TunerDataProviderRadioBrowser* self;
	GeeHashSet* stations;
};

struct _Block5Data {
	int _ref_count_;
	TunerDataProviderRadioBrowser* self;
	GeeHashSet* tags;
};

struct _Block6Data {
	int _ref_count_;
	TunerDataProviderRadioBrowser* self;
	GeeArrayList* results;
};

static gint TunerDataProviderRadioBrowser_private_offset;
static gpointer tuner_data_provider_radio_browser_parent_class = NULL;
static TunerDataProviderAPIIface * tuner_data_provider_radio_browser_tuner_data_provider_api_parent_iface = NULL;

VALA_EXTERN GType tuner_data_provider_tag_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderTag, g_object_unref)
VALA_EXTERN GQuark tuner_data_provider_data_error_quark (void);
VALA_EXTERN GType tuner_data_provider_data_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_model_favicon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelFavicon, g_object_unref)
VALA_EXTERN GType tuner_model_station_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerModelStation, g_object_unref)
VALA_EXTERN GType tuner_data_provider_search_params_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_sort_order_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TunerDataProviderSearchParams* tuner_data_provider_search_params_dup (const TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_free (TunerDataProviderSearchParams* self);
VALA_EXTERN void tuner_data_provider_search_params_copy (const TunerDataProviderSearchParams* self,
                                             TunerDataProviderSearchParams* dest);
VALA_EXTERN void tuner_data_provider_search_params_destroy (TunerDataProviderSearchParams* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (TunerDataProviderSearchParams, tuner_data_provider_search_params_destroy)
VALA_EXTERN GType tuner_data_provider_api_status_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType tuner_data_provider_api_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderAPI, g_object_unref)
VALA_EXTERN GType tuner_data_provider_radio_browser_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerDataProviderRadioBrowser, g_object_unref)
static gchar* tuner_data_provider_radio_browser_real_name (TunerDataProviderAPI* base);
static gint tuner_data_provider_radio_browser_real_available_stations (TunerDataProviderAPI* base);
static gint tuner_data_provider_radio_browser_real_available_tags (TunerDataProviderAPI* base);
VALA_EXTERN TunerDataProviderRadioBrowser* tuner_data_provider_radio_browser_new (const gchar* optionalservers);
VALA_EXTERN TunerDataProviderRadioBrowser* tuner_data_provider_radio_browser_construct (GType object_type,
                                                                            const gchar* optionalservers);
VALA_EXTERN void tuner_data_provider_api_set_status (TunerDataProviderAPI* self,
                                         TunerDataProviderAPIStatus value);
static GUri* tuner_data_provider_radio_browser_build_uri (TunerDataProviderRadioBrowser* self,
                                                   const gchar* path,
                                                   const gchar* query);
static gboolean tuner_data_provider_radio_browser_real_initialize (TunerDataProviderAPI* base);
VALA_EXTERN GType tuner_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TunerApplication, g_object_unref)
VALA_EXTERN TunerApplication* tuner_app (void);
VALA_EXTERN gboolean tuner_application_get_is_offline (TunerApplication* self);
static GeeArrayList* tuner_data_provider_radio_browser_get_srv_api_servers (TunerDataProviderRadioBrowser* self,
                                                                     GError** error);
VALA_EXTERN void tuner_data_provider_api_set_last_data_error (TunerDataProviderAPI* self,
                                                  GError* value);
static void tuner_data_provider_radio_browser_choose_server (TunerDataProviderRadioBrowser* self);
VALA_EXTERN void tuner_data_provider_api_clear_last_error (TunerDataProviderAPI* self);
static void tuner_data_provider_radio_browser_stats (TunerDataProviderRadioBrowser* self);
static void tuner_data_provider_radio_browser_real_click (TunerDataProviderAPI* base,
                                                   const gchar* stationuuid);
VALA_EXTERN GInputStream* tuner_http_client_GET (GUri* uri,
                                     guint* status_code);
static void tuner_data_provider_radio_browser_real_vote (TunerDataProviderAPI* base,
                                                  const gchar* stationuuid);
static GeeSet* tuner_data_provider_radio_browser_real_get_tags (TunerDataProviderAPI* base,
                                                         gint offset,
                                                         gint limit,
                                                         GError** error);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static GeeSet* tuner_data_provider_radio_browser_jarray_to_tags (TunerDataProviderRadioBrowser* self,
                                                          JsonArray* data);
static GeeSet* tuner_data_provider_radio_browser_real_by_uuid (TunerDataProviderAPI* base,
                                                        const gchar* uuid,
                                                        GError** error);
VALA_EXTERN const gchar* tuner_safestrip (const gchar* text);
static GeeSet* tuner_data_provider_radio_browser_station_query (TunerDataProviderRadioBrowser* self,
                                                         const gchar* path,
                                                         const gchar* query,
                                                         GError** error);
static GeeSet* tuner_data_provider_radio_browser_real_by_uuids (TunerDataProviderAPI* base,
                                                         GeeCollection* uuids,
                                                         GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_by_uuid (TunerDataProviderAPI* self,
                                         const gchar* uuids,
                                         GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_radio_browser_by_url (TunerDataProviderRadioBrowser* self,
                                                  const gchar* url,
                                                  GError** error);
static GeeSet* tuner_data_provider_radio_browser_real_search (TunerDataProviderAPI* base,
                                                       TunerDataProviderSearchParams* params,
                                                       guint rowcount,
                                                       guint offset,
                                                       GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_by_uuids (TunerDataProviderAPI* self,
                                          GeeCollection* uuids,
                                          GError** error);
static gchar* tuner_data_provider_radio_browser_get_search_query_params (TunerDataProviderRadioBrowser* self,
                                                                  TunerDataProviderSearchParams* params,
                                                                  guint rowcount,
                                                                  guint offset);
static void tuner_data_provider_radio_browser_real_search_async_data_free (gpointer _data);
static void tuner_data_provider_radio_browser_real_search_async (TunerDataProviderAPI* base,
                                                          TunerDataProviderSearchParams* params,
                                                          guint rowcount,
                                                          guint offset,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static gboolean tuner_data_provider_radio_browser_real_search_async_co (TunerDataProviderRadioBrowserSearchAsyncData* _data_);
static void tuner_data_provider_radio_browser_station_query_async (TunerDataProviderRadioBrowser* self,
                                                            const gchar* path,
                                                            const gchar* query,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_);
static GeeSet* tuner_data_provider_radio_browser_station_query_finish (TunerDataProviderRadioBrowser* self,
                                                                GAsyncResult* _res_,
                                                                GError** error);
static void tuner_data_provider_radio_browser_search_async_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void tuner_data_provider_radio_browser_degrade (TunerDataProviderRadioBrowser* self,
                                                gboolean degraded);
static GeeSet* tuner_data_provider_radio_browser_parse_json_response (TunerDataProviderRadioBrowser* self,
                                                               GInputStream* stream,
                                                               GError** error);
static void tuner_data_provider_radio_browser_station_query_async_data_free (gpointer _data);
static gboolean tuner_data_provider_radio_browser_station_query_async_co (TunerDataProviderRadioBrowserStationQueryAsyncData* _data_);
VALA_EXTERN void tuner_http_client_GETasync (GUri* uri,
                                 gint priority,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN GInputStream* tuner_http_client_GETasync_finish (GAsyncResult* _res_,
                                                 guint* status_code);
static void tuner_data_provider_radio_browser_station_query_async_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
VALA_EXTERN gchar* tuner_data_provider_sort_order_to_string (TunerDataProviderSortOrder self);
static gchar* tuner_data_provider_radio_browser_encode_text (const gchar* tag);
static GeeSet* tuner_data_provider_radio_browser_jarray_to_stations (TunerDataProviderRadioBrowser* self,
                                                              JsonArray* data);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ___lambda101_ (Block4Data* _data4_,
                    JsonArray* array,
                    guint index,
                    JsonNode* element);
VALA_EXTERN TunerModelStation* tuner_model_station_make (JsonNode* json_node);
static void ____lambda101__json_array_foreach (JsonArray* array,
                                        guint index_,
                                        JsonNode* element_node,
                                        gpointer self);
static TunerDataProviderTag* tuner_data_provider_radio_browser_jnode_to_tag (TunerDataProviderRadioBrowser* self,
                                                                      JsonNode* node);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda100_ (Block5Data* _data5_,
                    JsonArray* array,
                    guint index,
                    JsonNode* element);
static void ____lambda100__json_array_foreach (JsonArray* array,
                                        guint index_,
                                        JsonNode* element_node,
                                        gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static GSrvTarget* _vala_GSrvTarget_copy (GSrvTarget* self);
static void _vala_GSrvTarget_free (GSrvTarget* self);
static void __vala_GSrvTarget_free0_ (gpointer var);
static inline void _g_list_free___vala_GSrvTarget_free0_ (GList* self);
static void ______lambda99_ (Block6Data* _data6_,
                      JsonArray* array,
                      guint index_,
                      JsonNode* element_node);
static void _______lambda99__json_array_foreach (JsonArray* array,
                                          guint index_,
                                          JsonNode* element_node,
                                          gpointer self);
VALA_EXTERN gchar* tuner_data_provider_api_name (TunerDataProviderAPI* self);
VALA_EXTERN gint tuner_data_provider_api_available_stations (TunerDataProviderAPI* self);
VALA_EXTERN gint tuner_data_provider_api_available_tags (TunerDataProviderAPI* self);
VALA_EXTERN gboolean tuner_data_provider_api_initialize (TunerDataProviderAPI* self);
VALA_EXTERN void tuner_data_provider_api_click (TunerDataProviderAPI* self,
                                    const gchar* stationuuid);
VALA_EXTERN void tuner_data_provider_api_vote (TunerDataProviderAPI* self,
                                   const gchar* stationuuid);
VALA_EXTERN GeeSet* tuner_data_provider_api_get_tags (TunerDataProviderAPI* self,
                                          gint offset,
                                          gint limit,
                                          GError** error);
VALA_EXTERN GeeSet* tuner_data_provider_api_search (TunerDataProviderAPI* self,
                                        TunerDataProviderSearchParams* params,
                                        guint rowcount,
                                        guint offset,
                                        GError** error);
VALA_EXTERN void tuner_data_provider_api_search_async (TunerDataProviderAPI* self,
                                           TunerDataProviderSearchParams* params,
                                           guint rowcount,
                                           guint offset,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN GeeSet* tuner_data_provider_api_search_finish (TunerDataProviderAPI* self,
                                               GAsyncResult* _res_,
                                               GError** error);
VALA_EXTERN TunerDataProviderAPIStatus tuner_data_provider_api_get_status (TunerDataProviderAPI* self);
VALA_EXTERN GError* tuner_data_provider_api_get_last_data_error (TunerDataProviderAPI* self);
static void tuner_data_provider_radio_browser_finalize (GObject * obj);
static GType tuner_data_provider_radio_browser_get_type_once (void);
static void _vala_tuner_data_provider_radio_browser_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_tuner_data_provider_radio_browser_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
tuner_data_provider_radio_browser_get_instance_private (TunerDataProviderRadioBrowser* self)
{
	return G_STRUCT_MEMBER_P (self, TunerDataProviderRadioBrowser_private_offset);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 560 "RadioBrowser.c"
}

static gchar*
tuner_data_provider_radio_browser_real_name (TunerDataProviderAPI* base)
{
	TunerDataProviderRadioBrowser * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 69 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 71 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = self->priv->_current_server;
#line 71 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = string_to_string (_tmp0_);
#line 71 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = g_strconcat ("RadioBrowser 2.0\n\nServer: ", _tmp1_, NULL);
#line 71 "../src/Providers/RadioBrowser.vala"
	result = _tmp2_;
#line 71 "../src/Providers/RadioBrowser.vala"
	return result;
#line 583 "RadioBrowser.c"
}

static gint
tuner_data_provider_radio_browser_real_available_stations (TunerDataProviderAPI* base)
{
	TunerDataProviderRadioBrowser * self;
	gint result;
#line 79 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 81 "../src/Providers/RadioBrowser.vala"
	result = self->priv->_available_stations;
#line 81 "../src/Providers/RadioBrowser.vala"
	return result;
#line 597 "RadioBrowser.c"
}

static gint
tuner_data_provider_radio_browser_real_available_tags (TunerDataProviderAPI* base)
{
	TunerDataProviderRadioBrowser * self;
	gint result;
#line 84 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 86 "../src/Providers/RadioBrowser.vala"
	result = self->priv->_available_tags;
#line 86 "../src/Providers/RadioBrowser.vala"
	return result;
#line 611 "RadioBrowser.c"
}

/**
        * @brief Constructor for RadioBrowser Client
        *
        * @throw DataError if unable to initialize the client
        */
TunerDataProviderRadioBrowser*
tuner_data_provider_radio_browser_construct (GType object_type,
                                             const gchar* optionalservers)
{
	TunerDataProviderRadioBrowser * self = NULL;
	gchar* _tmp0_;
#line 97 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) g_object_new (object_type, NULL);
#line 98 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = g_strdup (optionalservers);
#line 98 "../src/Providers/RadioBrowser.vala"
	_g_free0 (self->priv->_optionalservers);
#line 98 "../src/Providers/RadioBrowser.vala"
	self->priv->_optionalservers = _tmp0_;
#line 99 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, TUNER_DATA_PROVIDER_API_STATUS_NOT_AVAILABLE);
#line 95 "../src/Providers/RadioBrowser.vala"
	return self;
#line 637 "RadioBrowser.c"
}

TunerDataProviderRadioBrowser*
tuner_data_provider_radio_browser_new (const gchar* optionalservers)
{
#line 95 "../src/Providers/RadioBrowser.vala"
	return tuner_data_provider_radio_browser_construct (TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, optionalservers);
#line 645 "RadioBrowser.c"
}

/**
         * @brief Builds a Glib Uri from path and query
         *
         * Uses Glib Uri Parse with encoding to correctly check and encode the query
         *
         * @return the Uri if successful
         */
static GUri*
tuner_data_provider_radio_browser_build_uri (TunerDataProviderRadioBrowser* self,
                                             const gchar* path,
                                             const gchar* query)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* _inner_error0_ = NULL;
	GUri* result;
#line 110 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 110 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 112 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = self->priv->_current_server;
#line 112 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = string_to_string (_tmp0_);
#line 112 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = string_to_string (path);
#line 112 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = string_to_string (query);
#line 112 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = g_strconcat ("http://", _tmp1_, _tmp2_, "?", _tmp3_, NULL);
#line 112 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = _tmp4_;
#line 112 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:112: %s", _tmp5_);
#line 112 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp5_);
#line 690 "RadioBrowser.c"
	{
#line 114 "../src/Providers/RadioBrowser.vala"
		if (g_strcmp0 (query, "") == 0) {
#line 694 "RadioBrowser.c"
			GUri* _tmp6_ = NULL;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GUri* _tmp12_;
			GUri* _tmp13_;
			GUri* _tmp14_;
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp7_ = self->priv->_current_server;
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp8_ = string_to_string (_tmp7_);
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp9_ = string_to_string (path);
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp10_ = g_strconcat ("http://", _tmp8_, _tmp9_, NULL);
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp11_ = _tmp10_;
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp12_ = g_uri_parse (_tmp11_, G_URI_FLAGS_ENCODED, &_inner_error0_);
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp13_ = _tmp12_;
#line 116 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp11_);
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp6_ = _tmp13_;
#line 116 "../src/Providers/RadioBrowser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 116 "../src/Providers/RadioBrowser.vala"
				if (_inner_error0_->domain == G_URI_ERROR) {
#line 726 "RadioBrowser.c"
					goto __catch0_g_uri_error;
				}
#line 116 "../src/Providers/RadioBrowser.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 116 "../src/Providers/RadioBrowser.vala"
				g_clear_error (&_inner_error0_);
#line 116 "../src/Providers/RadioBrowser.vala"
				return NULL;
#line 735 "RadioBrowser.c"
			}
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp14_ = _tmp6_;
#line 116 "../src/Providers/RadioBrowser.vala"
			_tmp6_ = NULL;
#line 116 "../src/Providers/RadioBrowser.vala"
			result = _tmp14_;
#line 116 "../src/Providers/RadioBrowser.vala"
			_g_uri_unref0 (_tmp6_);
#line 116 "../src/Providers/RadioBrowser.vala"
			return result;
#line 747 "RadioBrowser.c"
		} else {
			GUri* _tmp15_ = NULL;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			GUri* _tmp22_;
			GUri* _tmp23_;
			GUri* _tmp24_;
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp16_ = self->priv->_current_server;
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp17_ = string_to_string (_tmp16_);
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp18_ = string_to_string (path);
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp19_ = string_to_string (query);
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp20_ = g_strconcat ("http://", _tmp17_, _tmp18_, "?", _tmp19_, NULL);
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp21_ = _tmp20_;
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp22_ = g_uri_parse (_tmp21_, G_URI_FLAGS_ENCODED, &_inner_error0_);
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp23_ = _tmp22_;
#line 120 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp21_);
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp15_ = _tmp23_;
#line 120 "../src/Providers/RadioBrowser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../src/Providers/RadioBrowser.vala"
				if (_inner_error0_->domain == G_URI_ERROR) {
#line 783 "RadioBrowser.c"
					goto __catch0_g_uri_error;
				}
#line 120 "../src/Providers/RadioBrowser.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/Providers/RadioBrowser.vala"
				g_clear_error (&_inner_error0_);
#line 120 "../src/Providers/RadioBrowser.vala"
				return NULL;
#line 792 "RadioBrowser.c"
			}
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp24_ = _tmp15_;
#line 120 "../src/Providers/RadioBrowser.vala"
			_tmp15_ = NULL;
#line 120 "../src/Providers/RadioBrowser.vala"
			result = _tmp24_;
#line 120 "../src/Providers/RadioBrowser.vala"
			_g_uri_unref0 (_tmp15_);
#line 120 "../src/Providers/RadioBrowser.vala"
			return result;
#line 804 "RadioBrowser.c"
		}
	}
	goto __finally0;
	__catch0_g_uri_error:
	{
		GError* e = NULL;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		const gchar* _tmp28_;
		GError* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 113 "../src/Providers/RadioBrowser.vala"
		e = _inner_error0_;
#line 113 "../src/Providers/RadioBrowser.vala"
		_inner_error0_ = NULL;
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp25_ = self->priv->_current_server;
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp26_ = string_to_string (_tmp25_);
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp27_ = string_to_string (path);
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp28_ = string_to_string (query);
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp29_ = e;
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp30_ = _tmp29_->message;
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp31_ = string_to_string (_tmp30_);
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp32_ = g_strconcat ("Server: ", _tmp26_, "  Path: ", _tmp27_, "  Query: ", _tmp28_, "  Error: ", _tmp31_, NULL);
#line 124 "../src/Providers/RadioBrowser.vala"
		_tmp33_ = _tmp32_;
#line 124 "../src/Providers/RadioBrowser.vala"
		g_warning ("RadioBrowser.vala:124: %s", _tmp33_);
#line 124 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp33_);
#line 113 "../src/Providers/RadioBrowser.vala"
		_g_error_free0 (e);
#line 848 "RadioBrowser.c"
	}
	__finally0:
#line 113 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/Providers/RadioBrowser.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "../src/Providers/RadioBrowser.vala"
		g_clear_error (&_inner_error0_);
#line 113 "../src/Providers/RadioBrowser.vala"
		return NULL;
#line 859 "RadioBrowser.c"
	}
#line 126 "../src/Providers/RadioBrowser.vala"
	result = NULL;
#line 126 "../src/Providers/RadioBrowser.vala"
	return result;
#line 865 "RadioBrowser.c"
}

/**
         * @brief Initialize the DataProvider implementation
         *
         * @return true if initialization successful
        */
static gboolean
tuner_data_provider_radio_browser_real_initialize (TunerDataProviderAPI* base)
{
	TunerDataProviderRadioBrowser * self;
	TunerApplication* _tmp0_;
	TunerApplication* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp5_;
	GeeArrayList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 135 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 137 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = tuner_app ();
#line 137 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _tmp0_;
#line 137 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = tuner_application_get_is_offline (_tmp1_);
#line 137 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = _tmp2_;
#line 137 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = _tmp3_;
#line 137 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_tmp1_);
#line 137 "../src/Providers/RadioBrowser.vala"
	if (_tmp4_) {
#line 137 "../src/Providers/RadioBrowser.vala"
		result = FALSE;
#line 137 "../src/Providers/RadioBrowser.vala"
		return result;
#line 908 "RadioBrowser.c"
	}
#line 139 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = self->priv->_optionalservers;
#line 139 "../src/Providers/RadioBrowser.vala"
	if (_tmp5_ != NULL) {
#line 914 "RadioBrowser.c"
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		GeeArrayList* _tmp9_;
#line 142 "../src/Providers/RadioBrowser.vala"
		_tmp6_ = self->priv->_optionalservers;
#line 142 "../src/Providers/RadioBrowser.vala"
		_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, ":", 0);
#line 142 "../src/Providers/RadioBrowser.vala"
		_tmp9_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp8_, _vala_array_length (_tmp7_), NULL, NULL, NULL);
#line 142 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (self->priv->_servers);
#line 142 "../src/Providers/RadioBrowser.vala"
		self->priv->_servers = _tmp9_;
#line 929 "RadioBrowser.c"
	} else {
		{
			GeeArrayList* _tmp10_ = NULL;
			GeeArrayList* _tmp11_;
			GeeArrayList* _tmp13_;
#line 147 "../src/Providers/RadioBrowser.vala"
			_tmp11_ = tuner_data_provider_radio_browser_get_srv_api_servers (self, &_inner_error0_);
#line 147 "../src/Providers/RadioBrowser.vala"
			_tmp10_ = _tmp11_;
#line 147 "../src/Providers/RadioBrowser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 941 "RadioBrowser.c"
				gboolean _tmp12_ = FALSE;
#line 147 "../src/Providers/RadioBrowser.vala"
				if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 945 "RadioBrowser.c"
					goto __catch0_tuner_data_provider_data_error;
				}
#line 147 "../src/Providers/RadioBrowser.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/Providers/RadioBrowser.vala"
				g_clear_error (&_inner_error0_);
#line 147 "../src/Providers/RadioBrowser.vala"
				return _tmp12_;
#line 954 "RadioBrowser.c"
			}
#line 147 "../src/Providers/RadioBrowser.vala"
			_tmp13_ = _tmp10_;
#line 147 "../src/Providers/RadioBrowser.vala"
			_tmp10_ = NULL;
#line 147 "../src/Providers/RadioBrowser.vala"
			_g_object_unref0 (self->priv->_servers);
#line 147 "../src/Providers/RadioBrowser.vala"
			self->priv->_servers = _tmp13_;
#line 146 "../src/Providers/RadioBrowser.vala"
			_g_object_unref0 (_tmp10_);
#line 966 "RadioBrowser.c"
		}
		goto __finally0;
		__catch0_tuner_data_provider_data_error:
		{
			GError* e = NULL;
			GError* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GError* _tmp19_;
			GError* _tmp20_;
#line 146 "../src/Providers/RadioBrowser.vala"
			e = _inner_error0_;
#line 146 "../src/Providers/RadioBrowser.vala"
			_inner_error0_ = NULL;
#line 149 "../src/Providers/RadioBrowser.vala"
			_tmp14_ = e;
#line 149 "../src/Providers/RadioBrowser.vala"
			_tmp15_ = _tmp14_->message;
#line 149 "../src/Providers/RadioBrowser.vala"
			_tmp16_ = string_to_string (_tmp15_);
#line 149 "../src/Providers/RadioBrowser.vala"
			_tmp17_ = g_strconcat ("Failed to retrieve API servers: ", _tmp16_, NULL);
#line 149 "../src/Providers/RadioBrowser.vala"
			_tmp18_ = _tmp17_;
#line 149 "../src/Providers/RadioBrowser.vala"
			_tmp19_ = g_error_new_literal (TUNER_DATA_PROVIDER_DATA_ERROR, TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION, _tmp18_);
#line 149 "../src/Providers/RadioBrowser.vala"
			_tmp20_ = _tmp19_;
#line 149 "../src/Providers/RadioBrowser.vala"
			tuner_data_provider_api_set_last_data_error ((TunerDataProviderAPI*) self, _tmp20_);
#line 149 "../src/Providers/RadioBrowser.vala"
			_g_error_free0 (_tmp20_);
#line 149 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp18_);
#line 150 "../src/Providers/RadioBrowser.vala"
			tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, TUNER_DATA_PROVIDER_API_STATUS_NO_SERVER_LIST);
#line 151 "../src/Providers/RadioBrowser.vala"
			result = FALSE;
#line 151 "../src/Providers/RadioBrowser.vala"
			_g_error_free0 (e);
#line 151 "../src/Providers/RadioBrowser.vala"
			return result;
#line 1011 "RadioBrowser.c"
		}
		__finally0:
#line 146 "../src/Providers/RadioBrowser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1016 "RadioBrowser.c"
			gboolean _tmp21_ = FALSE;
#line 146 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 146 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 146 "../src/Providers/RadioBrowser.vala"
			return _tmp21_;
#line 1024 "RadioBrowser.c"
		}
	}
#line 155 "../src/Providers/RadioBrowser.vala"
	_tmp22_ = self->priv->_servers;
#line 155 "../src/Providers/RadioBrowser.vala"
	_tmp23_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp22_);
#line 155 "../src/Providers/RadioBrowser.vala"
	_tmp24_ = _tmp23_;
#line 155 "../src/Providers/RadioBrowser.vala"
	if (_tmp24_ == 0) {
#line 1035 "RadioBrowser.c"
		GError* _tmp25_;
		GError* _tmp26_;
#line 157 "../src/Providers/RadioBrowser.vala"
		_tmp25_ = g_error_new_literal (TUNER_DATA_PROVIDER_DATA_ERROR, TUNER_DATA_PROVIDER_DATA_ERROR_NO_CONNECTION, "Unable to resolve API servers for radio-browser.info");
#line 157 "../src/Providers/RadioBrowser.vala"
		_tmp26_ = _tmp25_;
#line 157 "../src/Providers/RadioBrowser.vala"
		tuner_data_provider_api_set_last_data_error ((TunerDataProviderAPI*) self, _tmp26_);
#line 157 "../src/Providers/RadioBrowser.vala"
		_g_error_free0 (_tmp26_);
#line 158 "../src/Providers/RadioBrowser.vala"
		tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, TUNER_DATA_PROVIDER_API_STATUS_NO_SERVERS_PRESENTED);
#line 159 "../src/Providers/RadioBrowser.vala"
		result = FALSE;
#line 159 "../src/Providers/RadioBrowser.vala"
		return result;
#line 1052 "RadioBrowser.c"
	}
#line 162 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_choose_server (self);
#line 163 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, TUNER_DATA_PROVIDER_API_STATUS_OK);
#line 164 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_api_clear_last_error ((TunerDataProviderAPI*) self);
#line 165 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_stats (self);
#line 166 "../src/Providers/RadioBrowser.vala"
	result = TRUE;
#line 166 "../src/Providers/RadioBrowser.vala"
	return result;
#line 1066 "RadioBrowser.c"
}

/**
         * @brief Track a station listen event
         *
         * @param stationuuid UUID of the station being listened to
         */
static void
tuner_data_provider_radio_browser_real_click (TunerDataProviderAPI* base,
                                              const gchar* stationuuid)
{
	TunerDataProviderRadioBrowser * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint status_code = 0U;
	GUri* _tmp3_;
	GUri* _tmp4_;
	guint _tmp5_ = 0U;
	GInputStream* _tmp6_;
	GInputStream* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 175 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 175 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (stationuuid != NULL);
#line 176 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = string_to_string (stationuuid);
#line 176 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = g_strconcat ("sending listening event for station ", _tmp0_, NULL);
#line 176 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _tmp1_;
#line 176 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:176: %s", _tmp2_);
#line 176 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp2_);
#line 178 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = tuner_data_provider_radio_browser_build_uri (self, TUNER_DATA_PROVIDER_RBI_STATION, stationuuid);
#line 178 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = _tmp3_;
#line 178 "../src/Providers/RadioBrowser.vala"
	_tmp6_ = tuner_http_client_GET (_tmp4_, &_tmp5_);
#line 178 "../src/Providers/RadioBrowser.vala"
	status_code = _tmp5_;
#line 178 "../src/Providers/RadioBrowser.vala"
	_tmp7_ = _tmp6_;
#line 178 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_tmp7_);
#line 178 "../src/Providers/RadioBrowser.vala"
	_g_uri_unref0 (_tmp4_);
#line 179 "../src/Providers/RadioBrowser.vala"
	_tmp8_ = g_strdup_printf ("%u", status_code);
#line 179 "../src/Providers/RadioBrowser.vala"
	_tmp9_ = _tmp8_;
#line 179 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = g_strconcat ("response: ", _tmp9_, NULL);
#line 179 "../src/Providers/RadioBrowser.vala"
	_tmp11_ = _tmp10_;
#line 179 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:179: %s", _tmp11_);
#line 179 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp11_);
#line 179 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp9_);
#line 1134 "RadioBrowser.c"
}

/**
         * @brief Vote for a station
         * @param stationuuid UUID of the station being voted for
         */
static void
tuner_data_provider_radio_browser_real_vote (TunerDataProviderAPI* base,
                                             const gchar* stationuuid)
{
	TunerDataProviderRadioBrowser * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint status_code = 0U;
	GUri* _tmp3_;
	GUri* _tmp4_;
	guint _tmp5_ = 0U;
	GInputStream* _tmp6_;
	GInputStream* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 187 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 187 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (stationuuid != NULL);
#line 188 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = string_to_string (stationuuid);
#line 188 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = g_strconcat ("sending vote event for station ", _tmp0_, NULL);
#line 188 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _tmp1_;
#line 188 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:188: %s", _tmp2_);
#line 188 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp2_);
#line 191 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = tuner_data_provider_radio_browser_build_uri (self, TUNER_DATA_PROVIDER_RBI_VOTE, stationuuid);
#line 191 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = _tmp3_;
#line 191 "../src/Providers/RadioBrowser.vala"
	_tmp6_ = tuner_http_client_GET (_tmp4_, &_tmp5_);
#line 191 "../src/Providers/RadioBrowser.vala"
	status_code = _tmp5_;
#line 191 "../src/Providers/RadioBrowser.vala"
	_tmp7_ = _tmp6_;
#line 191 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_tmp7_);
#line 191 "../src/Providers/RadioBrowser.vala"
	_g_uri_unref0 (_tmp4_);
#line 194 "../src/Providers/RadioBrowser.vala"
	_tmp8_ = g_strdup_printf ("%u", status_code);
#line 194 "../src/Providers/RadioBrowser.vala"
	_tmp9_ = _tmp8_;
#line 194 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = g_strconcat ("response: ", _tmp9_, NULL);
#line 194 "../src/Providers/RadioBrowser.vala"
	_tmp11_ = _tmp10_;
#line 194 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:194: %s", _tmp11_);
#line 194 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp11_);
#line 194 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp9_);
#line 1201 "RadioBrowser.c"
}

/**
         * @brief Get all available tags
         *
         * @return ArrayList of Tag objects
         * @throw DataError if unable to retrieve or parse tag data
         */
static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 220 "../src/Providers/RadioBrowser.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1215 "RadioBrowser.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 220 "../src/Providers/RadioBrowser.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1223 "RadioBrowser.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 220 "../src/Providers/RadioBrowser.vala"
	g_boxed_free (json_node_get_type (), self);
#line 1231 "RadioBrowser.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 224 "../src/Providers/RadioBrowser.vala"
	return self ? json_array_ref (self) : NULL;
#line 1239 "RadioBrowser.c"
}

static GeeSet*
tuner_data_provider_radio_browser_real_get_tags (TunerDataProviderAPI* base,
                                                 gint offset,
                                                 gint limit,
                                                 GError** error)
{
	TunerDataProviderRadioBrowser * self;
	JsonNode* rootnode = NULL;
	GeeHashSet* _tmp33_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 204 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 1255 "RadioBrowser.c"
	{
		guint status_code = 0U;
		gchar* query = NULL;
		gchar* _tmp0_;
		GUri* uri = NULL;
		const gchar* _tmp9_;
		GUri* _tmp10_;
		GInputStream* stream = NULL;
		GUri* _tmp11_;
		guint _tmp12_ = 0U;
		GInputStream* _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 208 "../src/Providers/RadioBrowser.vala"
		_tmp0_ = g_strdup ("");
#line 208 "../src/Providers/RadioBrowser.vala"
		query = _tmp0_;
#line 209 "../src/Providers/RadioBrowser.vala"
		if (offset > 0) {
#line 1274 "RadioBrowser.c"
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 209 "../src/Providers/RadioBrowser.vala"
			_tmp1_ = g_strdup_printf ("%i", offset);
#line 209 "../src/Providers/RadioBrowser.vala"
			_tmp2_ = _tmp1_;
#line 209 "../src/Providers/RadioBrowser.vala"
			_tmp3_ = g_strconcat ("offset=", _tmp2_, NULL);
#line 209 "../src/Providers/RadioBrowser.vala"
			_g_free0 (query);
#line 209 "../src/Providers/RadioBrowser.vala"
			query = _tmp3_;
#line 209 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp2_);
#line 1290 "RadioBrowser.c"
		}
#line 210 "../src/Providers/RadioBrowser.vala"
		if (limit > 0) {
#line 1294 "RadioBrowser.c"
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 210 "../src/Providers/RadioBrowser.vala"
			_tmp4_ = query;
#line 210 "../src/Providers/RadioBrowser.vala"
			_tmp5_ = string_to_string (_tmp4_);
#line 210 "../src/Providers/RadioBrowser.vala"
			_tmp6_ = g_strdup_printf ("%i", limit);
#line 210 "../src/Providers/RadioBrowser.vala"
			_tmp7_ = _tmp6_;
#line 210 "../src/Providers/RadioBrowser.vala"
			_tmp8_ = g_strconcat (_tmp5_, "&limit=", _tmp7_, NULL);
#line 210 "../src/Providers/RadioBrowser.vala"
			_g_free0 (query);
#line 210 "../src/Providers/RadioBrowser.vala"
			query = _tmp8_;
#line 210 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp7_);
#line 1316 "RadioBrowser.c"
		}
#line 212 "../src/Providers/RadioBrowser.vala"
		_tmp9_ = query;
#line 212 "../src/Providers/RadioBrowser.vala"
		_tmp10_ = tuner_data_provider_radio_browser_build_uri (self, TUNER_DATA_PROVIDER_RBI_TAGS, _tmp9_);
#line 212 "../src/Providers/RadioBrowser.vala"
		uri = _tmp10_;
#line 213 "../src/Providers/RadioBrowser.vala"
		_tmp11_ = uri;
#line 213 "../src/Providers/RadioBrowser.vala"
		_tmp13_ = tuner_http_client_GET (_tmp11_, &_tmp12_);
#line 213 "../src/Providers/RadioBrowser.vala"
		status_code = _tmp12_;
#line 213 "../src/Providers/RadioBrowser.vala"
		stream = _tmp13_;
#line 215 "../src/Providers/RadioBrowser.vala"
		if (status_code != ((guint) 0)) {
#line 1334 "RadioBrowser.c"
			GInputStream* _tmp15_;
#line 215 "../src/Providers/RadioBrowser.vala"
			_tmp15_ = stream;
#line 215 "../src/Providers/RadioBrowser.vala"
			_tmp14_ = _tmp15_ != NULL;
#line 1340 "RadioBrowser.c"
		} else {
#line 215 "../src/Providers/RadioBrowser.vala"
			_tmp14_ = FALSE;
#line 1344 "RadioBrowser.c"
		}
#line 215 "../src/Providers/RadioBrowser.vala"
		if (_tmp14_) {
#line 1348 "RadioBrowser.c"
			JsonArray* rootarray = NULL;
			JsonArray* _tmp29_;
			JsonArray* _tmp30_;
			GeeSet* tags = NULL;
			JsonArray* _tmp31_;
			GeeSet* _tmp32_;
			{
				JsonParser* parser = NULL;
				JsonParser* _tmp16_;
				JsonParser* _tmp17_;
				GInputStream* _tmp18_;
				JsonParser* _tmp19_;
				JsonNode* _tmp20_;
				JsonNode* _tmp21_;
#line 218 "../src/Providers/RadioBrowser.vala"
				_tmp16_ = json_parser_new ();
#line 218 "../src/Providers/RadioBrowser.vala"
				parser = _tmp16_;
#line 219 "../src/Providers/RadioBrowser.vala"
				_tmp17_ = parser;
#line 219 "../src/Providers/RadioBrowser.vala"
				_tmp18_ = stream;
#line 219 "../src/Providers/RadioBrowser.vala"
				json_parser_load_from_stream (_tmp17_, _tmp18_, NULL, &_inner_error0_);
#line 219 "../src/Providers/RadioBrowser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 219 "../src/Providers/RadioBrowser.vala"
					_g_object_unref0 (parser);
#line 1377 "RadioBrowser.c"
					goto __catch1_g_error;
				}
#line 220 "../src/Providers/RadioBrowser.vala"
				_tmp19_ = parser;
#line 220 "../src/Providers/RadioBrowser.vala"
				_tmp20_ = json_parser_get_root (_tmp19_);
#line 220 "../src/Providers/RadioBrowser.vala"
				_tmp21_ = __vala_JsonNode_copy0 (_tmp20_);
#line 220 "../src/Providers/RadioBrowser.vala"
				__vala_JsonNode_free0 (rootnode);
#line 220 "../src/Providers/RadioBrowser.vala"
				rootnode = _tmp21_;
#line 217 "../src/Providers/RadioBrowser.vala"
				_g_object_unref0 (parser);
#line 1392 "RadioBrowser.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				GError* _tmp27_;
				GError* _tmp28_;
#line 217 "../src/Providers/RadioBrowser.vala"
				e = _inner_error0_;
#line 217 "../src/Providers/RadioBrowser.vala"
				_inner_error0_ = NULL;
#line 222 "../src/Providers/RadioBrowser.vala"
				_tmp22_ = e;
#line 222 "../src/Providers/RadioBrowser.vala"
				_tmp23_ = _tmp22_->message;
#line 222 "../src/Providers/RadioBrowser.vala"
				_tmp24_ = string_to_string (_tmp23_);
#line 222 "../src/Providers/RadioBrowser.vala"
				_tmp25_ = g_strconcat ("unable to parse JSON response: ", _tmp24_, NULL);
#line 222 "../src/Providers/RadioBrowser.vala"
				_tmp26_ = _tmp25_;
#line 222 "../src/Providers/RadioBrowser.vala"
				_tmp27_ = g_error_new_literal (TUNER_DATA_PROVIDER_DATA_ERROR, TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA, _tmp26_);
#line 222 "../src/Providers/RadioBrowser.vala"
				_tmp28_ = _tmp27_;
#line 222 "../src/Providers/RadioBrowser.vala"
				_g_free0 (_tmp26_);
#line 222 "../src/Providers/RadioBrowser.vala"
				_inner_error0_ = _tmp28_;
#line 222 "../src/Providers/RadioBrowser.vala"
				_g_error_free0 (e);
#line 1429 "RadioBrowser.c"
				goto __finally1;
			}
			__finally1:
#line 217 "../src/Providers/RadioBrowser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "../src/Providers/RadioBrowser.vala"
				_g_object_unref0 (stream);
#line 217 "../src/Providers/RadioBrowser.vala"
				_g_uri_unref0 (uri);
#line 217 "../src/Providers/RadioBrowser.vala"
				_g_free0 (query);
#line 1441 "RadioBrowser.c"
				goto __catch0_g_error;
			}
#line 224 "../src/Providers/RadioBrowser.vala"
			_tmp29_ = json_node_get_array (rootnode);
#line 224 "../src/Providers/RadioBrowser.vala"
			_tmp30_ = _json_array_ref0 (_tmp29_);
#line 224 "../src/Providers/RadioBrowser.vala"
			rootarray = _tmp30_;
#line 225 "../src/Providers/RadioBrowser.vala"
			_tmp31_ = rootarray;
#line 225 "../src/Providers/RadioBrowser.vala"
			_tmp32_ = tuner_data_provider_radio_browser_jarray_to_tags (self, _tmp31_);
#line 225 "../src/Providers/RadioBrowser.vala"
			tags = _tmp32_;
#line 226 "../src/Providers/RadioBrowser.vala"
			result = tags;
#line 226 "../src/Providers/RadioBrowser.vala"
			_json_array_unref0 (rootarray);
#line 226 "../src/Providers/RadioBrowser.vala"
			_g_object_unref0 (stream);
#line 226 "../src/Providers/RadioBrowser.vala"
			_g_uri_unref0 (uri);
#line 226 "../src/Providers/RadioBrowser.vala"
			_g_free0 (query);
#line 226 "../src/Providers/RadioBrowser.vala"
			__vala_JsonNode_free0 (rootnode);
#line 226 "../src/Providers/RadioBrowser.vala"
			return result;
#line 1470 "RadioBrowser.c"
		}
#line 206 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (stream);
#line 206 "../src/Providers/RadioBrowser.vala"
		_g_uri_unref0 (uri);
#line 206 "../src/Providers/RadioBrowser.vala"
		_g_free0 (query);
#line 1478 "RadioBrowser.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 206 "../src/Providers/RadioBrowser.vala"
		g_clear_error (&_inner_error0_);
#line 229 "../src/Providers/RadioBrowser.vala"
		g_debug ("RadioBrowser.vala:229: cannot get_tags()");
#line 1487 "RadioBrowser.c"
	}
	__finally0:
#line 206 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/Providers/RadioBrowser.vala"
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 206 "../src/Providers/RadioBrowser.vala"
			g_propagate_error (error, _inner_error0_);
#line 206 "../src/Providers/RadioBrowser.vala"
			__vala_JsonNode_free0 (rootnode);
#line 206 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1500 "RadioBrowser.c"
		} else {
#line 206 "../src/Providers/RadioBrowser.vala"
			__vala_JsonNode_free0 (rootnode);
#line 206 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 206 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1510 "RadioBrowser.c"
		}
	}
#line 231 "../src/Providers/RadioBrowser.vala"
	_tmp33_ = gee_hash_set_new (TUNER_DATA_PROVIDER_TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 231 "../src/Providers/RadioBrowser.vala"
	result = (GeeSet*) _tmp33_;
#line 231 "../src/Providers/RadioBrowser.vala"
	__vala_JsonNode_free0 (rootnode);
#line 231 "../src/Providers/RadioBrowser.vala"
	return result;
#line 1521 "RadioBrowser.c"
}

/**
         * @brief Get a station or stations by UUID
         *
         * @param uuids comma seperated lists of the stations to retrieve
         * @return Station object if found, null otherwise
         * @throw DataError if unable to retrieve or parse station data
         */
static GeeSet*
tuner_data_provider_radio_browser_real_by_uuid (TunerDataProviderAPI* base,
                                                const gchar* uuid,
                                                GError** error)
{
	TunerDataProviderRadioBrowser * self;
	gboolean _tmp0_ = FALSE;
	TunerApplication* _tmp1_;
	TunerApplication* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GeeSet* _result_ = NULL;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GeeSet* _tmp13_;
	GeeSet* _tmp14_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 242 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 242 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 243 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = tuner_app ();
#line 243 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _tmp1_;
#line 243 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = tuner_application_get_is_offline (_tmp2_);
#line 243 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = _tmp3_;
#line 243 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = _tmp4_;
#line 243 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_tmp2_);
#line 243 "../src/Providers/RadioBrowser.vala"
	if (_tmp5_) {
#line 243 "../src/Providers/RadioBrowser.vala"
		_tmp0_ = TRUE;
#line 1571 "RadioBrowser.c"
	} else {
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 243 "../src/Providers/RadioBrowser.vala"
		_tmp6_ = tuner_safestrip (uuid);
#line 243 "../src/Providers/RadioBrowser.vala"
		_tmp7_ = strlen (_tmp6_);
#line 243 "../src/Providers/RadioBrowser.vala"
		_tmp8_ = _tmp7_;
#line 243 "../src/Providers/RadioBrowser.vala"
		_tmp0_ = _tmp8_ == 0;
#line 1584 "RadioBrowser.c"
	}
#line 243 "../src/Providers/RadioBrowser.vala"
	if (_tmp0_) {
#line 1588 "RadioBrowser.c"
		GeeHashSet* _tmp9_;
#line 243 "../src/Providers/RadioBrowser.vala"
		_tmp9_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 243 "../src/Providers/RadioBrowser.vala"
		result = (GeeSet*) _tmp9_;
#line 243 "../src/Providers/RadioBrowser.vala"
		return result;
#line 1596 "RadioBrowser.c"
	}
#line 244 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = string_to_string (uuid);
#line 244 "../src/Providers/RadioBrowser.vala"
	_tmp11_ = g_strconcat ("uuids=", _tmp10_, NULL);
#line 244 "../src/Providers/RadioBrowser.vala"
	_tmp12_ = _tmp11_;
#line 244 "../src/Providers/RadioBrowser.vala"
	_tmp13_ = tuner_data_provider_radio_browser_station_query (self, TUNER_DATA_PROVIDER_RBI_UUID, _tmp12_, &_inner_error0_);
#line 244 "../src/Providers/RadioBrowser.vala"
	_tmp14_ = _tmp13_;
#line 244 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp12_);
#line 244 "../src/Providers/RadioBrowser.vala"
	_result_ = _tmp14_;
#line 244 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 244 "../src/Providers/RadioBrowser.vala"
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 244 "../src/Providers/RadioBrowser.vala"
			g_propagate_error (error, _inner_error0_);
#line 244 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1620 "RadioBrowser.c"
		} else {
#line 244 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 244 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 244 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1628 "RadioBrowser.c"
		}
	}
#line 245 "../src/Providers/RadioBrowser.vala"
	result = _result_;
#line 245 "../src/Providers/RadioBrowser.vala"
	return result;
#line 1635 "RadioBrowser.c"
}

/**
         * @brief Get a station or stations by UUIDs
         *
         * @param a collection of uuids of the stations to retrieve
         * @return Station object if found, null otherwise
         * @throw DataError if unable to retrieve or parse station data
         */
static GeeSet*
tuner_data_provider_radio_browser_real_by_uuids (TunerDataProviderAPI* base,
                                                 GeeCollection* uuids,
                                                 GError** error)
{
	TunerDataProviderRadioBrowser * self;
	GString* sb = NULL;
	GString* _tmp0_;
	GeeSet* _tmp8_ = NULL;
	GString* _tmp9_;
	const gchar* _tmp10_;
	GeeSet* _tmp11_;
	GeeSet* _tmp12_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 256 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 256 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (uuids != NULL, NULL);
#line 257 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = g_string_new ("");
#line 257 "../src/Providers/RadioBrowser.vala"
	sb = _tmp0_;
#line 1668 "RadioBrowser.c"
	{
		GeeIterator* _uuid_it = NULL;
		GeeIterator* _tmp1_;
#line 258 "../src/Providers/RadioBrowser.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) uuids);
#line 258 "../src/Providers/RadioBrowser.vala"
		_uuid_it = _tmp1_;
#line 258 "../src/Providers/RadioBrowser.vala"
		while (TRUE) {
#line 1678 "RadioBrowser.c"
			GeeIterator* _tmp2_;
			gchar* uuid = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GString* _tmp5_;
			const gchar* _tmp6_;
			GString* _tmp7_;
#line 258 "../src/Providers/RadioBrowser.vala"
			_tmp2_ = _uuid_it;
#line 258 "../src/Providers/RadioBrowser.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 258 "../src/Providers/RadioBrowser.vala"
				break;
#line 1692 "RadioBrowser.c"
			}
#line 258 "../src/Providers/RadioBrowser.vala"
			_tmp3_ = _uuid_it;
#line 258 "../src/Providers/RadioBrowser.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 258 "../src/Providers/RadioBrowser.vala"
			uuid = (gchar*) _tmp4_;
#line 258 "../src/Providers/RadioBrowser.vala"
			_tmp5_ = sb;
#line 258 "../src/Providers/RadioBrowser.vala"
			_tmp6_ = uuid;
#line 258 "../src/Providers/RadioBrowser.vala"
			_tmp7_ = g_string_append (_tmp5_, _tmp6_);
#line 258 "../src/Providers/RadioBrowser.vala"
			g_string_append (_tmp7_, ",");
#line 258 "../src/Providers/RadioBrowser.vala"
			_g_free0 (uuid);
#line 1710 "RadioBrowser.c"
		}
#line 258 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (_uuid_it);
#line 1714 "RadioBrowser.c"
	}
#line 259 "../src/Providers/RadioBrowser.vala"
	_tmp9_ = sb;
#line 259 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = _tmp9_->str;
#line 259 "../src/Providers/RadioBrowser.vala"
	_tmp11_ = tuner_data_provider_api_by_uuid ((TunerDataProviderAPI*) self, _tmp10_, &_inner_error0_);
#line 259 "../src/Providers/RadioBrowser.vala"
	_tmp8_ = _tmp11_;
#line 259 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 259 "../src/Providers/RadioBrowser.vala"
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 259 "../src/Providers/RadioBrowser.vala"
			g_propagate_error (error, _inner_error0_);
#line 259 "../src/Providers/RadioBrowser.vala"
			_g_string_free0 (sb);
#line 259 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1734 "RadioBrowser.c"
		} else {
#line 259 "../src/Providers/RadioBrowser.vala"
			_g_string_free0 (sb);
#line 259 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 259 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 259 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1744 "RadioBrowser.c"
		}
	}
#line 259 "../src/Providers/RadioBrowser.vala"
	_tmp12_ = _tmp8_;
#line 259 "../src/Providers/RadioBrowser.vala"
	_tmp8_ = NULL;
#line 259 "../src/Providers/RadioBrowser.vala"
	result = _tmp12_;
#line 259 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_tmp8_);
#line 259 "../src/Providers/RadioBrowser.vala"
	_g_string_free0 (sb);
#line 259 "../src/Providers/RadioBrowser.vala"
	return result;
#line 1759 "RadioBrowser.c"
}

/**
            Not implemented
        */
GeeSet*
tuner_data_provider_radio_browser_by_url (TunerDataProviderRadioBrowser* self,
                                          const gchar* url,
                                          GError** error)
{
	gboolean _tmp0_ = FALSE;
	TunerApplication* _tmp1_;
	TunerApplication* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GeeSet* _result_ = NULL;
	const gchar* _tmp10_;
	GeeSet* _tmp11_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 266 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 266 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 267 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = tuner_app ();
#line 267 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _tmp1_;
#line 267 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = tuner_application_get_is_offline (_tmp2_);
#line 267 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = _tmp3_;
#line 267 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = _tmp4_;
#line 267 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_tmp2_);
#line 267 "../src/Providers/RadioBrowser.vala"
	if (_tmp5_) {
#line 267 "../src/Providers/RadioBrowser.vala"
		_tmp0_ = TRUE;
#line 1801 "RadioBrowser.c"
	} else {
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 267 "../src/Providers/RadioBrowser.vala"
		_tmp6_ = tuner_safestrip (url);
#line 267 "../src/Providers/RadioBrowser.vala"
		_tmp7_ = strlen (_tmp6_);
#line 267 "../src/Providers/RadioBrowser.vala"
		_tmp8_ = _tmp7_;
#line 267 "../src/Providers/RadioBrowser.vala"
		_tmp0_ = _tmp8_ == 0;
#line 1814 "RadioBrowser.c"
	}
#line 267 "../src/Providers/RadioBrowser.vala"
	if (_tmp0_) {
#line 1818 "RadioBrowser.c"
		GeeHashSet* _tmp9_;
#line 267 "../src/Providers/RadioBrowser.vala"
		_tmp9_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 267 "../src/Providers/RadioBrowser.vala"
		result = (GeeSet*) _tmp9_;
#line 267 "../src/Providers/RadioBrowser.vala"
		return result;
#line 1826 "RadioBrowser.c"
	}
#line 268 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = string_to_string (url);
#line 268 "../src/Providers/RadioBrowser.vala"
	_tmp11_ = tuner_data_provider_radio_browser_station_query (self, TUNER_DATA_PROVIDER_RBI_URL, _tmp10_, &_inner_error0_);
#line 268 "../src/Providers/RadioBrowser.vala"
	_result_ = _tmp11_;
#line 268 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 268 "../src/Providers/RadioBrowser.vala"
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 268 "../src/Providers/RadioBrowser.vala"
			g_propagate_error (error, _inner_error0_);
#line 268 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1842 "RadioBrowser.c"
		} else {
#line 268 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 268 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 268 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1850 "RadioBrowser.c"
		}
	}
#line 269 "../src/Providers/RadioBrowser.vala"
	result = _result_;
#line 269 "../src/Providers/RadioBrowser.vala"
	return result;
#line 1857 "RadioBrowser.c"
}

/**
        * @brief Search for stations based on given parameters
        *
        * @param params Search parameters
        * @param rowcount Maximum number of results to return
        * @param offset Offset for pagination
        * @return ArrayList of Station objects matching the search criteria
        * @throw DataError if unable to retrieve or parse station data
        */
static GeeSet*
tuner_data_provider_radio_browser_real_search (TunerDataProviderAPI* base,
                                               TunerDataProviderSearchParams* params,
                                               guint rowcount,
                                               guint offset,
                                               GError** error)
{
	TunerDataProviderRadioBrowser * self;
	TunerDataProviderSearchParams _tmp0_;
	GeeSet* _tmp1_;
	gchar* query = NULL;
	TunerDataProviderSearchParams _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GeeSet* _tmp13_ = NULL;
	const gchar* _tmp14_;
	GeeSet* _tmp15_;
	GeeSet* _tmp16_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 282 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 282 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 285 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = *params;
#line 285 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _tmp0_.uuids;
#line 285 "../src/Providers/RadioBrowser.vala"
	if (_tmp1_ != NULL) {
#line 1902 "RadioBrowser.c"
		GeeSet* _tmp2_ = NULL;
		TunerDataProviderSearchParams _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
#line 287 "../src/Providers/RadioBrowser.vala"
		_tmp3_ = *params;
#line 287 "../src/Providers/RadioBrowser.vala"
		_tmp4_ = _tmp3_.uuids;
#line 287 "../src/Providers/RadioBrowser.vala"
		_tmp5_ = tuner_data_provider_api_by_uuids ((TunerDataProviderAPI*) self, (GeeCollection*) _tmp4_, &_inner_error0_);
#line 287 "../src/Providers/RadioBrowser.vala"
		_tmp2_ = _tmp5_;
#line 287 "../src/Providers/RadioBrowser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 287 "../src/Providers/RadioBrowser.vala"
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 287 "../src/Providers/RadioBrowser.vala"
				g_propagate_error (error, _inner_error0_);
#line 287 "../src/Providers/RadioBrowser.vala"
				return NULL;
#line 1924 "RadioBrowser.c"
			} else {
#line 287 "../src/Providers/RadioBrowser.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 287 "../src/Providers/RadioBrowser.vala"
				g_clear_error (&_inner_error0_);
#line 287 "../src/Providers/RadioBrowser.vala"
				return NULL;
#line 1932 "RadioBrowser.c"
			}
		}
#line 287 "../src/Providers/RadioBrowser.vala"
		_tmp6_ = _tmp2_;
#line 287 "../src/Providers/RadioBrowser.vala"
		_tmp2_ = NULL;
#line 287 "../src/Providers/RadioBrowser.vala"
		result = _tmp6_;
#line 287 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (_tmp2_);
#line 287 "../src/Providers/RadioBrowser.vala"
		return result;
#line 1945 "RadioBrowser.c"
	}
#line 293 "../src/Providers/RadioBrowser.vala"
	_tmp7_ = *params;
#line 293 "../src/Providers/RadioBrowser.vala"
	_tmp8_ = tuner_data_provider_radio_browser_get_search_query_params (self, &_tmp7_, rowcount, offset);
#line 293 "../src/Providers/RadioBrowser.vala"
	query = _tmp8_;
#line 295 "../src/Providers/RadioBrowser.vala"
	_tmp9_ = query;
#line 295 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = string_to_string (_tmp9_);
#line 295 "../src/Providers/RadioBrowser.vala"
	_tmp11_ = g_strconcat ("Search: ", _tmp10_, NULL);
#line 295 "../src/Providers/RadioBrowser.vala"
	_tmp12_ = _tmp11_;
#line 295 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:295: %s", _tmp12_);
#line 295 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp12_);
#line 296 "../src/Providers/RadioBrowser.vala"
	_tmp14_ = query;
#line 296 "../src/Providers/RadioBrowser.vala"
	_tmp15_ = tuner_data_provider_radio_browser_station_query (self, TUNER_DATA_PROVIDER_RBI_SEARCH, _tmp14_, &_inner_error0_);
#line 296 "../src/Providers/RadioBrowser.vala"
	_tmp13_ = _tmp15_;
#line 296 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 296 "../src/Providers/RadioBrowser.vala"
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 296 "../src/Providers/RadioBrowser.vala"
			g_propagate_error (error, _inner_error0_);
#line 296 "../src/Providers/RadioBrowser.vala"
			_g_free0 (query);
#line 296 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1981 "RadioBrowser.c"
		} else {
#line 296 "../src/Providers/RadioBrowser.vala"
			_g_free0 (query);
#line 296 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 296 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 296 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 1991 "RadioBrowser.c"
		}
	}
#line 296 "../src/Providers/RadioBrowser.vala"
	_tmp16_ = _tmp13_;
#line 296 "../src/Providers/RadioBrowser.vala"
	_tmp13_ = NULL;
#line 296 "../src/Providers/RadioBrowser.vala"
	result = _tmp16_;
#line 296 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_tmp13_);
#line 296 "../src/Providers/RadioBrowser.vala"
	_g_free0 (query);
#line 296 "../src/Providers/RadioBrowser.vala"
	return result;
#line 2006 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_real_search_async_data_free (gpointer _data)
{
	TunerDataProviderRadioBrowserSearchAsyncData* _data_;
	_data_ = _data;
#line 56 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_search_params_destroy (&_data_->params);
#line 56 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_data_->result);
#line 56 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_data_->self);
#line 56 "../src/Providers/RadioBrowser.vala"
	g_slice_free (TunerDataProviderRadioBrowserSearchAsyncData, _data_);
#line 2022 "RadioBrowser.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../src/Providers/RadioBrowser.vala"
	return self ? g_object_ref (self) : NULL;
#line 2030 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_real_search_async (TunerDataProviderAPI* base,
                                                     TunerDataProviderSearchParams* params,
                                                     guint rowcount,
                                                     guint offset,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	TunerDataProviderRadioBrowser * self;
	TunerDataProviderRadioBrowserSearchAsyncData* _data_;
	TunerDataProviderRadioBrowser* _tmp0_;
	TunerDataProviderSearchParams _tmp1_;
	TunerDataProviderSearchParams _tmp2_;
	TunerDataProviderSearchParams _tmp3_ = {0};
#line 56 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (params != NULL);
#line 56 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_ = g_slice_new0 (TunerDataProviderRadioBrowserSearchAsyncData);
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 56 "../src/Providers/RadioBrowser.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tuner_data_provider_radio_browser_real_search_async_data_free);
#line 56 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->self = _tmp0_;
#line 56 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = *params;
#line 56 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _tmp1_;
#line 56 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_search_params_copy (&_tmp2_, &_tmp3_);
#line 56 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_search_params_destroy (&_data_->params);
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->params = _tmp3_;
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->rowcount = rowcount;
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->offset = offset;
#line 56 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_real_search_async_co (_data_);
#line 2077 "RadioBrowser.c"
}

static GeeSet*
tuner_data_provider_radio_browser_search_finish (TunerDataProviderAPI* base,
                                                 GAsyncResult* _res_,
                                                 GError** error)
{
	GeeSet* result;
	TunerDataProviderRadioBrowserSearchAsyncData* _data_;
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 56 "../src/Providers/RadioBrowser.vala"
	if (NULL == _data_) {
#line 56 "../src/Providers/RadioBrowser.vala"
		return NULL;
#line 2093 "RadioBrowser.c"
	}
#line 56 "../src/Providers/RadioBrowser.vala"
	result = _data_->result;
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->result = NULL;
#line 56 "../src/Providers/RadioBrowser.vala"
	return result;
#line 2101 "RadioBrowser.c"
}

/**
        * @brief Search for stations based on given parameters
        *
        * @param params Search parameters
        * @param rowcount Maximum number of results to return
        * @param offset Offset for pagination
        * @return ArrayList of Station objects matching the search criteria
        * @throw DataError if unable to retrieve or parse station data
        */
static void
tuner_data_provider_radio_browser_search_async_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	TunerDataProviderRadioBrowserSearchAsyncData* _data_;
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_ = _user_data_;
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->_source_object_ = source_object;
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->_res_ = _res_;
#line 323 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_real_search_async_co (_data_);
#line 2127 "RadioBrowser.c"
}

static gboolean
tuner_data_provider_radio_browser_real_search_async_co (TunerDataProviderRadioBrowserSearchAsyncData* _data_)
{
#line 309 "../src/Providers/RadioBrowser.vala"
	switch (_data_->_state_) {
#line 309 "../src/Providers/RadioBrowser.vala"
		case 0:
#line 2137 "RadioBrowser.c"
		goto _state_0;
#line 309 "../src/Providers/RadioBrowser.vala"
		case 1:
#line 2141 "RadioBrowser.c"
		goto _state_1;
		default:
#line 309 "../src/Providers/RadioBrowser.vala"
		g_assert_not_reached ();
#line 2146 "RadioBrowser.c"
	}
	_state_0:
#line 312 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp0_ = _data_->params;
#line 312 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp1_ = _data_->_tmp0_.uuids;
#line 312 "../src/Providers/RadioBrowser.vala"
	if (_data_->_tmp1_ != NULL) {
#line 314 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp3_ = _data_->params;
#line 314 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp4_ = _data_->_tmp3_.uuids;
#line 314 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp5_ = tuner_data_provider_api_by_uuids ((TunerDataProviderAPI*) _data_->self, (GeeCollection*) _data_->_tmp4_, &_data_->_inner_error0_);
#line 314 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp2_ = _data_->_tmp5_;
#line 314 "../src/Providers/RadioBrowser.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 314 "../src/Providers/RadioBrowser.vala"
			if (_data_->_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 314 "../src/Providers/RadioBrowser.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 314 "../src/Providers/RadioBrowser.vala"
				g_object_unref (_data_->_async_result);
#line 314 "../src/Providers/RadioBrowser.vala"
				return FALSE;
#line 2173 "RadioBrowser.c"
			} else {
#line 314 "../src/Providers/RadioBrowser.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 314 "../src/Providers/RadioBrowser.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 314 "../src/Providers/RadioBrowser.vala"
				g_object_unref (_data_->_async_result);
#line 314 "../src/Providers/RadioBrowser.vala"
				return FALSE;
#line 2183 "RadioBrowser.c"
			}
		}
#line 314 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp6_ = _data_->_tmp2_;
#line 314 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp2_ = NULL;
#line 314 "../src/Providers/RadioBrowser.vala"
		_data_->result = _data_->_tmp6_;
#line 314 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (_data_->_tmp2_);
#line 314 "../src/Providers/RadioBrowser.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 314 "../src/Providers/RadioBrowser.vala"
		if (_data_->_state_ != 0) {
#line 314 "../src/Providers/RadioBrowser.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 314 "../src/Providers/RadioBrowser.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2202 "RadioBrowser.c"
			}
		}
#line 314 "../src/Providers/RadioBrowser.vala"
		g_object_unref (_data_->_async_result);
#line 314 "../src/Providers/RadioBrowser.vala"
		return FALSE;
#line 2209 "RadioBrowser.c"
	}
#line 320 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp7_ = _data_->params;
#line 320 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp8_ = tuner_data_provider_radio_browser_get_search_query_params (_data_->self, &_data_->_tmp7_, _data_->rowcount, _data_->offset);
#line 320 "../src/Providers/RadioBrowser.vala"
	_data_->query = _data_->_tmp8_;
#line 322 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp9_ = _data_->query;
#line 322 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp10_ = string_to_string (_data_->_tmp9_);
#line 322 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp11_ = g_strconcat ("Search: ", _data_->_tmp10_, NULL);
#line 322 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 322 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:322: %s", _data_->_tmp12_);
#line 322 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->_tmp12_);
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp14_ = _data_->query;
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->_state_ = 1;
#line 323 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_station_query_async (_data_->self, TUNER_DATA_PROVIDER_RBI_SEARCH, _data_->_tmp14_, tuner_data_provider_radio_browser_search_async_ready, _data_);
#line 323 "../src/Providers/RadioBrowser.vala"
	return FALSE;
#line 2237 "RadioBrowser.c"
	_state_1:
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp15_ = tuner_data_provider_radio_browser_station_query_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp13_ = _data_->_tmp15_;
#line 323 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 323 "../src/Providers/RadioBrowser.vala"
		if (_data_->_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 323 "../src/Providers/RadioBrowser.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 323 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_data_->query);
#line 323 "../src/Providers/RadioBrowser.vala"
			g_object_unref (_data_->_async_result);
#line 323 "../src/Providers/RadioBrowser.vala"
			return FALSE;
#line 2255 "RadioBrowser.c"
		} else {
#line 323 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_data_->query);
#line 323 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 323 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 323 "../src/Providers/RadioBrowser.vala"
			g_object_unref (_data_->_async_result);
#line 323 "../src/Providers/RadioBrowser.vala"
			return FALSE;
#line 2267 "RadioBrowser.c"
		}
	}
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp16_ = _data_->_tmp13_;
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp13_ = NULL;
#line 323 "../src/Providers/RadioBrowser.vala"
	_data_->result = _data_->_tmp16_;
#line 323 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_data_->_tmp13_);
#line 323 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->query);
#line 323 "../src/Providers/RadioBrowser.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 323 "../src/Providers/RadioBrowser.vala"
	if (_data_->_state_ != 0) {
#line 323 "../src/Providers/RadioBrowser.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 323 "../src/Providers/RadioBrowser.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2288 "RadioBrowser.c"
		}
	}
#line 323 "../src/Providers/RadioBrowser.vala"
	g_object_unref (_data_->_async_result);
#line 323 "../src/Providers/RadioBrowser.vala"
	return FALSE;
#line 2295 "RadioBrowser.c"
}

/**
         * @brief Get all available tags
         *
         * @return ArrayList of Tag objects
         * @throw DataError if unable to retrieve or parse tag data
         */
static void
tuner_data_provider_radio_browser_choose_server (TunerDataProviderRadioBrowser* self)
{
	gint32 random_server = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 338 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (self != NULL);
#line 340 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = self->priv->_servers;
#line 340 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 340 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _tmp1_;
#line 340 "../src/Providers/RadioBrowser.vala"
	random_server = g_random_int_range ((gint32) 0, (gint32) _tmp2_);
#line 2326 "RadioBrowser.c"
	{
		gint a = 0;
#line 342 "../src/Providers/RadioBrowser.vala"
		a = 0;
#line 2331 "RadioBrowser.c"
		{
			gboolean _tmp3_ = FALSE;
#line 342 "../src/Providers/RadioBrowser.vala"
			_tmp3_ = TRUE;
#line 342 "../src/Providers/RadioBrowser.vala"
			while (TRUE) {
#line 2338 "RadioBrowser.c"
				GeeArrayList* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				guint status = 0U;
				gint32 server = 0;
				GeeArrayList* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				GeeArrayList* _tmp11_;
				gpointer _tmp12_;
#line 342 "../src/Providers/RadioBrowser.vala"
				if (!_tmp3_) {
#line 2351 "RadioBrowser.c"
					gint _tmp4_;
#line 342 "../src/Providers/RadioBrowser.vala"
					_tmp4_ = a;
#line 342 "../src/Providers/RadioBrowser.vala"
					a = _tmp4_ + 1;
#line 2357 "RadioBrowser.c"
				}
#line 342 "../src/Providers/RadioBrowser.vala"
				_tmp3_ = FALSE;
#line 342 "../src/Providers/RadioBrowser.vala"
				_tmp5_ = self->priv->_servers;
#line 342 "../src/Providers/RadioBrowser.vala"
				_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 342 "../src/Providers/RadioBrowser.vala"
				_tmp7_ = _tmp6_;
#line 342 "../src/Providers/RadioBrowser.vala"
				if (!(a < _tmp7_)) {
#line 342 "../src/Providers/RadioBrowser.vala"
					break;
#line 2371 "RadioBrowser.c"
				}
#line 345 "../src/Providers/RadioBrowser.vala"
				status = (guint) 0;
#line 346 "../src/Providers/RadioBrowser.vala"
				_tmp8_ = self->priv->_servers;
#line 346 "../src/Providers/RadioBrowser.vala"
				_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 346 "../src/Providers/RadioBrowser.vala"
				_tmp10_ = _tmp9_;
#line 346 "../src/Providers/RadioBrowser.vala"
				server = (random_server + a) % _tmp10_;
#line 347 "../src/Providers/RadioBrowser.vala"
				_tmp11_ = self->priv->_servers;
#line 347 "../src/Providers/RadioBrowser.vala"
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, (gint) server);
#line 347 "../src/Providers/RadioBrowser.vala"
				_g_free0 (self->priv->_current_server);
#line 347 "../src/Providers/RadioBrowser.vala"
				self->priv->_current_server = (gchar*) _tmp12_;
#line 2391 "RadioBrowser.c"
				{
					GUri* uri = NULL;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					GUri* _tmp17_;
					GUri* _tmp18_;
					GUri* _tmp19_;
					guint _tmp20_ = 0U;
					GInputStream* _tmp21_;
					GInputStream* _tmp22_;
#line 349 "../src/Providers/RadioBrowser.vala"
					_tmp13_ = self->priv->_current_server;
#line 349 "../src/Providers/RadioBrowser.vala"
					_tmp14_ = string_to_string (_tmp13_);
#line 349 "../src/Providers/RadioBrowser.vala"
					_tmp15_ = g_strconcat ("http://", _tmp14_, "/json/stats", NULL);
#line 349 "../src/Providers/RadioBrowser.vala"
					_tmp16_ = _tmp15_;
#line 349 "../src/Providers/RadioBrowser.vala"
					_tmp17_ = g_uri_parse (_tmp16_, G_URI_FLAGS_NONE, &_inner_error0_);
#line 349 "../src/Providers/RadioBrowser.vala"
					_tmp18_ = _tmp17_;
#line 349 "../src/Providers/RadioBrowser.vala"
					_g_free0 (_tmp16_);
#line 349 "../src/Providers/RadioBrowser.vala"
					uri = _tmp18_;
#line 349 "../src/Providers/RadioBrowser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 349 "../src/Providers/RadioBrowser.vala"
						if (_inner_error0_->domain == G_URI_ERROR) {
#line 2424 "RadioBrowser.c"
							goto __catch0_g_uri_error;
						}
#line 349 "../src/Providers/RadioBrowser.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 349 "../src/Providers/RadioBrowser.vala"
						g_clear_error (&_inner_error0_);
#line 349 "../src/Providers/RadioBrowser.vala"
						return;
#line 2433 "RadioBrowser.c"
					}
#line 351 "../src/Providers/RadioBrowser.vala"
					_tmp19_ = uri;
#line 351 "../src/Providers/RadioBrowser.vala"
					_tmp21_ = tuner_http_client_GET (_tmp19_, &_tmp20_);
#line 351 "../src/Providers/RadioBrowser.vala"
					status = _tmp20_;
#line 351 "../src/Providers/RadioBrowser.vala"
					_tmp22_ = _tmp21_;
#line 351 "../src/Providers/RadioBrowser.vala"
					_g_object_unref0 (_tmp22_);
#line 348 "../src/Providers/RadioBrowser.vala"
					_g_uri_unref0 (uri);
#line 2447 "RadioBrowser.c"
				}
				goto __finally0;
				__catch0_g_uri_error:
				{
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
#line 348 "../src/Providers/RadioBrowser.vala"
					g_clear_error (&_inner_error0_);
#line 354 "../src/Providers/RadioBrowser.vala"
					_tmp23_ = self->priv->_current_server;
#line 354 "../src/Providers/RadioBrowser.vala"
					_tmp24_ = string_to_string (_tmp23_);
#line 354 "../src/Providers/RadioBrowser.vala"
					_tmp25_ = g_strconcat ("Server - bad Uri from ", _tmp24_, NULL);
#line 354 "../src/Providers/RadioBrowser.vala"
					_tmp26_ = _tmp25_;
#line 354 "../src/Providers/RadioBrowser.vala"
					g_debug ("RadioBrowser.vala:354: %s", _tmp26_);
#line 354 "../src/Providers/RadioBrowser.vala"
					_g_free0 (_tmp26_);
#line 2470 "RadioBrowser.c"
				}
				__finally0:
#line 348 "../src/Providers/RadioBrowser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "../src/Providers/RadioBrowser.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 348 "../src/Providers/RadioBrowser.vala"
					g_clear_error (&_inner_error0_);
#line 348 "../src/Providers/RadioBrowser.vala"
					return;
#line 2481 "RadioBrowser.c"
				}
#line 356 "../src/Providers/RadioBrowser.vala"
				if (status == ((guint) 200)) {
#line 356 "../src/Providers/RadioBrowser.vala"
					break;
#line 2487 "RadioBrowser.c"
				}
			}
		}
	}
#line 358 "../src/Providers/RadioBrowser.vala"
	_tmp27_ = self->priv->_current_server;
#line 358 "../src/Providers/RadioBrowser.vala"
	_tmp28_ = string_to_string (_tmp27_);
#line 358 "../src/Providers/RadioBrowser.vala"
	_tmp29_ = g_strconcat ("RadioBrowser Client - Chosen radio-browser.info server: ", _tmp28_, NULL);
#line 358 "../src/Providers/RadioBrowser.vala"
	_tmp30_ = _tmp29_;
#line 358 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:358: %s", _tmp30_);
#line 358 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp30_);
#line 2504 "RadioBrowser.c"
}

/**
         * @brief Manages tracking server degradation and new server selection
         *
         * Tracks degraded server responses and at a certain level will choose 
         * a new server if possible 
         */
static void
tuner_data_provider_radio_browser_degrade (TunerDataProviderRadioBrowser* self,
                                           gboolean degraded)
{
#line 368 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (self != NULL);
#line 370 "../src/Providers/RadioBrowser.vala"
	if (!degraded) {
#line 2521 "RadioBrowser.c"
		gint _tmp0_ = 0;
#line 373 "../src/Providers/RadioBrowser.vala"
		if (self->priv->_degrade > TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_CAPITAL) {
#line 373 "../src/Providers/RadioBrowser.vala"
			_tmp0_ = 0;
#line 2527 "RadioBrowser.c"
		} else {
#line 373 "../src/Providers/RadioBrowser.vala"
			_tmp0_ = 1;
#line 2531 "RadioBrowser.c"
		}
#line 373 "../src/Providers/RadioBrowser.vala"
		self->priv->_degrade = self->priv->_degrade + _tmp0_;
#line 2535 "RadioBrowser.c"
	} else {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 378 "../src/Providers/RadioBrowser.vala"
		_tmp1_ = self->priv->_current_server;
#line 378 "../src/Providers/RadioBrowser.vala"
		_tmp2_ = string_to_string (_tmp1_);
#line 378 "../src/Providers/RadioBrowser.vala"
		_tmp3_ = g_strconcat ("RadioBrowser degrading server: ", _tmp2_, NULL);
#line 378 "../src/Providers/RadioBrowser.vala"
		_tmp4_ = _tmp3_;
#line 378 "../src/Providers/RadioBrowser.vala"
		g_warning ("RadioBrowser.vala:378: %s", _tmp4_);
#line 378 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp4_);
#line 379 "../src/Providers/RadioBrowser.vala"
		self->priv->_degrade = -TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_COST;
#line 380 "../src/Providers/RadioBrowser.vala"
		if (self->priv->_degrade < 0) {
#line 383 "../src/Providers/RadioBrowser.vala"
			tuner_data_provider_radio_browser_choose_server (self);
#line 384 "../src/Providers/RadioBrowser.vala"
			self->priv->_degrade = TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_CAPITAL;
#line 2561 "RadioBrowser.c"
		}
	}
}

/**
         * @brief Retrieve server stats
         *
         */
static gpointer
_json_object_ref0 (gpointer self)
{
#line 407 "../src/Providers/RadioBrowser.vala"
	return self ? json_object_ref (self) : NULL;
#line 2575 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_stats (TunerDataProviderRadioBrowser* self)
{
	guint status_code = 0U;
	JsonNode* rootnode = NULL;
	GInputStream* stream = NULL;
	GUri* _tmp0_;
	GUri* _tmp1_;
	guint _tmp2_ = 0U;
	GInputStream* _tmp3_;
	GInputStream* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 394 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (self != NULL);
#line 399 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = tuner_data_provider_radio_browser_build_uri (self, TUNER_DATA_PROVIDER_RBI_STATS, "");
#line 399 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _tmp0_;
#line 399 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = tuner_http_client_GET (_tmp1_, &_tmp2_);
#line 399 "../src/Providers/RadioBrowser.vala"
	status_code = _tmp2_;
#line 399 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = _tmp3_;
#line 399 "../src/Providers/RadioBrowser.vala"
	_g_uri_unref0 (_tmp1_);
#line 399 "../src/Providers/RadioBrowser.vala"
	stream = _tmp4_;
#line 401 "../src/Providers/RadioBrowser.vala"
	if (status_code != ((guint) 0)) {
#line 2617 "RadioBrowser.c"
		GInputStream* _tmp6_;
#line 401 "../src/Providers/RadioBrowser.vala"
		_tmp6_ = stream;
#line 401 "../src/Providers/RadioBrowser.vala"
		_tmp5_ = _tmp6_ != NULL;
#line 2623 "RadioBrowser.c"
	} else {
#line 401 "../src/Providers/RadioBrowser.vala"
		_tmp5_ = FALSE;
#line 2627 "RadioBrowser.c"
	}
#line 401 "../src/Providers/RadioBrowser.vala"
	if (_tmp5_) {
#line 2631 "RadioBrowser.c"
		{
			JsonParser* parser = NULL;
			JsonParser* _tmp7_;
			JsonParser* _tmp8_;
			GInputStream* _tmp9_;
			JsonParser* _tmp10_;
			JsonNode* _tmp11_;
			JsonNode* _tmp12_;
			JsonObject* json_object = NULL;
			JsonNode* _tmp13_;
			JsonObject* _tmp14_;
			JsonObject* _tmp15_;
			JsonObject* _tmp16_;
			JsonObject* _tmp17_;
#line 404 "../src/Providers/RadioBrowser.vala"
			_tmp7_ = json_parser_new ();
#line 404 "../src/Providers/RadioBrowser.vala"
			parser = _tmp7_;
#line 405 "../src/Providers/RadioBrowser.vala"
			_tmp8_ = parser;
#line 405 "../src/Providers/RadioBrowser.vala"
			_tmp9_ = stream;
#line 405 "../src/Providers/RadioBrowser.vala"
			json_parser_load_from_stream (_tmp8_, _tmp9_, NULL, &_inner_error0_);
#line 405 "../src/Providers/RadioBrowser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 405 "../src/Providers/RadioBrowser.vala"
				_g_object_unref0 (parser);
#line 2660 "RadioBrowser.c"
				goto __catch0_g_error;
			}
#line 406 "../src/Providers/RadioBrowser.vala"
			_tmp10_ = parser;
#line 406 "../src/Providers/RadioBrowser.vala"
			_tmp11_ = json_parser_get_root (_tmp10_);
#line 406 "../src/Providers/RadioBrowser.vala"
			_tmp12_ = __vala_JsonNode_copy0 (_tmp11_);
#line 406 "../src/Providers/RadioBrowser.vala"
			__vala_JsonNode_free0 (rootnode);
#line 406 "../src/Providers/RadioBrowser.vala"
			rootnode = _tmp12_;
#line 407 "../src/Providers/RadioBrowser.vala"
			_tmp13_ = rootnode;
#line 407 "../src/Providers/RadioBrowser.vala"
			_tmp14_ = json_node_get_object (_tmp13_);
#line 407 "../src/Providers/RadioBrowser.vala"
			_tmp15_ = _json_object_ref0 (_tmp14_);
#line 407 "../src/Providers/RadioBrowser.vala"
			json_object = _tmp15_;
#line 408 "../src/Providers/RadioBrowser.vala"
			_tmp16_ = json_object;
#line 408 "../src/Providers/RadioBrowser.vala"
			self->priv->_available_stations = (gint) json_object_get_int_member (_tmp16_, "stations");
#line 409 "../src/Providers/RadioBrowser.vala"
			_tmp17_ = json_object;
#line 409 "../src/Providers/RadioBrowser.vala"
			self->priv->_available_tags = (gint) json_object_get_int_member (_tmp17_, "tags");
#line 403 "../src/Providers/RadioBrowser.vala"
			_json_object_unref0 (json_object);
#line 403 "../src/Providers/RadioBrowser.vala"
			_g_object_unref0 (parser);
#line 2693 "RadioBrowser.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
#line 403 "../src/Providers/RadioBrowser.vala"
			e = _inner_error0_;
#line 403 "../src/Providers/RadioBrowser.vala"
			_inner_error0_ = NULL;
#line 412 "../src/Providers/RadioBrowser.vala"
			_tmp18_ = e;
#line 412 "../src/Providers/RadioBrowser.vala"
			_tmp19_ = _tmp18_->message;
#line 412 "../src/Providers/RadioBrowser.vala"
			_tmp20_ = string_to_string (_tmp19_);
#line 412 "../src/Providers/RadioBrowser.vala"
			_tmp21_ = g_strconcat ("Could not get server stats: ", _tmp20_, NULL);
#line 412 "../src/Providers/RadioBrowser.vala"
			_tmp22_ = _tmp21_;
#line 412 "../src/Providers/RadioBrowser.vala"
			g_warning ("RadioBrowser.vala:412: %s", _tmp22_);
#line 412 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp22_);
#line 403 "../src/Providers/RadioBrowser.vala"
			_g_error_free0 (e);
#line 2724 "RadioBrowser.c"
		}
		__finally0:
#line 403 "../src/Providers/RadioBrowser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 403 "../src/Providers/RadioBrowser.vala"
			_g_object_unref0 (stream);
#line 403 "../src/Providers/RadioBrowser.vala"
			__vala_JsonNode_free0 (rootnode);
#line 403 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 403 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 403 "../src/Providers/RadioBrowser.vala"
			return;
#line 2739 "RadioBrowser.c"
		}
	}
#line 415 "../src/Providers/RadioBrowser.vala"
	_tmp23_ = g_strdup_printf ("%u", status_code);
#line 415 "../src/Providers/RadioBrowser.vala"
	_tmp24_ = _tmp23_;
#line 415 "../src/Providers/RadioBrowser.vala"
	_tmp25_ = g_strdup_printf ("%i", self->priv->_available_stations);
#line 415 "../src/Providers/RadioBrowser.vala"
	_tmp26_ = _tmp25_;
#line 415 "../src/Providers/RadioBrowser.vala"
	_tmp27_ = g_strdup_printf ("%i", self->priv->_available_tags);
#line 415 "../src/Providers/RadioBrowser.vala"
	_tmp28_ = _tmp27_;
#line 415 "../src/Providers/RadioBrowser.vala"
	_tmp29_ = g_strconcat ("response: ", _tmp24_, " - Stations: ", _tmp26_, " Tags: ", _tmp28_, NULL);
#line 415 "../src/Providers/RadioBrowser.vala"
	_tmp30_ = _tmp29_;
#line 415 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:415: %s", _tmp30_);
#line 415 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp30_);
#line 415 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp28_);
#line 415 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp26_);
#line 415 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp24_);
#line 394 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (stream);
#line 394 "../src/Providers/RadioBrowser.vala"
	__vala_JsonNode_free0 (rootnode);
#line 2772 "RadioBrowser.c"
}

/**
         * @brief Get stations by querying the API
         *
         * @param query the API query
         * @return ArrayList of Station objects
         * @throw DataError if unable to retrieve or parse station data
         */
static GeeSet*
tuner_data_provider_radio_browser_station_query (TunerDataProviderRadioBrowser* self,
                                                 const gchar* path,
                                                 const gchar* query,
                                                 GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint status_code = 0U;
	GUri* uri = NULL;
	GUri* _tmp4_;
	GUri* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GInputStream* stream = NULL;
	GUri* _tmp11_;
	guint _tmp12_ = 0U;
	GInputStream* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GeeHashSet* _tmp34_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 426 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 426 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 426 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (query != NULL, NULL);
#line 429 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = string_to_string (path);
#line 429 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = string_to_string (query);
#line 429 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = g_strconcat ("station_query - ", _tmp0_, " ", _tmp1_, NULL);
#line 429 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = _tmp2_;
#line 429 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:429: %s", _tmp3_);
#line 429 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp3_);
#line 432 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = tuner_data_provider_radio_browser_build_uri (self, path, query);
#line 432 "../src/Providers/RadioBrowser.vala"
	uri = _tmp4_;
#line 433 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = uri;
#line 433 "../src/Providers/RadioBrowser.vala"
	_tmp6_ = g_uri_to_string (_tmp5_);
#line 433 "../src/Providers/RadioBrowser.vala"
	_tmp7_ = _tmp6_;
#line 433 "../src/Providers/RadioBrowser.vala"
	_tmp8_ = string_to_string (_tmp7_);
#line 433 "../src/Providers/RadioBrowser.vala"
	_tmp9_ = g_strconcat ("station_query - ", _tmp8_, NULL);
#line 433 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = _tmp9_;
#line 433 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:433: %s", _tmp10_);
#line 433 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp10_);
#line 433 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp7_);
#line 435 "../src/Providers/RadioBrowser.vala"
	_tmp11_ = uri;
#line 435 "../src/Providers/RadioBrowser.vala"
	_tmp13_ = tuner_http_client_GET (_tmp11_, &_tmp12_);
#line 435 "../src/Providers/RadioBrowser.vala"
	status_code = _tmp12_;
#line 435 "../src/Providers/RadioBrowser.vala"
	stream = _tmp13_;
#line 437 "../src/Providers/RadioBrowser.vala"
	if (status_code == ((guint) 200)) {
#line 2859 "RadioBrowser.c"
		GInputStream* _tmp15_;
#line 437 "../src/Providers/RadioBrowser.vala"
		_tmp15_ = stream;
#line 437 "../src/Providers/RadioBrowser.vala"
		_tmp14_ = _tmp15_ != NULL;
#line 2865 "RadioBrowser.c"
	} else {
#line 437 "../src/Providers/RadioBrowser.vala"
		_tmp14_ = FALSE;
#line 2869 "RadioBrowser.c"
	}
#line 437 "../src/Providers/RadioBrowser.vala"
	if (_tmp14_) {
#line 439 "../src/Providers/RadioBrowser.vala"
		tuner_data_provider_radio_browser_degrade (self, FALSE);
#line 2875 "RadioBrowser.c"
		{
			GeeSet* stations = NULL;
			GInputStream* _tmp16_;
			GeeSet* _tmp17_;
#line 442 "../src/Providers/RadioBrowser.vala"
			_tmp16_ = stream;
#line 442 "../src/Providers/RadioBrowser.vala"
			_tmp17_ = tuner_data_provider_radio_browser_parse_json_response (self, _tmp16_, &_inner_error0_);
#line 442 "../src/Providers/RadioBrowser.vala"
			stations = _tmp17_;
#line 442 "../src/Providers/RadioBrowser.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2888 "RadioBrowser.c"
				goto __catch0_g_error;
			}
#line 443 "../src/Providers/RadioBrowser.vala"
			result = stations;
#line 443 "../src/Providers/RadioBrowser.vala"
			_g_object_unref0 (stream);
#line 443 "../src/Providers/RadioBrowser.vala"
			_g_uri_unref0 (uri);
#line 443 "../src/Providers/RadioBrowser.vala"
			return result;
#line 2899 "RadioBrowser.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			GUri* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 440 "../src/Providers/RadioBrowser.vala"
			e = _inner_error0_;
#line 440 "../src/Providers/RadioBrowser.vala"
			_inner_error0_ = NULL;
#line 446 "../src/Providers/RadioBrowser.vala"
			_tmp18_ = e;
#line 446 "../src/Providers/RadioBrowser.vala"
			_tmp19_ = _tmp18_->message;
#line 446 "../src/Providers/RadioBrowser.vala"
			_tmp20_ = string_to_string (_tmp19_);
#line 446 "../src/Providers/RadioBrowser.vala"
			_tmp21_ = uri;
#line 446 "../src/Providers/RadioBrowser.vala"
			_tmp22_ = g_uri_to_string (_tmp21_);
#line 446 "../src/Providers/RadioBrowser.vala"
			_tmp23_ = _tmp22_;
#line 446 "../src/Providers/RadioBrowser.vala"
			_tmp24_ = g_strconcat ("JSON error \"", _tmp20_, "\" for uri ", _tmp23_, NULL);
#line 446 "../src/Providers/RadioBrowser.vala"
			_tmp25_ = _tmp24_;
#line 446 "../src/Providers/RadioBrowser.vala"
			g_debug ("RadioBrowser.vala:446: %s", _tmp25_);
#line 446 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp25_);
#line 446 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp23_);
#line 440 "../src/Providers/RadioBrowser.vala"
			_g_error_free0 (e);
#line 2941 "RadioBrowser.c"
		}
		__finally0:
#line 440 "../src/Providers/RadioBrowser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 440 "../src/Providers/RadioBrowser.vala"
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 440 "../src/Providers/RadioBrowser.vala"
				g_propagate_error (error, _inner_error0_);
#line 440 "../src/Providers/RadioBrowser.vala"
				_g_object_unref0 (stream);
#line 440 "../src/Providers/RadioBrowser.vala"
				_g_uri_unref0 (uri);
#line 440 "../src/Providers/RadioBrowser.vala"
				return NULL;
#line 2956 "RadioBrowser.c"
			} else {
#line 440 "../src/Providers/RadioBrowser.vala"
				_g_object_unref0 (stream);
#line 440 "../src/Providers/RadioBrowser.vala"
				_g_uri_unref0 (uri);
#line 440 "../src/Providers/RadioBrowser.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 440 "../src/Providers/RadioBrowser.vala"
				g_clear_error (&_inner_error0_);
#line 440 "../src/Providers/RadioBrowser.vala"
				return NULL;
#line 2968 "RadioBrowser.c"
			}
		}
	} else {
		gchar* _tmp26_;
		gchar* _tmp27_;
		GUri* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 451 "../src/Providers/RadioBrowser.vala"
		_tmp26_ = g_strdup_printf ("%u", status_code);
#line 451 "../src/Providers/RadioBrowser.vala"
		_tmp27_ = _tmp26_;
#line 451 "../src/Providers/RadioBrowser.vala"
		_tmp28_ = uri;
#line 451 "../src/Providers/RadioBrowser.vala"
		_tmp29_ = g_uri_to_string (_tmp28_);
#line 451 "../src/Providers/RadioBrowser.vala"
		_tmp30_ = _tmp29_;
#line 451 "../src/Providers/RadioBrowser.vala"
		_tmp31_ = string_to_string (_tmp30_);
#line 451 "../src/Providers/RadioBrowser.vala"
		_tmp32_ = g_strconcat ("Response from 'radio-browser.info': ", _tmp27_, " for url: ", _tmp31_, NULL);
#line 451 "../src/Providers/RadioBrowser.vala"
		_tmp33_ = _tmp32_;
#line 451 "../src/Providers/RadioBrowser.vala"
		g_warning ("RadioBrowser.vala:451: %s", _tmp33_);
#line 451 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp33_);
#line 451 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp30_);
#line 451 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp27_);
#line 452 "../src/Providers/RadioBrowser.vala"
		tuner_data_provider_radio_browser_degrade (self, TRUE);
#line 3006 "RadioBrowser.c"
	}
#line 454 "../src/Providers/RadioBrowser.vala"
	_tmp34_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 454 "../src/Providers/RadioBrowser.vala"
	result = (GeeSet*) _tmp34_;
#line 454 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (stream);
#line 454 "../src/Providers/RadioBrowser.vala"
	_g_uri_unref0 (uri);
#line 454 "../src/Providers/RadioBrowser.vala"
	return result;
#line 3018 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_station_query_async_data_free (gpointer _data)
{
	TunerDataProviderRadioBrowserStationQueryAsyncData* _data_;
	_data_ = _data;
#line 56 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->path);
#line 56 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->query);
#line 56 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_data_->result);
#line 56 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_data_->self);
#line 56 "../src/Providers/RadioBrowser.vala"
	g_slice_free (TunerDataProviderRadioBrowserStationQueryAsyncData, _data_);
#line 3036 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_station_query_async (TunerDataProviderRadioBrowser* self,
                                                       const gchar* path,
                                                       const gchar* query,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_)
{
	TunerDataProviderRadioBrowserStationQueryAsyncData* _data_;
	TunerDataProviderRadioBrowser* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 56 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (path != NULL);
#line 56 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (query != NULL);
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_ = g_slice_new0 (TunerDataProviderRadioBrowserStationQueryAsyncData);
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 56 "../src/Providers/RadioBrowser.vala"
	g_task_set_task_data (_data_->_async_result, _data_, tuner_data_provider_radio_browser_station_query_async_data_free);
#line 56 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->self = _tmp0_;
#line 56 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = g_strdup (path);
#line 56 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->path);
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->path = _tmp1_;
#line 56 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = g_strdup (query);
#line 56 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->query);
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->query = _tmp2_;
#line 56 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_station_query_async_co (_data_);
#line 3080 "RadioBrowser.c"
}

static GeeSet*
tuner_data_provider_radio_browser_station_query_finish (TunerDataProviderRadioBrowser* self,
                                                        GAsyncResult* _res_,
                                                        GError** error)
{
	GeeSet* result;
	TunerDataProviderRadioBrowserStationQueryAsyncData* _data_;
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 56 "../src/Providers/RadioBrowser.vala"
	if (NULL == _data_) {
#line 56 "../src/Providers/RadioBrowser.vala"
		return NULL;
#line 3096 "RadioBrowser.c"
	}
#line 56 "../src/Providers/RadioBrowser.vala"
	result = _data_->result;
#line 56 "../src/Providers/RadioBrowser.vala"
	_data_->result = NULL;
#line 56 "../src/Providers/RadioBrowser.vala"
	return result;
#line 3104 "RadioBrowser.c"
}

/**
        * @brief Get stations by querying the API
        *
        * @param query the API query
        * @return ArrayList of Station objects
        * @throw DataError if unable to retrieve or parse station data
        */
static void
tuner_data_provider_radio_browser_station_query_async_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	TunerDataProviderRadioBrowserStationQueryAsyncData* _data_;
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_ = _user_data_;
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_->_source_object_ = source_object;
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_->_res_ = _res_;
#line 473 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_station_query_async_co (_data_);
#line 3128 "RadioBrowser.c"
}

static gboolean
tuner_data_provider_radio_browser_station_query_async_co (TunerDataProviderRadioBrowserStationQueryAsyncData* _data_)
{
#line 465 "../src/Providers/RadioBrowser.vala"
	switch (_data_->_state_) {
#line 465 "../src/Providers/RadioBrowser.vala"
		case 0:
#line 3138 "RadioBrowser.c"
		goto _state_0;
#line 465 "../src/Providers/RadioBrowser.vala"
		case 1:
#line 3142 "RadioBrowser.c"
		goto _state_1;
		default:
#line 465 "../src/Providers/RadioBrowser.vala"
		g_assert_not_reached ();
#line 3147 "RadioBrowser.c"
	}
	_state_0:
#line 467 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp0_ = string_to_string (_data_->path);
#line 467 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp1_ = string_to_string (_data_->query);
#line 467 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp2_ = g_strconcat ("station_query - ", _data_->_tmp0_, " ", _data_->_tmp1_, NULL);
#line 467 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 467 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:467: %s", _data_->_tmp3_);
#line 467 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->_tmp3_);
#line 470 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp4_ = tuner_data_provider_radio_browser_build_uri (_data_->self, _data_->path, _data_->query);
#line 470 "../src/Providers/RadioBrowser.vala"
	_data_->uri = _data_->_tmp4_;
#line 471 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp5_ = _data_->uri;
#line 471 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp6_ = g_uri_to_string (_data_->_tmp5_);
#line 471 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 471 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp8_ = string_to_string (_data_->_tmp7_);
#line 471 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp9_ = g_strconcat ("station_query - ", _data_->_tmp8_, NULL);
#line 471 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 471 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:471: %s", _data_->_tmp10_);
#line 471 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->_tmp10_);
#line 471 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_data_->_tmp7_);
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp11_ = _data_->uri;
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp12_ = 0U;
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_->_state_ = 1;
#line 473 "../src/Providers/RadioBrowser.vala"
	tuner_http_client_GETasync (_data_->_tmp11_, G_PRIORITY_HIGH_IDLE, tuner_data_provider_radio_browser_station_query_async_ready, _data_);
#line 473 "../src/Providers/RadioBrowser.vala"
	return FALSE;
#line 3194 "RadioBrowser.c"
	_state_1:
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp13_ = tuner_http_client_GETasync_finish (_data_->_res_, &_data_->_tmp12_);
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_->status_code = _data_->_tmp12_;
#line 473 "../src/Providers/RadioBrowser.vala"
	_data_->stream = _data_->_tmp13_;
#line 475 "../src/Providers/RadioBrowser.vala"
	if (_data_->status_code == ((guint) 200)) {
#line 475 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp15_ = _data_->stream;
#line 475 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp14_ = _data_->_tmp15_ != NULL;
#line 3208 "RadioBrowser.c"
	} else {
#line 475 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp14_ = FALSE;
#line 3212 "RadioBrowser.c"
	}
#line 475 "../src/Providers/RadioBrowser.vala"
	if (_data_->_tmp14_) {
#line 477 "../src/Providers/RadioBrowser.vala"
		tuner_data_provider_radio_browser_degrade (_data_->self, FALSE);
#line 3218 "RadioBrowser.c"
		{
#line 480 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp16_ = _data_->stream;
#line 480 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp17_ = tuner_data_provider_radio_browser_parse_json_response (_data_->self, _data_->_tmp16_, &_data_->_inner_error0_);
#line 480 "../src/Providers/RadioBrowser.vala"
			_data_->stations = _data_->_tmp17_;
#line 480 "../src/Providers/RadioBrowser.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3228 "RadioBrowser.c"
				goto __catch0_g_error;
			}
#line 481 "../src/Providers/RadioBrowser.vala"
			_data_->result = _data_->stations;
#line 481 "../src/Providers/RadioBrowser.vala"
			_g_object_unref0 (_data_->stream);
#line 481 "../src/Providers/RadioBrowser.vala"
			_g_uri_unref0 (_data_->uri);
#line 481 "../src/Providers/RadioBrowser.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 481 "../src/Providers/RadioBrowser.vala"
			if (_data_->_state_ != 0) {
#line 481 "../src/Providers/RadioBrowser.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 481 "../src/Providers/RadioBrowser.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3245 "RadioBrowser.c"
				}
			}
#line 481 "../src/Providers/RadioBrowser.vala"
			g_object_unref (_data_->_async_result);
#line 481 "../src/Providers/RadioBrowser.vala"
			return FALSE;
#line 3252 "RadioBrowser.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 478 "../src/Providers/RadioBrowser.vala"
			_data_->e = _data_->_inner_error0_;
#line 478 "../src/Providers/RadioBrowser.vala"
			_data_->_inner_error0_ = NULL;
#line 484 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp18_ = _data_->e;
#line 484 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp19_ = _data_->_tmp18_->message;
#line 484 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp20_ = string_to_string (_data_->_tmp19_);
#line 484 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp21_ = _data_->uri;
#line 484 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp22_ = g_uri_to_string (_data_->_tmp21_);
#line 484 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp23_ = _data_->_tmp22_;
#line 484 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp24_ = g_strconcat ("JSON error \"", _data_->_tmp20_, "\" for uri ", _data_->_tmp23_, NULL);
#line 484 "../src/Providers/RadioBrowser.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 484 "../src/Providers/RadioBrowser.vala"
			g_debug ("RadioBrowser.vala:484: %s", _data_->_tmp25_);
#line 484 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_data_->_tmp25_);
#line 484 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_data_->_tmp23_);
#line 478 "../src/Providers/RadioBrowser.vala"
			_g_error_free0 (_data_->e);
#line 3285 "RadioBrowser.c"
		}
		__finally0:
#line 478 "../src/Providers/RadioBrowser.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 478 "../src/Providers/RadioBrowser.vala"
			if (_data_->_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 478 "../src/Providers/RadioBrowser.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 478 "../src/Providers/RadioBrowser.vala"
				_g_object_unref0 (_data_->stream);
#line 478 "../src/Providers/RadioBrowser.vala"
				_g_uri_unref0 (_data_->uri);
#line 478 "../src/Providers/RadioBrowser.vala"
				g_object_unref (_data_->_async_result);
#line 478 "../src/Providers/RadioBrowser.vala"
				return FALSE;
#line 3302 "RadioBrowser.c"
			} else {
#line 478 "../src/Providers/RadioBrowser.vala"
				_g_object_unref0 (_data_->stream);
#line 478 "../src/Providers/RadioBrowser.vala"
				_g_uri_unref0 (_data_->uri);
#line 478 "../src/Providers/RadioBrowser.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 478 "../src/Providers/RadioBrowser.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 478 "../src/Providers/RadioBrowser.vala"
				g_object_unref (_data_->_async_result);
#line 478 "../src/Providers/RadioBrowser.vala"
				return FALSE;
#line 3316 "RadioBrowser.c"
			}
		}
	} else {
#line 489 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp26_ = g_strdup_printf ("%u", _data_->status_code);
#line 489 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp27_ = _data_->_tmp26_;
#line 489 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp28_ = _data_->uri;
#line 489 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp29_ = g_uri_to_string (_data_->_tmp28_);
#line 489 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 489 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp31_ = string_to_string (_data_->_tmp30_);
#line 489 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp32_ = g_strconcat ("Response from 'radio-browser.info': ", _data_->_tmp27_, " for url: ", _data_->_tmp31_, NULL);
#line 489 "../src/Providers/RadioBrowser.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 489 "../src/Providers/RadioBrowser.vala"
		g_warning ("RadioBrowser.vala:489: %s", _data_->_tmp33_);
#line 489 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_data_->_tmp33_);
#line 489 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_data_->_tmp30_);
#line 489 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_data_->_tmp27_);
#line 490 "../src/Providers/RadioBrowser.vala"
		tuner_data_provider_radio_browser_degrade (_data_->self, TRUE);
#line 3346 "RadioBrowser.c"
	}
#line 492 "../src/Providers/RadioBrowser.vala"
	_data_->_tmp34_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 492 "../src/Providers/RadioBrowser.vala"
	_data_->result = (GeeSet*) _data_->_tmp34_;
#line 492 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_data_->stream);
#line 492 "../src/Providers/RadioBrowser.vala"
	_g_uri_unref0 (_data_->uri);
#line 492 "../src/Providers/RadioBrowser.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 492 "../src/Providers/RadioBrowser.vala"
	if (_data_->_state_ != 0) {
#line 492 "../src/Providers/RadioBrowser.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 492 "../src/Providers/RadioBrowser.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3364 "RadioBrowser.c"
		}
	}
#line 492 "../src/Providers/RadioBrowser.vala"
	g_object_unref (_data_->_async_result);
#line 492 "../src/Providers/RadioBrowser.vala"
	return FALSE;
#line 3371 "RadioBrowser.c"
}

/**
         * Generates query parameters string for radio-browser API search requests.
         *
         * @param params    SearchParams object containing search criteria
         * @param rowcount  Maximum number of results to return
         * @param offset    Starting position in the result set
         *
         * @return String containing formatted query parameters
         */
static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 3389 "RadioBrowser.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 3397 "RadioBrowser.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 3406 "RadioBrowser.c"
	}
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 3421 "RadioBrowser.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 3425 "RadioBrowser.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 3431 "RadioBrowser.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 3436 "RadioBrowser.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 3442 "RadioBrowser.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 3446 "RadioBrowser.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 3450 "RadioBrowser.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 3454 "RadioBrowser.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 3458 "RadioBrowser.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3462 "RadioBrowser.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 3477 "RadioBrowser.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 3486 "RadioBrowser.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 3493 "RadioBrowser.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 3499 "RadioBrowser.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 3507 "RadioBrowser.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 3511 "RadioBrowser.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 3517 "RadioBrowser.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 3522 "RadioBrowser.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 3528 "RadioBrowser.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 3532 "RadioBrowser.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 3536 "RadioBrowser.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 3542 "RadioBrowser.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 3548 "RadioBrowser.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 3560 "RadioBrowser.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 3564 "RadioBrowser.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 3568 "RadioBrowser.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 3573 "RadioBrowser.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 3581 "RadioBrowser.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 3599 "RadioBrowser.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 3605 "RadioBrowser.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 3609 "RadioBrowser.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 3617 "RadioBrowser.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 3626 "RadioBrowser.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 3635 "RadioBrowser.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 3641 "RadioBrowser.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 3649 "RadioBrowser.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 3661 "RadioBrowser.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 3667 "RadioBrowser.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 3671 "RadioBrowser.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 3679 "RadioBrowser.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 3690 "RadioBrowser.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 3699 "RadioBrowser.c"
	}
}

static gchar*
tuner_data_provider_radio_browser_get_search_query_params (TunerDataProviderRadioBrowser* self,
                                                           TunerDataProviderSearchParams* params,
                                                           guint rowcount,
                                                           guint offset)
{
	gchar* query = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	TunerDataProviderSearchParams _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	TunerDataProviderSearchParams _tmp9_;
	const gchar* _tmp10_;
	TunerDataProviderSearchParams _tmp20_;
	const gchar* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	TunerDataProviderSearchParams _tmp31_;
	TunerDataProviderSearchParams _tmp39_;
	GeeSet* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gchar* result;
#line 506 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 506 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = g_strdup_printf ("%u", rowcount);
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _tmp0_;
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = *params;
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = tuner_data_provider_sort_order_to_string (_tmp2_.order);
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = _tmp3_;
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = g_strdup_printf ("%u", offset);
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp6_ = _tmp5_;
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp7_ = g_strconcat ("limit=", _tmp1_, "&order=", _tmp4_, "&offset=", _tmp6_, NULL);
#line 509 "../src/Providers/RadioBrowser.vala"
	_tmp8_ = _tmp7_;
#line 509 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp6_);
#line 509 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp4_);
#line 509 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp1_);
#line 509 "../src/Providers/RadioBrowser.vala"
	query = _tmp8_;
#line 511 "../src/Providers/RadioBrowser.vala"
	_tmp9_ = *params;
#line 511 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = _tmp9_.text;
#line 511 "../src/Providers/RadioBrowser.vala"
	if (g_strcmp0 (_tmp10_, "") != 0) {
#line 3767 "RadioBrowser.c"
		const gchar* _tmp11_;
		TunerDataProviderSearchParams _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp11_ = query;
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp12_ = *params;
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp13_ = _tmp12_.text;
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp14_ = tuner_data_provider_radio_browser_encode_text (_tmp13_);
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp15_ = _tmp14_;
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp16_ = string_to_string (_tmp15_);
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp17_ = g_strconcat ("&name=", _tmp16_, NULL);
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp18_ = _tmp17_;
#line 512 "../src/Providers/RadioBrowser.vala"
		_tmp19_ = g_strconcat (_tmp11_, _tmp18_, NULL);
#line 512 "../src/Providers/RadioBrowser.vala"
		_g_free0 (query);
#line 512 "../src/Providers/RadioBrowser.vala"
		query = _tmp19_;
#line 512 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp18_);
#line 512 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp15_);
#line 3803 "RadioBrowser.c"
	}
#line 514 "../src/Providers/RadioBrowser.vala"
	_tmp20_ = *params;
#line 514 "../src/Providers/RadioBrowser.vala"
	_tmp21_ = _tmp20_.countrycode;
#line 514 "../src/Providers/RadioBrowser.vala"
	_tmp22_ = strlen (_tmp21_);
#line 514 "../src/Providers/RadioBrowser.vala"
	_tmp23_ = _tmp22_;
#line 514 "../src/Providers/RadioBrowser.vala"
	if (_tmp23_ > 0) {
#line 3815 "RadioBrowser.c"
		const gchar* _tmp24_;
		TunerDataProviderSearchParams _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
#line 515 "../src/Providers/RadioBrowser.vala"
		_tmp24_ = query;
#line 515 "../src/Providers/RadioBrowser.vala"
		_tmp25_ = *params;
#line 515 "../src/Providers/RadioBrowser.vala"
		_tmp26_ = _tmp25_.countrycode;
#line 515 "../src/Providers/RadioBrowser.vala"
		_tmp27_ = string_to_string (_tmp26_);
#line 515 "../src/Providers/RadioBrowser.vala"
		_tmp28_ = g_strconcat ("&countrycode=", _tmp27_, NULL);
#line 515 "../src/Providers/RadioBrowser.vala"
		_tmp29_ = _tmp28_;
#line 515 "../src/Providers/RadioBrowser.vala"
		_tmp30_ = g_strconcat (_tmp24_, _tmp29_, NULL);
#line 515 "../src/Providers/RadioBrowser.vala"
		_g_free0 (query);
#line 515 "../src/Providers/RadioBrowser.vala"
		query = _tmp30_;
#line 515 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp29_);
#line 3843 "RadioBrowser.c"
	}
#line 517 "../src/Providers/RadioBrowser.vala"
	_tmp31_ = *params;
#line 517 "../src/Providers/RadioBrowser.vala"
	if (_tmp31_.order != TUNER_DATA_PROVIDER_SORT_ORDER_RANDOM) {
#line 3849 "RadioBrowser.c"
		const gchar* _tmp32_;
		TunerDataProviderSearchParams _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
#line 519 "../src/Providers/RadioBrowser.vala"
		_tmp32_ = query;
#line 519 "../src/Providers/RadioBrowser.vala"
		_tmp33_ = *params;
#line 519 "../src/Providers/RadioBrowser.vala"
		_tmp34_ = bool_to_string (_tmp33_.reverse);
#line 519 "../src/Providers/RadioBrowser.vala"
		_tmp35_ = _tmp34_;
#line 519 "../src/Providers/RadioBrowser.vala"
		_tmp36_ = g_strconcat ("&reverse=", _tmp35_, NULL);
#line 519 "../src/Providers/RadioBrowser.vala"
		_tmp37_ = _tmp36_;
#line 519 "../src/Providers/RadioBrowser.vala"
		_tmp38_ = g_strconcat (_tmp32_, _tmp37_, NULL);
#line 519 "../src/Providers/RadioBrowser.vala"
		_g_free0 (query);
#line 519 "../src/Providers/RadioBrowser.vala"
		query = _tmp38_;
#line 519 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp37_);
#line 519 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp35_);
#line 3879 "RadioBrowser.c"
	}
#line 522 "../src/Providers/RadioBrowser.vala"
	_tmp39_ = *params;
#line 522 "../src/Providers/RadioBrowser.vala"
	_tmp40_ = _tmp39_.tags;
#line 522 "../src/Providers/RadioBrowser.vala"
	_tmp41_ = gee_collection_get_size ((GeeCollection*) _tmp40_);
#line 522 "../src/Providers/RadioBrowser.vala"
	_tmp42_ = _tmp41_;
#line 522 "../src/Providers/RadioBrowser.vala"
	if (_tmp42_ > 0) {
#line 3891 "RadioBrowser.c"
		gchar* tag_list = NULL;
		TunerDataProviderSearchParams _tmp43_;
		GeeSet* _tmp44_;
		gint _tmp45_ = 0;
		gpointer* _tmp46_;
		gchar** _tmp47_;
		gint _tmp47__length1;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		TunerDataProviderSearchParams _tmp51_;
		GeeSet* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		const gchar* _tmp61_;
		const gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		const gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		gchar* _tmp68_;
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp43_ = *params;
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp44_ = _tmp43_.tags;
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp46_ = gee_collection_to_array ((GeeCollection*) _tmp44_, &_tmp45_);
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp47_ = _tmp46_;
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp47__length1 = _tmp45_;
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp48_ = _tmp47_[0];
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp49_ = g_strdup (_tmp48_);
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp50_ = _tmp49_;
#line 523 "../src/Providers/RadioBrowser.vala"
		_tmp47_ = (_vala_array_free (_tmp47_, _tmp47__length1, (GDestroyNotify) g_free), NULL);
#line 523 "../src/Providers/RadioBrowser.vala"
		tag_list = _tmp50_;
#line 524 "../src/Providers/RadioBrowser.vala"
		_tmp51_ = *params;
#line 524 "../src/Providers/RadioBrowser.vala"
		_tmp52_ = _tmp51_.tags;
#line 524 "../src/Providers/RadioBrowser.vala"
		_tmp53_ = gee_collection_get_size ((GeeCollection*) _tmp52_);
#line 524 "../src/Providers/RadioBrowser.vala"
		_tmp54_ = _tmp53_;
#line 524 "../src/Providers/RadioBrowser.vala"
		if (_tmp54_ > 1) {
#line 3944 "RadioBrowser.c"
			TunerDataProviderSearchParams _tmp55_;
			GeeSet* _tmp56_;
			gint _tmp57_ = 0;
			gpointer* _tmp58_;
			gchar** _tmp59_;
			gint _tmp59__length1;
			gchar* _tmp60_;
#line 525 "../src/Providers/RadioBrowser.vala"
			_tmp55_ = *params;
#line 525 "../src/Providers/RadioBrowser.vala"
			_tmp56_ = _tmp55_.tags;
#line 525 "../src/Providers/RadioBrowser.vala"
			_tmp58_ = gee_collection_to_array ((GeeCollection*) _tmp56_, &_tmp57_);
#line 525 "../src/Providers/RadioBrowser.vala"
			_tmp59_ = _tmp58_;
#line 525 "../src/Providers/RadioBrowser.vala"
			_tmp59__length1 = _tmp57_;
#line 525 "../src/Providers/RadioBrowser.vala"
			_tmp60_ = _vala_g_strjoinv (",", _tmp59_, (gint) _tmp57_);
#line 525 "../src/Providers/RadioBrowser.vala"
			_g_free0 (tag_list);
#line 525 "../src/Providers/RadioBrowser.vala"
			tag_list = _tmp60_;
#line 525 "../src/Providers/RadioBrowser.vala"
			_tmp59_ = (_vala_array_free (_tmp59_, _tmp59__length1, (GDestroyNotify) g_free), NULL);
#line 3970 "RadioBrowser.c"
		}
#line 527 "../src/Providers/RadioBrowser.vala"
		_tmp61_ = query;
#line 527 "../src/Providers/RadioBrowser.vala"
		_tmp62_ = tag_list;
#line 527 "../src/Providers/RadioBrowser.vala"
		_tmp63_ = tuner_data_provider_radio_browser_encode_text (_tmp62_);
#line 527 "../src/Providers/RadioBrowser.vala"
		_tmp64_ = _tmp63_;
#line 527 "../src/Providers/RadioBrowser.vala"
		_tmp65_ = string_to_string (_tmp64_);
#line 527 "../src/Providers/RadioBrowser.vala"
		_tmp66_ = g_strconcat ("&tagExact=false&tagList=", _tmp65_, NULL);
#line 527 "../src/Providers/RadioBrowser.vala"
		_tmp67_ = _tmp66_;
#line 527 "../src/Providers/RadioBrowser.vala"
		_tmp68_ = g_strconcat (_tmp61_, _tmp67_, NULL);
#line 527 "../src/Providers/RadioBrowser.vala"
		_g_free0 (query);
#line 527 "../src/Providers/RadioBrowser.vala"
		query = _tmp68_;
#line 527 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp67_);
#line 527 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp64_);
#line 522 "../src/Providers/RadioBrowser.vala"
		_g_free0 (tag_list);
#line 3998 "RadioBrowser.c"
	}
#line 529 "../src/Providers/RadioBrowser.vala"
	result = query;
#line 529 "../src/Providers/RadioBrowser.vala"
	return result;
#line 4004 "RadioBrowser.c"
}

/**
         * Parses JSON response from Radio Browser API into a set of stations.
         *
         * @param stream The input stream containing JSON data to be parsed
         *
         * @return Set<Model.Station> A set of Station objects parsed from the JSON
         *
         * @throws Error If there is an error parsing the JSON or processing the data
         */
static GeeSet*
tuner_data_provider_radio_browser_parse_json_response (TunerDataProviderRadioBrowser* self,
                                                       GInputStream* stream,
                                                       GError** error)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	JsonNode* rootnode = NULL;
	JsonNode* _tmp1_;
	JsonNode* _tmp2_;
	JsonArray* rootarray = NULL;
	JsonNode* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	JsonArray* _tmp6_;
	GeeSet* _tmp7_;
	GError* _inner_error0_ = NULL;
	GeeSet* result;
#line 542 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 542 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (stream != NULL, NULL);
#line 544 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = json_parser_new_immutable ();
#line 544 "../src/Providers/RadioBrowser.vala"
	parser = _tmp0_;
#line 545 "../src/Providers/RadioBrowser.vala"
	json_parser_load_from_stream (parser, stream, NULL, &_inner_error0_);
#line 545 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 545 "../src/Providers/RadioBrowser.vala"
		g_propagate_error (error, _inner_error0_);
#line 545 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (parser);
#line 545 "../src/Providers/RadioBrowser.vala"
		return NULL;
#line 4052 "RadioBrowser.c"
	}
#line 546 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = json_parser_get_root (parser);
#line 546 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = __vala_JsonNode_copy0 (_tmp1_);
#line 546 "../src/Providers/RadioBrowser.vala"
	rootnode = _tmp2_;
#line 547 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = rootnode;
#line 547 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = json_node_get_array (_tmp3_);
#line 547 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = _json_array_ref0 (_tmp4_);
#line 547 "../src/Providers/RadioBrowser.vala"
	rootarray = _tmp5_;
#line 548 "../src/Providers/RadioBrowser.vala"
	_tmp6_ = rootarray;
#line 548 "../src/Providers/RadioBrowser.vala"
	_tmp7_ = tuner_data_provider_radio_browser_jarray_to_stations (self, _tmp6_);
#line 548 "../src/Providers/RadioBrowser.vala"
	result = _tmp7_;
#line 548 "../src/Providers/RadioBrowser.vala"
	_json_array_unref0 (rootarray);
#line 548 "../src/Providers/RadioBrowser.vala"
	__vala_JsonNode_free0 (rootnode);
#line 548 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (parser);
#line 548 "../src/Providers/RadioBrowser.vala"
	return result;
#line 4082 "RadioBrowser.c"
}

/**
        * @brief Marshals JSON array data into an array of Station
        *
        * Not knowing what the produce did, allow null data
        *
        * @param data JSON array containing station data
        * @return ArrayList of Station objects
        */
static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 560 "../src/Providers/RadioBrowser.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 560 "../src/Providers/RadioBrowser.vala"
	return _data4_;
#line 4100 "RadioBrowser.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 560 "../src/Providers/RadioBrowser.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 4110 "RadioBrowser.c"
		TunerDataProviderRadioBrowser* self;
#line 560 "../src/Providers/RadioBrowser.vala"
		self = _data4_->self;
#line 560 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (_data4_->stations);
#line 560 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (self);
#line 560 "../src/Providers/RadioBrowser.vala"
		g_slice_free (Block4Data, _data4_);
#line 4120 "RadioBrowser.c"
	}
}

static void
___lambda101_ (Block4Data* _data4_,
               JsonArray* array,
               guint index,
               JsonNode* element)
{
	TunerDataProviderRadioBrowser* self;
	TunerModelStation* s = NULL;
	TunerModelStation* _tmp0_;
	GeeHashSet* _tmp1_;
#line 566 "../src/Providers/RadioBrowser.vala"
	self = _data4_->self;
#line 566 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (array != NULL);
#line 566 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (element != NULL);
#line 567 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = tuner_model_station_make (element);
#line 567 "../src/Providers/RadioBrowser.vala"
	s = _tmp0_;
#line 568 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _data4_->stations;
#line 568 "../src/Providers/RadioBrowser.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, s);
#line 566 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (s);
#line 4150 "RadioBrowser.c"
}

static void
____lambda101__json_array_foreach (JsonArray* array,
                                   guint index_,
                                   JsonNode* element_node,
                                   gpointer self)
{
#line 566 "../src/Providers/RadioBrowser.vala"
	___lambda101_ (self, array, index_, element_node);
#line 4161 "RadioBrowser.c"
}

static GeeSet*
tuner_data_provider_radio_browser_jarray_to_stations (TunerDataProviderRadioBrowser* self,
                                                      JsonArray* data)
{
	Block4Data* _data4_;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* result;
#line 560 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 560 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 560 "../src/Providers/RadioBrowser.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 560 "../src/Providers/RadioBrowser.vala"
	_data4_->_ref_count_ = 1;
#line 560 "../src/Providers/RadioBrowser.vala"
	_data4_->self = g_object_ref (self);
#line 562 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = gee_hash_set_new (TUNER_MODEL_TYPE_STATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 562 "../src/Providers/RadioBrowser.vala"
	_data4_->stations = _tmp0_;
#line 564 "../src/Providers/RadioBrowser.vala"
	if (data != NULL) {
#line 566 "../src/Providers/RadioBrowser.vala"
		json_array_foreach_element (data, ____lambda101__json_array_foreach, _data4_);
#line 4191 "RadioBrowser.c"
	}
#line 571 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _data4_->stations;
#line 571 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _g_object_ref0 ((GeeSet*) _tmp1_);
#line 571 "../src/Providers/RadioBrowser.vala"
	result = _tmp2_;
#line 571 "../src/Providers/RadioBrowser.vala"
	block4_data_unref (_data4_);
#line 571 "../src/Providers/RadioBrowser.vala"
	_data4_ = NULL;
#line 571 "../src/Providers/RadioBrowser.vala"
	return result;
#line 4205 "RadioBrowser.c"
}

/**
        * @brief Converts a JSON node to a Tag object
        *
        * @param node JSON node representing a tag
        * @return Tag object
        */
static TunerDataProviderTag*
tuner_data_provider_radio_browser_jnode_to_tag (TunerDataProviderRadioBrowser* self,
                                                JsonNode* node)
{
	GObject* _tmp0_;
	TunerDataProviderTag* _tmp1_;
	TunerDataProviderTag* result;
#line 581 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 581 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 583 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = json_gobject_deserialize (TUNER_DATA_PROVIDER_TYPE_TAG, node);
#line 583 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = TUNER_DATA_PROVIDER_IS_TAG (_tmp0_) ? ((TunerDataProviderTag*) _tmp0_) : NULL;
#line 583 "../src/Providers/RadioBrowser.vala"
	if (_tmp1_ == NULL) {
#line 583 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (_tmp0_);
#line 4233 "RadioBrowser.c"
	}
#line 583 "../src/Providers/RadioBrowser.vala"
	result = _tmp1_;
#line 583 "../src/Providers/RadioBrowser.vala"
	return result;
#line 4239 "RadioBrowser.c"
}

/**
        * @brief Marshals JSON tag data into an array of Tag
        *
        * Not knowing what the produce did, allow null data
        *
        * @param data JSON array containing tag data
        * @return ArrayList of Tag objects
        */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 595 "../src/Providers/RadioBrowser.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 595 "../src/Providers/RadioBrowser.vala"
	return _data5_;
#line 4257 "RadioBrowser.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 595 "../src/Providers/RadioBrowser.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4267 "RadioBrowser.c"
		TunerDataProviderRadioBrowser* self;
#line 595 "../src/Providers/RadioBrowser.vala"
		self = _data5_->self;
#line 595 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (_data5_->tags);
#line 595 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (self);
#line 595 "../src/Providers/RadioBrowser.vala"
		g_slice_free (Block5Data, _data5_);
#line 4277 "RadioBrowser.c"
	}
}

static void
___lambda100_ (Block5Data* _data5_,
               JsonArray* array,
               guint index,
               JsonNode* element)
{
	TunerDataProviderRadioBrowser* self;
	TunerDataProviderTag* s = NULL;
	TunerDataProviderTag* _tmp0_;
	GeeHashSet* _tmp1_;
#line 601 "../src/Providers/RadioBrowser.vala"
	self = _data5_->self;
#line 601 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (array != NULL);
#line 601 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (element != NULL);
#line 602 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = tuner_data_provider_radio_browser_jnode_to_tag (self, element);
#line 602 "../src/Providers/RadioBrowser.vala"
	s = _tmp0_;
#line 603 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _data5_->tags;
#line 603 "../src/Providers/RadioBrowser.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, s);
#line 601 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (s);
#line 4307 "RadioBrowser.c"
}

static void
____lambda100__json_array_foreach (JsonArray* array,
                                   guint index_,
                                   JsonNode* element_node,
                                   gpointer self)
{
#line 601 "../src/Providers/RadioBrowser.vala"
	___lambda100_ (self, array, index_, element_node);
#line 4318 "RadioBrowser.c"
}

static GeeSet*
tuner_data_provider_radio_browser_jarray_to_tags (TunerDataProviderRadioBrowser* self,
                                                  JsonArray* data)
{
	Block5Data* _data5_;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* result;
#line 595 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 595 "../src/Providers/RadioBrowser.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 595 "../src/Providers/RadioBrowser.vala"
	_data5_->_ref_count_ = 1;
#line 595 "../src/Providers/RadioBrowser.vala"
	_data5_->self = g_object_ref (self);
#line 597 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = gee_hash_set_new (TUNER_DATA_PROVIDER_TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 597 "../src/Providers/RadioBrowser.vala"
	_data5_->tags = _tmp0_;
#line 599 "../src/Providers/RadioBrowser.vala"
	if (data != NULL) {
#line 601 "../src/Providers/RadioBrowser.vala"
		json_array_foreach_element (data, ____lambda100__json_array_foreach, _data5_);
#line 4346 "RadioBrowser.c"
	}
#line 607 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _data5_->tags;
#line 607 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _g_object_ref0 ((GeeSet*) _tmp1_);
#line 607 "../src/Providers/RadioBrowser.vala"
	result = _tmp2_;
#line 607 "../src/Providers/RadioBrowser.vala"
	block5_data_unref (_data5_);
#line 607 "../src/Providers/RadioBrowser.vala"
	_data5_ = NULL;
#line 607 "../src/Providers/RadioBrowser.vala"
	return result;
#line 4360 "RadioBrowser.c"
}

/**
         * @brief Get all radio-browser.info API servers
         * 
         * Gets server list from Radio Browser DNS SRV record, 
         * and failing that, from the API
         *
         * @since 1.5.4
         * @return ArrayList of strings containing the resolved hostnames
         * @throw DataError if unable to resolve DNS records
         */
static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 621 "../src/Providers/RadioBrowser.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 621 "../src/Providers/RadioBrowser.vala"
	return _data6_;
#line 4380 "RadioBrowser.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 621 "../src/Providers/RadioBrowser.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 4390 "RadioBrowser.c"
		TunerDataProviderRadioBrowser* self;
#line 621 "../src/Providers/RadioBrowser.vala"
		self = _data6_->self;
#line 621 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (_data6_->results);
#line 621 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (self);
#line 621 "../src/Providers/RadioBrowser.vala"
		g_slice_free (Block6Data, _data6_);
#line 4400 "RadioBrowser.c"
	}
}

static GSrvTarget*
_vala_GSrvTarget_copy (GSrvTarget* self)
{
#line 632 "../src/Providers/RadioBrowser.vala"
	return g_boxed_copy (g_srv_target_get_type (), self);
#line 4409 "RadioBrowser.c"
}

static gpointer
__vala_GSrvTarget_copy0 (gpointer self)
{
#line 632 "../src/Providers/RadioBrowser.vala"
	return self ? _vala_GSrvTarget_copy (self) : NULL;
#line 4417 "RadioBrowser.c"
}

static void
_vala_GSrvTarget_free (GSrvTarget* self)
{
#line 632 "../src/Providers/RadioBrowser.vala"
	g_boxed_free (g_srv_target_get_type (), self);
#line 4425 "RadioBrowser.c"
}

static void
__vala_GSrvTarget_free0_ (gpointer var)
{
#line 627 "../src/Providers/RadioBrowser.vala"
	(var == NULL) ? NULL : (var = (_vala_GSrvTarget_free (var), NULL));
#line 4433 "RadioBrowser.c"
}

static inline void
_g_list_free___vala_GSrvTarget_free0_ (GList* self)
{
#line 627 "../src/Providers/RadioBrowser.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GSrvTarget_free0_);
#line 4441 "RadioBrowser.c"
}

static void
______lambda99_ (Block6Data* _data6_,
                 JsonArray* array,
                 guint index_,
                 JsonNode* element_node)
{
	TunerDataProviderRadioBrowser* self;
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	JsonObject* _tmp2_;
#line 663 "../src/Providers/RadioBrowser.vala"
	self = _data6_->self;
#line 663 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (array != NULL);
#line 663 "../src/Providers/RadioBrowser.vala"
	g_return_if_fail (element_node != NULL);
#line 664 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = json_node_get_object (element_node);
#line 664 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = _json_object_ref0 (_tmp0_);
#line 664 "../src/Providers/RadioBrowser.vala"
	object = _tmp1_;
#line 665 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = object;
#line 665 "../src/Providers/RadioBrowser.vala"
	if (_tmp2_ != NULL) {
#line 4471 "RadioBrowser.c"
		gchar* name = NULL;
		JsonObject* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
#line 666 "../src/Providers/RadioBrowser.vala"
		_tmp3_ = object;
#line 666 "../src/Providers/RadioBrowser.vala"
		_tmp4_ = json_object_get_string_member (_tmp3_, "name");
#line 666 "../src/Providers/RadioBrowser.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 666 "../src/Providers/RadioBrowser.vala"
		name = _tmp5_;
#line 667 "../src/Providers/RadioBrowser.vala"
		_tmp7_ = name;
#line 667 "../src/Providers/RadioBrowser.vala"
		if (_tmp7_ != NULL) {
#line 4490 "RadioBrowser.c"
			GeeArrayList* _tmp8_;
			const gchar* _tmp9_;
#line 667 "../src/Providers/RadioBrowser.vala"
			_tmp8_ = _data6_->results;
#line 667 "../src/Providers/RadioBrowser.vala"
			_tmp9_ = name;
#line 667 "../src/Providers/RadioBrowser.vala"
			_tmp6_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_);
#line 4499 "RadioBrowser.c"
		} else {
#line 667 "../src/Providers/RadioBrowser.vala"
			_tmp6_ = FALSE;
#line 4503 "RadioBrowser.c"
		}
#line 667 "../src/Providers/RadioBrowser.vala"
		if (_tmp6_) {
#line 4507 "RadioBrowser.c"
			GeeArrayList* _tmp10_;
			const gchar* _tmp11_;
#line 668 "../src/Providers/RadioBrowser.vala"
			_tmp10_ = _data6_->results;
#line 668 "../src/Providers/RadioBrowser.vala"
			_tmp11_ = name;
#line 668 "../src/Providers/RadioBrowser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 4516 "RadioBrowser.c"
		}
#line 665 "../src/Providers/RadioBrowser.vala"
		_g_free0 (name);
#line 4520 "RadioBrowser.c"
	}
#line 663 "../src/Providers/RadioBrowser.vala"
	_json_object_unref0 (object);
#line 4524 "RadioBrowser.c"
}

static void
_______lambda99__json_array_foreach (JsonArray* array,
                                     guint index_,
                                     JsonNode* element_node,
                                     gpointer self)
{
#line 663 "../src/Providers/RadioBrowser.vala"
	______lambda99_ (self, array, index_, element_node);
#line 4535 "RadioBrowser.c"
}

static GeeArrayList*
tuner_data_provider_radio_browser_get_srv_api_servers (TunerDataProviderRadioBrowser* self,
                                                       GError** error)
{
	Block6Data* _data6_;
	GeeArrayList* _tmp0_;
	TunerApplication* _tmp1_;
	TunerApplication* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GeeArrayList* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GeeArrayList* _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	gchar* _tmp62_;
	GeeArrayList* _tmp63_;
	GeeArrayList* _tmp64_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 621 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 621 "../src/Providers/RadioBrowser.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 621 "../src/Providers/RadioBrowser.vala"
	_data6_->_ref_count_ = 1;
#line 621 "../src/Providers/RadioBrowser.vala"
	_data6_->self = g_object_ref (self);
#line 623 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 623 "../src/Providers/RadioBrowser.vala"
	_data6_->results = _tmp0_;
#line 625 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = tuner_app ();
#line 625 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = _tmp1_;
#line 625 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = tuner_application_get_is_offline (_tmp2_);
#line 625 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = _tmp3_;
#line 625 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = _tmp4_;
#line 625 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (_tmp2_);
#line 625 "../src/Providers/RadioBrowser.vala"
	if (_tmp5_) {
#line 4589 "RadioBrowser.c"
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
#line 625 "../src/Providers/RadioBrowser.vala"
		_tmp6_ = _data6_->results;
#line 625 "../src/Providers/RadioBrowser.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 625 "../src/Providers/RadioBrowser.vala"
		result = _tmp7_;
#line 625 "../src/Providers/RadioBrowser.vala"
		block6_data_unref (_data6_);
#line 625 "../src/Providers/RadioBrowser.vala"
		_data6_ = NULL;
#line 625 "../src/Providers/RadioBrowser.vala"
		return result;
#line 4604 "RadioBrowser.c"
	}
	{
		GList* srv_targets = NULL;
		GResolver* _tmp8_;
		GResolver* _tmp9_;
		GList* _tmp10_;
		GList* _tmp11_;
		GList* _tmp12_;
#line 631 "../src/Providers/RadioBrowser.vala"
		_tmp8_ = g_resolver_get_default ();
#line 631 "../src/Providers/RadioBrowser.vala"
		_tmp9_ = _tmp8_;
#line 631 "../src/Providers/RadioBrowser.vala"
		_tmp10_ = g_resolver_lookup_service (_tmp9_, TUNER_DATA_PROVIDER_SRV_SERVICE, TUNER_DATA_PROVIDER_SRV_PROTOCOL, TUNER_DATA_PROVIDER_SRV_DOMAIN, NULL, &_inner_error0_);
#line 631 "../src/Providers/RadioBrowser.vala"
		_tmp11_ = _tmp10_;
#line 631 "../src/Providers/RadioBrowser.vala"
		_g_object_unref0 (_tmp9_);
#line 631 "../src/Providers/RadioBrowser.vala"
		srv_targets = _tmp11_;
#line 631 "../src/Providers/RadioBrowser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4627 "RadioBrowser.c"
			goto __catch0_g_error;
		}
#line 632 "../src/Providers/RadioBrowser.vala"
		_tmp12_ = srv_targets;
#line 4632 "RadioBrowser.c"
		{
			GList* target_collection = NULL;
			GList* target_it = NULL;
#line 632 "../src/Providers/RadioBrowser.vala"
			target_collection = _tmp12_;
#line 632 "../src/Providers/RadioBrowser.vala"
			for (target_it = target_collection; target_it != NULL; target_it = target_it->next) {
#line 4640 "RadioBrowser.c"
				GSrvTarget* _tmp13_;
				GSrvTarget* target = NULL;
#line 632 "../src/Providers/RadioBrowser.vala"
				_tmp13_ = __vala_GSrvTarget_copy0 ((GSrvTarget*) target_it->data);
#line 632 "../src/Providers/RadioBrowser.vala"
				target = _tmp13_;
#line 4647 "RadioBrowser.c"
				{
					GeeArrayList* _tmp14_;
					GSrvTarget* _tmp15_;
					const gchar* _tmp16_;
#line 633 "../src/Providers/RadioBrowser.vala"
					_tmp14_ = _data6_->results;
#line 633 "../src/Providers/RadioBrowser.vala"
					_tmp15_ = target;
#line 633 "../src/Providers/RadioBrowser.vala"
					_tmp16_ = g_srv_target_get_hostname (_tmp15_);
#line 633 "../src/Providers/RadioBrowser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp16_);
#line 632 "../src/Providers/RadioBrowser.vala"
					__vala_GSrvTarget_free0 (target);
#line 4662 "RadioBrowser.c"
				}
			}
		}
#line 627 "../src/Providers/RadioBrowser.vala"
		(srv_targets == NULL) ? NULL : (srv_targets = (_g_list_free___vala_GSrvTarget_free0_ (srv_targets), NULL));
#line 4668 "RadioBrowser.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 627 "../src/Providers/RadioBrowser.vala"
		e = _inner_error0_;
#line 627 "../src/Providers/RadioBrowser.vala"
		_inner_error0_ = NULL;
#line 636 "../src/Providers/RadioBrowser.vala"
		_tmp17_ = e;
#line 636 "../src/Providers/RadioBrowser.vala"
		_tmp18_ = _tmp17_->message;
#line 636 "../src/Providers/RadioBrowser.vala"
		_tmp19_ = string_to_string (_tmp18_);
#line 636 "../src/Providers/RadioBrowser.vala"
		_tmp20_ = g_strconcat ("Unable to resolve Radio-Browser SRV records: ", _tmp19_, NULL);
#line 636 "../src/Providers/RadioBrowser.vala"
		_tmp21_ = _tmp20_;
#line 636 "../src/Providers/RadioBrowser.vala"
		g_warning ("RadioBrowser.vala:636: %s", _tmp21_);
#line 636 "../src/Providers/RadioBrowser.vala"
		_g_free0 (_tmp21_);
#line 627 "../src/Providers/RadioBrowser.vala"
		_g_error_free0 (e);
#line 4699 "RadioBrowser.c"
	}
	__finally0:
#line 627 "../src/Providers/RadioBrowser.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 627 "../src/Providers/RadioBrowser.vala"
		if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 627 "../src/Providers/RadioBrowser.vala"
			g_propagate_error (error, _inner_error0_);
#line 627 "../src/Providers/RadioBrowser.vala"
			block6_data_unref (_data6_);
#line 627 "../src/Providers/RadioBrowser.vala"
			_data6_ = NULL;
#line 627 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 4714 "RadioBrowser.c"
		} else {
#line 627 "../src/Providers/RadioBrowser.vala"
			block6_data_unref (_data6_);
#line 627 "../src/Providers/RadioBrowser.vala"
			_data6_ = NULL;
#line 627 "../src/Providers/RadioBrowser.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 627 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 627 "../src/Providers/RadioBrowser.vala"
			return NULL;
#line 4726 "RadioBrowser.c"
		}
	}
#line 639 "../src/Providers/RadioBrowser.vala"
	_tmp22_ = _data6_->results;
#line 639 "../src/Providers/RadioBrowser.vala"
	_tmp23_ = gee_collection_get_is_empty ((GeeCollection*) _tmp22_);
#line 639 "../src/Providers/RadioBrowser.vala"
	_tmp24_ = _tmp23_;
#line 639 "../src/Providers/RadioBrowser.vala"
	if (_tmp24_) {
#line 4737 "RadioBrowser.c"
		{
			guint status_code = 0U;
			GInputStream* stream = NULL;
			const gchar* _tmp25_;
			GUri* _tmp26_;
			GUri* _tmp27_;
			guint _tmp28_ = 0U;
			GInputStream* _tmp29_;
			GInputStream* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
#line 647 "../src/Providers/RadioBrowser.vala"
			_tmp25_ = string_to_string (TUNER_DATA_PROVIDER_RBI_SERVERS);
#line 647 "../src/Providers/RadioBrowser.vala"
			_tmp26_ = tuner_data_provider_radio_browser_build_uri (self, _tmp25_, "");
#line 647 "../src/Providers/RadioBrowser.vala"
			_tmp27_ = _tmp26_;
#line 647 "../src/Providers/RadioBrowser.vala"
			_tmp29_ = tuner_http_client_GET (_tmp27_, &_tmp28_);
#line 647 "../src/Providers/RadioBrowser.vala"
			status_code = _tmp28_;
#line 647 "../src/Providers/RadioBrowser.vala"
			_tmp30_ = _tmp29_;
#line 647 "../src/Providers/RadioBrowser.vala"
			_g_uri_unref0 (_tmp27_);
#line 647 "../src/Providers/RadioBrowser.vala"
			stream = _tmp30_;
#line 649 "../src/Providers/RadioBrowser.vala"
			_tmp31_ = self->priv->_current_server;
#line 649 "../src/Providers/RadioBrowser.vala"
			_tmp32_ = string_to_string (_tmp31_);
#line 649 "../src/Providers/RadioBrowser.vala"
			_tmp33_ = string_to_string (TUNER_DATA_PROVIDER_RBI_SERVERS);
#line 649 "../src/Providers/RadioBrowser.vala"
			_tmp34_ = g_strdup_printf ("%u", status_code);
#line 649 "../src/Providers/RadioBrowser.vala"
			_tmp35_ = _tmp34_;
#line 649 "../src/Providers/RadioBrowser.vala"
			_tmp36_ = g_strconcat ("response from ", _tmp32_, _tmp33_, ": ", _tmp35_, NULL);
#line 649 "../src/Providers/RadioBrowser.vala"
			_tmp37_ = _tmp36_;
#line 649 "../src/Providers/RadioBrowser.vala"
			g_debug ("RadioBrowser.vala:649: %s", _tmp37_);
#line 649 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp37_);
#line 649 "../src/Providers/RadioBrowser.vala"
			_g_free0 (_tmp35_);
#line 651 "../src/Providers/RadioBrowser.vala"
			if (status_code == ((guint) 200)) {
#line 4792 "RadioBrowser.c"
				JsonNode* root_node = NULL;
				gboolean _tmp51_ = FALSE;
				JsonNode* _tmp52_;
				{
					JsonParser* parser = NULL;
					JsonParser* _tmp38_;
					JsonParser* _tmp39_;
					GInputStream* _tmp40_;
					JsonParser* _tmp41_;
					JsonNode* _tmp42_;
					JsonNode* _tmp43_;
#line 655 "../src/Providers/RadioBrowser.vala"
					_tmp38_ = json_parser_new ();
#line 655 "../src/Providers/RadioBrowser.vala"
					parser = _tmp38_;
#line 656 "../src/Providers/RadioBrowser.vala"
					_tmp39_ = parser;
#line 656 "../src/Providers/RadioBrowser.vala"
					_tmp40_ = stream;
#line 656 "../src/Providers/RadioBrowser.vala"
					json_parser_load_from_stream (_tmp39_, _tmp40_, NULL, &_inner_error0_);
#line 656 "../src/Providers/RadioBrowser.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 656 "../src/Providers/RadioBrowser.vala"
						_g_object_unref0 (parser);
#line 4818 "RadioBrowser.c"
						goto __catch2_g_error;
					}
#line 657 "../src/Providers/RadioBrowser.vala"
					_tmp41_ = parser;
#line 657 "../src/Providers/RadioBrowser.vala"
					_tmp42_ = json_parser_get_root (_tmp41_);
#line 657 "../src/Providers/RadioBrowser.vala"
					_tmp43_ = __vala_JsonNode_copy0 (_tmp42_);
#line 657 "../src/Providers/RadioBrowser.vala"
					__vala_JsonNode_free0 (root_node);
#line 657 "../src/Providers/RadioBrowser.vala"
					root_node = _tmp43_;
#line 654 "../src/Providers/RadioBrowser.vala"
					_g_object_unref0 (parser);
#line 4833 "RadioBrowser.c"
				}
				goto __finally2;
				__catch2_g_error:
				{
					GError* e = NULL;
					GError* _tmp44_;
					const gchar* _tmp45_;
					const gchar* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					GError* _tmp49_;
					GError* _tmp50_;
#line 654 "../src/Providers/RadioBrowser.vala"
					e = _inner_error0_;
#line 654 "../src/Providers/RadioBrowser.vala"
					_inner_error0_ = NULL;
#line 659 "../src/Providers/RadioBrowser.vala"
					_tmp44_ = e;
#line 659 "../src/Providers/RadioBrowser.vala"
					_tmp45_ = _tmp44_->message;
#line 659 "../src/Providers/RadioBrowser.vala"
					_tmp46_ = string_to_string (_tmp45_);
#line 659 "../src/Providers/RadioBrowser.vala"
					_tmp47_ = g_strconcat ("RBI API get servers - unable to parse JSON response: ", _tmp46_, NULL);
#line 659 "../src/Providers/RadioBrowser.vala"
					_tmp48_ = _tmp47_;
#line 659 "../src/Providers/RadioBrowser.vala"
					_tmp49_ = g_error_new_literal (TUNER_DATA_PROVIDER_DATA_ERROR, TUNER_DATA_PROVIDER_DATA_ERROR_PARSE_DATA, _tmp48_);
#line 659 "../src/Providers/RadioBrowser.vala"
					_tmp50_ = _tmp49_;
#line 659 "../src/Providers/RadioBrowser.vala"
					_g_free0 (_tmp48_);
#line 659 "../src/Providers/RadioBrowser.vala"
					_inner_error0_ = _tmp50_;
#line 659 "../src/Providers/RadioBrowser.vala"
					_g_error_free0 (e);
#line 4870 "RadioBrowser.c"
					goto __finally2;
				}
				__finally2:
#line 654 "../src/Providers/RadioBrowser.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 654 "../src/Providers/RadioBrowser.vala"
					__vala_JsonNode_free0 (root_node);
#line 654 "../src/Providers/RadioBrowser.vala"
					_g_object_unref0 (stream);
#line 4880 "RadioBrowser.c"
					goto __catch1_g_error;
				}
#line 662 "../src/Providers/RadioBrowser.vala"
				_tmp52_ = root_node;
#line 662 "../src/Providers/RadioBrowser.vala"
				if (_tmp52_ != NULL) {
#line 4887 "RadioBrowser.c"
					JsonNode* _tmp53_;
#line 662 "../src/Providers/RadioBrowser.vala"
					_tmp53_ = root_node;
#line 662 "../src/Providers/RadioBrowser.vala"
					_tmp51_ = json_node_get_node_type (_tmp53_) == JSON_NODE_ARRAY;
#line 4893 "RadioBrowser.c"
				} else {
#line 662 "../src/Providers/RadioBrowser.vala"
					_tmp51_ = FALSE;
#line 4897 "RadioBrowser.c"
				}
#line 662 "../src/Providers/RadioBrowser.vala"
				if (_tmp51_) {
#line 4901 "RadioBrowser.c"
					JsonNode* _tmp54_;
					JsonArray* _tmp55_;
#line 663 "../src/Providers/RadioBrowser.vala"
					_tmp54_ = root_node;
#line 663 "../src/Providers/RadioBrowser.vala"
					_tmp55_ = json_node_get_array (_tmp54_);
#line 663 "../src/Providers/RadioBrowser.vala"
					json_array_foreach_element (_tmp55_, _______lambda99__json_array_foreach, _data6_);
#line 4910 "RadioBrowser.c"
				}
#line 651 "../src/Providers/RadioBrowser.vala"
				__vala_JsonNode_free0 (root_node);
#line 4914 "RadioBrowser.c"
			}
#line 644 "../src/Providers/RadioBrowser.vala"
			_g_object_unref0 (stream);
#line 4918 "RadioBrowser.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 644 "../src/Providers/RadioBrowser.vala"
			g_clear_error (&_inner_error0_);
#line 675 "../src/Providers/RadioBrowser.vala"
			g_warning ("RadioBrowser.vala:675: Failed to parse RBI APIs JSON response: $(e.mes" \
"sage)");
#line 4927 "RadioBrowser.c"
		}
		__finally1:
#line 644 "../src/Providers/RadioBrowser.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 644 "../src/Providers/RadioBrowser.vala"
			if (_inner_error0_->domain == TUNER_DATA_PROVIDER_DATA_ERROR) {
#line 644 "../src/Providers/RadioBrowser.vala"
				g_propagate_error (error, _inner_error0_);
#line 644 "../src/Providers/RadioBrowser.vala"
				block6_data_unref (_data6_);
#line 644 "../src/Providers/RadioBrowser.vala"
				_data6_ = NULL;
#line 644 "../src/Providers/RadioBrowser.vala"
				return NULL;
#line 4942 "RadioBrowser.c"
			} else {
#line 644 "../src/Providers/RadioBrowser.vala"
				block6_data_unref (_data6_);
#line 644 "../src/Providers/RadioBrowser.vala"
				_data6_ = NULL;
#line 644 "../src/Providers/RadioBrowser.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 644 "../src/Providers/RadioBrowser.vala"
				g_clear_error (&_inner_error0_);
#line 644 "../src/Providers/RadioBrowser.vala"
				return NULL;
#line 4954 "RadioBrowser.c"
			}
		}
	}
#line 679 "../src/Providers/RadioBrowser.vala"
	_tmp56_ = _data6_->results;
#line 679 "../src/Providers/RadioBrowser.vala"
	_tmp57_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp56_);
#line 679 "../src/Providers/RadioBrowser.vala"
	_tmp58_ = _tmp57_;
#line 679 "../src/Providers/RadioBrowser.vala"
	_tmp59_ = g_strdup_printf ("%i", _tmp58_);
#line 679 "../src/Providers/RadioBrowser.vala"
	_tmp60_ = _tmp59_;
#line 679 "../src/Providers/RadioBrowser.vala"
	_tmp61_ = g_strconcat ("Results ", _tmp60_, NULL);
#line 679 "../src/Providers/RadioBrowser.vala"
	_tmp62_ = _tmp61_;
#line 679 "../src/Providers/RadioBrowser.vala"
	g_debug ("RadioBrowser.vala:679: %s", _tmp62_);
#line 679 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp62_);
#line 679 "../src/Providers/RadioBrowser.vala"
	_g_free0 (_tmp60_);
#line 680 "../src/Providers/RadioBrowser.vala"
	_tmp63_ = _data6_->results;
#line 680 "../src/Providers/RadioBrowser.vala"
	_tmp64_ = _g_object_ref0 (_tmp63_);
#line 680 "../src/Providers/RadioBrowser.vala"
	result = _tmp64_;
#line 680 "../src/Providers/RadioBrowser.vala"
	block6_data_unref (_data6_);
#line 680 "../src/Providers/RadioBrowser.vala"
	_data6_ = NULL;
#line 680 "../src/Providers/RadioBrowser.vala"
	return result;
#line 4990 "RadioBrowser.c"
}

/**
        * Encodes a text string for use in RadioBrowser API requests.
        *
        * This method ensures that the text is properly encoded for use in URLs
        * by converting special characters into their URL-safe equivalents.
        *
        * @param tag The text string to be encoded
        * @return A URL-encoded string representation of the input text
        */
static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 5021 "RadioBrowser.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 5025 "RadioBrowser.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 5031 "RadioBrowser.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 5035 "RadioBrowser.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 5039 "RadioBrowser.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 5047 "RadioBrowser.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 5075 "RadioBrowser.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 5084 "RadioBrowser.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 5098 "RadioBrowser.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 5107 "RadioBrowser.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 5121 "RadioBrowser.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 5130 "RadioBrowser.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 5139 "RadioBrowser.c"
}

static gchar*
tuner_data_provider_radio_browser_encode_text (const gchar* tag)
{
	gchar* output = NULL;
	gchar* _tmp0_;
	gchar** x = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gint x_length1;
	gint x_length2;
	gchar* result;
#line 693 "../src/Providers/RadioBrowser.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 696 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = g_strdup (tag);
#line 696 "../src/Providers/RadioBrowser.vala"
	output = _tmp0_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp1_ = g_strdup ("%");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp2_ = g_strdup ("%25");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp3_ = g_strdup (":");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp4_ = g_strdup ("%3B");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp5_ = g_strdup ("/");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp6_ = g_strdup ("%2F");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp7_ = g_strdup ("#");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp8_ = g_strdup ("%23");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp9_ = g_strdup ("?");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp10_ = g_strdup ("%3F");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp11_ = g_strdup ("&");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp12_ = g_strdup ("%26");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp13_ = g_strdup ("@");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp14_ = g_strdup ("%40");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp15_ = g_strdup ("+");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp16_ = g_strdup ("%2B");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp17_ = g_strdup (" ");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp18_ = g_strdup ("%20");
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_ = g_new0 (gchar*, (9 * 2) + 1);
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[0] = _tmp1_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[1] = _tmp2_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[2] = _tmp3_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[3] = _tmp4_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[4] = _tmp5_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[5] = _tmp6_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[6] = _tmp7_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[7] = _tmp8_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[8] = _tmp9_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[9] = _tmp10_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[10] = _tmp11_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[11] = _tmp12_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[12] = _tmp13_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[13] = _tmp14_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[14] = _tmp15_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[15] = _tmp16_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[16] = _tmp17_;
#line 697 "../src/Providers/RadioBrowser.vala"
	_tmp19_[17] = _tmp18_;
#line 697 "../src/Providers/RadioBrowser.vala"
	x = _tmp19_;
#line 697 "../src/Providers/RadioBrowser.vala"
	x_length1 = 9;
#line 697 "../src/Providers/RadioBrowser.vala"
	x_length2 = 2;
#line 5256 "RadioBrowser.c"
	{
		gint a = 0;
#line 710 "../src/Providers/RadioBrowser.vala"
		a = 0;
#line 5261 "RadioBrowser.c"
		{
			gboolean _tmp20_ = FALSE;
#line 710 "../src/Providers/RadioBrowser.vala"
			_tmp20_ = TRUE;
#line 710 "../src/Providers/RadioBrowser.vala"
			while (TRUE) {
#line 5268 "RadioBrowser.c"
				const gchar* _tmp22_;
				gchar** _tmp23_;
				gint _tmp23__length1;
				gint _tmp23__length2;
				const gchar* _tmp24_;
				gchar** _tmp25_;
				gint _tmp25__length1;
				gint _tmp25__length2;
				const gchar* _tmp26_;
				gchar* _tmp27_;
#line 710 "../src/Providers/RadioBrowser.vala"
				if (!_tmp20_) {
#line 5281 "RadioBrowser.c"
					gint _tmp21_;
#line 710 "../src/Providers/RadioBrowser.vala"
					_tmp21_ = a;
#line 710 "../src/Providers/RadioBrowser.vala"
					a = _tmp21_ + 1;
#line 5287 "RadioBrowser.c"
				}
#line 710 "../src/Providers/RadioBrowser.vala"
				_tmp20_ = FALSE;
#line 710 "../src/Providers/RadioBrowser.vala"
				if (!(a < 9)) {
#line 710 "../src/Providers/RadioBrowser.vala"
					break;
#line 5295 "RadioBrowser.c"
				}
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp22_ = output;
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp23_ = x;
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp23__length1 = x_length1;
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp23__length2 = x_length2;
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp24_ = _tmp23_[(a * _tmp23__length2) + 0];
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp25_ = x;
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp25__length1 = x_length1;
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp25__length2 = x_length2;
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp26_ = _tmp25_[(a * _tmp25__length2) + 1];
#line 712 "../src/Providers/RadioBrowser.vala"
				_tmp27_ = string_replace (_tmp22_, _tmp24_, _tmp26_);
#line 712 "../src/Providers/RadioBrowser.vala"
				_g_free0 (output);
#line 712 "../src/Providers/RadioBrowser.vala"
				output = _tmp27_;
#line 5321 "RadioBrowser.c"
			}
		}
	}
#line 714 "../src/Providers/RadioBrowser.vala"
	result = output;
#line 714 "../src/Providers/RadioBrowser.vala"
	x = (_vala_array_free (x, x_length1 * x_length2, (GDestroyNotify) g_free), NULL);
#line 714 "../src/Providers/RadioBrowser.vala"
	return result;
#line 5331 "RadioBrowser.c"
}

static TunerDataProviderAPIStatus
tuner_data_provider_radio_browser_real_get_status (TunerDataProviderAPI* base)
{
	TunerDataProviderAPIStatus result;
	TunerDataProviderRadioBrowser* self;
#line 75 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 75 "../src/Providers/RadioBrowser.vala"
	result = self->priv->_status;
#line 75 "../src/Providers/RadioBrowser.vala"
	return result;
#line 5345 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_real_set_status (TunerDataProviderAPI* base,
                                                   TunerDataProviderAPIStatus value)
{
	TunerDataProviderRadioBrowser* self;
	TunerDataProviderAPIStatus old_value;
#line 75 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 75 "../src/Providers/RadioBrowser.vala"
	old_value = tuner_data_provider_radio_browser_real_get_status (base);
#line 75 "../src/Providers/RadioBrowser.vala"
	if (old_value != value) {
#line 75 "../src/Providers/RadioBrowser.vala"
		self->priv->_status = value;
#line 75 "../src/Providers/RadioBrowser.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY]);
#line 5364 "RadioBrowser.c"
	}
}

static GError*
tuner_data_provider_radio_browser_real_get_last_data_error (TunerDataProviderAPI* base)
{
	GError* result;
	TunerDataProviderRadioBrowser* self;
	GError* _tmp0_;
#line 77 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 77 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = self->priv->_last_data_error;
#line 77 "../src/Providers/RadioBrowser.vala"
	result = _tmp0_;
#line 77 "../src/Providers/RadioBrowser.vala"
	return result;
#line 5382 "RadioBrowser.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 77 "../src/Providers/RadioBrowser.vala"
	return self ? g_error_copy (self) : NULL;
#line 5390 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_real_set_last_data_error (TunerDataProviderAPI* base,
                                                            GError* value)
{
	TunerDataProviderRadioBrowser* self;
	GError* old_value;
#line 77 "../src/Providers/RadioBrowser.vala"
	self = (TunerDataProviderRadioBrowser*) base;
#line 77 "../src/Providers/RadioBrowser.vala"
	old_value = tuner_data_provider_radio_browser_real_get_last_data_error (base);
#line 77 "../src/Providers/RadioBrowser.vala"
	if (old_value != value) {
#line 5405 "RadioBrowser.c"
		GError* _tmp0_;
#line 77 "../src/Providers/RadioBrowser.vala"
		_tmp0_ = _g_error_copy0 (value);
#line 77 "../src/Providers/RadioBrowser.vala"
		_g_error_free0 (self->priv->_last_data_error);
#line 77 "../src/Providers/RadioBrowser.vala"
		self->priv->_last_data_error = _tmp0_;
#line 77 "../src/Providers/RadioBrowser.vala"
		g_object_notify_by_pspec ((GObject *) self, tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY]);
#line 5415 "RadioBrowser.c"
	}
}

static void
tuner_data_provider_radio_browser_class_init (TunerDataProviderRadioBrowserClass * klass,
                                              gpointer klass_data)
{
#line 56 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_parent_class = g_type_class_peek_parent (klass);
#line 56 "../src/Providers/RadioBrowser.vala"
	g_type_class_adjust_private_offset (klass, &TunerDataProviderRadioBrowser_private_offset);
#line 56 "../src/Providers/RadioBrowser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuner_data_provider_radio_browser_get_property;
#line 56 "../src/Providers/RadioBrowser.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuner_data_provider_radio_browser_set_property;
#line 56 "../src/Providers/RadioBrowser.vala"
	G_OBJECT_CLASS (klass)->finalize = tuner_data_provider_radio_browser_finalize;
#line 56 "../src/Providers/RadioBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY, tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", TUNER_DATA_PROVIDER_API_TYPE_STATUS, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 56 "../src/Providers/RadioBrowser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY, tuner_data_provider_radio_browser_properties[TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY] = g_param_spec_boxed ("last-data-error", "last-data-error", "last-data-error", G_TYPE_ERROR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5437 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_tuner_data_provider_api_interface_init (TunerDataProviderAPIIface * iface,
                                                                          gpointer iface_data)
{
#line 56 "../src/Providers/RadioBrowser.vala"
	tuner_data_provider_radio_browser_tuner_data_provider_api_parent_iface = g_type_interface_peek_parent (iface);
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->name = (gchar* (*) (TunerDataProviderAPI*)) tuner_data_provider_radio_browser_real_name;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->available_stations = (gint (*) (TunerDataProviderAPI*)) tuner_data_provider_radio_browser_real_available_stations;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->available_tags = (gint (*) (TunerDataProviderAPI*)) tuner_data_provider_radio_browser_real_available_tags;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->initialize = (gboolean (*) (TunerDataProviderAPI*)) tuner_data_provider_radio_browser_real_initialize;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->click = (void (*) (TunerDataProviderAPI*, const gchar*)) tuner_data_provider_radio_browser_real_click;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->vote = (void (*) (TunerDataProviderAPI*, const gchar*)) tuner_data_provider_radio_browser_real_vote;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->get_tags = (GeeSet* (*) (TunerDataProviderAPI*, gint, gint, GError**)) tuner_data_provider_radio_browser_real_get_tags;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->by_uuid = (GeeSet* (*) (TunerDataProviderAPI*, const gchar*, GError**)) tuner_data_provider_radio_browser_real_by_uuid;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->by_uuids = (GeeSet* (*) (TunerDataProviderAPI*, GeeCollection*, GError**)) tuner_data_provider_radio_browser_real_by_uuids;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->search = (GeeSet* (*) (TunerDataProviderAPI*, TunerDataProviderSearchParams*, guint, guint, GError**)) tuner_data_provider_radio_browser_real_search;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->search_async = (void (*) (TunerDataProviderAPI*, TunerDataProviderSearchParams*, guint, guint, GAsyncReadyCallback, gpointer)) tuner_data_provider_radio_browser_real_search_async;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->search_finish = (GeeSet* (*) (TunerDataProviderAPI*, GAsyncResult*, GError**)) tuner_data_provider_radio_browser_search_finish;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->get_status = tuner_data_provider_radio_browser_real_get_status;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->set_status = tuner_data_provider_radio_browser_real_set_status;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->get_last_data_error = tuner_data_provider_radio_browser_real_get_last_data_error;
#line 56 "../src/Providers/RadioBrowser.vala"
	iface->set_last_data_error = tuner_data_provider_radio_browser_real_set_last_data_error;
#line 5478 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_instance_init (TunerDataProviderRadioBrowser * self,
                                                 gpointer klass)
{
	gchar* _tmp0_;
#line 56 "../src/Providers/RadioBrowser.vala"
	self->priv = tuner_data_provider_radio_browser_get_instance_private (self);
#line 63 "../src/Providers/RadioBrowser.vala"
	_tmp0_ = g_strdup (TUNER_DATA_PROVIDER_RBI_ALL_API);
#line 63 "../src/Providers/RadioBrowser.vala"
	self->priv->_current_server = _tmp0_;
#line 64 "../src/Providers/RadioBrowser.vala"
	self->priv->_degrade = TUNER_DATA_PROVIDER_RADIO_BROWSER_DEGRADE_CAPITAL;
#line 65 "../src/Providers/RadioBrowser.vala"
	self->priv->_available_stations = 1000;
#line 66 "../src/Providers/RadioBrowser.vala"
	self->priv->_available_tags = 1000;
#line 5498 "RadioBrowser.c"
}

static void
tuner_data_provider_radio_browser_finalize (GObject * obj)
{
	TunerDataProviderRadioBrowser * self;
#line 56 "../src/Providers/RadioBrowser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser);
#line 61 "../src/Providers/RadioBrowser.vala"
	_g_free0 (self->priv->_optionalservers);
#line 62 "../src/Providers/RadioBrowser.vala"
	_g_object_unref0 (self->priv->_servers);
#line 63 "../src/Providers/RadioBrowser.vala"
	_g_free0 (self->priv->_current_server);
#line 77 "../src/Providers/RadioBrowser.vala"
	_g_error_free0 (self->priv->_last_data_error);
#line 56 "../src/Providers/RadioBrowser.vala"
	G_OBJECT_CLASS (tuner_data_provider_radio_browser_parent_class)->finalize (obj);
#line 5517 "RadioBrowser.c"
}

/**
     * A data provider implementation for the Radio Browser API.
     * 
     * RadioBrowser class implements the DataProvider.API interface to fetch
     * radio station data from the Radio Browser service.
     * 
     * See https://www.radio-browser.info/ for API details.
     */
static GType
tuner_data_provider_radio_browser_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TunerDataProviderRadioBrowserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuner_data_provider_radio_browser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TunerDataProviderRadioBrowser), 0, (GInstanceInitFunc) tuner_data_provider_radio_browser_instance_init, NULL };
	static const GInterfaceInfo tuner_data_provider_api_info = { (GInterfaceInitFunc) tuner_data_provider_radio_browser_tuner_data_provider_api_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType tuner_data_provider_radio_browser_type_id;
	tuner_data_provider_radio_browser_type_id = g_type_register_static (G_TYPE_OBJECT, "TunerDataProviderRadioBrowser", &g_define_type_info, 0);
	g_type_add_interface_static (tuner_data_provider_radio_browser_type_id, TUNER_DATA_PROVIDER_TYPE_API, &tuner_data_provider_api_info);
	TunerDataProviderRadioBrowser_private_offset = g_type_add_instance_private (tuner_data_provider_radio_browser_type_id, sizeof (TunerDataProviderRadioBrowserPrivate));
	return tuner_data_provider_radio_browser_type_id;
}

GType
tuner_data_provider_radio_browser_get_type (void)
{
	static volatile gsize tuner_data_provider_radio_browser_type_id__once = 0;
	if (g_once_init_enter (&tuner_data_provider_radio_browser_type_id__once)) {
		GType tuner_data_provider_radio_browser_type_id;
		tuner_data_provider_radio_browser_type_id = tuner_data_provider_radio_browser_get_type_once ();
		g_once_init_leave (&tuner_data_provider_radio_browser_type_id__once, tuner_data_provider_radio_browser_type_id);
	}
	return tuner_data_provider_radio_browser_type_id__once;
}

static void
_vala_tuner_data_provider_radio_browser_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	TunerDataProviderRadioBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser);
#line 56 "../src/Providers/RadioBrowser.vala"
	switch (property_id) {
#line 56 "../src/Providers/RadioBrowser.vala"
		case TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY:
#line 56 "../src/Providers/RadioBrowser.vala"
		g_value_set_enum (value, tuner_data_provider_api_get_status ((TunerDataProviderAPI*) self));
#line 56 "../src/Providers/RadioBrowser.vala"
		break;
#line 56 "../src/Providers/RadioBrowser.vala"
		case TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY:
#line 56 "../src/Providers/RadioBrowser.vala"
		g_value_set_boxed (value, tuner_data_provider_api_get_last_data_error ((TunerDataProviderAPI*) self));
#line 56 "../src/Providers/RadioBrowser.vala"
		break;
#line 5574 "RadioBrowser.c"
		default:
#line 56 "../src/Providers/RadioBrowser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 56 "../src/Providers/RadioBrowser.vala"
		break;
#line 5580 "RadioBrowser.c"
	}
}

static void
_vala_tuner_data_provider_radio_browser_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	TunerDataProviderRadioBrowser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUNER_DATA_PROVIDER_TYPE_RADIO_BROWSER, TunerDataProviderRadioBrowser);
#line 56 "../src/Providers/RadioBrowser.vala"
	switch (property_id) {
#line 56 "../src/Providers/RadioBrowser.vala"
		case TUNER_DATA_PROVIDER_RADIO_BROWSER_STATUS_PROPERTY:
#line 56 "../src/Providers/RadioBrowser.vala"
		tuner_data_provider_api_set_status ((TunerDataProviderAPI*) self, g_value_get_enum (value));
#line 56 "../src/Providers/RadioBrowser.vala"
		break;
#line 56 "../src/Providers/RadioBrowser.vala"
		case TUNER_DATA_PROVIDER_RADIO_BROWSER_LAST_DATA_ERROR_PROPERTY:
#line 56 "../src/Providers/RadioBrowser.vala"
		tuner_data_provider_api_set_last_data_error ((TunerDataProviderAPI*) self, g_value_get_boxed (value));
#line 56 "../src/Providers/RadioBrowser.vala"
		break;
#line 5606 "RadioBrowser.c"
		default:
#line 56 "../src/Providers/RadioBrowser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 56 "../src/Providers/RadioBrowser.vala"
		break;
#line 5612 "RadioBrowser.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

